/* Copyright OCHIAI Laboratory 
modified by Noriko Imafuji in 1998, Nobuko KOMAGATA in 1999, 
Chihiro Nakai in 2002 and Mari Yasuda in 2003
*/
#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <math.h>
#include <GL/glut.h>
/* #include <GLUT/glut.h> for Macintosh */

#define		NMAX	20
#define		EOD		555
#define		PI		(GLdouble)3.14159265357989323844
#define		SIDES	30
static GLint		rightdrug=0;
static GLint		dora = 0,ss=0,ii=0,tt=0,jj=0,ss16=0,tt16=0;
static GLdouble		KK0, KK1, KK2,dxyz1[3], dxyz0[3],dxyz2[3], dxyz4[3], dxyz6[3], g_rot=0.0;
static GLint		chara = 1;
static GLint		motion  = 1, motion2	= 0;
static GLfloat		angle   = 0;
static int			k[7]={0,0,0,0,0,0,0},r[11]={0,0,0,0,0,0,0,0,0,0,0},rt=0;

static float Color1[4] = {1.0, 1.0, 1.0, 1.0};
static float Color2[4] = {0.0, 0.0, 0.0, 1.0};
static float Color3[4] = {0.0, 0.0, 1.0, 1.0};
static float Color4[4] = {0.0, 1.0, 0.0, 1.0};
static float Color5[4] = {1.0, 0.0, 0.0, 1.0};
static float Color6[4] = {1.0, 1.0, 0.0, 1.0};
static float Color7[4] = {0.0, 1.0, 1.0, 1.0};
static float Color8[4] = {1.0, 1.0, 0.5, 1.0};
static float Color9[4] = {0.02, 0.02, 0.02, 1.0};
static float Color10[4] = {0.5, 0.5, 0.0, 1.0};
static float Color11[4] = {0.0, 0.0, 0.5, 1.0};
static float Color12[4] = {0.9, 0.9, 0.9, 1.0};
static float Color13[4] = {0.8, 0.8, 0.8, 1.0};
static float Color14[4] = {1.0, 1.0, 0.8, 1.0};
static float Color15[4] = {1.0, 0.2, 0.2, 1.0};
static float Color16[4] = {1.0, 1.0, 0.3, 1.0};
static float Color17[4] = {1.0, 0.8, 0.1, 1.0};
static float Color18[4] = {0.5, 0.1, 0.0, 1.0};
static float Color19[4] = {0.5, 0.5, 0.45, 1.0};
static float Color20[4] = {0.0, 0.2, 0.0, 1.0};
static float Color21[4] = {0.3, 0.3, 0.2, 1.0};
static float Color22[4] = {0.5, 1.0, 0.0, 1.0};

typedef struct
{
    GLfloat	ambient[4];
    GLfloat diffuse[4];
    GLfloat	specular[4];
    GLfloat	shininess[1];
    GLfloat	emission[4];
} MATERIAL_LIST;
typedef struct
{
    GLfloat	ambient[4];
    GLfloat	local_view;
    GLfloat	two_size;
} LIGHT_MODEL;
typedef struct
{
    GLint	ON;
    GLfloat	ambient[4];
    GLfloat diffuse[4];
    GLfloat	specular[4];
    GLfloat	position[4];
    GLfloat	spot_direction[3];
    GLfloat	spot_exponet;
    GLfloat	spot_cutoff;
    GLfloat	KC;
    GLfloat KL;
    GLfloat	KQ;
} LIGHT;

GLfloat no_mat[4] = { 0.0, 0.0, 0.0, 1.0 };
jmp_buf			env;
extern double	*g_KPRO[];
extern void		FreeDrawMemory(void);
extern int		GetDrawData(FILE *, int *, int *);
static int		g_com, g_nump[NMAX];
static GLint	g_LButton = 0;
static FILE		*g_fp;
MATERIAL_LIST	Material;
LIGHT_MODEL		Lmodel;
LIGHT			Light0;
static GLfloat  spin_x  = 0.0;
static GLfloat  spin_y  = 0.0;
static GLint	xsize	= 500;
static GLint	ysize	= 500;
void		MyReshape(GLsizei, GLsizei);
void		DisplayKnot(void);
void		Wave(int,GLdouble *, GLdouble *);
void		MyInitWindow(void);
void MiddlePoint(GLdouble u[], GLdouble v[], GLdouble w[])
{
    w[0] = (u[0]+v[0])/2.0;
    w[1] = (u[1]+v[1])/2.0;
    w[2] = (u[2]+v[2])/2.0;
}
double length(double v0,double v1 ,double v2)
{
    return sqrt(v0*v0+v1*v1+v2*v2);
}
void Framing(GLdouble r, GLdouble R, GLint nsides, GLint rings, GLenum type)
{
    int			i, j;
    GLdouble    theta, phi, theta1, phi1;
    GLdouble    p0[03], p1[3], p2[3], p3[3];
    GLdouble    n0[3], n1[3], n2[3], n3[3];
    for (i = 0; i < rings; i++) {
        theta = (GLdouble)i*(GLdouble)2.0*PI/rings;
        theta1 = (GLdouble)(i+1)*(GLdouble)2.0*PI/rings;
        for (j = 0; j < nsides; j++) {
            phi = (GLdouble)j*(GLdouble)2.0*PI/nsides;
            phi1 = (GLdouble)(j+1)*(GLdouble)2.0*PI/nsides;
            p0[0] = cos(theta)*(R + r*cos(phi));
            p0[1] = -sin(theta)*(R + r*cos(phi));
            p0[2] = r*sin(phi);
            p1[0] = cos(theta1)*(R + r*cos(phi));
            p1[1] = -sin(theta1)*(R + r*cos(phi));
            p1[2] = r*sin(phi);
            p2[0] = cos(theta1)*(R + r*cos(phi1));
            p2[1] = -sin(theta1)*(R + r*cos(phi1));
            p2[2] = r*sin(phi1);
            p3[0] = cos(theta)*(R + r*cos(phi1));
            p3[1] = -sin(theta)*(R + r*cos(phi1));
            p3[2] = r*sin(phi1);
            n0[0] = cos(theta)*(cos(phi));
            n0[1] = -sin(theta)*(cos(phi));
            n0[2] = sin(phi);
            n1[0] = cos(theta1)*(cos(phi));
            n1[1] = -sin(theta1)*(cos(phi));
            n1[2] = sin(phi);
            n2[0] = cos(theta1)*(cos(phi1));
            n2[1] = -sin(theta1)*(cos(phi1));
            n2[2] = sin(phi1);
            n3[0] = cos(theta)*(cos(phi1));
            n3[1] = -sin(theta)*(cos(phi1));
            n3[2] = sin(phi1);
            glBegin(type);
            glNormal3dv(n3);
            glVertex3dv(p3);
            glNormal3dv(n2);
            glVertex3dv(p2);
            glNormal3dv(n1);
            glVertex3dv(p1);
            glNormal3dv(n0);
            glVertex3dv(p0);
            glEnd();
        }
    }
}
void kyuu(double x[][37], double y[][37], double z[][37])
{
    int		i,j,m=0,n=0;
    double	r,h;
    for(i=-180;i<=0;i=i+10) {
        h=(3.1415924/180)*i;
        for(j=-180;j<=180;j=j+10) {
            r=(3.141592/180)*j;
            x[m][n]=sin(h)*cos(r);
            y[m][n]=sin(h)*sin(r);
            z[m][n]=cos(h);
            n=n+1;
        }
        n=0;
        m=m+1;
    }
}
void draw(int m,int n,double x[37][37],double y[37][37],double z[37][37],double nx[37][37],double ny[37][37],double nz[37][37])
{
    glNormal3d(-nx[m][n],-ny[m][n],-nz[m][n]);
    glBegin(GL_QUADS);
    glVertex3d(x[m][n],    y[m][n],    z[m][n]+0.04);
    glVertex3d(x[m+1][n],  y[m+1][n],  z[m+1][n]+0.04);
    glVertex3d(x[m+1][n+1],y[m+1][n+1],z[m+1][n+1]+0.04);
    glVertex3d(x[m][n+1],  y[m][n+1],  z[m][n+1]+0.04);
    glEnd();
}
void CalcNormal(double x[][37], double y[][37], double z[][37],double nx[][37],double ny[][37], double nz[][37])
{
    double	a[3],b[3],length;
    int		i,j;
    
    for(i=0;i<36;i++) {
        for(j=0;j<36;j++) {
            a[0]=x[i][j]-x[i][j+1];
            a[1]=y[i][j]-y[i][j+1];
            a[2]=z[i][j]-z[i][j+1];
            b[0]=x[i+1][j]-x[i][j+1];
            b[1]=y[i+1][j]-y[i][j+1];
            b[2]=z[i+1][j]-z[i][j+1];
            nx[i][j]=a[1]*b[2]-a[2]*b[1];
            ny[i][j]=a[2]*b[0]-a[0]*b[2];
            nz[i][j]=a[0]*b[1]-a[1]*b[0];
            length=sqrt(nx[i][j]*nx[i][j]+ny[i][j]*ny[i][j]+nz[i][j]*nz[i][j]);
            if(length!=0){
                nx[i][j]=nx[i][j]/length;
                ny[i][j]=ny[i][j]/length;
                nz[i][j]=nz[i][j]/length;
            }
        }
    }
}
void footmotion(void)
{
    if(motion == 1) {
        if(r[0] ==0) r[0]=r[0]-10;
        if(r[0] ==-10)
        r[0]=10;
        else if(r[0] ==10)
        r[0]=-10;
        if(r[1] ==0) r[1]=r[1]+10;
        if(r[1] ==10)
        r[1]=-10;
        else if(r[1] ==-10)
        r[1]=10;
    }
}
void tailmotion(void)
{
    if(motion == 1) {
        if(rt==0) rt=-30;
        if(rt==30) rt=-30;
        else rt=30;
        
    }
}
void dog(void)
{
    double	x[37][37],y[37][37],z[37][37];
    double	nx[37][37],ny[37][37],nz[37][37];
    int		m, n;

    kyuu(x,y,z);
    CalcNormal(x,y,z,nx,ny,nz);
    glPushMatrix();	/* total body */
    glTranslated(0.0,0.14,0.0);
    glMaterialfv(GL_FRONT,GL_SPECULAR,Color2);
    glScaled(0.05,0.05,0.05);
    glPushMatrix();	/* head */
    glRotated (-10, 1.0, 0.0, 0.0);
    glPushMatrix();	/* face */
    glScaled(0.65,0.9,0.6);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color1);
    glutSolidSphere(1.0, 10, 10);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color9);
    for(m=0;m<18;m++) {
        for(n=0;n<18;n++) {
            draw(m,n,x,y,z,nx,ny,nz);
        }
    }
    glNormal3d(nx[16][23],ny[16][23],-nz[16][23]);
    glBegin(GL_QUADS);
    glVertex3d(x[17][23], 0.1,  z[17][23]+0.04);
    glVertex3d(x[17][23], y[17][23],  z[17][23]+0.04);
    glVertex3d(x[17][31], y[17][31],  z[17][31]+0.04);
    glVertex3d(x[17][31], 0.1,  z[17][31]+0.04);
    glEnd();
    glBegin(GL_QUADS);
    glVertex3d(x[17][23], y[17][23]+0.01,  z[17][23]+0.04);
    glVertex3d(x[16][23], y[16][23],  z[16][23]+0.04);
    glVertex3d(x[16][31], y[16][31],  z[16][31]+0.04);
    glVertex3d(x[17][31], y[17][31],  z[17][31]+0.04);
    glEnd();
    glBegin(GL_QUADS);
    glVertex3d(x[16][23], y[16][23]+0.01,  z[16][23]+0.04);
    glVertex3d(x[15][24], y[15][24],  z[15][24]+0.05);
    glVertex3d(x[15][30], y[15][30],  z[15][30]+0.05);
    glVertex3d(x[16][31], y[16][31],  z[16][31]+0.04);
    glEnd();
    glBegin(GL_QUADS);
    glVertex3d(x[15][24], y[15][24]+0.01,  z[15][24]+0.04);
    glVertex3d(x[14][25], y[14][25],  z[14][25]+0.05);
    glVertex3d(x[14][29], y[14][29],  z[14][29]+0.05);
    glVertex3d(x[15][30], y[15][30],  z[15][30]+0.04);
    glEnd();
    glPopMatrix();	/* face */
    glPushMatrix();	/* left eyebrows */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color1);
    glTranslated(0.35,0.15,0.55);
    glRotated (-10, 0.0, 0.0, 1.0);
    glScaled(1.0,0.4,0.5);
    glutSolidSphere(0.16, 10, 10);
    glPopMatrix();	/* left eyebrows */
    glPushMatrix();	/* right eyebrows */
    glTranslated(-0.35,0.15,0.55);
    glRotated (10, 0.0, 0.0, 1.0);
    glScaled(1.0,0.4,0.5);
    glutSolidSphere(0.16, 10, 10);
    glPopMatrix();	/* right eyebrows */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color9);
    glPushMatrix();	/* left ear */
    glRotated (30, 1.0, 0.0, 0.0);
    glTranslated(0.45,0.8,0.0);
    glScaled(0.7,1.0,0.7);
    glutSolidSphere(0.3, 10, 10);
    glPopMatrix();	/* left ear */
    glPushMatrix();	/* right ear */
    glRotated (30, 1.0, 0.0, 0.0);
    glTranslated(-0.45,0.8,0.0);
    glScaled(0.7,1.0,0.7);
    glutSolidSphere(0.3, 10, 10);
    glPopMatrix();	/* right ear */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color2);
    glPushMatrix();//hana
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color1);
    glTranslated(0.0,-0.6,0.3);
    glScaled(1.0,0.6,1.0);
    glutSolidSphere(0.5, 10, 10);
    glPopMatrix();	/* belly */
    glPushMatrix();	/* black belly */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color2);
    glTranslated(0.0,-0.5,0.8);
    glScaled(1.0,0.7,0.8);
    glutSolidSphere(0.15, 10, 10);
    glPopMatrix();	/* black belly */
    glPushMatrix();	/* mouse */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color5);
    
    glTranslated(0.0,-0.9,0.7);
    glRotated (60, 1.0, 0.0, 0.0);
    glScaled(0.7,0.2,1.0);
    glutSolidSphere(0.15, 10, 10);
    glPopMatrix();	/* mouse */
    glPushMatrix();	/* left eye */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color2);
    glTranslated(0.35,0.0,0.6);
    glScaled(1.0,0.8,1.0);
    glutSolidSphere(0.1, 10, 10);
    glPopMatrix();	/* left eye */
    glPushMatrix();	/* right eye */
    glTranslated(-0.35,0.0,0.6);
    glScaled(1.0,0.8,1.0);
    glutSolidSphere(0.1, 10, 10);
    glPopMatrix();	/* right eye */
    glPopMatrix();	/* head */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color1);
    glPushMatrix();	/* trunk */
    glTranslated(-0.0,-1.4,-0.8);
    glScaled(0.5,0.5,0.9);
    glutSolidSphere(1.5, 10, 10);
    glScaled(1.5,1.6,1.5);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color9);
    for(m=0;m<18;m++) {
        for(n=0;n<18;n++) {
            draw(m,n,x,y,z,nx,ny,nz);
        }
    }
    glPopMatrix(); /* trunk */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color3);
    glPushMatrix();	/* neck ring */
    glTranslated(0.0,-0.7,0.0);
    glRotatef (100.0f, 1.0, 0.0, 0.0);
    glScaled(0.47,0.4,0.38);
    Framing(0.3, 1.0, 10, 30, GL_QUADS);
    glPopMatrix();	/* neck ring */
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color1);
    glPushMatrix();	/* left front foot */
    glTranslated(0.7,-1.5,0.3);
    glRotated (r[0], 1.0, 0.0, 0.0);
    glTranslated(0.0,-0.5,0.0);
    glScaled(0.5,1.5,0.5);
    glutSolidSphere(0.5, 10, 10);
    glPopMatrix();	/* left front foot */
    glPushMatrix();	/* right front foot */
    glTranslated(-0.7,-1.5,0.3);
    glRotated (r[1], 1.0, 0.0, 0.0);
    glTranslated(0.0,-0.5,0.0);
    glScaled(0.5,1.5,0.5);
    glutSolidSphere(0.5, 10, 10);
    glPopMatrix();	/* right front foot */
    glPushMatrix();	/* left back foot */
    glTranslated(0.7,-1.5,-1.5);
    glRotated (r[0], 1.0, 0.0, 0.0);
    glTranslated(0.0,-0.5,0.0);
    glScaled(0.5,1.5,0.5);
    glutSolidSphere(0.5, 10, 10);
    glPopMatrix();	/* left back foot */
    glPushMatrix();	/* right back foot */
    glTranslated(-0.7,-1.5,-1.5);
    glRotated (r[1], 1.0, 0.0, 0.0);
    glTranslated(0.0,-0.5,0.0);
    glScaled(0.5,1.5,0.5);
    glutSolidSphere(0.5, 10, 10);
    glPopMatrix();	/* right back foot */
    footmotion();
    glPushMatrix();	/* tail */
    glTranslated(0.0,-1.3,-2.2);
    glRotated (rt, 0.0, 0.0, 1.0);
    glTranslated(0.0,0.8,0.0);
    glScaled(0.5,1.5,0.5);
    glutSolidSphere(0.5, 10, 10);
    tailmotion();
    glPopMatrix();	/* tail */
    glMaterialfv(GL_FRONT,GL_SPECULAR,Color1);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Color8);
    glPopMatrix();	/* total body */
}
void DisplayKnot(void)
{
    int			i, j, k,s, t, s16, t16;
    GLdouble	xyz0[3], xyz1[3];
    GLdouble	xyz2[3], xyz4[3], xyz6[3];
    GLdouble	K0, K1, K2;
    double dvs[2],theta[2],ctheta[2];

	glMatrixMode(GL_MODELVIEW);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

    if (!g_LButton) {
		dog();
        glFlush();
        glutSwapBuffers();
        return;
    }
    g_LButton = 2;
    glPushMatrix();
    glRotatef(spin_x,0.0,1.0,0.0);
    glRotatef(spin_y,1.0,0.0,0.0);
    
    for (s = 0, i = 1; i <= g_com; i++) {
        t = s + g_nump[i]; s16 = 16 * s; t16 = 16 * t;
        K0=g_KPRO[0][s16]; K1=g_KPRO[1][s16]; K2=g_KPRO[2][s16];
        xyz0[0] = g_KPRO[0][s16] = g_KPRO[0][t16];
        xyz0[1] = g_KPRO[1][s16] = g_KPRO[1][t16];
        xyz0[2] = g_KPRO[2][s16] = g_KPRO[2][t16];
        for (j = s16; j < t16; j++) {
            xyz1[0] = g_KPRO[0][j+1];
            xyz1[1] = g_KPRO[1][j+1];
            xyz1[2] = g_KPRO[2][j+1];
            MiddlePoint(xyz0, xyz1, xyz2);
            MiddlePoint(xyz0, xyz2, xyz4);
            MiddlePoint(xyz1, xyz2, xyz6);
            if (j == s16) Wave(1,xyz4,xyz6);
            else if (j == t16-1) Wave(2,xyz4,xyz6);
            else Wave(0,xyz4,xyz6);
            for (k = 0; k < 3; k++) xyz0[k] = xyz1[k];
        }
        
        g_KPRO[0][s16]=K0; g_KPRO[1][s16]=K1; g_KPRO[2][s16]=K2;
        s += g_nump[i];
        
    }
    if(chara!=0) {
        if(ii <= g_com) {
            if(dora==0 ) {
                ss=0;
                ii=1;
                jj=0;
            }
            else {
                if(dora==1) {                   
                    g_KPRO[0][ss16]=KK0; g_KPRO[1][ss16]=KK1; g_KPRO[2][ss16]=KK2;
                    ss += g_nump[ii];
                    ii++;
                }
            }
        }
        tt = ss + g_nump[ii]; ss16 = 16 * ss; tt16 = 16 * tt;
        if(jj < tt16) {
            if(dora==0 || dora==1) {
                KK0=g_KPRO[0][ss16]; KK1=g_KPRO[1][ss16]; KK2=g_KPRO[2][ss16];               
                dxyz0[0] = g_KPRO[0][tt16];
                dxyz0[1] = g_KPRO[1][tt16];
                dxyz0[2] = g_KPRO[2][tt16];
                jj=ss16;
                dora=2;
            }
            else {
                jj=jj+1;
                if(jj==tt16) {
                    jj=ss16;
                    if(ii+1 <= g_com)
                    dora=1;
                }
                
            }
        }
        dxyz1[0] = g_KPRO[0][jj+1];
        dxyz1[1] = g_KPRO[1][jj+1];
        dxyz1[2] = g_KPRO[2][jj+1];
        MiddlePoint(dxyz0, dxyz1, dxyz2);
        MiddlePoint(dxyz0, dxyz2, dxyz4);
        MiddlePoint(dxyz1, dxyz2, dxyz6);
        glPushMatrix();
        dvs[0]=length(dxyz1[0]-dxyz0[0],0.0,dxyz1[2]-dxyz0[2]);
        dvs[1]=length(dxyz1[0]-dxyz0[0],dxyz1[1]-dxyz0[1],dxyz1[2]-dxyz0[2]);
        ctheta[0]=(dxyz1[0]-dxyz0[0])/dvs[0];
        ctheta[1]=((dxyz1[0]-dxyz0[0])*(dxyz1[0]-dxyz0[0])+(dxyz1[2]-dxyz0[2])*(dxyz1[2]-dxyz0[2]))/(dvs[0]*dvs[1]);
        theta[0]=acos(ctheta[0]);
        theta[1]=acos(ctheta[1]);
		theta[0]=(180.0/PI)*theta[0];
        theta[1]=(180.0/PI)*theta[1];
        if(dxyz1[2]>dxyz0[2])
			theta[0]=-theta[0];
        if(dxyz1[1]>dxyz0[1])
			theta[1]=-theta[1];
        glTranslated(dxyz0[0],dxyz0[1],dxyz0[2]);
		glRotatef(theta[0]+90, 0.0, 1.0, 0.0);	// y-coordinate
		glRotatef(theta[1], 1.0, 0.0, 0.0);		// x-coordinate
		glRotatef(g_rot, 0.0, 0.0, 1.0);		// rotation around a knot
        if(chara==1)
			dog();
        glPopMatrix();
        for (k = 0; k < 3; k++)
			dxyz0[k] = dxyz1[k];
    }
    glPopMatrix();
    glFlush();
    glutSwapBuffers();
    g_LButton = 1;
}
void SetLightMaterial(void)
{
    Lmodel.ambient[0] = 0.2;
    Lmodel.ambient[1] = 0.2;
    Lmodel.ambient[2] = 0.2;
    Lmodel.ambient[3] = 1.0;
    Lmodel.local_view = 0.0;
    Lmodel.two_size   = 0.0;
    Light0.ambient[0] = 0.0;
    Light0.ambient[1] = 0.0;
    Light0.ambient[2] = 0.0;
    Light0.ambient[3] = 1.0;
    Light0.diffuse[0] = 1.0;
    Light0.diffuse[1] = 1.0;
    Light0.diffuse[2] = 1.0;
    Light0.diffuse[3] = 1.0;
    Light0.specular[0] = 1.0;
    Light0.specular[1] = 1.0;
    Light0.specular[2] = 1.0;
    Light0.specular[3] = 1.0;
    
    Light0.position[0] = 0.0;
    Light0.position[1] = 2.0;
    Light0.position[2] = 2.0;
    Light0.position[3] = 0.0;
    
    Light0.spot_direction[0] = 0.0;
    Light0.spot_direction[1] = 0.0;
    Light0.spot_direction[2] = -1.0;
    Light0.spot_exponet = 0.0;
    Light0.spot_cutoff  = 180.0;
    Light0.KC = 1.0;
    Light0.KL = 0.0;
    Light0.KQ = 0.0;
    Material.ambient[0] = 1.0;
    Material.ambient[1] = 0.2;
    Material.ambient[2] = 0.2;
    Material.ambient[3] = 1.0;
    Material.diffuse[0] = 1.0;
    Material.diffuse[1] = 1.0;
    Material.diffuse[2] = 0.5;
    Material.diffuse[3] = 1.0;
    Material.specular[0] = 1.0;
    Material.specular[1] = 1.0;
    Material.specular[2] = 1.0;
    Material.specular[3] = 1.0;
    
    Material.shininess[0] = 50.0;
    
    Material.emission[0] = 0.0;
    Material.emission[1] = 0.0;
    Material.emission[2] = 0.0;
    Material.emission[3] = 1.0;
}
void SetLightModel(void)
{
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, Lmodel.ambient);
    glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER, Lmodel.local_view);
    glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, Lmodel.two_size);
}
void SetLight(void)
{
    glLightfv(GL_LIGHT0,GL_AMBIENT,Light0.ambient);
    glLightfv(GL_LIGHT0,GL_DIFFUSE,Light0.diffuse);
    glLightfv(GL_LIGHT0,GL_SPECULAR,Light0.specular);
    glLightfv(GL_LIGHT0,GL_POSITION,Light0.position);
    glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,Light0.spot_direction);
    glLightf(GL_LIGHT0,GL_SPOT_EXPONENT,Light0.spot_exponet);
    glLightf(GL_LIGHT0,GL_SPOT_CUTOFF,Light0.spot_cutoff);
    glLightf(GL_LIGHT0,GL_CONSTANT_ATTENUATION,Light0.KC);
    glLightf(GL_LIGHT0,GL_LINEAR_ATTENUATION,Light0.KL);
    glLightf(GL_LIGHT0,GL_QUADRATIC_ATTENUATION,Light0.KQ);
}
void SetMaterial(void)
{
    glMaterialfv(GL_FRONT,GL_AMBIENT,no_mat);
    glMaterialfv(GL_FRONT,GL_DIFFUSE,Material.diffuse);
    glMaterialfv(GL_FRONT,GL_SPECULAR,Material.specular);
    glMaterialfv(GL_FRONT,GL_SHININESS,Material.shininess);
    glMaterialfv(GL_FRONT,GL_EMISSION,no_mat);
}
void NormalVector(p0, p1, p2, p)
GLdouble	*p0, *p1, *p2, *p;
{
    GLdouble	nx, ny, nz, dd, sqrt(GLdouble);
    nx = (p1[1]-p0[1])*(p2[2]-p1[2])-(p1[2]-p0[2])*(p2[1]-p1[1]);
    ny = (p1[2]-p0[2])*(p2[0]-p1[0])-(p1[0]-p0[0])*(p2[2]-p1[2]);
    nz = (p1[0]-p0[0])*(p2[1]-p1[1])-(p1[1]-p0[1])*(p2[0]-p1[0]);
    dd = sqrt(nx*nx+ny*ny+nz*nz);
    p[0] = nx / dd; p[1] = ny / dd; p[2] = nz / dd;
}
void DrawTriangle(p0, p1, p2)
GLdouble	p0[], p1[], p2[];
{
    GLdouble	p[3];
    glBegin(GL_TRIANGLES);
    NormalVector(p0, p1, p2, p);
    glNormal3dv(p);
    glVertex3dv(p0);
    glVertex3dv(p1);
    glVertex3dv(p2);
    glEnd();
}
void GetVertex(xyz, col, sil, t, k, p)
GLdouble	xyz[], col, sil, t[], k[], p[];
{
    p[0]=xyz[0]+col*t[0]+sil*k[0];
    p[1]=xyz[1]+col*t[1]+sil*k[1];
    p[2]=xyz[2]+col*t[2]+sil*k[2];
}
void Wave(tail, xyz0, xyz1)
int		tail;
GLdouble xyz0[], xyz1[];
{
    int			i, j;
    GLdouble	r, s, th1, th2;
    GLdouble	co1, co2, si1, si2;
    GLdouble	w[3], u[3], v[3], t[3], k[3];
    GLdouble	p0[3], p1[3], p2[3], p3[3];
    GLdouble	bp[SIDES+1][3], tp[SIDES+1][3];
    static GLdouble	btm[SIDES+1][3], top[SIDES+1][3];
    r = 0.03;
    for(i = 0; i < SIDES; i++) {
        for (j = 0; j < 3; j++) w[j] = xyz1[j] - xyz0[j];
        u[0]=-w[1]; u[1]=w[0]; u[2]=0.0;
        s=sqrt(u[0]*u[0]+u[1]*u[1]+u[2]*u[2]);
        t[0]=r*u[0]/s; t[1]=r*u[1]/s; t[2]=r*u[2]/s;
        v[0]=w[1]*t[2]-t[1]*w[2];
        v[1]=w[2]*t[0]-t[2]*w[0];
        v[2]=w[0]*t[1]-t[0]*w[1];
        s=sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
        k[0]=r*v[0]/s; k[1]=r*v[1]/s; k[2]=r*v[2]/s;
        th1=(GLdouble)i*2.0*PI/SIDES;
        th2=(GLdouble)(i+1)*2.0*PI/SIDES;
        co1=cos(th1); si1=sin(th1);
        co2=cos(th2); si2=sin(th2);
        GetVertex(xyz0, co1, si1, t, k, p0);
        GetVertex(xyz0, co2, si2, t, k, p1);
        GetVertex(xyz1, co2, si2, t, k, p2);
        GetVertex(xyz1, co1, si1, t, k, p3);
        for (j = 0; j < 3; j++) {
            bp[i][j] = p0[j]; tp[i][j] = p3[j];
        }
        DrawTriangle(p0, p1, p2);
        DrawTriangle(p0, p2, p3);
    }
    for (j = 0; j < 3; j++) {
        bp[SIDES][j] = bp[0][j]; tp[SIDES][j] = tp[0][j];
    }
    if (tail != 1) {
        for (i = 0; i < SIDES; i++) {
            DrawTriangle(top[i], bp[i+1], bp[i]);
            DrawTriangle(top[i], top[i+1], bp[i+1]);
        }
        if (tail == 2) {
            for (i = 0; tail == 2 && i < SIDES; i++) {
                DrawTriangle(tp[i], btm[i+1], btm[i]);
                DrawTriangle(tp[i], tp[i+1], btm[i+1]);
            }
        }
    }
    for (i = 0; i <= SIDES; i++) {
        for (j = 0; j < 3; j++)	{
            if (tail == 1) btm[i][j] = bp[i][j];
            if (tail != 2) top[i][j] = tp[i][j];
        }
    }
}
void MyReshape(GLsizei w, GLsizei h)
{
    h = (h == 0) ? 1 : h;
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w <= h)
    glOrtho(-1.0, 1.0, -(GLdouble)h/(GLdouble)w,
    (GLdouble)h/(GLdouble)w, -1.0, 1.0);
    else
    glOrtho(-(GLdouble)w/(GLdouble)h,
    (GLdouble)w/(GLdouble)h, -1.0, 1.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}
void MyInitWindow(void)
{
    glClearColor (0.7, 0.9, 0.7, 1.0);
    SetLightMaterial();
    
    SetLightModel();
    SetLight();
    SetMaterial();
    glShadeModel(GL_SMOOTH);
    glCullFace(GL_BACK);
    glEnable(GL_LIGHTING); glEnable(GL_LIGHT0);
    glDepthFunc(GL_LESS);
    glEnable(GL_DEPTH_TEST);
    glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
}
void motionfunc(int x, int y)
{
    static GLint	last_x=0,last_y=0;
    
    if (!rightdrug) {
        ;
    }
    else if(abs(last_x-x)>8 || abs(last_y-y)>8) {
        spin_x=300.0*2.0*x/xsize;
        spin_y=300.0*2.0*y/ysize;
        
        if(spin_x>360.0)       spin_x-=360.0;
        else if(spin_x<-360.0) spin_x+=360.0;
        if(spin_y>360.0)       spin_y-=360.0;
        else if(spin_y<-360.0) spin_y+=360.0;
        
        DisplayKnot();
        last_x=x;
        last_y=y;
    }
    glFlush();
    glutSwapBuffers();
}
void mousefunc(int button, int state, int x, int y)
{
    int		code;
    switch (button) {
    case GLUT_LEFT_BUTTON:
        if (g_LButton == 2 || g_fp == NULL)
        return;
        if (state==GLUT_DOWN) {
            if ((code=GetDrawData(g_fp,&g_com,g_nump))<1) {
                printf("Failed to get a knot data.\n");
                fclose(g_fp);
                g_fp = NULL;
                longjmp(env, 1);
            }
            else if (code == EOD) {
                printf("Reached at EOF.\n");
                fclose(g_fp);
                g_fp = NULL;
                FreeDrawMemory();
                longjmp(env, 1);
            }
        }
        else if (state==GLUT_UP) {
            g_LButton = 1;
            DisplayKnot();
        }
        break;
    case GLUT_RIGHT_BUTTON:
        switch (state) {
        case GLUT_UP:
            rightdrug = 0;
            break;
        case GLUT_DOWN:
            rightdrug = 1;
            break;
        }
        break;
    default:
        break;
    }
}
void keyboard(unsigned char key, int x, int y)
{
    switch (key) {
    case 'r':	/* reset position */
    case 'R':
        spin_x=0;
        spin_y=0;
        DisplayKnot();
        break;
    case 'g':	/* go to walk */
    case 'G':
        DisplayKnot();
        break;
	case '1':
		g_rot = 90.0;
		break;
	case '2':
		g_rot = 180.0;
		break;
	case '3':
		g_rot = 0.0;
		break;
    case 'a':	/* appearance */
    case 'A':
        if(chara==0)
        chara=1;
        else
        chara=0;
        break;
    case 'q':	/* quit */
    case 'Q':
    case '\033':
        longjmp(env, 1);
        break;
    default:
        break;
    }
}
int main(int argc, char** argv)
{
    char	filename[50];
    if (setjmp(env)) {
        return 0;
    }
    printf("Usage: the left button click -> read a p-data \n");
    printf("       the right button drug -> rotate the knot\n");
    printf("keyin: g -> go a dog walking on the knot\n");
	printf("       1,2,3 -> dog's rotation around knot (90,180,0)\n");
    printf("       r -> reset the knot position\n");
    printf("       a -> dog appearence\n");
    printf("       q -> quit\n");
    
    printf("Please input a data filename ? ");
	fflush(stdout);
    scanf("%s", filename);
    if ((g_fp=fopen(filename, "r"))== NULL) {
        printf("Can not open the input file.\n");
        return(0);
    }
    g_LButton = 0;
    g_KPRO[0] = g_KPRO[1] = g_KPRO[2] = NULL;
    glutInitWindowPosition(0, 0);
    glutInitWindowSize(xsize, ysize);
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    glutCreateWindow("A dog walking on a knot or link");
    
    MyInitWindow();
    glutDisplayFunc(DisplayKnot);
    glutReshapeFunc(MyReshape);
    glutMouseFunc(mousefunc);
    glutMotionFunc(motionfunc);
    glutKeyboardFunc(keyboard);
    
    glutMainLoop();
    return(0);
}
