/* @Copyright OCHIAI LAB. of Nara Women's University
programmed by M. Ochiai
2004/1/25
*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>

#include	<GL/glut.h>
/* #include	<GLUT/glut.h> in Macintosh */
#define		MAXLINES	100
#define		IF(K)	if(key==K)

int			XWindowSize = 500;
int			YWindowSize = 500;
double		startX, startY;
double		currentX, currentY;

int			swapBufferState = 0;
int			lineStarted = 0;

double		lineList[2][MAXLINES];
int			vnum=1, Vertex[MAXLINES], D[MAXLINES];
int			MLIST[2*MAXLINES], AMAT[MAXLINES][MAXLINES];
GLfloat		VP[2][MAXLINES], MP[2][MAXLINES];
int			DVED = 0;	/* subdivide an edge */
int			currentP;
int			NUMON = 1;
int			INDATA = 0;

int			numberOfLines = 0;

int			DUMMY=10;

int			DIVIDE=8;
int			PLANARITY2=7;
int			PLANARITY1=6;
int			TRICONNECTED=5;
int			NUMBER=4;
int			DELETE = 3;
int			GRAPH = 2;
int			CLEAR=1;
int			QUIT = 0;

FILE		*infile = NULL;
char		filename[30];

extern int	HopcroftTarjan(void);
extern int	CaiHanTarjan(void);
extern int	triconnected(int *, long);

void initmatrix(void);

void draw_str(GLfloat x,GLfloat y,void *font,char *string)
{
	glRasterPos2f(x,y);
	while(*string)
		glutBitmapCharacter(font, *string++);
}   

void glutinit(void)
{
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity();
	glClearColor ( 1.0, 1.0, 1.0, 0.0);   /* White Background */
	glEnable (GL_DEPTH_TEST);
	glOrtho(0.0, (double)XWindowSize, 0.0, (double)YWindowSize, -20.0, 20.0);
}

void drawgraph(void)
{
	int		i;
	double	x, y;
	char	str[4]="000";

	for (i = 0; i < numberOfLines; i++) {
		glPushMatrix();
		glTranslated(lineList[0][i], lineList[1][i], 0);        
		glutSolidSphere( 3.0, 16, 16 );
		glPopMatrix();	
		if ((i+1) == numberOfLines)
			break;
		glBegin(GL_LINE_STRIP);
			glVertex3d(lineList[0][i], lineList[1][i], 0);
			i++;
			glVertex3d(lineList[0][i], lineList[1][i], 0);
		glEnd();
		glPushMatrix();
		glTranslated(lineList[0][i], lineList[1][i], 0);        
		glutSolidSphere( 3.0, 16, 16 );
		glPopMatrix();
	}
	if (NUMON) {
		for (i = 1; i < vnum; i++) {
			_snprintf(str, sizeof(str), "%d", i);
			/* snprintf(str, sizeof(str), "%d", i); in Macintosh */
			draw_str(VP[0][i]+5.0,VP[1][i]+5.0,GLUT_BITMAP_8_BY_13,str);
		}
		for (i = 0; i < numberOfLines-1; i += 2) {
			x = (lineList[0][i+1]+lineList[0][i])/2.0;
			y = (lineList[1][i+1]+lineList[1][i])/2.0;
			glPushMatrix();
			glTranslated(x, y, 0);        
			glutSolidSphere( 1.3, 16, 16 );
			glPopMatrix();	
		}
	}
}

void display(void)
{
	glMatrixMode(GL_MODELVIEW);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	if (!lineStarted) {
		glFlush();
		glutSwapBuffers();
		return;
	}

/* Draw the rubber band line in black */

    glColor3f(0.0, 0.0, 0.0);

	glBegin(GL_LINES);
		glVertex3d(startX, startY, 0.0);
		glVertex3d(currentX, currentY, 0.0);
	glEnd();


/* Previous lines are drawn in blue */
	glColor3f(0.0, 0.0, 1.0);

	drawgraph();

	glFlush();
	glutSwapBuffers();
}

void resize(int w, int h)
{
	/* EBhEŜr[|[gɂ */
	glViewport(0, 0, w, h);

	/* ϊs̏ */
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity();

	/* XN[̍Wn}EX̍WnɈv */
	glOrtho(0.0, (double)w, 0.0, (double)h, -20.0, 20.0);
	XWindowSize = w; YWindowSize = h;
}

void mouseTracking(int xPosition, int yPosition)
{
/* determine the current endpoint using screen coordinates */
	if (DVED == 2) {
		lineList[0][currentP] = xPosition;
		lineList[1][currentP] = YWindowSize - yPosition;
		lineList[0][currentP+1] = xPosition;
		lineList[1][currentP+1] = YWindowSize - yPosition;
		glutPostRedisplay();
	}
	if (swapBufferState) {
		currentX = xPosition;
		currentY = YWindowSize - yPosition;
		glutPostRedisplay();
	}
}

int VertexCheck(double x, double y)
{
	int		i;

	for (i = 0; i < numberOfLines; i++) {
		if (fabs(lineList[0][i]-x)<15.0 && fabs(lineList[1][i]-y)<15.0) {
			return(i);
		}
	}
	return(-1);
}

int Degree(int type, double x, double y)
{
	int		i;

	for (i = 1; i < vnum; i++) {
		if (fabs(VP[0][i]-x)<15.0 && fabs(VP[1][i]-y)<15.0) {
			if (type == 1)
				D[i]++;
			else if (type == 0)
				D[i]--;
			else
				return(i);
			return(0);
		}
	}
	return(0);
}

void remakeGraph(void)
{
	int		i, k, n;
	double	LList[2][MAXLINES];

	n = numberOfLines;
	for (i = 0; i < n; i++) {
		LList[0][i] = lineList[0][i];
		LList[1][i] = lineList[1][i];
	}
	numberOfLines = 0;
	vnum = 1;
	swapBufferState = 0;
	for (i = 0; i < MAXLINES; i++)
		D[i] = 0;
	
	for (i = 0; i < n; i++) {
		if (!swapBufferState) {
			startX = currentX = LList[0][i];
			startY = currentY = LList[1][i];
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				startX = currentX = lineList[0][numberOfLines] = lineList[0][k];
				startY = currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 1;
			numberOfLines++;
		}
		else if (fabs(startX-LList[0][i])>15.0 || fabs(startY-LList[1][i])>15.0) {
			currentX = LList[0][i];
			currentY = LList[1][i];
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				currentX = lineList[0][numberOfLines] = lineList[0][k];
				currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 0;
			numberOfLines++;
		}
		Degree(1, LList[0][i], LList[1][i]);
	}
	initmatrix();
	INDATA = 0;
}

int middlePointCheck(double mx, double my)
{
	int		i, j, k1, k2;
	double	x, y;

	for (i = 0; i < numberOfLines-1; i += 2) {
		x = (lineList[0][i+1]+lineList[0][i])/2.0;
		y = (lineList[1][i+1]+lineList[1][i])/2.0;
		if (fabs(mx-x)<15.0 && fabs(my-y)<15.0) {
			k1 = Degree(-1, lineList[0][i], lineList[1][i]);
			k2 = Degree(-1, lineList[0][i+1], lineList[1][i+1]);
//			This code to avoid isorated vertexes
//			if (k1 > 0 && D[k1] <= 1 || k2 > 0 && D[k2] <= 1)
//				return(2);
			Degree(0, lineList[0][i], lineList[1][i]);
			Degree(0, lineList[0][i+1], lineList[1][i+1]);
			for (j = i+1; j < numberOfLines-1; j++) {
				lineList[0][j-1] = lineList[0][j+1];
				lineList[1][j-1] = lineList[1][j+1];
			}
			numberOfLines -= 2;
			remakeGraph();
			return(1);
		}
	}
	return(0);
}

void addOneVertex(int k, double x, double y)
{
	int		i;
	double	LList[2][MAXLINES];

	for (i = 0; i <= k; i++) {
		LList[0][i] = lineList[0][i];
		LList[1][i] = lineList[1][i];
	}

	currentP = k+1;

	LList[0][k+1] = x;
	LList[1][k+1] = y;
	LList[0][k+2] = x;
	LList[1][k+2] = y;
	for (i = k+1; i < numberOfLines; i++) {
		LList[0][i+2] = lineList[0][i];
		LList[1][i+2] = lineList[1][i];
	}
	numberOfLines += 2;
	for (i = 0; i < numberOfLines; i++) {
		lineList[0][i] = LList[0][i];
		lineList[1][i] = LList[1][i];
	}
}

void sudivideEdge(double mx, double my)
{
	int		i;
	double	x, y;

	for (i = 0; i < numberOfLines-1; i += 2) {
		x = (lineList[0][i+1]+lineList[0][i])/2.0;
		y = (lineList[1][i+1]+lineList[1][i])/2.0;
		if (fabs(mx-x)<15.0 && fabs(my-y)<15.0) {
			addOneVertex(i, x, y);
			remakeGraph();
			return;
		}
	}
	return;
}

void strart_end_Tracking(int Button, int state, int xPosition, int yPosition)
{
	int		k;

/* Start drawing a line by picking a first position (or finish by
 * releasing the mouse button.... */

	if (Button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
		lineStarted = 1;
		if (!swapBufferState) {
			startX = currentX = xPosition;
			startY = currentY = YWindowSize - yPosition;
			if (DVED == 1) {
				sudivideEdge(startX, startY);
				DVED = 2;
				glutPassiveMotionFunc(mouseTracking);
				glutPostRedisplay();
				return;
			}
			else if (DVED == 2) {
				lineList[0][currentP] = startX;
				lineList[1][currentP] = startY;
				lineList[0][currentP+1] = startX;
				lineList[1][currentP+1] = startY;
				DVED = 0;
				remakeGraph();
				glutPassiveMotionFunc(mouseTracking);
				glutPostRedisplay();
				return;
			}
			if (middlePointCheck(startX, startY)) {
				glutPassiveMotionFunc(mouseTracking);
				glutPostRedisplay();
				return;
			}
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				startX = currentX = lineList[0][numberOfLines] = lineList[0][k];
				startY = currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 1;
			numberOfLines++;
		}
		else if (fabs(startX-xPosition)>15.0 || fabs(startY-(YWindowSize - yPosition))>15.0) {
			currentX = xPosition;
			currentY = YWindowSize - yPosition;
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				currentX = lineList[0][numberOfLines] = lineList[0][k];
				currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 0;
			numberOfLines++;
		}
		Degree(1, xPosition, YWindowSize - yPosition);
		glutPassiveMotionFunc(mouseTracking);
	}

	glutPostRedisplay();	
}

void initmatrix(void)
{
	int		i, j;

	for (i = 1; i < MAXLINES; i++) {
		for (j = 1; j < MAXLINES; j++) 
			AMAT[i][j] = 0;
	}
}

void menu(int value)
{
	int		i, j, k, retcode;
	double	x, y;

	if(value == DELETE && swapBufferState == 0) {
		k = numberOfLines-1;
		x = (lineList[0][k]+lineList[0][k-1])/2.0;
		y = (lineList[1][k]+lineList[1][k-1])/2.0;
		if (middlePointCheck(x, y)) {
			glutPassiveMotionFunc(mouseTracking);
			glutPostRedisplay();
		}
	}
	else if (value == DIVIDE) {
		DVED = 1;
	}
	else if (value == NUMBER) {
		NUMON = 1 - NUMON;
	}
	else if (value == TRICONNECTED) {
		if (numberOfLines == 0)
			printf("Please input a graph by mouse tracking.\n");
		else if (INDATA) {
			retcode = triconnected(MLIST, (vnum-1)*(vnum-1));
			if (retcode==1)
				printf("*** This graph is triconnected. *** \n");
			else if (retcode==2)
				printf("*** This graph has separation points. *** \n");
			else if (retcode==3)
				printf("*** This graph is disconnected. *** \n");
			else
				printf("*** This graph has separation pairs. *** \n");
		}
		else
			printf("Please determine the adjacency matrix.\n");
	}
	else if (value == PLANARITY2) {
		if (numberOfLines == 0) {
loop2:
			INDATA = 0;
			printf("Input a data file name ? ");
			gets(filename);
			infile = NULL;
			if (strlen(filename) == 0)
				goto loopout;
			if ((infile = fopen(filename, "r")) == NULL)  {
				printf("Can't open file : %s\n", filename);
				goto loopout;
			}
			else {
				retcode = CaiHanTarjan();
				if (retcode == 1)
					printf("*** This graph is planar by Cai-Han-Tarjan algorithm. *** \n");
				else if (retcode == 0)
					printf("*** This graph is nonplanar by Cai-Han-Tarjan algorithm. *** \n");
				else
					printf("*** ERROR. *** \n");
			}
			fflush(stdout);
			filename[0] = '\0';
			goto loop2;
		}
		if (INDATA) {
			retcode = CaiHanTarjan();
			if (retcode == 1)
				printf("*** This graph is planar by Cai-Han-Tarjan algorithm. *** \n");
			else if (retcode == 0)
				printf("*** This graph is nonplanar by Cai-Han-Tarjan algorithm. *** \n");
			else
				printf("*** ERROR. *** \n");
		}
		else
			printf("Please determine the adjacency matrix.\n");
	}
	else if (value == PLANARITY1) {
		if (numberOfLines == 0) {
loop1:
			INDATA = 0;
			printf("Input a data file name ? ");
			gets(filename);
			infile = NULL;
			if (strlen(filename) == 0)
				goto loopout;
			if ((infile = fopen(filename, "r")) == NULL)  {
				printf("Can't open file : %s\n", filename);
				goto loopout;
			}
			else {
				retcode = HopcroftTarjan();
				if (retcode)
					printf("*** This graph is planar by Hopcroft-Tarjan algorithm. *** \n");
				else if (retcode == 0)
					printf("*** This graph is nonplanar by Hopcroft-Tarjan algorithm. *** \n");
				else
					printf("*** ERROR. *** \n");
			}
			fflush(stdout);
			filename[0] = '\0';
			goto loop1;
		}
		if (INDATA) {
			retcode = HopcroftTarjan();
			if (retcode)
				printf("*** This graph is planar by Hopcroft-Tarjan algorithm. *** \n");
			else if (retcode == 0)
				printf("*** This graph is nonplanar by Hopcroft-Tarjan algorithm. *** \n");
			else
				printf("*** ERROR. *** \n");
		}
		else
			printf("Please determine the adjacency matrix.\n");
	}
	else if(value == CLEAR) {
		vnum = 1;
		numberOfLines = 0;
		swapBufferState = 0;
		lineStarted = 0;
		NUMON = 0;
		initmatrix();
		INDATA = 0;
	}
	else if(value == GRAPH) {
		if (numberOfLines == 0)
			printf("Please input a graph by mouse tracking.\n");
		else if ((infile = fopen("INDATA.dat", "w")) == NULL)  {
			printf("Can't open file : %s\n", "INDATA.dat");			
		}
		else {
			for (i = 1; i < numberOfLines; i += 2) 
				AMAT[Vertex[i-1]][Vertex[i]] = AMAT[Vertex[i]][Vertex[i-1]] = 1;
			printf("|V[G]| = %d\n", vnum-1);
			fprintf(infile, "%d\n", vnum-1);
			for (i = 1; i < vnum; i++) {
				fprintf(infile, "%d  ", i);
				for (j = 1; j < vnum; j++) {
					printf("%d ", AMAT[i][j]);
					MLIST[(j-1)+(i-1)*(vnum-1)] = AMAT[i][j];
					if (AMAT[i][j] == 1)
						fprintf(infile, "%d ", j);
				}
				printf("\n");
				fprintf(infile, "0\n");
			}
			fprintf(infile, "0\n");
			fclose(infile);
			infile = NULL;
			fflush(stdout);
			INDATA = 1;
		}
	}
	else if(value == QUIT) {
		exit(0); 
	}

loopout:
	glutPostRedisplay();
}

void keyboard(unsigned char key, int xPosition, int yPosition)
/*x,y̓L[ꂽƂ̃}EXʒu */
{
	IF(27) { /* 0x1B */
		exit(0); 
	}

    switch (key) {
	case 'd':	/* Delete one edge */
		vnum -= 2;
		numberOfLines -= 2;
		swapBufferState = 0;
		break;	
    default:
        break;
	}
	glutPostRedisplay();
}

int main(int argCount, char *argValues[])
{
	int		i;

	for (i = 0; i < MAXLINES; i++)
		D[i] = 0;
	initmatrix();
	INDATA = 0;

	glutInit(&argCount, argValues);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize (XWindowSize, YWindowSize);
	glutCreateWindow(argValues[0]);
	glutReshapeFunc(resize);
	glutinit();
	/* Set up callback routines   */
	glutMouseFunc(strart_end_Tracking);
	glutPassiveMotionFunc(mouseTracking);
    glutKeyboardFunc(keyboard);
    glutCreateMenu(menu);

	glutAddMenuEntry("DELETE the last edge", DELETE);
	glutAddMenuEntry("-------------------------", DUMMY);
	glutAddMenuEntry("DIVIDE an edge", DIVIDE);
	glutAddMenuEntry("-------------------------", DUMMY);
    glutAddMenuEntry("NUMBER", NUMBER);
	glutAddMenuEntry("-------------------------", DUMMY);
	glutAddMenuEntry("Hopcroft-Tarjan", PLANARITY1);
	glutAddMenuEntry("-------------------------", DUMMY);
	glutAddMenuEntry("Cai-Han-Tarjan", PLANARITY2);
	glutAddMenuEntry("-------------------------", DUMMY);
    glutAddMenuEntry("TRICONNECTED", TRICONNECTED);
	glutAddMenuEntry("-------------------------", DUMMY);
	glutAddMenuEntry("CLEAR", CLEAR);
	glutAddMenuEntry("-------------------------", DUMMY);
	glutAddMenuEntry("DETERMINE an adjacency matrix", GRAPH);

	glutAddMenuEntry("-------------------------", DUMMY);
    glutAddMenuEntry("QUIT", QUIT);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
	
	glutDisplayFunc(display);
	glutMainLoop();
	return EXIT_SUCCESS;
}

