/* @Copyright OCHIAI LAB. of Nara Women's University
programmed by M. Ochiai
2004/1/25
*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>
#include	"glui.h"

#include	<GL/glut.h>
/* #include	<GLUT/glut.h> in Macintosh */
#define		MAXVTX		150
#define		MAXEDGE		200

#define		PI  (GLdouble)3.14159265357989323844

#define		IF(K)	if(key==K)

int			main_window;

int			XWindowSize = 500;
int			YWindowSize = 500;
int			XWindowPos = 50;
int			YWindowPos = 50;

double		startX, startY;
double		currentX, currentY;

int			swapBufferState = 0;
int			lineStarted = 0;

int			vnum = 1;
double		lineList[2][MAXEDGE];		/* edge coordinate */
int			Vertex[MAXEDGE];			/* both vertexes of edge */	

int			D[MAXVTX];					/* vertex degree */
int			AMAT[MAXVTX][MAXVTX];
GLfloat		VP[2][MAXVTX];				/* vetex coordinate */

int			DVED = 0;	/* subdivide an edge */
int			DEVST = 0;
int			currentP;
int			NUMON = 1;
int			INDATA = 0;

int			numberOfLines = 0;

int			DUMMY = 10;

int			DIVIDE = 8;
int			PLANARITY1 = 6;
int			TRICONNECTED = 5;
int			NUMBER = 4;
int			DELETE = 3;
int			GRAPH = 2;
int			CLEAR = 1;
int			QUIT = 0;

FILE		*infile = NULL;
char		filename[30] = "k33.dat";
char		message[100] = "Welcome Graph World !!!";

GLUI		*glui;

extern int	HopcroftTarjan(void);
extern int	triconnected(int mm[][MAXVTX], long);

void initmatrix(void);
void remakeGraph(void);

void initmatrix(void)
{
	int		i, j;

	for (i = 1; i < MAXVTX; i++) {
		for (j = 1; j < MAXVTX; j++) 
			AMAT[i][j] = 0;
	}
}

static int readgraph(FILE *infile, int *nu, int MAT[][MAXVTX])
{
	int		i, ed, k, retcode;

	k = i = 1;
	retcode = 0;
	fscanf(infile, "%d", nu);  
	fscanf(infile, "%d", &ed);
	if (*nu < ed || k != ed)
		goto ext;
	fscanf(infile, "%d", &ed);
	if (*nu < ed || ed == 0)
		goto ext;
	MAT[k][i] = ed;
	i++;

	while (fscanf(infile, "%d", &ed) != EOF) {
		if (ed == 0) {
			MAT[k][i] = ed;
			k++; i = 1;
			fscanf(infile, "%d", &ed);
			if(ed == 0) {
				retcode = 1;
				break;
			}
			else {
				if (*nu < ed || k != ed)
					goto ext;
			}
		}
		else {
			if (*nu < ed || ed == 0)
				goto ext;
			MAT[k][i] = ed;
			i++;
		}
	}
ext:
	return(retcode);
}

int makegraphfromfile(FILE *infile)
{
	int		nu, retcode, MAT[MAXVTX][MAXVTX];
    int		i, j, k, l, d;
    double	c;
    double	r, x, y;
	int		XCenter = XWindowSize/2, YCenter = YWindowSize/2;

	for (i = 1; i < MAXVTX; i++) {
		for (j = 1; j < MAXVTX; j++) 
			MAT[i][j] = 0;
	}
	retcode = readgraph(infile, &nu, MAT);
	if (retcode == 0)
		return(0);
	if (nu > 30)
		r = YWindowSize / 2.1;	/*radius of circle */
	else
		r = YWindowSize / 2.5;
	for(i=1;i<=nu;i++){
		c = 2.0*(i-1)*PI/nu+PI/2.0;
		x = XCenter+cos(c)*r;
		y = YCenter+sin(c)*r;
		VP[0][i] = x; VP[1][i] = y;
	}
	k = numberOfLines = 0;
	for(i=1;i<=nu;i++){
		d = 0;
		for(j=1;MAT[i][j]!=0;j++) {
			d++;
			l = MAT[i][j];
			if (i < l) {
				lineList[0][k] = VP[0][i];
				lineList[1][k] = VP[1][i];
				lineList[0][k+1] = VP[0][l];
				lineList[1][k+1] = VP[1][l];
				Vertex[k] = i; Vertex[k+1] = l;
				k += 2;
			}
		}
		D[i] = d;
	}
	numberOfLines = k;
	vnum = nu + 1;

	return(1);
}

void draw_str(GLfloat x,GLfloat y,void *font,char *string)
{
	glRasterPos2f(x,y);
	while(*string)
		glutBitmapCharacter(font, *string++);
}   

void glutinit(void)
{
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity();
	glClearColor ( 1.0, 1.0, 1.0, 0.0);   /* White Background */
	glEnable (GL_DEPTH_TEST);
	glOrtho(0.0, (double)XWindowSize, 0.0, (double)YWindowSize, -20.0, 20.0);
}

void drawgraph(void)
{
	int		i;
	double	x, y;
	char	str[4]="000";

	for (i = 0; i < numberOfLines; i++) {
		glPushMatrix();
		glTranslated(lineList[0][i], lineList[1][i], 0);        
		glutSolidSphere( 3.0, 16, 16 );
		glPopMatrix();	
		if ((i+1) == numberOfLines)
			break;
		glBegin(GL_LINE_STRIP);
			glVertex3d(lineList[0][i], lineList[1][i], 0);
			i++;
			glVertex3d(lineList[0][i], lineList[1][i], 0);
		glEnd();
		glPushMatrix();
		glTranslated(lineList[0][i], lineList[1][i], 0);        
		glutSolidSphere( 3.0, 16, 16 );
		glPopMatrix();
	}
	if (NUMON) {
		for (i = 1; i < vnum; i++) {
			_snprintf(str, sizeof(str), "%d", i);
			/* snprintf(str, sizeof(str), "%d", i); in Macintosh */
			draw_str(VP[0][i]+5.0,VP[1][i]+5.0,GLUT_BITMAP_8_BY_13,str);
		}
		for (i = 0; i < numberOfLines-1; i += 2) {
			x = (lineList[0][i+1]+lineList[0][i])/2.0;
			y = (lineList[1][i+1]+lineList[1][i])/2.0;
			glPushMatrix();
			glTranslated(x, y, 0);        
			glutSolidSphere( 1.3, 16, 16 );
			glPopMatrix();	
		}
	}
	draw_str(10.0,5.0,GLUT_BITMAP_8_BY_13,message);
}

void display(void)
{
	int		i;

	glMatrixMode(GL_MODELVIEW);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	if (!lineStarted) {
		glDisable( GL_LIGHTING );  
		glMatrixMode( GL_PROJECTION );
		glLoadIdentity();
		gluOrtho2D( 0.0, 100.0, 0.0, 100.0  );
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
		glColor3ub( 0, 0, 0 );
		glRasterPos2i( 5, 10 );
		for( i=0; i<(int)strlen(message); i++ )
			glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, message[i] );
		glEnable( GL_LIGHTING );

		glFlush();
		glutSwapBuffers();
		return;
	}

/* Draw the rubber band line in black */

    glColor3f(0.0, 0.0, 0.0);

	glBegin(GL_LINES);
		glVertex3d(startX, startY, 0.0);
		glVertex3d(currentX, currentY, 0.0);
	glEnd();


/* Previous lines are drawn in blue */
	glColor3f(0.0, 0.0, 1.0);

	drawgraph();

	glFlush();
	glutSwapBuffers();
}

void resize(int w, int h)
{
	/* EBhEŜr[|[gɂ */
	glViewport(0, 0, w, h);

	/* ϊs̏ */
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity();

	/* XN[̍Wn}EX̍WnɈv */
	glOrtho(0.0, (double)w, 0.0, (double)h, -20.0, 20.0);
	XWindowSize = w; YWindowSize = h;
}

void mouseTracking(int xPosition, int yPosition)
{
/* determine the current endpoint using screen coordinates */
	if (DEVST == 2) {
		lineList[0][currentP] = xPosition;
		lineList[1][currentP] = YWindowSize - yPosition;
		lineList[0][currentP+1] = xPosition;
		lineList[1][currentP+1] = YWindowSize - yPosition;
		glutPostRedisplay();
	}
	if (swapBufferState) {
		currentX = xPosition;
		currentY = YWindowSize - yPosition;
		glutPostRedisplay();
	}
}

int VertexCheck(double x, double y)
{
	int		i;

	for (i = 0; i < numberOfLines; i++) {
		if (fabs(lineList[0][i]-x)<15.0 && fabs(lineList[1][i]-y)<15.0) {
			return(i);
		}
	}
	return(-1);
}

int Degree(int type, double x, double y)
{
	int		i;

	for (i = 1; i < vnum; i++) {
		if (fabs(VP[0][i]-x)<15.0 && fabs(VP[1][i]-y)<15.0) {
			if (type == 1)
				D[i]++;
			else if (type == 0)
				D[i]--;
			else
				return(i);
			return(0);
		}
	}
	return(0);
}

void remakeGraph(void)
{
	int		i, k, n;
	double	LList[2][MAXEDGE];

	n = numberOfLines;
	for (i = 0; i < n; i++) {
		LList[0][i] = lineList[0][i];
		LList[1][i] = lineList[1][i];
	}
	numberOfLines = 0;
	vnum = 1;
	swapBufferState = 0;
	for (i = 0; i < MAXVTX; i++)
		D[i] = 0;
	
	for (i = 0; i < n; i++) {
		if (!swapBufferState) {
			startX = currentX = LList[0][i];
			startY = currentY = LList[1][i];
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				startX = currentX = lineList[0][numberOfLines] = lineList[0][k];
				startY = currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 1;
			numberOfLines++;
		}
		else if (fabs(startX-LList[0][i])>15.0 || fabs(startY-LList[1][i])>15.0) {
			currentX = LList[0][i];
			currentY = LList[1][i];
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				currentX = lineList[0][numberOfLines] = lineList[0][k];
				currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 0;
			numberOfLines++;
		}
		Degree(1, LList[0][i], LList[1][i]);
	}
	initmatrix();
	INDATA = 0;
}

int middlePointCheck(double mx, double my)
{
	int		i, j, k1, k2;
	double	x, y;

	for (i = 0; i < numberOfLines-1; i += 2) {
		x = (lineList[0][i+1]+lineList[0][i])/2.0;
		y = (lineList[1][i+1]+lineList[1][i])/2.0;
		if (fabs(mx-x)<15.0 && fabs(my-y)<15.0) {
			k1 = Degree(-1, lineList[0][i], lineList[1][i]);
			k2 = Degree(-1, lineList[0][i+1], lineList[1][i+1]);
//			This code to avoid isorated vertexes
//			if (k1 > 0 && D[k1] <= 1 || k2 > 0 && D[k2] <= 1)
//				return(2);
			Degree(0, lineList[0][i], lineList[1][i]);
			Degree(0, lineList[0][i+1], lineList[1][i+1]);
			for (j = i+1; j < numberOfLines-1; j++) {
				lineList[0][j-1] = lineList[0][j+1];
				lineList[1][j-1] = lineList[1][j+1];
			}
			numberOfLines -= 2;
			remakeGraph();
			return(1);
		}
	}
	return(0);
}

void addOneVertex(int k, double x, double y)
{
	int		i;
	double	LList[2][MAXEDGE];

	for (i = 0; i <= k; i++) {
		LList[0][i] = lineList[0][i];
		LList[1][i] = lineList[1][i];
	}

	currentP = k+1;

	LList[0][k+1] = x;
	LList[1][k+1] = y;
	LList[0][k+2] = x;
	LList[1][k+2] = y;
	for (i = k+1; i < numberOfLines; i++) {
		LList[0][i+2] = lineList[0][i];
		LList[1][i+2] = lineList[1][i];
	}
	numberOfLines += 2;
	for (i = 0; i < numberOfLines; i++) {
		lineList[0][i] = LList[0][i];
		lineList[1][i] = LList[1][i];
	}
}

void sudivideEdge(double mx, double my)
{
	int		i;
	double	x, y;

	for (i = 0; i < numberOfLines-1; i += 2) {
		x = (lineList[0][i+1]+lineList[0][i])/2.0;
		y = (lineList[1][i+1]+lineList[1][i])/2.0;
		if (fabs(mx-x)<15.0 && fabs(my-y)<15.0) {
			addOneVertex(i, x, y);
			remakeGraph();
			return;
		}
	}
	return;
}

void strart_end_Tracking(int Button, int state, int xPosition, int yPosition)
{
	int		k;

/* Start drawing a line by picking a first position (or finish by
 * releasing the mouse button.... */

	if (Button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
		if (lineStarted == 0) {
			message[0] = '\0';
			glutinit();
		}
		lineStarted = 1;
		if (!swapBufferState) {
			startX = currentX = xPosition;
			startY = currentY = YWindowSize - yPosition;
			if (DVED == 1 && DEVST != 2) {
				if (VertexCheck(currentX, currentY) >= 0)
					return;
				if (DEVST == 0)
					DEVST = 1;
			}

			if (DEVST == 1) {
				sudivideEdge(startX, startY);
				DEVST = 2;
				glutPassiveMotionFunc(mouseTracking);
				glutPostRedisplay();
				return;
			}
			else if (DEVST == 2) {
				lineList[0][currentP] = startX;
				lineList[1][currentP] = startY;
				lineList[0][currentP+1] = startX;
				lineList[1][currentP+1] = startY;
				DEVST = 0;
				remakeGraph();
				glutPassiveMotionFunc(mouseTracking);
				glutPostRedisplay();
				return;
			}
			if (middlePointCheck(startX, startY)) {
				glutPassiveMotionFunc(mouseTracking);
				glutPostRedisplay();
				return;
			}
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				startX = currentX = lineList[0][numberOfLines] = lineList[0][k];
				startY = currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 1;
			numberOfLines++;
		}
		else if (fabs(startX-xPosition)>15.0 || fabs(startY-(YWindowSize - yPosition))>15.0) {
			currentX = xPosition;
			currentY = YWindowSize - yPosition;
			if ((k=VertexCheck(currentX, currentY)) >= 0) {
				currentX = lineList[0][numberOfLines] = lineList[0][k];
				currentY = lineList[1][numberOfLines] = lineList[1][k];
				Vertex[numberOfLines] = Vertex[k];
			}
			else {
				lineList[0][numberOfLines] = currentX;
				lineList[1][numberOfLines] = currentY;
				VP[0][vnum] = currentX;
				VP[1][vnum] = currentY;
				Vertex[numberOfLines] = vnum++;
			}
			swapBufferState = 0;
			numberOfLines++;
		}
		Degree(1, xPosition, YWindowSize - yPosition);
		glutPassiveMotionFunc(mouseTracking);
	}

	glutPostRedisplay();	
}

void menu(int value)
{
	int		k;
	double	x, y;

	if(value == DELETE && swapBufferState == 0) {
		k = numberOfLines-1;
		x = (lineList[0][k]+lineList[0][k-1])/2.0;
		y = (lineList[1][k]+lineList[1][k-1])/2.0;
		if (middlePointCheck(x, y)) {
			glutPassiveMotionFunc(mouseTracking);
			glutPostRedisplay();
		}
	}
	else if(value == CLEAR) {
		vnum = 1;
		numberOfLines = 0;
		swapBufferState = 0;
		lineStarted = 0;
		initmatrix();
		INDATA = 0;
		message[0] = '\0';
		startX = currentX = 0;
		startY = currentY = 0;
	}
	else if(value == QUIT) {
		exit(0); 
	}

	glutPostRedisplay();
}

void keyboard(unsigned char key, int xPosition, int yPosition)
/*x,y̓L[ꂽƂ̃}EXʒu */
{
	IF(27) { /* 0x1B */
		exit(0); 
	}

    switch (key) {
	case 'd':	/* Delete one edge */
		break;	
    default:
        break;
	}
	glutPostRedisplay();
}

void myGlutIdle( void )
{
  if ( glutGetWindow() != main_window ) 
    glutSetWindow(main_window);  
  glutPostRedisplay();
}

int					algotype=0;
GLUI_RadioGroup		*radio;
#define		PUSH_Judge	100
#define		PUSH_Det	101

void control_adjacency(int control)
{
	int		i, j, retcode;

	if(control!=PUSH_Det)
		return;

	if (numberOfLines == 0) {
		INDATA = 0;
		infile = NULL;
		if (strlen(filename) == 0) {
			sprintf(message, "Please input a graph by mouse tracking.");
			return;
		}
		if ((infile = fopen(filename, "r")) == NULL) {
			sprintf(message, "Can't open the file %s.", filename);	
			return;
		}
		else {
			strcpy(message,"OK !");
		}
		retcode = makegraphfromfile(infile);
		fclose(infile);
		infile = NULL;
		if (retcode == 0) {
			sprintf(message, "Please input a graph by mouse tracking.");
			return;
		}
		lineStarted = 1;
		glutinit();
		glutPostRedisplay();
	}
	
	if ((infile = fopen("INDATA.dat", "w")) == NULL)  {
		sprintf(message, "Can't open the file INDATA.dat");			
	}
	else {
		initmatrix();
		for (i = 1; i < numberOfLines; i += 2) 
			AMAT[Vertex[i-1]][Vertex[i]] = AMAT[Vertex[i]][Vertex[i-1]] = 1;
		printf("|V[G]| = %d\n", vnum-1);
		fprintf(infile, "%d\n", vnum-1);
		for (i = 1; i < vnum; i++) {
			fprintf(infile, "%d  ", i);
			for (j = 1; j < vnum; j++) {
				printf("%d ", AMAT[i][j]);
				if (AMAT[i][j] == 1)
					fprintf(infile, "%d ", j);
			}
			printf("\n");
			fprintf(infile, "0\n");
		}
		fprintf(infile, "0\n");
		fclose(infile);
		infile = NULL;
		fflush(stdout);
		INDATA = 1;
	}
}

void action(void)
{
	int		retcode;

	if (algotype==0)
		retcode = HopcroftTarjan();
	else
		retcode = triconnected(AMAT, vnum-1);

	message[0] = '\0';
	if (retcode == 0) {
		if (algotype == 0)
			sprintf(message, "This graph is nonplanar by Hopcroft-Tarjan algorithm.");
		else
			sprintf(message, "This graph has separation pairs.");
	}
	else if (retcode == 1) {
		if (algotype == 0)
			sprintf(message, "This graph is planar by Hopcroft-Tarjan algorithm.");
		else
			sprintf(message, "This graph is triconnected.");
	}
	else if (retcode == 2)
		sprintf(message, "This graph has separation points.");
	else if (retcode == 3)
		sprintf(message, "This graph is disconnected.");
	else
		sprintf(message, "*** ERROR. *** \n");
}

void control_judge(int control)
{
	if(control == PUSH_Judge) {
		if (numberOfLines == 0) {
			sprintf(message, "Please input a graph by mouse tracking.");
		}
		else if (INDATA) {
			action();
		}
		else
			sprintf(message, "Please determine the adjacency matrix.");
	}
}

int main(int argCount, char *argValues[])
{
	int		i;

	for (i = 0; i < MAXVTX; i++)
		D[i] = 0;
	initmatrix();
	INDATA = 0;

	glutInit(&argCount, argValues);
	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowPosition( XWindowPos, YWindowPos );
	glutInitWindowSize (XWindowSize, YWindowSize);
	main_window = glutCreateWindow(argValues[0]);
	glutReshapeFunc(resize);
	glutinit();
	/* Set up callback routines   */
	glutMouseFunc(strart_end_Tracking);
	glutPassiveMotionFunc(mouseTracking);
    glutKeyboardFunc(keyboard);
    glutCreateMenu(menu);

	glutAddMenuEntry("DELETE the last edge", DELETE);
	glutAddMenuEntry("-------------------------", DUMMY);
	glutAddMenuEntry("CLEAR", CLEAR);
	glutAddMenuEntry("-------------------------", DUMMY);
    glutAddMenuEntry("QUIT", QUIT);
	glutAttachMenu(GLUT_RIGHT_BUTTON);
	
	glutDisplayFunc(display);

  /////////////////////////////////////////////////////
  glui = GLUI_Master.create_glui("GRAPH",0,XWindowSize+50,50);
  glui->set_main_gfx_window(main_window);
  GLUI_Panel *obj_panel = glui->add_panel("INPUT A FILENAME");
  
  glui->add_edittext_to_panel(obj_panel,"KEYIN",GLUI_EDITTEXT_TEXT,filename);
	radio = glui->add_radiogroup_to_panel(obj_panel,&algotype);

  glui->add_separator();
  glui->add_radiobutton_to_group(radio, "Hopcroft-Tarjan");
  glui->add_radiobutton_to_group(radio, "Triconnected");
  glui->add_button("Judge", PUSH_Judge, control_judge);
  glui->add_separator();
  glui->add_button("Determine a graph", PUSH_Det, control_adjacency);
  glui->add_separator();
  glui->add_checkbox("Subdivide | Delete", &DVED);
  glui->add_separator();
  glui->add_checkbox("Number", &NUMON);
  glui->add_separator();
  glui->add_button("Quit", 0,(GLUI_Update_CB)exit);
  GLUI_Master.set_glutIdleFunc( myGlutIdle ); 
  /////////////////////////////////////////////////////

	glutMainLoop();
	return EXIT_SUCCESS;
}

