//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//
/* This program gives a wrong output of the following data:
12
1  2 3 4 10 12 0
2  1 3 6 7 12 0
3  1 2 4 5 6 0
4  1 3 5 9 10 0
5  3 4 6 8 9 0
6  2 3 5 7 8 0
7  2 6 8 11 12 0
8  5 6 7 9 11 0
9  4 5 8 10 11 0
10  1 4 9 11 12 0
11  7 8 9 10 12 0
12  1 2 7 10 11 0 0
*/

#include "stdafx.h"
#include <stdio.h>
#include <string.h>
#include "CPlanarity.h"

//////////////////////////
//KNX base_planarity
base_planarity::base_planarity(CGraph &g, int *VtxNo) //Defalut VtxNo=NULL
{
	/// CGraph o[ɒl ///
	nV = g.NumV();
	nE = g.NumE();
	AdjList = g.GetAdjList();

	///o[Ӑ///
	nSetsudan = 0;
	pg_no = -1;
	UsrNum = OutputNum = NULL;
	list = NULL;

	if(nV != G_EMPTY) {
		/// o͗p_ԍݒ ///
		UsrNum = new int[nV];

		if(VtxNo != NULL)
			for(int i = 0; i < nV; i++)	UsrNum[i] = VtxNo[i];
		else //default
			for(int i = 0; i < nV; i++)	UsrNum[i] = i+1;
	}
	STATUS = PG_PLANAR; //STATUS
}

base_planarity::~base_planarity()
{//̈̊J
	if(OutputNum != NULL)	delete[] OutputNum;
	if(UsrNum != NULL)		delete[] UsrNum;
	if(list != NULL)		delete[] list;
}

////////////////////////////////////////
///@n߂鏀
void base_planarity::Judge()
{
	int i;
	char buf[128];

	if(nV < 5 || nE < 9) { //|V|<5܂|E|<9͕̎ʓI
	}else if(nE > 3*nV-3 || (nV >= 3 && nE > 3*nV-6)){  // |E|>3|V|-3 ܂ |V|>=3 @3|E|>3|V|-6
		STATUS=PG_NONPLANAR;							// ͔̎񕽖ʓI
	} else {
		InitNumber(nV, true); ////NumberReNum̏
		Init();			//o[ϐ̏	//hNXInitĂ΂
		list=GetAdjList();	//אڃXg̍쐬

		///////Ǘ_T////////
		for(i = 0; i < nV; i++) {
			list[i].Sort(0);
			if(list[i].Num() == 0) {//אڒ_O̎
				nSetsudan++; //ؒf_P₷

				//////////////////Start Message////////////////////////
				sprintf(buf, "### No.(%d) bicomponent ###\n",nSetsudan);
				ms += buf;
				sprintf(buf,"%3d is isolated point\n", i+1);
				strcat(buf, "\n--> This Graph is Planar \n");
				ms += buf;
				////////////////// End  Message////////////////////////
			}
		}
		//////ʐ̔///////
		Testing();	//hNXTesting()Ă΂
	}
	Output();
}
////////////////////////////////////////
/// 茋ʏo͗p
void base_planarity::Output()
{
	char buf[128];

	if(STATUS==PG_PLANAR)
		sprintf(buf, "\n *** This graph is planar. (|V|=%d, |E|=%d) *** \n", nV, nE);
	else
		sprintf(buf, "\n *** This graph is nonplanar. (|V|=%d, |E|=%d) *** \n", nV, nE);

	ms += buf;
	if(Number!=NULL) {
		ms += "Preorder tree search ordering.\n";
		for(int i = 0; i < nV; i++) {
			sprintf(buf, "%d ", Number[i]+1);
			ms += buf;
		}
	}
}

////////////////////////////////////////////////////////////////////////////////
void plBundle::Push()
{//V쐬
	int v;
	if(bst == NULL) {
		v=0;
		bst = new StackPtr;
		bst->before;
	} else {
		v = IST->Pop();
		bst->next = new StackPtr;
		bst->next->before = bst;
		bst = bst->next;
	}
	bst->next=NULL;
	//ISTOST̍XV//
	IST = bst->ist = new CdList; bst->ist->Push(v);
	OST = bst->ost = new CdList;
}

void plBundle::Pop()
{
	if(bst->before != NULL) {
		delete IST; delete OST;
		bst = bst->before;
		delete bst->next;
		bst->next = NULL;
		IST = bst->ist; OST = bst->ost;
	} else {
		delete IST; delete OST;
		bst = NULL;
	}
}

void plBundle::UpDate(int Vi, int Vj, int s)
{
	int f = IST->Before();

	if(f == 0 || Vj < f || s <= Vj || Vi == s) 
		Push();
}

void plBundle::Swap()
{//BST.ISTBST.OSTꊷ
	CdList *temp;
	
	temp = OST;	OST = IST;	IST = temp;
	bst->ist=IST; bst->ost=OST;
}

////////////////////////////////////////////////////////////////////////////////
//destructor
CPlanarity::~CPlanarity()
{
	OutputNum = NULL;
	if(nV != G_EMPTY) {  //gp̈̊J
		if(LowPt1 != NULL)	delete[] LowPt1;
		if(LowPt2 != NULL)	delete[] LowPt2;
		if(tree   != NULL)  delete[] tree;
	}
}

void CPlanarity::Testing()
{
	OutputNum = UsrNum;
	DipthFirstSearch(0,0);
}

void CPlanarity::Init()
{
	////o[ϐ̏//////
	pg_PalamTreeNum = 0;	// ֐PalmTreeEdgNumEŎgp

	LowPt1 = new int[nV]; //̈̊m
	LowPt2 = new int[nV]; //̈̊m
	tree = new PalmTree[nE]; // "
}

//////////////////////////////////////////////////////
// [DT
void CPlanarity::DipthFirstSearch(int v, int u)
{
	pg_no++;
	
	Number[v] = pg_no;
	LowPt1[v] = pg_no;
	LowPt2[v] = pg_no;
	ReNum[pg_no]=v;
	
	while(list[v].Num()) { //list[v]̗vfOŖ

		int w = list[v].Pop();

		if(Number[w] == -1) {
			
			tree[pg_PalamTreeNum++].Set(v, w, PalmTree::TreeEdge);	//(v,w)؂̕ӂƂĔF

			DipthFirstSearch(w, v);//ċA

			if(LowPt1[v] > LowPt1[w]) {
				LowPt2[v] = LowPt1[v];  //LowPt2
				LowPt1[v] = LowPt1[w];  //LowPt1
			}
			if(LowPt2[v] > LowPt1[w] && LowPt1[v] != LowPt1[w])  //LowPt2
				LowPt2[v] = LowPt1[w];
			else if(LowPt2[v] > LowPt2[w])
				LowPt2[v] = LowPt2[w];
			
			if(LowPt1[w] >= Number[v]) { //_vؒf_łƂ
				nSetsudan++;		//ؒf_̐P₷
				embed(v, w);		//ؕЂ̖ߍ
				pg_no = Number[v];	//ȌAؒf_𖳎
			}
		} else {
			if(Number[w] < Number[v] && w != u) {
				tree[pg_PalamTreeNum++].Set(v,w,PalmTree::FrondEdge);	//(v,w)t̕ӂƂĔF
				if(LowPt1[v] > Number[w])  {
					LowPt2[v] = LowPt1[v]; //LowPt2
					LowPt1[v] = Number[w]; //LowPt1
				} else if(LowPt2[v] > Number[w])
					LowPt2[v] = Number[w];
			}
		}
	};
}

///////////////////////////////////////
// ߍ߂邩肷

void CPlanarity::embed(int v, int w)
{
	int Vcount, Ecount;
	char buf[128];
	
	CountVandE(v, w, Vcount, Ecount);

	if(Vcount < 5 || Ecount < 9) { //|V|<5܂|E|<9͕̎ʓI

		//////////   Start Message  //////////////////////
		sprintf(buf, "### No.(%d) bicomponent. (|V|=%d, |E|=%d) ###\n",nSetsudan, Vcount, Ecount);
		ms += buf;
		//////////   End   Message  //////////////////////

		PA = new PAList[Vcount];

		MakePA(v, w, Vcount);
		OutputPA(Vcount, Ecount);

		//////////   Start Message  //////////////////////
		ms += "--> This component is planar.(Because |V|<5 or |E|<9.)\n";
		//////////   End   Message  //////////////////////

		delete[] PA;
	}else if(Ecount > 3*Vcount-3 || (Vcount >= 3 && Ecount > 3*Vcount-6)){
		STATUS=PG_NONPLANAR;

		//////////   Start Message  //////////////////////
		sprintf(buf, "### No.(%d) bicomponent. (|V|=%d, |E|=%d) ###\n",nSetsudan, Vcount, Ecount);
		ms += buf;
		ms += "--> This component is nonplaar.(Because |E|>3|V|-3 or (|V|>= 3 , |E|>3|V|-6).)\n";
		//////////   End   Message  //////////////////////

	} else { //ߍ
		//the Porperly ordered Adjacency list ̍쐬
		PA = new PAList[Vcount];

		//////////   Start Message  //////////////////////
		sprintf(buf, "### No.(%d) bicomponent. (|V|=%d, |E|=%d) ###\n",nSetsudan, Vcount, Ecount);
		ms += buf;
		//////////   End   Message  //////////////////////

		MakePA(v, w, Vcount);
		OutputPA(Vcount, Ecount);

		//pX̍쐬
		path = new int[Vcount];
		nullity = Ecount-Vcount+1; // |E| - |V| + 1
		final = new int[nullity];

		PathFind(0, 1);

		//////////   Start Message  //////////////////////
		if(STATUS == PG_PLANAR)
			ms += "--> This component is planar.\n";
		else
			ms += "--> This component is nonplanar.\n";
		//////////   End   Message  //////////////////////

		delete[] PA;
		delete[] path;
		delete[] final;
	}
}

void CPlanarity::AddPA(int root, PalmTree &edge)
{
	PAList *now, *add;
	int v = edge.Vtx1(), w = edge.Vtx2();
	
	//VKXg̍쐬
	add = new PAList;
	add->vtx = Number[w]-Number[root];
	add->next = NULL;
	add->no = w;

	//((v,w))̌vZ
	if(edge.type == PalmTree::FrondEdge)	     //t̕ v->>w
		add->phi = 2*Number[w];
	else if(LowPt2[w] >= Number[v])//؂̕ v->w
		add->phi = 2*LowPt1[w];
	else // LowPt2[w] < Number[v] @؂̕  v->w
		add->phi = 2*LowPt1[w] + 1;

	//VXg}
	now = &PA[Number[v]-Number[root]];
	now->no = v;

	while(now->next != NULL && now->next->phi < add->phi)	
		now = now->next;

	if(now->next != NULL) {
		add->next = now->next;
		now->next = add;
	} else
		now->next = add;
}

void CPlanarity::MakePA(int v, int w, int Vcount) //Porperly ordered Adjacency list
{//v : ؕЂ̍, Vcount : ؕЂɑ钸_

	for(int i = 0; i < Vcount; i++)	//PȀ
		PA[i].next = NULL;

	AddPA(v, PalmTree(v, w, PalmTree::TreeEdge)); //(v,w)
	for(i = 0; i < nE; i++)
		if(tree[i].Vtx1() == v && tree[i].Vtx2() == w) {
			tree[i].type = PalmTree::NullEdge;
			break;
		}
	
	for(i = 0; i < nE; i++)	//PA̍쐬
		if(tree[i].type != PalmTree::NullEdge && Number[tree[i].Vtx1()] >= Number[w] && Number[tree[i].Vtx2()] >= Number[v]) {
			//܂ׂĂȂӂłؕЂɑ́i=w荂ӁjToAPAɉB
			AddPA(v, tree[i]);
			tree[i].type = PalmTree::NullEdge;
		}
}

void CPlanarity::CountVandE(int v, int w, int &Vcount, int &Ecount)
{//ؕЂɊ܂܂钸_̐ƁAӂ̐𐔂B
	Vcount = 2; Ecount = 1; //_v,wƕ(v,w)

	for(int i = 0; i < nE; i++)
		if(tree[i].type != PalmTree::NullEdge &&		//܂ׂĂȂ
			Number[tree[i].Vtx1()] >= Number[w] &&	//wȏ̓_n܂
			Number[tree[i].Vtx2()] >= Number[v] ){	//vȏ̓_ɂǂ蒅
			if(tree[i].type == PalmTree::TreeEdge)
				Vcount++;  //_̐؂̕ӂ̐{P
			Ecount++;
		}
}

void CPlanarity::PathFind(int v1, int flg = 0)
{//ŗpv1,w1͕`ؕЂƂ0,1,...ƕtĂ钸_ԍ
	static int s=-1, p=-1;
	char buf[128]; //o͗p

	if(flg){ //@eؕЂ𒲂ׂƂɂ͂߂ɂP񂾂Ă΂B
		s = -1; p = -1;
		path[0]=0;
	}

	while(PA[v1].next != NULL){

		int w1 = PA[v1].next->vtx;		//̒_
		int v  = PA[v1].no;				//o͂Ɏgp
		int w  = PA[v1].next->no;		//o͂Ɏgp
		
		//PA폜
		PAList *DelList = PA[v1].next;
		PA[v1].next = DelList->next;

		delete DelList;

		//////////////////////
		if(s == -1) {

			//////////   Start Message  //////////////////////
			sprintf(buf, "No.%2d Path :", p+2);
			ms += buf;
			//////////   End Message   ////////////////////////

			s = v1;
			p++;
		}

		if(v1 < w1) { //(v1,w1)؂̕
			if(STATUS == PG_NONPLANAR)
				return;

			//////////   Start Message  //////////////////////			
			sprintf(buf, "%d-",OutputNum[v]);
			ms += buf;
			//////////   End Message   ////////////////////////

			path[w1] = p;

			PathFind(w1);

			Stage1(v1);

			if(path[v1] != path[w1])  //v_łƂ
				Stage2(v1, w1);		//ivwŏɒʂ铹ႤƂj

		} else {  //(v1,w1)t̕(݂̓ꂽ)

			//////////   Start Message  //////////////////////
			sprintf(buf, "%d-%d\n",OutputNum[v], OutputNum[w]);
			ms += buf;
			//////////   End Message   ////////////////////////
			
			final[p] = w1; //pԖڂpath̏I_L^
			Stage3(v1, w1); //ߍ݉\ǂ̔

			if(STATUS == PG_NONPLANAR) return;

			if(s != v1)
				Base.Push(s);  //Stage6

			s=-1;
		}
	};
}

////////////////////////////////////////
///ʐi𖄂ߍގ菇j
void CPlanarity::Stage1(int v)
{//vȏ̒_BST.IST,BST.OST,BST폜
	while(BST.bst != NULL && (BST.IST->Num() == 0 || BST.IST->Start() >= v) && 
		(BST.OST->Num() == 0 || BST.OST->Start() >= v))
		BST.Pop();

//	if(BST.bst != NULL && BST.OST->Num() != 0 && BST.OST->Start() >= v)
//		BST.OST->Delete();

	while(BST.bst != NULL && BST.IST->Num() && BST.IST->Value() >= v)
		BST.IST->Pop();

	while(BST.bst != NULL && BST.OST->Num() && BST.OST->Value() >= v)
		BST.OST->Pop();

	if(BST.IST->Num() == 0)
		BST.Swap();

}

int CPlanarity::PathNo(int n, int min)
{
	for(int i = nullity-1; i>min ; i--) {
		if(final[i] == n)
			return i;
	}
	return -1;
}

void CPlanarity::Stage2(int v, int w)
{//(v,w)Ŏn܂ؕЂb̎c̕NĂȂׂB

	if(BST.OST->Num() == 0 || path[w] > PathNo(BST.OST->Value(), path[w]));
	//OɃpXAÕpXc̕ƌĂȂ
	 else {
		 BST.Swap();	//ƊO̓ւ
		 if(path[w] > PathNo(BST.OST->Value(), path[w]));
		 else {	//ƊOւĂ_
			STATUS = PG_NONPLANAR;
			return;
		 }
	 }
	 Base.Pop();
}

void CPlanarity::Stage3(int Vi, int Vj)
{//Aɖߍ߂邩肷B

	char buf[128];
	static int nPathNo; //o͗ppath̔ԍ

	if(BST.bst == NULL) { //Ԃ͂߁@--> ߍ݉\
		BST.Push();					//BST̒g쐬
		BST.IST->Push(Vj);			//Stage4 BST.IST̍XV

		//////////   Start Message  //////////////////////
		nPathNo=path[Vi]+1;
		sprintf(buf,"Please embed No.(%3d) path counterclockwisely.\n\n",nPathNo++);
		ms += buf;
		//////////   End   Message  //////////////////////

		return;
	}else if (Vj >= BST.IST->Value()) { // Vj < Vt < Vi 𖞂 Vt Ƃ -->ߍ݉\
		//////////   Start Message  //////////////////////
		sprintf(buf, "Please embed No.(%3d) path on the inside of the current cycle.\n\n", nPathNo++);
		ms += buf;
		//////////   End   Message  //////////////////////

		if(Vj != BST.IST->Value()) {	//Stage4 BST.ISTɃpX̏I_ȂƂBST.ISTXV
			BST.IST->Push(Vj);
			BST.UpDate(Vi, Vj,Base.Value());	//Stage5 ̍XV
		}
		return;

	}else { //̌
		if(BST.OST->Num() != 0 && BST.OST->Value() > Vj) {  //Ăߍݕs\

			//////////   Start Message  //////////////////////
			sprintf(buf, "!! No.(%d) path can not be embeded. !!\n", nPathNo++);
			ms += buf;
			//////////   End   Message  //////////////////////

			STATUS = PG_NONPLANAR;
			return;
		} else { 
			//̒inside outside邽߂̏
			BST.OST->Push(Vj);
			BST.Swap();

			//////////   Start Message  //////////////////////
			ms += "Please move paths on outside to inside, and if necessary,\n";
			sprintf(buf, "move some paths above the vertex (%3d)\n\n", OutputNum[Vi]);
			ms += buf;
			sprintf(buf, "Please embed No.(%3d) path on the inside of the current cycle.\n", nPathNo++);
			ms += buf;
			//////////   End   Message  //////////////////////
		}
	}
}

////////////////////////////////////////
/// 茋ʏo͗p
void CPlanarity::OutputPA(int Vcount, int Ecount)
{
	ms += "***** Properly Ordered Adjaceny List *****\n";

	char buf[128];
	PAList *now;
	int Enum = 0;

	for(int i = 0; i < Vcount; i++) {
		now = &PA[i];
		sprintf(buf, "%3d : ", OutputNum[now->no]);
		ms += buf;
		now = PA[i].next;
		while(now != NULL) {
			if(now->vtx > i) //؂̕
				sprintf(buf, "%3d  ", OutputNum[now->no]);
			else		//t̕
				sprintf(buf, "(%d) ", OutputNum[now->no]);

			ms += buf;
			now = now->next;
			Enum++;
		}
		ms += "\n";
		if(Enum >= Ecount) break;
	}
	ms += "\n";
}
////////////////////////////////////////////////////////////////////////////////
// class CPlanarity2

//ʐ̑O
void CPlanarity2::Init()
{
	Descendant = new int[nV];

	for(int i = 0; i < nV; i++) { //NumberS-1ŏ
		Number[i] = -1;
		Descendant[i] = 1;
	}

}

void CPlanarity2::Testing()
{
	//////[DTƕʐ̔///////
	SuccList = new CdList[nE];
	DFSdat dat = DipthFirstSearch(0,0);
	Stree.Set(dat.bt);
	PalmTreeEdge e = PalmTreeEdge(0,1);

	CalReNum();	//DFSŌvZꂽNumberReNum߂
	OutputNum = new int[nV];
	for(int i = 0; i < nV; i++)
		if(ReNum[i] != -1) {
			OutputNum[i] = UsrNum[ReNum[i]];
		}

	//////////   Start Message   ////////////////////////
	char buf[108];
	sprintf(buf, "### No.(%d) bicomponent ###\npath ",nSetsudan);
	ms += buf;
	//////////   End   Message   ////////////////////////

	comp_no = nSetsudan;
	ATT *att =	lplanar(e,0);
}
		
//////////////////////////////////////////////////////
// [DT
DFSdat CPlanarity2::DipthFirstSearch(int v, int u)
{
	pg_no++;
	
	Number[v] = pg_no;
	BaseTree *bt1=NULL,*bt2=NULL;
	DFSdat dat;
	dat.bt = NULL; dat.num=0;
	
	while(list[v].Num()) { //list[v]̗vfOŖ

		int w = list[v].Pop();

		if(Number[w] == -1) {

			dat = DipthFirstSearch(w, v);//ċA
			// if(bt1 == NULL && bt2 == NULL) ؂̕ӂ̐ɗt̕ӂȂƂ
			bt1 = Stree.Merge(bt1, dat.bt);
			Stree.Renew(bt1);
			SuccList[Number[v]].Push(Number[w]);
			Descendant[Number[v]] += dat.num;

			if(bt1->low1 >= Number[v])
				nSetsudan++;		//ؒf_̐P₷

		} else {//t̕
			if(Number[v] > Number[w] && w != u) {
				bt2 = Stree.BackEdge(Number[v], Number[w], nV);
				bt1 = Stree.Merge(bt1, bt2);
				bt2 = NULL;
				SuccList[Number[v]].Push(Number[w]);
			}
		}
	};
	dat.bt = bt1;
	dat.num = Descendant[Number[v]];
	return dat;
}

ATT* CPlanarity2::lplanar(PalmTreeEdge &e, int l)
{
	char *cc;

	//////////   Start Message   ////////////////////////
	cc = new char[100];
	sprintf(cc, "%d-",OutputNum[e.Tail()]);
	ms += cc; delete cc;
	//////////   End   Message   ////////////////////////

	if(e.IsBackEdge()) {//t̕
		//////////   Start Message   ////////////////////////
		cc = new char[100];
		sprintf(cc, "%d\n",OutputNum[e.Head()]);
		ms += cc; delete cc;
		//////////   End   Message   ////////////////////////

		ATT *att_=new ATT(e.Head());
		att_->BackEdge(e);
		return att_;
	}


	int N = SuccList[e.Head()].Num();
	int b = e.Head();
	if(N == 0) //ěp̐[
		return NULL;
	
	PalmTreeEdge *e1, *ei, *ej;	//1,i,jԖڂ̌p

	PTEList Elst;	//ěp̃XgAe0,...,ek-1ŁA
	Elst.Succ(e, SuccList[b]);	//head̑ŗ^AA'delete'󂪂Ȃ

	BaseTree **tree; 
	tree = new BaseTree * [N];
	int i;
	for(i = 0; i < N; i++) {//tree(e0),...,tree(ek-1)ɕ
		ei = &Elst.edge[i];
		tree[i] = Stree.Split(*ei, Descendant[ei->Head()]);
		ei->tree = tree[i];
		Elst.SetLow(i, tree[i]->low1, tree[i]->low2);
	}

	e1=Elst.HeapSort();//low1̒lɊÂāAe0,...,ek-1heapɑgDA
	Elst.DeleteEi();	//top̕ӂe0ƂAe0heap폜
	ATT *atte = lplanar(*e1,l);	//e1ċAIɌvZ
	if(atte == NULL)	return NULL;	//nonplanar

	//////////   Start Message   ////////////////////////
	cc = e1->Output(OutputNum, nV);
	ms += cc; delete[] cc;
	cc = atte->Output(OutputNum);
	ms += cc; delete[] cc;
	//////////   End   Message   ////////////////////////

	atte->DelOccur(b);	//e1Ɍb폜

	int j = 0;i = 1; 
	ATT *atti;
//	int h1, h2, h3=0;
	ej=e1;
	
	while(Elst.Num > 0) { //HeapłȂ
//		atte->Get(l, h1, h2, h3);
		ei=Elst.HeapSort();
		if(ei->low1>=b){//ʁXɔ肵ĂǂꂽB
			//////////   Start Message  //////////////////////
			char buf[108];
			sprintf(buf, "### No.(%d) bicomponent ###\npath ",++comp_no);
			ms += buf;
			//////////   End   Message  //////////////////////

			nSetsudan++;
			lplanar(*ei,b);
			Elst.DeleteEi();

			//////////   Start Message  //////////////////////
			if(STATUS == PG_PLANAR) {
				ms += "\n--> This component is planar.\n";
				sprintf(buf, "### Returen  No.(%d) bicomponent###\n", --comp_no);
				ms += buf;
			}
			else
				ms += "--> This component is nonplanar.\n";
			//////////   End   Message  //////////////////////

		}
/*
		else if(j == 0 && ei->low1 < h2 || // Condition AA
				  ej->low1 < ei->low1 && ei->low1 < h2 ||
				  ej->low1 < ei->low1 && ei->low1 < (h3 < l ? h3 : l)) {
			Stree.Delete(ei->tree, ei->low1);
			if(ei->tree->flg == DELETED){
				Elst.DeleteEi();
			}
			Stree.Modify();
			while(ei->tree->low1 == v) Stree.Delete(ei->tree, v);
		} else if(ei->low2 < b && ei->low1 < h2 ||  // Condtion BB
			      ei->low2 < b && e1->low1 < ei->low1 && ei->low1 < (h3 < l ? h3 : l) ||
				  ei->low2<l && ei->low1 < h3){
			Stree.Delete(ei->tree, ei->low2);

		}
*/
		else {
			//////////   Start Message   ////////////////////////
			ms += "path ";
			//////////   End   Message   ////////////////////////

			Elst.DeleteEi();
			atti=lplanar(*ei, e.Head()); //att(ei)ċAIɋ߂
			if(atti == NULL)	return NULL;
	
			//////////   Start Message  //////////////////////
			cc = ei->Output(OutputNum, nV);
			ms += cc; delete[] cc;

			cc = atti->Output(OutputNum);
			ms += cc; delete[] cc;
			//////////   End   Message  //////////////////////
			
			atti->DelOccur(e.Head());	//att(ei)̍ŌɌb폜B
			if(atti->Merge() == false){	//Xebv2 att(ei)̃ubNP̃ubNɍB
				STATUS = PG_NONPLANAR;
				delete atti;	return NULL;
			}
			if(i == 1) {			//Xebv3sB
				if(atte->Merge(ei->low2) == false) {
					STATUS = PG_NONPLANAR;
					delete atti;	return NULL;
				}
			}
			atte->Merge(atti);	//Xebv4' att(e)att(ei)B
			delete atti;
			i++;
		}
	}
	delete tree;
	return atte;
}


////////////////////////////////////////////////////////////////////////
/////  Class Selection Tree 's member functions
SelectionTree::~SelectionTree()
{
	if(tree == NULL) return;
	Delete(&tree);
}

void SelectionTree::Delete(BaseTree **node)
{
	if((*node)->lchild != NULL)
		Delete(&(*node)->lchild);
	if((*node)->rchild != NULL)
		Delete(&(*node)->rchild);

	delete *node;
	*node = NULL;
}
BaseTree* SelectionTree::Merge(BaseTree *r1, BaseTree *r2)
{//r1 <= r2
	if(r1 == NULL)
		return r2;
	else if (r2 == NULL)
		return r1;
	else if (r1->rb > r2->rb || r1->rb == r2->rb && r1->low1 > r2->low1) //r1 > r2 ̎
		return Merge(r2, r1);
	else {
		BaseTree *r = new BaseTree;
		r->flg = UNDELETED;
		r->lchild = r1;
		r->rchild = r2;
		r->lb = r1->lb;
		r->rb = r2->rb;
		r->low1 = ((r1->low1 < r2->low1) ? r1->low1 : r2->low1);
		if(r1->low1 == r2->low1)
			r->low2 = ((r1->low2 < r2->low2) ? r1->low2 : r2->low2);
		else if(r->low1 == r1->low1)
			r->low2 = ((r1->low2 < r2->low1) ? r1->low2 : r2->low1);
		else
			r->low2 = ((r1->low1 < r2->low2) ? r1->low1 : r2->low2);
		return r;
	}
}

void SelectionTree::Renew(BaseTree *r)
{//݂̖؂r؂
	BaseTree *bt;
	bt = Merge(tree, r);
	tree = r;
}

BaseTree* SelectionTree::Split(BaseTree *r, int v, int ux)
{
	if(ux < r->lb)
		return NULL;
	else if(ux >= r->rb && v <= r->lb)
		return r;
	else {
		if(ux <= r->lchild->rb)
			return Split(r->lchild, v, ux);
		else
			return Split(r->rchild, v, ux);
	}
}

BaseTree* SelectionTree::Split(PalmTreeEdge e, int ni)
{
	if(e.IsTreeEdge())	return Split(tree, e.Head(), e.Head()+ni-1);
	else	return Split(tree, e.Head(), e.Tail());
}
/*
BaseTree* SelectionTree::Delete(BaseTree *r, int v)
{
	if(r->lchild == NULL) {//Tree̖[̈Back EdgełB
		delete r;//t̕ӂ
		return NULL;
	} else {
		BaseTree *lchild = r->lchild, *rchild = r->rchild;
		if(v == lchild->low1 || v == lchild->low2 )
			return Merge(Delete(lchild,v), rchild);
		else
			return Merge(lchild, Delete(rchild,v));
	}
}
*/
/*
void SelectionTree::Delete(BaseTree *r, int v)
{
	if(r->lchild == NULL) {
		r->flg = DELETED;
	} else {
		if(r->lchild->low1 == v || r->lchild->low2 == v)
			Delete(r->lchild, v);	
		if(r->rchild->low1 == v || r->rchild->low2 == v)
			Delete(r->rchild);
		if(r->lchild->flg == DELETED && r->rchild->flg == DELETED)
			r->flg = DELETED;
	}
}
*/
BaseTree* SelectionTree::BackEdge(int x, int y, int n)
{
	BaseTree *r = new BaseTree;
	r->lb = r->rb = x;
	r->lchild = r->rchild = NULL;
	r->low1 = y;
	r->low2 = n;
	r->flg = UNDELETED;
	return r;
}
////////////////////////////////////////////////////////////////////////
/////  Class ATT 's member functions

int ATT::LastX()
{//X,Y att̂ƂgƂBlast(X)ԂB
	if(att->lchild->Num() == 0)	return -1;
	else return att->lchild->Value();
}

int ATT::LastY()
{//X,Y att̂ƂgƂBlast(Y)ԂB
	if(att->rchild->Num() == 0)	return -1;
	else return att->rchild->Value();
}

int ATT::FirstX()
{//X,Y att̂ƂgƂBfirst(X)ԂB
	if(att->lchild->Num() == 0)	return -1;
	else 	return att->lchild->Start();
}

int ATT::FirstY()
{//X,Y att̂ƂgƂBfirst(Y)ԂB
	if(att->rchild->Num() == 0)	return -1;
	else 	return att->rchild->Start();
}

void ATT::BackEdge(PalmTreeEdge e)
{//t̕ӂatt[[[b][]]]쐬
	if(att != NULL)
		return;
	CdList *l, *r;
	att = new ATTbase;
	l = new CdList;	l->Push(e.Head());
	r = new CdList;
	att->lchild = l; att->rchild = r;
	att->next = att->before = NULL;
}

void ATT::DelOccur(int b)
{//ATT̍Ō̑g݂bΎ菜
	if(LastX() == b)
		att->lchild->Pop();
	if(LastY() == b)
		att->rchild->Pop();

	if(LastX() == -1 && LastY() == -1)
		Pop();

	if(LastX() < LastY())
		Swap();
}
/*
void ATT::Get(int l, int &h1, int &h2, int &h3)
{// h1={last(U):[U,Z]atti},h2={last(Z):[U,Z]atti},
 //	h3={last(Z):Zattil-nomal block}
	h1 = LastX(); h2 = LastY();
	if(att->before != NULL && FirstX() < l && LastX() > LastY())//singular łȂ
		h3 = LastX();
	else if(att->before != NULL && FirstY() < l && LastX() < LastY())
		h3 = LastY();
}
*/
void ATT::Swap()
{//[[X][Y]]  last(X) < last(Y) ̎AXYꊷ
	if(LastX() < LastY()) {
		CdList *temp;
		temp = att->lchild; att->lchild = att->rchild; att->rchild = temp;
	}
}

bool ATT::Interlace(int x, int y)
{
	return (x > y) ? true : false;
}

void ATT::Push(CdList *l, CdList *r)
{
	ATTbase *new1 = new ATTbase;	//̈m
	new1->lchild = l;	new1->rchild = r;	//l̑
	new1->next = NULL;
	att->next = new1;	//|C^ݒ
	att=att->next;		//|C^i߂
}

void ATT::Push(ATT *add)
{//݂att̍ŌaddȂ
	att->next = add->att;
	add->att->before = att;
	att = att->next;
}

bool ATT::Merge(ATT *add)
{//݂ATT̍Ōaddt
	if(Interlace(LastY(), add->FirstX())) //last(Y) > first(D) ̎ߍ߂Ȃ
		return false;
	else if(Interlace(LastX(), add->FirstX())){//last(X) > first(D)̎YD
		att->rchild->Merge(add->att->lchild);
		if(LastX() < LastY()) {
			CdList *tmp;
			tmp = att->lchild; att->lchild = att->rchild; att->lchild = tmp;
		}
	}else	//ȊO݂͌ATT̍Ōaddt
		Push(add);
	return true;
}

void ATT::Pop()
{
	att = att->before;
	att->lchild->Merge(att->next->lchild);
	att->rchild->Merge(att->next->rchild);  //??
	delete att->next;
	att->next=NULL;
}
bool ATT::Merge()//STEP2
{//att(ei)ubNBiɍB
 //att(ei)nomalubNinterlace΁A񕽖ʓIłB 
	while(att->before != NULL){
		if(att->rchild->Num() != 0 && att->rchild->Value() > low1)
			return false;	//nomalubNinterlace!
		Pop();
	}
	return true;
}

bool ATT::Merge(int low2)//STEP3
{//att(e)̃ubNlast(D)>low1(e2)łubNB
 //att(e)nomalubNinterlace΁A񕽖ʓIłB 
	while(att->before != NULL && att->before->lchild->Value() > low2){
		if(att->rchild->Num() != 0 && att->rchild->Value() > low1)
			return false;	//nomalubNinterlace!
		Pop();
	}
	return true;
}

char *ATT::Output(int *Renum)
{
	char *cc, buf[128];
	int *vtx, num, i;
	cc = new char[512];
	strcpy(cc, "   att(e) = [ [ [ ");

	while(att->before != NULL)	att = att->before;

	while(1) {
		num = att->lchild->Num();
		if(num == 0)
			strcat(cc, "] ");	//͂
		else {
			vtx = att->lchild->ToArray();
			for( i = 0; i < num; i++) {
				sprintf(buf, "%d ", Renum[vtx[i]]);
				strcat(cc, buf);
			}
			strcat(cc, "] ");
		}
		strcat(cc, "[ ");
		num = att->rchild->Num();
		if(num == 0)
			strcat(cc, "] ");
		else {
			vtx = att->rchild->ToArray();
			for( i = 0; i < num; i++) {
				sprintf(buf, "%d ", Renum[vtx[i]]);
				strcat(cc, buf);
			}
			strcat(cc, "] ");
		}
		if(att->next ==NULL) {
			strcat(cc ,"] ]\n");
			return cc;
		}
		strcat(cc, "] [ [ ");
		att=att->next;
	}
}
////////////////////////////////////////////////////////////////////////
/////  Class PTEList 's member functions
void PTEList::Succ(PalmTreeEdge &e, CdList &list)
{//p̃Xg쐬
	if(edge != NULL)
		delete edge;
	N = list.Num();
	Num = N; //for Heap Sort
	edge = new PalmTreeEdge[N];

	list.Sort();//head\[g
	for(int i = 0; i < N; i++)
		edge[N-i-1].Set(e.Head(), list.Pop());
}

void PTEList::Exchange(PalmTreeEdge &e1, PalmTreeEdge &e2)
{
	PalmTreeEdge temp;
	temp = e1; e1 = e2; e2 = temp;
}

void PTEList::Heapify(int i, int j)
{
	if(i*2+1 <= j) {// 'i' has both left and right childen
		if(edge[2*i-1].low1 < edge[2*i].low1) {
			if(edge[2*i-1].low1 < edge[i-1].low1) {
				Exchange(edge[2*i-1],edge[i-1]);
				Heapify(2*i, j);
			}
		} else {
			if(edge[2*i].low1 < edge[i-1].low1) {
				Exchange(edge[2*i],edge[i-1]);
				Heapify(2*i+1, j);
			}
		}
	} else if(2*i == j){ // 'i' has only left child
		if(edge[2*i-1].low1 < edge[i-1].low1) {
			Exchange(edge[2*i-1],edge[i-1]);
			Heapify(2*i, j);
		}
	}
}

void PTEList::BuildHeap()
{
	for(int i = Num/2; i >= 1; i--)
		Heapify(i, Num);
}

PalmTreeEdge* PTEList::HeapSort()
{
	if(Num <= 1){ //c̃f[^P̎
		return &edge[0];
	}
	else if(N == Num) {
		BuildHeap();
		Exchange(edge[0], edge[Num-1]);
	} else {
		Heapify(1, Num);
		Exchange(edge[0], edge[Num-1]);
	}
	return &edge[Num-1];
}

void PTEList::DeleteEi()
{
	Num--;
}

void PTEList::SetLow(int i, int l1, int l2)
{	
	if(edge==NULL)return;
	edge[i].SetLow(l1,l2);
}
/////////////////////////////////////////////////////////////////////////////////////
char *PalmTreeEdge::Output(int *num, int max)
{
	char		*buf;

	buf = new char[100];
	if(low2 < max) {	//Tree Edge
		sprintf(buf, " e=(%2d, %2d) low1=%d, low2=%d\n", num[u], num[v], num[low1],num[low2]);
	}
	else {
		sprintf(buf, " e=(%2d, %2d) low1=%d, low2=|V|+1\n",num[u], num[v], num[low1]);
	}

	return buf;
}

/*/////////////////////////////////////////////////////////////////////////////////////
SplitData SelectionTree::Split(BaseTree *r, int ux)
{
	SplitData dat;
	if(ux < r->lb) {
		dat.lchild = NULL; dat.rchild = r;
	} else if(ux >= r->rb) {
		dat.lchild = r; dat.rchild = NULL;
	} else {
		dat.lchild = r->lchild; dat.rchild = r->rchild;
		if(ux < dat.lchild->rb) {
			dat = Split(dat.lchild, ux);
			dat.rchild = Merge(dat.rchild, r->rchild);
		} else {
			dat = Split(dat.rchild, ux);
			dat.lchild = Merge(r->lchild, dat.lchild);
		}
	}
	return dat;
}

*/