//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//

/****************************************************************

   ######################################################
   #  Ot̕ʐNX  CPlanarity				#
   #						 by Chihiro Taninaka		#
   ######################################################

 @̃NX́A_Ɨאڍs^ꂽƂɁA
 ̃OtʓIǂ肷B
 ʓIł̂Ȃ΁AOHĂB

  ͂́AOt̒_Ɨאڍs񂪓CGraphƁA
o͗p̒_ԍzB̔z͖ꍇA
Iɒ_1,2,3,.....NƂȂB

  vZׂ͂Ē_0,1,2,...,N-1ƂĎn܂A
ɁA[DTɂNumber^B

		Efficent Planarity Testing
			John Hopcroft and Robart Tarjan
 Journal of the Association for Computing Machinery
 Vol. 24, No.4 Oct. 1974 549-568
****************************************************************/

#ifndef __CPLANAR_GRAPH_H__
#define __CPLANAR_GRAPH_H__

#include "..\CGraph\CGraph.h"
#include "..\Tools\CList.h"
#include "..\Tools\Matrix.h"

#include <string>
using namespace std;
////////////////////////////////////////////////////////////////////
//ʐKNX
//---------------2ނ̔@̋ʕ---------
class base_planarity : public CGraph, public CalNumber{
protected:
	enum {PG_PLANAR, PG_NONPLANAR, PG_OUT_NOT_FOUND, PG_OUT_FOUND};
	int			STATUS;		//ԁiʓIA񕽖ʓIj
	int			nSetsudan;	//ؒf_̐	
	int			*OutputNum;	//o͗p_ԍ
	int			*UsrNum;	//͂ԍ

	CrList		*list; //אڃXg@[U`̒_ԍp
	int pg_no;				// ֐DipthFirstSearchŎgp

public:
	string		ms;			//茋

	bool IsPlanar(){return (STATUS == PG_PLANAR)? true : false;}//ʓIǂ
	bool IsBiConnected(){return (nSetsudan == 0) ? true:false;}	//Aǂ

protected:
	base_planarity(CGraph &, int * = NULL);	//constructor
	~base_planarity();						//destructor
	void	Output();			//o͗p
	void	Judge();			//Ǘ_TAdfssB
	virtual void Testing(){}
	virtual void Init(){};

};


////////////////////////////////////////////////////////////////////
//ʐNX ̂P
//
typedef struct _palist {  //properly ordered adjacency list (^̗אڃXg)
	int vtx, no;
	int phi;
	_palist *next;
}PAList;

class PalmTree : public Edge{ //Palm tree (q̖)
public:
	enum {TreeEdge, FrondEdge, NullEdge};
	int type;
	PalmTree(){ type=NullEdge;}
	PalmTree(int a, int b, int t=NullEdge){u=a; v=b; type=t;}
	void Set(int a, int b, int t=NullEdge){u=a; v=b; type=t;}
};

class StackPtr {//bundlepoXg
	CdList *ist, *ost;
	StackPtr *next, *before;
	StackPtr(){
		next=before=NULL; ist=ost=NULL;
	}
	friend class plBundle;
};

class plBundle {
public:
	StackPtr *bst;
	CdList *IST, *OST;

public:
	plBundle(){	bst = NULL;	}
	void Push();
	void Pop();
	void Swap();
	void UpDate(int, int, int);
};

class CPlanarity : public base_planarity {
public:
	PAList		*PA;   //^̗אڃXg@Dipth First Search ɂĒ߂Numberp
	PalmTree	*tree; //؂𐶐ӂ̏@[U`̒_ԍp
	int			*LowPt1, *LowPt2;
	int			*path;
	int			*final;
	CdList		Base;
	plBundle	BST;
	int			nullity;	//ׂĂR|[lg̗t̕Ӑ

public:
	CPlanarity(CGraph &g, int *n = NULL):base_planarity(g,n)
	{LowPt1=LowPt2=path=final=NULL; tree=NULL; PA=NULL;Judge();};			//constructor
	~CPlanarity();		//destructor

private:
	int pg_PalamTreeNum;	// ֐PalmTreeEdgNumEŎgp

protected:
	virtual void	Init();			//o[ϐ̏B
	virtual void Testing();

	///ʐ̏///
	void	PalmTreeEdgeIs(int, int, const int);
	void	DipthFirstSearch(int, int);
	void	embed(int,int);					//ߍ݂n߂B
	void	MakePA(int, int, int);			//PAXg쐬
	void	AddPA(int, PalmTree &);			//MakePAŎgB

	void	CountVandE(int, int, int &, int &);  //ؕЂ̒_Aӂ̐𒲂ׂ
	void	PathFind(int, int);				//ߍޓ

	////o͗p////
	void	OutputPA(int, int);

	///ʐ///
	void	Stage1(int);
	void	Stage2(int, int);
	void	Stage3(int, int);
	int		PathNo(int, int);	//Stage2
};

/****************************************************************

   #####################################################
   #  ɑ啽ʓIOt߂NX  CPlanarity2  #
   #						 by Chihiro Taninaka       #
   #####################################################

 @̃NX́A_Ɨאڍs^ꂽƂɁA
 ̃OtʓIǂ肷B
 ʓIłȂ΁AOHB

  ͂́AOt̒_Ɨאڍs񂪓CGraphƁA
o͗p̒_ԍzB̔z͖ꍇA
Iɒ_1,2,3,.....NƂȂB
@茋ʂMFCpɂCString msɁAMs-Dospɂ
char ms[2048];ɔ[߂ĂB

  vZׂ͂Ē_0,1,2,...,N-1ƂĎn܂A
ɁA[DTɂNumber^B

  AN O(m log n)-TIME ALGORITHM FOR THE MAXIMAL PLANAR SUBGRAPH
   JIAZHEN CAI, XIAOFENG HAN, AND ROBERT E. TRAJAN
****************************************************************/
const int UNDELETED = 1000;
const int DELETED = -1000;

class BaseTree
{
public:
	int flg;
	int lb; //lb=min{x:[x,y]Sw}
	int rb; //lb=max{x:[x,y]Sw}
	int low1, low2;
	BaseTree *lchild, *rchild;
};

////////////////////////////////////////////////////////////////////
class PalmTreeEdge : public DirectedEdge{
public:
	int low1, low2;
	BaseTree *tree;

public:
	PalmTreeEdge(){u=v=-1;};	//Default constructer
	PalmTreeEdge(int a, int b):DirectedEdge(a,b){};	//(a,b)쐬

	void SetLow(int x1, int x2){low1=x1; low2=x2;};
	char *Output(int *, int);
};

class PTEList{
	int N;

public:
	PalmTreeEdge *edge;
	int Num;
	PTEList(){edge=NULL; N=Num=0;};

	void Succ(PalmTreeEdge &, CdList &);
	void Exchange(PalmTreeEdge &, PalmTreeEdge &); //ւ
	void Heapify(int, int);	//Heap Sort
	void BuildHeap();		//Heap Sort
	PalmTreeEdge* HeapSort();	//Heap Sort
	void DeleteEi();
	void SetLow(int, int, int);
};
////////////////////////////////////////////////////////////////////
class ATTbase {//attachment
	CdList *lchild, *rchild;
	ATTbase *next, *before;
	friend class ATT;
};

class ATT{
	ATTbase *att;
	int low1;

public:	
	ATT(int x){low1 = x; att=NULL;};
	void Swap();
	void DelOccur(int);			//b폜
//	void Get(int,int &,int &,int &);	//h1,h2,h3߂	//ɑ啽ʓIOtp
	bool Interlace(int x,int y);//X,YinterlaceĂ邩
	void Push(CdList *, CdList *);//
	void Push(ATT *);
	void Pop();
	bool Merge(ATT *); //attiatteȂ
	bool Merge();		//STEP2̍
	bool Merge(int);	//STEP3̍
	void BackEdge(PalmTreeEdge);	//t̕ӂatt[[[b][]]]쐬
	int	 FirstX(), FirstY(), LastX(), LastY();
	char *Output(int *);
};

////////////////////////////////////////////////////////////////////

class SelectionTree
{
public:
	BaseTree *tree;
	SelectionTree(){tree=NULL;};
	SelectionTree(BaseTree *t){tree = t;};
	~SelectionTree();

	void Set(BaseTree *t){tree=t;};
	void Delete(BaseTree **);

	BaseTree* Merge(BaseTree *, BaseTree *);
	void Renew(BaseTree *);
	BaseTree* Split(BaseTree *, int, int);
	BaseTree* Split(PalmTreeEdge e, int);
	BaseTree* Delete(BaseTree *, int);
	BaseTree* BackEdge(int, int, int);
};
////////////////////////////////////////////////////////////////////
typedef struct {
	BaseTree* bt;
	int num;
}DFSdat;

////////////////////////////////////////////////////////////////////
class CPlanarity2 : public base_planarity{

public:
	CdList		*SuccList;	//pXg
	SelectionTree Stree;
	int			*Descendant;	//q̐

public:
	CPlanarity2(CGraph &g, int *n = NULL):base_planarity(g,n)
	{Descendant = NULL; Judge();}	//constructor
	~CPlanarity2()
	{if(Descendant != NULL) delete Descendant;}		//destructor

protected:
	int		comp_no;
	virtual void	Init();			//o[ϐ̏
	virtual void	Testing();		//ʐ

	///ʐ̏///
	void	PalmTreeEdgeIs(int, int, const int);
	DFSdat	DipthFirstSearch(int, int);
	void	embed(int,int);					//ߍ݂n߂B
	void	CountVandE(int, int, int &, int &);  //ؕЂ̒_Aӂ̐𒲂ׂ
	void	PathFind(int, int);				//ߍޓ

	////o͗p////
	void	OutputATT(int, int);

	///ʐ///
	ATT*	lplanar(PalmTreeEdge &, int);

};


#endif