//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//
////////////////////////////////////////
// Class CPlaneGraph
//       by Chihiro Taninaka
#include "stdafx.h"
#include <math.h>
#include <stdlib.h>

#include "CPlaneGraph.h"

void CPlaneGraph::InitMember()
{//oӐ
	jisu = out = NULL;
	xy = NULL; nF = G_EMPTY; pColor = NULL; face = NULL;
	DrawFlg = CannotDraw;
}

void CPlaneGraph::DeleteMember()
{//oӐ폜
		if(jisu != NULL)	delete[] jisu;
		if(out != NULL)		delete[] out;
		if(face != NULL)	delete[] face;	
		if(xy != NULL)		delete[] xy;
		if(pColor!= NULL)	delete[] pColor;
		InitMember();
}

void CPlaneGraph::Init(CGraph &graph, int *outer, int num)
{//(public֐)
	if(nV != G_EMPTY)	DeleteMember();

	//Ot̏
	nV = graph.NumV();				//_
	nE = graph.NumE();				//Ӑ
	AdjList = graph.GetAdjList();	//אڃXg
	AdjMat = CGraph::GetAdjMat();	//אڍs쐬
	InitMember();					//oϐ
	Begin(outer, num);				//vZJn
}

void CPlaneGraph::Begin(int *outer, int num)
{	int i,j;						//JE^[

	//OH̐ݒBw肳ĂȂΒTB
	if(outer != NULL && num < 3)			//̏񂪂B
		return;
	else if(outer == NULL) {				//OH񂪂Ȃ͊OH߂B
		if(SearchFacialCycle() == false)	//OH߂Ȃ͏IB
			return;
	} else {								//OHw肳ꂽB
		r = num;			//O_
		out = new int[r];	//OHۑpz̊m
		for(i = 0; i < num; i++)
			out[i]=outer[i];
	}
	DrawFlg = DrawOnly;	//Ot͕`\łB
	
	///o͗p_ԍ̐ݒ///
	ReNum = new int[nV]; //X̒_LB
	int *temp = new int[nV]; //Ɨp

	for(i = 0; i < nV; i++)	temp[i]=1;

	for(i = 0; i < r; i++) {
		ReNum[i] = out[i];
		temp[out[i]] = 0;
	}

	for(j = 0; j < nV; j++)
		if(temp[j]) 
			ReNum[i++]=j;


	//אڍs̏
	int *mtx1 = AdjMat.to_array();
	int *mtx2 = new int[nV*nV];
	int k;

	//s̓ꂩ
	for(i = 0; i < nV; i++)	temp[i]=1;

	for(i = 0; i < r; i++) {
		for(j = 0; j < nV; j++) {
			mtx2[i*nV+j] = mtx1[out[i]*nV+j];
		}
		temp[out[i]] = 0;
	}

	k=i;
	for(i = 0 ; i < nV ; i++)
		if(temp[i]) {
			for(j = 0; j < nV; j++)
				mtx2[k*nV+j] = mtx1[i*nV+j];
			k++;
		}

	//̓ꂩ
	for(i = 0; i < nV; i++)
		temp[i]=1;

	for(i = 0; i < r; i++) {
		for(j = 0; j < nV; j++) {
			mtx1[i+nV*j] = mtx2[out[i]+nV*j];
		}
		temp[out[i]] = 0;
	}
	
	k = i;
	for(i = 0 ; i < nV ; i++)
		if(temp[i]) {
			for(j = 0; j < nV; j++)
				mtx1[k+nV*j] = mtx2[i+nV*j];
			k++;
		}

	AdjMat = iMatrix(nV, nV, mtx1);
	delete[] temp;
	delete[] mtx1;
	delete[] mtx2;

	InitDrawGraph();
	return;
}

//mainɂȂ֐
bool CPlaneGraph::InitDrawGraph(int flg /* = 1*/)
{//_Aאڍs񂪂킩Ă邱

	if(nV == G_EMPTY)	return false;
	if(out == NULL) {
		if(SearchFacialCycle() == false)
			return false;
	}
	if(flg)
		jisu = GetDegree();//count_jisu();	//߂

	Matrix A(nV-r, nV-r); // (nV-r)*(nV-r)̎s
	Matrix B(nV-r, r);   // (nV-r)*r̎s

	Get_Mat_AB(A, B);   //@אڍsA,B߂

	Matrix E(nV-r, "E"); //Pʍs̐
	E = E - A;
	A = E.inverse();

	if(flg)
		xy = new double[nV][2];

	Get_Mat_xy();
	Get_Maltiple(A, B);

	if(flg) {  //ʂ\钸_([U`̔ԍ)͕sςł̂łPx쐬
		if(Makeface()) //ʂ쐬i͌vZ̒_ԍgpj
			DrawFlg = Perfect;	//ʂ̔FłB

		Number = new int[nV];  //Numbeȑ쐬
		for(int i = 0; i < nV; i++)
			Number[ReNum[i]]=i;

		if(DrawFlg == Perfect)
			for(int i = 0; i < nF; i++) {  //_̔ԍ[U`̔ԍɒ
				int Fvtx = face[i].Num();
				for(int j = 0; j < Fvtx; j++) {
					face[i].Set(ReNum[face[i].Value()]);
					face[i].GoNext();
				}
			}
	}
	return true;
}

/////////////////////////////////////////////////
//אڍsOtœK`悷

void CPlaneGraph::Get_Mat_AB(Matrix &A, Matrix &B)
{//sA,B̍쐬
	int i,j;

	for(i=r;i<nV;i++) {
		for(j=r;j<nV;j++)
			A.equal(i-r,j-r,(double)AdjMat.youso(i,j) / jisu[ReNum[i]]);
		for(j=0;j<r;j++)
			B.equal(i-r,j,(double)AdjMat.youso(i,j) / jisu[ReNum[i]]);
	}
}

void CPlaneGraph::Get_Mat_xy()
{//O_Pʉ~ɔvɔzu
	int i;
	double rad,th;

	rad = 360.0 / r;

	for(i=0;i<r;i++){ //O_Pʉ~(0,1)zu
		th = 90 + i*rad; //vɐi
		xy[i][0] = cos(th*PI/180.0);
		xy[i][1] = sin(th*PI/180.0);
	}
}

void CPlaneGraph::Get_Maltiple(Matrix &A, Matrix &B)
{//ϊs_̍W߂
	int i,j;
	Matrix C = A*B; //C = (nV-r, r)̍s

	for(i=r;i<nV ;i++){
		xy[i][0] = 0;
		xy[i][1] = 0;
		for(j=0;j<r;j++){
			xy[i][0] += (double)C.youso(i-r,j) * xy[j][0];
			xy[i][1] += (double)C.youso(i-r,j) * xy[j][1];
		}
	}
}

/////////////////////////////////////////////////
//Ot̖ʂ\钸_߂

Edge * CPlaneGraph::MakeEdges()
{//GbW̏쐬
 //(n,m)(n,m)(m,n)ƂłQ񐔂B

	Edge *edges = new Edge[nE*2];
	int k = 0;
	for(int i = 0; i < nV; i++) {
		for(int j = 0; j < nV; j++) {
			if(AdjMat.youso(i,j)) { //אڍs(i,j)PȂΕ(i,j)ǉ
				edges[k].Set(i,j);	
				k++;
			}
		}
	}
	return edges;
}

double CPlaneGraph::area(int v0, int v1, int v2)
{//Op`v0v1v2̕tʐ v0->v1->v2->v0v̎[]Av̎[]
	double	x1 = xy[v0][0] - xy[v1][0], y1 = xy[v0][1] - xy[v1][1],
			x2 = xy[v2][0] - xy[v1][0], y2 = xy[v2][1] - xy[v1][1];//sړ

	x1 *= 1/sqrt(x1*x1+y1*y1); y1 *= 1/sqrt(x1*x1+y1*y1);
	x2 *= 1/sqrt(x2*x2+y2*y2); y2 *= 1/sqrt(x2*x2+y2*y2);

	return -(x1*y2-y1*x2)/2.0;
}

bool CPlaneGraph::FindNextVertex(Edge edges[], int flg[], Edge &e, int &start)
{//ʂ̎̒_TBiR_ڈȍ~j
	int i = 0;
	double norm = 100.0;    //Kɑ傫Ȓl
	double length;
	int	v0 = e.Vtx1(), v1 = e.Vtx2(), v2 = -1, no=-1;
	double x0,x2,y0,y2, l;

	while(edges[i].Vtx1() != v1 || flg[i] != 1){
		i++;
		if(i>=2*nE)	return false;
	}

	while(edges[i].Vtx1() == v1) {
		v2 = edges[i].Vtx2();
		if(v2 != v0 && flg[i]) {
			if(v2 == start) {
				no = i; break;
			}
			if(area(v0, v1, v2) >= -0.0000001) { //vłȂӂ̒Źipx̏́jI
											//ł́A悻-0.00001x܂ł̌덷F߂Ă
				x0 = xy[v0][0]-xy[v1][0];		y0 = xy[v0][1]-xy[v1][1];
				x2 = xy[v2][0]-xy[v1][0];		y2 = xy[v2][1]-xy[v1][1];
				l = sqrt(x2*x2+y2*y2);
				x2 /= l;						y2 /= l;

				length = (x2-x0)*(x2-x0)+(y2-y0)*(y2-y0);
				
				if(length < norm) {
					norm = length;
					no = i;
				}
			}
		}
		i++;
		if(i >= 2*nE)	break;
	}
	if(no == -1)
		return false;
	e=edges[no];
	flg[no]=0;
	return true;
}

bool CPlaneGraph::Makeface()
{//OH0,1,...r-1ƂČvZĂ
	int *flg;
	Edge *edges;
	int i,j,k;
	int startV;

	nF = 2-nV+nE; //IC[̒藝
	edges = MakeEdges();

	flg = new int[nE*2];

	for(i = 0; i < nE*2; i++) //SẴtOONɂ
		flg[i] = 1;

	for(i = 0; i < r; i++) { //Oʂ\ӂč폜
		for(j = 0; j < nE*2; j++) {  //Oʂ\钸_ r-1,r-2,...,1,0ł
			if((i+1)%r == edges[j].Vtx1() && i%r == edges[j].Vtx2()) {
				flg[j] = 0;
				break;
			}
		}
	}

	face = new CrList[nF]; //ʂ̐쐬

	//////////OʈȊO̖ʂ߂/////////////
	for(i = 0; i < nF-1; i++) {
		k = 0;
		while(!flg[k]) k++; //n_߂

		face[i].Push(edges[k].Vtx1()); //n_̊i[
		startV = edges[k].Vtx1();

		flg[k]=0;                  //ӂgpƈt

		face[i].Push(edges[k].Vtx2());//̓_i[
		Edge e=edges[k];
		while(1) {
			if(FindNextVertex(edges, flg, e, startV)) { //̒_T
				if(e.Vtx2() == startV)  break;//_n_Ȃ΂ŏIB
				face[i].Push(e.Vtx2());  //łȂΒ_
			} else {
				delete[] edges; delete[] flg; delete[] face;
				face = NULL;
				return false;
			}
		};
		face[i].Ring();		//ŏƍŌȂB
	}

	/////ŌɊOʂ̏//////
	nOutFace = i;

	for(j = r-1; j >= 0; j--) //ʂ͔̏vȂ̂ŋtɉ
		face[i].Push(j); //(Qʏł͊OH͎vƂȂ邩j

	face[i].Ring();  //ŏƍŌȂ

	///////////sKvȗ̈J/////////
	delete[] edges;	delete[] flg;
	return true;
}

//////////////////////////////////////////////////////
//OHςčĕ`悷邽߂̏

void CPlaneGraph::Default()
{//OHP0,1,...r-1Ɏw肷
 //܂AvZ̒_ԍƃ[U`̒_ԍ𓯂ɂ
	out = new int[r];
	ReNum = new int[nV];

	for(int i=0; i < r; i++)
		out[i]=i;
	for(i = 0; i < nV; i++)
		ReNum[i]=i;
}

void CPlaneGraph::Reset()
{//`\Ȍ`ɗאڍs𒼂B

	int *number, *nbuf;
	int i, j, k;
	int *flg;

	int *mtx, *temp;
	
	///////////////O////////////////
	mtx = new int[nV*nV];  //אڍs
	temp = new int[nV*nV]; //אڍsXV邽߂̍Ɨ̈
	number = new int[nV];  //ReNumČvZ悤
	flg = new int[nV];     //z̗vf1(ON)0(OFF)̂Q̏ԂƂ


	AdjMat.to_array(mtx); //אڍszɂ

	for(i = 0; i < nV; i++) //flgS1(ON)ɂ
		flg[i]=1;


	/////////š////////////////////

	for(i = 0; i < r; i++) { //OHɎĂ
		for(j = 0; j < nV; j++) {
			temp[i*nV+j] = mtx[out[i]*nV+j];
		}
		number[i] = ReNum[out[i]]; //ꏏɐVReNum̏
		flg[out[i]] = 0;
	}

	k=r;

	for(i = 0; i < nV; i++){ //c̍sォ珇ɋl߂
		while(flg[i] == 0 && i < nV) i++;
		if(i == nV) break;

		for(j = 0; j < nV; j++)
			temp[k*nV+j] = mtx[i*nV+j];
		number[k] = ReNum[i]; //ꏏɐVReNum̏
		k++;
	}

	/////////̌////////////////

	for(i = 0; i < r; i++) //OHɎĂ
		for(j = 0; j < nV; j++) {
			mtx[j*nV+i] = temp[j*nV+out[i]];
		}

	k=r;

	for(i = 0; i < nV; i++){ //c̍s珇ɋl߂
		while(flg[i] == 0 && i < nV) i++;
		if(i == nV) break;
		
		for(j = 0; j < nV; j++)
			mtx[j*nV+k] = temp[j*nV+i];
		k++;
	}
	
	//////////////XV///////////////////////

	AdjMat = iMatrix(nV, nV, mtx); //Vאڍs
	nbuf = ReNum;

	ReNum = number; //ReNumXV
	
	for(i = 0; i < nV; i++) //NumberXV
		Number[ReNum[i]]=i;

	/////////////sKvȗ̈̊J////////////
	delete[] nbuf;	delete[] mtx;
	delete[] temp;	delete[] flg;
}

void CPlaneGraph::SelectFace(double x, double y)
{//QW(x,y)܂܂ʂTA̖ʂ\钸_OHɎw肷
	int i, j; //JE^[
	int flg;
	double Px, Py, Qx, Qy, Rx, Ry; //R_P,Q,RxWyW

	//////////(x,y)ǂ̖ʂɊ܂܂Ă邩T///////////
	Px = x;
	Py = y;

	if(x*x+y*y < 1) {
		for(i = 0; i < nF; i++) {
			flg = 1;
			int Fvtx = face[i].Num();
			for(j = 0; j < Fvtx; j++) {

				Qx=xy[Number[face[i].Value()]][0];
				Qy=xy[Number[face[i].Value()]][1];
				face[i].GoNext();
				Rx=xy[Number[face[i].Value()]][0];
				Ry=xy[Number[face[i].Value()]][1];

			if((Px-Rx)*(Qy-Ry)-(Qx-Rx)*(Py-Ry) < 0) {//Rp`PQR̕tʐρi̎>Oj
					flg = 0; //ɂȂ-->ʏɑIꂽ_܂܂Ȃ
					break;	 //iʂɐɂȂΑIꂽ_͖ʂɊ܂܂j
				}
			}
			if(flg)	break;
		}

		/////////////OH֘Ȁ̍XV///////////////

		delete[] out;		//OH
		r = face[i].Num();		//O_̐XV
		out = new int[r];	//VɊm
		
		nOutFace = i;		//I΂ꂽʂOʂƂċL^

		for(j = 0; j < r; j++) { //ʂ̒_͔vȂ̂
			out[j] = Number[face[i].Value()];
			face[i].GoBefore(); //tɉAvɂȂ悤Ɏw肷
		}
		ReDrawGraph();
	}
}

void CPlaneGraph::ReDrawGraph()
{//OHw肵Ȃčĕ`
	Reset();
	InitDrawGraph(0);
}

/////////////////////̑///////////////////////////
//Dual Graph 𓾂
CPlaneGraph CPlaneGraph::GetDualGraph()
{//face eʂ\钸_̃Xg@Fnum@ʂ̐
 //Xg̒_͔vł邱
	
	if(DrawFlg!=Perfect)	return CPlaneGraph();
	int Vnum = nF; //ʂ̐Dual Graph̒_ɂȂ
	iMatrix Mat(Vnum,Vnum); //Vnum*Vnum̍s̍쐬

	///////ʂ̗אڊ֌W𓾂B/////////////////////////
	///////iƖjאڂĂ邩ǂׂB///////
	int flg;
	for(int i = 0; i < Vnum; i++) {
		int n0 = face[i].Num();	//i\钸_ۑ
		int u0 = face[i].Value();	//(u0,v0)̂u0oB
		face[i].GoNext();			//̒_ֈړ

		for(int k = 0; k < n0; k++) {
			int v0 = face[i].Value();	//(u0,v0)̂v0oB
			flg = 0;

			for(int j = i+1; j < Vnum; j++) {
				int n1 = face[j].Num();	//j\钸_ۑ
				int u1 = face[j].Value(); //(u1,v1)̂u1oB
				face[j].GoBefore();			//O̒_ֈړ

				for(int l = 0; l < n1; l++) {	//j̕ӂׂĒׂB
					int v1 = face[j].Value(); //(u1,v1)̂v1oB
					if(u0 == u1 && v0 == v1) {	//(u0,v0)(u1,v1)
						Mat.equal(i,j,1); Mat.equal(j,i,1);	//אڐݒ
						flg = 1; break;								//ׂ̖ʂƔ
					}
					u1 = v1;			//(u1,v1)->(v1,w1)Ɛi߂鏀
					face[j].GoBefore();	//O̒_ֈړ
				}
				if(flg) {//ׂ̖ʂłƂ킩烋[v甲
					face[j].GoStart(); //|C^߂̈ʒuɖ߂
					break;
				}
			}
			u0 = v0;			//(u0,v0)->(v0,w0)Ɛi߂鏀
			face[i].GoNext();	//̒_ֈړ
		}
		face[i].GoStart(); //|C^߂̈ʒuɖ߂
	}
	CPlaneGraph graph(Mat, Vnum);
	return graph;
}

void CPlaneGraph::MakeFaceColor()
{//lʐF邽߂̐Fz𓾂
	if(pColor == NULL){
		CFourColor fc(GetDualGraph());
		pColor = fc.GetColor();
	}
}

bool CPlaneGraph::SearchFacialCycle()
{
	CFacialCycle g(*this);
	r=0;
	if(g.Search()) {
		r = g.num;
		out = new int[r];
		for(int i=0; i<r; i++)
			out[i]=g.Fcycle[i];
		return true;
	}
	return false;
}

////////////////////////////////////////
//@@TvOt
void CPlaneGraph::Sample(int no)
{//no = 1
	DeleteMember();
	if(no == 1) {
		GraphC60();
		r = 6;		//O_̐w
		AdjMat = CGraph::GetAdjMat();
	} else if(no == 2) {
		GraphV6_1();
		r = 3;		//O_̐w
		AdjMat = CGraph::GetAdjMat();
	} else if(no == 3) {
		int mm[11][11] = {
			{0,1,1,0,0,0,0,1,1,0,0},
			{1,0,1,1,0,0,0,0,0,0,1},
			{1,1,0,0,0,0,0,0,0,0,1},
			{0,1,0,0,1,0,0,0,0,0,0},
			{0,0,0,1,0,1,0,0,0,1,0},
			{0,0,0,0,1,0,1,0,1,1,0},
			{0,0,0,0,0,1,0,1,0,0,1},
			{1,0,0,0,0,0,1,0,1,0,1},
			{1,0,0,0,0,1,0,1,0,1,0},
			{0,0,0,0,1,1,0,0,1,0,0},
			{0,1,1,0,0,0,1,1,0,0,0}};
		AdjMat = iMatrix(11, 11, (int *)mm);
		nV = 11;	nE = 19;
		AdjList = GetAdjList(AdjMat);
		r = 3;
	}

	Default();
	InitDrawGraph();
}

#ifdef	_draw_  //draw.hŒ`
	////////////////Ot̕`/////////////////////////
	//ł́Aac搶̕`NXgpB
	//炪A`ꂽȂƂ́A`ȂB
void CPlaneGraph::DrawGraph(draw &d)
{//ʃOt`
	if(nV == G_EMPTY)	return;
	iMatrix mtx = GetAdjMat();

	for(int i=0; i < nV; i++){
		for(int j=i; j < nV; j++) {
			if(mtx.youso(i,j))
				d.DrawLine(xy[i][0], xy[i][1], xy[j][0], xy[j][1]);
		}
	}
//	d.DrawCircle(0,0,1);	//Pʉ~`
}

void CPlaneGraph::PaintGraph(draw &d)
{//ʂʐF
	if(nV == G_EMPTY)	return;
	for(int i = 0; i < nF; i++) {
		if(i != nOutFace) {
			int count = face[i].Num();
			pvect *vec = new pvect[count];

			for(int j = 0; j < count; j++) {
				int num = Number[face[i].Value()];
				vec[j].x = xy[num][0];
				vec[j].y = xy[num][1];

				face[i].GoNext();
			}
			d.PaintPolygon(vec, count, rgb((200*i%255)/255.0, (30*i%255)/255.0, i*10/255.0));
			delete[] vec;
		}
	}
	DrawGraph(d);
}

void CPlaneGraph::DrawVertices(draw &d, double font_size) //=0.05
{//_o
	char buf[256];
	string str;
	for(int i=0; i < nV; i++){
		sprintf(buf, "%d", ReNum[i]+1);
		str = buf;
		d.DrawString(xy[i][0]*1.1, xy[i][1]*1.1, str, font_size, "Times",
			false, rgb(0,0,1));
	}
}

void CPlaneGraph::PaintFourColor(draw &d, rgb *col)
{//lʐF
	if(nV == G_EMPTY)	return;
	if(pColor == NULL){
		CFourColor fc(GetDualGraph());
		pColor = fc.GetColor();
	}
	if(col == NULL){
		col = new rgb[4];
		col[0] = rgb(1,0,0);	col[1] = rgb(0,1,0);
		col[2] = rgb(0,0,1);	col[3] = rgb(1,1,0);
	}
	for(int i = 0; i < nF; i++) {
		if(i != nOutFace) {
			int count = face[i].Num();
			pvect *vec = new pvect[count];

			for(int j = 0; j < count; j++) {
				int num = Number[face[i].Value()];
				vec[j].x = xy[num][0];
				vec[j].y = xy[num][1];

				face[i].GoNext();
			}
			d.PaintPolygon(vec, count, col[pColor[i]]);
			delete[] vec;
		}
	}
	DrawGraph(d);
}
#endif


//////////////////////////////////////////////////////////////////////////////////
//						l  F  											//
//////////////////////////////////////////////////////////////////////////////////
/////two constructors and one desutructer /////
CFourColor::CFourColor()
{
	Color = NULL; ConnList = NULL;
}

CFourColor::CFourColor(CPlaneGraph &graph)
{
	//o[//
	nV = graph.NumV();	nE = graph.NumE();
	AdjList = graph.GetAdjList();
	Color = NULL; ConnList = NULL;
	Init();
}

CFourColor::~CFourColor()
{
	if(Color != NULL) {
		delete[] ConnList; delete[] Color;
	}
}

////////lʐFvZ֌W/////
void CFourColor::Init()
{
	Number = DFS();	//DFSɂ蒸_ԍ^

	ConnList = new CrList[nV];	//אڃXg̈m
	MakeConnList(Number);		//אڃXg쐬

	Color = new int[nV];		//J[Xg̈m

	Success = TreeSearch();		//lʐF

	InitNumber(nV, false);		//ReNum̏쐬
	CalReNum();					//NumberReNumvZ

	int *temp = new int[nV];	//Ɨ̈
	int i;						//JE^[

	for(i = 0; i < nV; i++)
		temp[ReNum[i]]=Color[i];

	delete[] Color;
	DelNumber(); //Number,ReNum̗̈
	Color = temp;
}


void CFourColor::MakeConnList(int *Number)
{//אڃXg(is̗vfi菬)쐬
	int i, j;	//JE^[

	//אڃXgDFS̔ԍō쐬//
	for(i = 0; i < nV; i++) {
		AdjList[i].Ring();
		int n = AdjList[i].Num();
		for(j = 0; j < n; j++) {
			ConnList[Number[i]].Push(Number[AdjList[i].Value()]);
			AdjList[i].GoNext();
		}
		ConnList[i].Sort();  //evfɃ\[g
	}
	
	//sKvȗvf폜//
	for(i = 0; i < nV; i++) {
		while(ConnList[i].Num() && ConnList[i].Value() > i)
			ConnList[i].Pop();
		ConnList[i].Ring();
	}
}

bool CFourColor::TreeSearch()
{
	int k=0;	//xJE^
	int tc=0;	//̍ɓh낤ƂĂF@tc=1,2,3,4

	Color[k++]=0;

	while(1) {
		if(SeekAnotherSegment(k,tc)){
			Color[k++]=tc;
			tc=0;
			if(k == nV)
				return true;
		} else
			if(Retreat(k,tc)==false)
				return false;
	}
}

bool CFourColor::Retreat(int &k, int &tc)
{//߂肵Ȃ΂ȂȂƂ̏
	if(k==-1){
		return false;
	} else {
		tc = Color[--k]+1;
		return true;
	}
}

void CFourColor::Advance(int &k, int &tc)
{//ɐiނ߂̏
	Color[k]=tc;	tc = 0;	k++;
}

bool CFourColor::SeekAnotherSegment(int k, int &tc)
{//l̐F珇ԂɎg邩ׂB
 //F܂Ƃtrue,ȊOfalseԂB
	while(tc < 4) {
		//݂̐FɎgĂȂ`FbN
		if(AdmissibilityCheck(k, tc)) 
			return true;
		else
			tc++;
	}
	return false; //s
}

bool CFourColor::AdmissibilityCheck(int k, int tc)
{//̖ʂɓFȂׂB
 //ɓFȂƂtrue,ȊOfalseԂB
	int max = ConnList[k].Num();
	int neighbor;

	for(int j = 0; j < max; j++) {
		neighbor = ConnList[k].Value();
		if(tc == Color[neighbor])
			return false;
		ConnList[k].GoNext();
	}
	return true;
}

///// public ֐ //////
int * CFourColor::GetColor()
{//J[z̃Rs[^
	int *temp = new int[nV];

	for(int i = 0; i < nV; i++)
		temp[i] = Color[i];

	return temp;
}
//////////////////////////////////////////////////////////////////////////////////
//						O  H T 											//
//////////////////////////////////////////////////////////////////////////////////
CFacialCycle::CFacialCycle()
{
	edge = NULL;	num=0;
}

CFacialCycle::CFacialCycle(CGraph &g)
{//Constructor	
	nV = g.NumV();	nE = g.NumE();
	AdjList = g.GetAdjList();
	edge=NULL; Fflg = NULL;
	num = 0;
}

CFacialCycle::~CFacialCycle()
{
	if(Fflg  != NULL)		delete[] Fflg;
}

bool CFacialCycle::Search()
{//
	int i;	//counter
	iMatrix At, Al;		//ڑs̐ؕƗt̕
	DirectedEdge	*et, *el;	//؂̕ӁAt̕
	Number = GetReducedIncidenceMtx(At, Al, &et, &el);	//ڑs𓾂BɁADFSɂ钸_ԍB
	rank = nV-1;			//rank	 = ؂̕ӂ̐ = _-1
	nullity = nE-rank;		//nullity= t̕ӂ̐ = |E|-rank

	/////_ԍDFSɂ钸_ԍ̑Ήt////
	InitNumber(nV, false);
	CalReNum();	//ReNumvZ

	//////Hs쐬//////
	Bp = At.inverse() * Al;	Bp.mod(2);	//ؒfsQp𓾂B(Mod 2)
	Bp = ~Bp;							//Qp̓]us Hs𓾂B
	iMatrix I = iMatrix(nullity, "Identity Matrix");	//Pʍsp
	Bp = MatrixMerge1(I, Bp);							//Bp = [I:Bq]
	Fmtx = Bp;		//Fmtx̏

	//////ӂ̏쐬////////
	edge = new DirectedEdge[nE];	//eɕӂΉ
	for(i = 0; i<nullity; i++)		edge[i].Set(ReNum[el[i].Tail()], ReNum[el[i].Head()]);
	for(i = 0; i < rank; i++)		edge[i+nullity].Set(ReNum[et[i].Tail()], ReNum[et[i].Head()]);
	delete[] el; delete[] et;

	////OHT/////	
	int *ary;

	iMatrix gyou;	//HŝPŝ݂oĊi[
	Fflg = new int[nullity];

	for(i = 0; i < nullity; i++) {	//łɁAcycleɂȂĂsTB
		gyou = Bp.GetiGyou(i);
		ary = gyou.to_array();
		//@1 sgꍇ
		Fflg[i] = Seppen(Bp, ary, i);	//isڂʃTCNɂȂĂ邩m߂
		//@2 DFSgꍇ
//		Fflg[i] = Seppen(ary,i);	//isڂʃTCNɂȂĂ邩m߂
		delete[] ary;						//1:ʃTCN 0:PȂH
	}

	for(i = 0; i < nullity; i++)
		if(Fflg[i]) break;
	if(i == nullity)
		return false;
	gyou = Bp.GetiGyou(i);
	ary = gyou.to_array();
	Fcycle = GetCycle(ary, i, num);
	delete[] ary;
	if(Fcycle == NULL )return false;
	return true;
}

///sƗꊷ邱ƂɂAؕЂ̐߂
int CFacialCycle::Seppen(iMatrix Mtx, int *vec, int num)
{//ؕА1ȉ̎1AȊO0ԂB
 //̕@́ABq=[I:B] iB͊HsjɂĂ̂ݗLłB
	int mSize = Mtx.mSize();
	int nSize = Mtx.nSize();
	int i, j, k;
	int no=0, m=0, n=0;

	/////H菜FHɂȂEɊ񂹂/////
	i=nSize;
	while(--i >= 0) {
		if(vec[i]) {
			nSize--;
			if(i != nSize) {
				Mtx.ChangeRetsu(i, nSize);
				k = vec[i]; vec[i] = vec[nSize]; vec[nSize] = k;
			}
		}
	}

	Mtx.ChangeGyou(num, mSize-1);	//HɎw肳ꂽsԉɊ񂹂
	mSize--;
	if(mSize == 0 || nSize == 0)
		return 1;

	/////sł1̑sāA0sڂɎĂ/////
	for(i = 0; i < mSize; i++) {
		k = 0;
		for(j = 0; j < nSize; j++) {
			if(Mtx.youso(i,j)) k++;
		}
		if(k > n) {
			no = i; n = k;
		}
	}
	Mtx.ChangeGyou(0,no);	//̍sԏ

	/////0sڂɂ1ׂčɊ񂹂////
	k = 0;
	for(i = 0; i < nSize; i++) {
		if(Mtx.youso(0,i)){
			if(i!=k) Mtx.ChangeRetsu(i,k);
			k++;
	}}

	/////0sڂ1ōł1IŁA0ڂɎĂ/////
	for(i = 0; i < n; i++) {
		k = 0;
		for(j = 0; j < mSize; j++) {
			if(Mtx.youso(j,i)) k++;
		}
		if(k > m) {
			no = i; m = k;
		}
	}
	Mtx.ChangeRetsu(0, no);	//̗ԍ

	/////0ڂɂ1ׂďɊ񂹂////
	k = 0;
	for(i = 0; i < mSize; i++) {
		if(Mtx.youso(i,0)) {
			if(i!=k) Mtx.ChangeGyou(i,k);
			k++;
	}}
	i = j = 1;
	k = 0;

	while(i < m-1 || j < n-1) {
		for(k = n; k < nSize; k++) {
			if(Mtx.youso(i,k)) {
				if(k != n) Mtx.ChangeRetsu(n,k);
				n++;
		}}
		if(n >= nSize) {
			return 1;
		}

		for(k = m; k < mSize; k++) {
			if(Mtx.youso(k,j)) {
				if(k != m) Mtx.ChangeGyou(m,k);
				m++;
		}}
		if(m >= mSize) {
			return 1;
		}
		if(i < m-1) i++;
		if(j < n-1) j++;
	}
	return 0;
}

int CFacialCycle::IsOnCycle(int *ary, int k, int x, int y)
{//cycle̒_[_ɎӂAcycle̕ӂǂׂB
 //(x,y)cycle̕ӂłƂ1ԂB
 //(x,y)cycle̕ӂł͂ȂA_x,ycycle̒_łƂA0ԂB
 //ȊO̕ӂłƂ-1ԂB
 //Farycycle̒_̕сBk:cycle\钸_ (x,y):xcycle̒_łCӂ̕
 
	int i = 0;
	while(ary[i] != y ) {
		i++;
		if(i >= k) return -1; //(x,y) is the edge x is on the cycle and y is not on the cycle
	}
	if(ary[(i+k+1)%k] == x || ary[(i+k-1)%k] == x)	//yׂ̗x݂Ƃ
		return 1;	//(x,y) is the edge and on the cycle
	else return 0;
}

int CFacialCycle::Seppen(int *vec, int gyou)
{//Hs̊OHɂȂĂ邩ǂׂsB
	int *cycle;		//cycle
	int k;			//cycle̒_
	int i,j;		//JE^[
	int num = 0;	//ؕЂ̐
	int x, y;

	/////H̒_𓾂/////
	if((cycle = GetCycle(vec, gyou, k))==NULL)
		return 0;	//AHcycleł͂ȂƂ́AI

	/////אڃXg̃Rs[/////////
	CrList *buf = GetAdjList();

	/////(x,y)x,ycycle̒_łA(x,y)cycle̕ӂłȂ̂𐔂B/////
	int max;
	for(i = 0; i < k; i++) {
		x = cycle[i];
		max = buf[ReNum[x]].Num();
		for(j = 0; j < max; j++) {
			y = Number[buf[ReNum[x]].Pop()];
			if(IsOnCycle(cycle, k, x, y)==0) num++;	//x,ycycle̒_ŁAcycle̕ӂłȂ
		}
		if(num >= 1) {
			delete[] buf; delete[] cycle;
			return 0;
		}
	}
	/////Ǘ_T/////
	////////////////////////

	//DFSɂAؕЂ邩///
	int *nn = new int[nV];
	int no=0,Vnum;

	for(i = 0; i < nV; i++)		nn[i] = -1;					//initialize
	for(i = 0; i < k;  i++)		nn[ReNum[cycle[i]]] = -2;	//delete vertices on the cycle
	i = 0;
	while(nn[i] == -2) {
		i++;
		if(i >= nV){	//3-AOtȂ΁A蓾ȂB
			delete[] nn;	delete[] cycle;
			if(num == 0)	return 1;
			else			return 0;
		}
	}
	
	Vnum = _DFS_(nn, buf,  no, ReNum[i]);	//[DT

	delete[] nn; delete[] buf;	delete[] cycle;

	if(Vnum != nV-k) return 0;	//DFSɂAׂĂ̒_ǂȂ=ؕЂQȏ
	else if(num >= 1) return 0;	//DFSɂAׂĂ̒_ǂꂽAȊOɂؕЂB
	else			return 1;	//LȊO@=@ؕЂ1łB
}

int __getcycle_check(int *cycle, int h, int vtx)
{
	for(int i = 0; i < h; i++)
		if(cycle[i] == vtx)
			return 0;
	return 1;
}

int* CFacialCycle::GetCycle(int *ary, int x, int &k)
{//aryFHsxsځ@k:Hɑӂ̐
 //^ꂽAaryPcycle\ĂƂcycle̒_̕тԂB
 //ӂLQȏcycle\ĂƂAcycle̍ŴƂ́A
 //NULLԂB

	int i,j;				//counter
	int *cycle;				//cycle̒_i[邽߂̃|C^
	int *buf = new int[nE];	//ƗpBaryRs[ĎgB
	int a,b;				//(a,b)itĂȂj

	for(i = 0, k = 0; i < nE; i++) {//zRs[ƓɁA(_)𐔂B
		if(ary[i]) k++;
		buf[i] = ary[i];
	}

	cycle = new int[k];	//TCN̒_̈mہB

	cycle[0] = edge[x].Head();	//ŏ̕ӂ̏𓾂B
	cycle[1] = edge[x].Tail();	//ł́Abuf[i]͕K1ƂȂĂ邱ƂɒӁB
	buf[x] = 0;					//B

	i=0; j=2;
	while(j < k) {
		for(i = 0; i < nE; i++) {
			if(buf[i]) {	//ӂ݂ƂB
				a = edge[i].Head(); b = edge[i].Tail();
				if(a == cycle[j-1] && b != cycle[0]) {// -> a -> b ->@ƂȂ鎞
					if(__getcycle_check(cycle, j, b)) {
						cycle[j] = b;	buf[i] = 0;	//_i[āAӂ
						j++; i=0; break;
					} else {
						i = nE; break;
					}
				} else if(b == cycle[j-1] && a != cycle[0]) {	// -> b -> a -> ƂȂ鎞
					if(__getcycle_check(cycle,j,a)) {
						cycle[j] = a;	buf[i] = 0; //_i[āAӂ
						j++; i=0; break;
					} else {
						i = nE; break;
					}
				}
			}
		}
		if(i == nE) {//cycle1łȂƔƂ
			delete[] cycle;		delete[] buf;
			return NULL;
		}
	}
	delete[] buf;
	return cycle;
}