//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//

/////////////////////////////////////////////////////////////////////////////////
//OtAvP[V
//@ʐA3-AOt̊OHTA3-AOt̕`
//
#ifndef __TANIKO_H__
#define __TANIKO_H__
#include "CGraph.h"
#include "CPlanarity.h"
#include "CPlaneGraph.h"
#include "..\Wada\draw.h"
#include <iostream>
#include <string>

using namespace std;

class MyGraphApp {
	enum {	NoGraph		= ~0x0001,	//Ot
			NonPlanar	= ~0x0002,	//񕽖ʓI
			Planar		= ~0x0004,	//ʓI
			DisConnected= ~0x0008,	//A
			Connected	= ~0x0010,	//A
			BiConnected = ~0x0020,	//2-A
			TriConnected= ~0x0040,	//3-A
			CannotDraw  = ~0x0080,	//`s\
			Plane		= ~0x0100,	//`\
			FaceInfo	= ~0x0200,	//OHύX\
	};

	CGraph		*m_pGraph;
	CPlanarity	*m_pTesting1;
	CPlanarity2 *m_pTesting2;
	CPlaneGraph *m_pDraw;
	unsigned	m_nStatus;	//Ԃ\
	int m_nComp;	//Componrnt̐
public:
	string msg;

	MyGraphApp()	//constructor
	{
		m_pGraph = NULL;	m_pTesting1 = NULL;
		m_pTesting2 = NULL; m_pDraw = NULL;
		m_nStatus = NoGraph; msg="";
	}

	void DeleteMember()
	{
		if(m_pGraph != NULL)	delete m_pGraph;
		if(m_pTesting1 != NULL)	delete m_pTesting1;
		if(m_pTesting2 != NULL)	delete m_pTesting2;
		if(m_pDraw != NULL)		delete m_pDraw;
	}

	~MyGraphApp()	//destructor
	{
		DeleteMember();
	}
	bool CheckFlg(const unsigned &x)
	{
		return ((~m_nStatus & ~x) != 0)? true:false;
	}
	void SetFlg(const unsigned &x)
	{
		if(CheckFlg(NoGraph))	m_nStatus = x;
		else					m_nStatus &= x;
	}

	bool CreateGraph(iostream fin)
	{//Ot쐬
		if(m_pGraph != NULL)
			return true;
		m_pGraph = new CGraph(fin);
		if(m_pGraph->NumV() != CGraph::G_EMPTY){
			msg=m_pGraph->Output();
			if(m_pGraph->IsConnected()) {
				SetFlg(Connected);
				msg = msg + "This Graph is connected.\n";
			} else {
				SetFlg(DisConnected);
				msg = msg + "This Graph is disconnected.\n";
			}
			return true;
		} else	return false;
	}

	bool PlanarityTesting1()
	{
		if(CheckFlg(NoGraph))	//Graph̏񂪂ȂƂ
			return false;

		if(m_pTesting1 != NULL)	//ł1񔻒肵Ƃ
			return true;
			
		if(m_pTesting2 != NULL){//@Q΁A
			delete m_pTesting2;
			m_pTesting2=NULL;
		}

		m_pTesting1 = new CPlanarity(*m_pGraph);
		string buf = "\n";	//
		msg = m_pGraph->Output() + buf + m_pTesting1->ms;

		if(m_pTesting1->IsPlanar()) {	//ʓIOt
			SetFlg(Planar);
		} else							//񕽖ʓIOt
			SetFlg(NonPlanar);
		if(m_pTesting1->IsBiConnected())	//2-Aǂ
			SetFlg(BiConnected);

		return true;
	}

	bool PlanarityTesting2()
	{
		if(CheckFlg(NoGraph))	//Graph̏񂪂ȂƂ
			return false;

		if(m_pTesting2 != NULL)		//ł1񔻒肵Ƃ
			return true;

		if(m_pTesting1 != NULL) {	//@Q΁A
			delete m_pTesting1;
			m_pTesting1 = NULL;
		}
			
		m_pTesting2 = new CPlanarity2(*m_pGraph);
		string buf = "\n";	//
		msg = m_pGraph->Output() + buf + m_pTesting2->ms;

		if(m_pTesting2->IsPlanar()) {	//ʓIOt
			SetFlg(Planar);
		} else							//񕽖ʓIOt
			SetFlg(NonPlanar);
		if(m_pTesting2->IsBiConnected())	//2-Aǂ
			SetFlg(BiConnected);
		return true;
	}


	bool CreatePlaneGraph()
	{
		if(CheckFlg(NoGraph) || CheckFlg(NonPlanar) || CheckFlg(DisConnected))	return false;
		if(m_pDraw != NULL) return true;
		m_pDraw = new CPlaneGraph(*m_pGraph);

		if(m_pDraw->GetInfo() == CPlaneGraph::CannotDraw) {	//OHȂ
			SetFlg(CannotDraw);
			delete m_pDraw; m_pDraw = NULL;
			return false;
		}else if(m_pDraw->GetInfo() == CPlaneGraph::DrawOnly) //ʂ̏񂪓Ȃ(2-A)
			SetFlg(Plane);
		else {
			SetFlg(Plane); SetFlg(FaceInfo);
		}
		return true;
	}

	bool DrawGraph(draw &d)
	{
		if(CheckFlg(NoGraph)) return false;
		else if(CheckFlg(Plane)) {	//ʃOtł鎞B
			m_pDraw->DrawGraph(d);
			m_pDraw->DrawVertices(d);
			return true;
		} else {					//ʃOtłȂB
			m_pGraph->DrawGraph(d);
			return true;
		}
	}

	bool PaintFourColor(draw &d, rgb *color=NULL)
	{
		if(CheckFlg(FaceInfo)){
			m_pDraw->PaintFourColor(d,color);
			return true;
		} else return false;
	}

	bool ChangeOuterMostCycle(double x, double y)
	{
		if(CheckFlg(FaceInfo)) {
			m_pDraw->SelectFace(x,y);
			return true;
		} else return false;
	}

	////////////ԂԂ֐///////////////
	bool CanChangeOuterCycle()
	{
		if(CheckFlg(FaceInfo)) return true;
		else	return false;
	}

};
#endif