//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//
#include "stdafx.h" //for MFC
#include <stdio.h>
#include <stdlib.h>
#include "CList.h"

//constructor
CdList::CdList()
{
	start = list = NULL; n = 0;
}

CdList::CdList(const CdList &lst)
{
	int i;
	int num;
	sList *now;

	start = list = NULL; n = 0;
	if(lst.n != 0) {
		num = lst.n;
		now = lst.start;
		for(i = 0; i < num; i++) {
			this->Push(now->value);
			now = now->next;
		}
	}
}

//destroctor
CdList::~CdList()
{
	while(list != NULL)
		Pop();
}

//Xǧ݂̈ʒuB
Type CdList::Pop()
{
	Type v;
	if(list == NULL) //Xg̎
		return 0;

	v = list->value;
	if(list->before != NULL) { //Xgŏ̃XgłȂƂ
		list = list->before;        //iOɃXgƂj
		delete list->next;
		list->next = NULL;
	} else { //Xg̍ŏ̎iXgj
		delete list;
		start = list = NULL;
	}
	n--; //vf炷
	return v;
}

//Xǧ݂̈ʒuɃf[^t
Type CdList::Push(Type v)
{
	if(list != NULL) { //XgłȂƂ
		list->next = new sList;
		list->next->before = list;
		list->next->value = v;
		list->next->next = NULL;
		list = list->next;
	} else {  //Xg̎iԏ߁j
		list= new sList;
		list->value = v;
		list->before = list->next = NULL;
		start = list;
	}
	n++; //vf𑝂₷
	return v;
}

//݂̈ʒu̒l
Type CdList::Set(Type v)
{
	if(list != NULL)
		list->value = v;
	return v;
}


//Xg
void CdList::Delete()
{
	while(list != NULL)
		Pop();
}

//vf̐Ԃ
int CdList::Num()
{
	return n;
}

//݂̒lԂ
Type CdList::Value()
{
	return list->value;
}

//1O̒lԂ
Type CdList::Before()
{
	if(list != NULL && list->before != NULL)
		return list->before->value;
	else
		return -111111; //G[II
}

int compare(const void *elnum1, const void *elnum2)
{
	return *(Type *)elnum1 - *(Type *)elnum2;
}

void CdList::Sort(int flg) //flg=1
{
	Type *array;
	int i, nn = n;
	array = new Type[n];
	for(i = 0; i < nn; i++)
		array[i]=Pop();
	qsort((void *)array, (size_t)nn, sizeof(Type), compare);
	if(flg) //
		for(i = 0; i < nn; i++)
			Push(array[i]);
	else	//~
		for(i = nn-1; i >= 0; i--)
			Push(array[i]);
}

void CdList::Merge(CdList *lst)
{
	if(lst == NULL || lst->n == 0)
		return;
	if(list != NULL) {
		list->next = lst->start;  //Ȃ
		list->next->before = list;
		list = lst->list;
		n += lst->n;
	} else {
		list = lst->list;
		start = lst->start;
		n = lst->n;
	}
	lst->n = 0;	//lst̓e
	lst->list=lst->start=NULL;
}

Type* CdList::ToArray()
{
	if(n == 0) return NULL;

	Type *array = new Type[n];
	int i; 
	sList *lst = start;
	for(i = 0; i < n; i++) {
		array[i] = lst->value;
		lst = lst->next;
	}
	return array;
}

CdList CdList::operator = (const CdList &lst)
{//lstƑSlXg쐬
	int i,num;
	sList *now;

	if(lst.n == 0){
		this->Delete();
		return *this;
	}
	if(start == lst.start)	// = ̎
		return *this;

	this->Delete();	//g

	num = lst.n;
	if(num == 0)
		return *this;	//Rs[Ƃ̃Xgł鎞

	now = lst.start;
	for(i = 0; i < num; i++) {
		this->Push(now->value);
		now = now->next;
	}
	return *this;
}

CMessages CdList::Output(Type num /*= 0*/)
{
	CMessages msg;
	char buf[128];

	msg += "\0";
	if(n == 0) return msg;

	list = start;
	while(1) {
		sprintf(buf, "%d", list->value+num);
		msg += buf;
		if(list->next == NULL) return msg;
		list = list->next;
		msg += " ";

	}
	return msg;
}

//////////////////////////////////////////////////////
/// CrList֐
///
CrList::CrList()
{
	flg = 0; //ւɂȂĂȂ
}
CrList::CrList(CrList &lst)
{
	int i;
	int num;
	sList *now;

	start = list = NULL; n = 0;
	if(lst.n != 0) {
		num = lst.n;
		now = lst.start;
		for(i = 0; i < num; i++) {
			this->Push(now->value);
			now = now->next;
		}
	}
	flg = lst.flg;
	if(flg)
		Ring();
}

CrList::~CrList()
{//ւؒfĊ{NX̊֐Ă
	if(n && flg){
		list = start->before;
		start->before=NULL;
		list->next = NULL;
		flg = 0;
	}
//	CdList::Delete();
}

void CrList::Ring()
{//ԍŏƍŌȂŗւɂ
	if(list != NULL) {
		list->next = start;
		start->before = list;
		list = start;
		flg = 1; //ւɂȂ
	}
}

void CrList::Cut()
{//ւɂȂĂƂAւ؂Čɖ߂B
	if(flg) {
		flg = 0;	//ւɂȂĂȂ
		list = start->before;
		start->before = NULL;
		list->next = NULL;
	}
}
//ւɂȂĂƂAɐi
bool CrList::GoNext()
{
	if(flg) {list = list->next;	return true;}
	else		return false;
}

//ւɂȂĂƂAOɖ߂
bool CrList::GoBefore()
{
	if(flg) { list = list->before;	return true;}
	else		return false;
}

bool CrList::GoStart()
{
	if(flg) { list = start; return true;} 
	else		return false;
}

void CrList::Delete()
{//ւؒfĊ{NX̊֐Ă
	flg = 0;
	list = start->before;
	start->before=NULL;
	list->next = NULL;
	CdList::Delete();
}

bool CrList::RingIs()
{
	if(flg) return true;
	else	return false;
}

Type CrList::Pop()	//|bv
{
	if(flg)		return 0;
	else		return CdList::Pop();
}

Type CrList::Push(Type v)//vbV
{
	if(flg)		return 0;
	else		return CdList::Push(v);
}

CrList CrList::operator = (const CrList &lst)
{//lstƑSlXg쐬
	CdList::operator=(lst);
	flg = lst.flg;
	if(flg) this->Ring();
	return *this;
}


void CrList::Sort(int _flg_) //flg=1
{
	if(flg) return;
	else
		CdList::Sort(_flg_);
}




