//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//

/********************************
 Class Matrix
*********************************/
#ifndef __Matrix_h__

#define __Matrix_h__

#include <iostream>
#include <string>
#include <stdlib.h>
#include <math.h>
using namespace std;
//#include "..\Tools\CMessages.h"
typedef string CMessages;

const double matrix_eps = 0.0000000000001;

template<class Type> class base_Matrix {
public:
	int m, n;

public:
	Type *mtx;

	base_Matrix()							//construcotrs
		{m=n=0;mtx=NULL;};
	base_Matrix(int, int, Type *p=NULL);
	base_Matrix(int, char *);
	base_Matrix(const base_Matrix &);
	~base_Matrix()
		{ if(mtx != NULL)	delete[] mtx;};	//destructors

	int mSize(){return m;};
	int nSize(){return n;};

	friend	base_Matrix operator +(const base_Matrix &);
	friend	base_Matrix operator -(const base_Matrix &);
	friend	base_Matrix operator +(const base_Matrix &, const base_Matrix &); //Z
	friend	base_Matrix operator -(const base_Matrix &, const base_Matrix &); //Z
	friend	base_Matrix operator *(const base_Matrix &, const base_Matrix &); //Z
	friend	base_Matrix operator *(const double &, const base_Matrix &); //XJ[{
	friend	base_Matrix operator *(const base_Matrix &, const double &); //  "
	friend	base_Matrix operator /(const base_Matrix &, const double &); //  "


	base_Matrix	operator =(const base_Matrix &); //
	//͕sKvȗ̈J悤ݒ肳ĂnY^^;
	base_Matrix	operator +=(const base_Matrix &);
	base_Matrix	operator -=(const base_Matrix &);
	base_Matrix	operator *=(const double &);
	base_Matrix	operator /=(const double &);
    //*= base_Matrix͍ĂȂ (ʂAB != BA)

	friend	base_Matrix operator ~(const base_Matrix &);// transposed matrix
//	friend	base_Matrix operator ^(const base_Matrix &);// inverse matrix

	friend	int  operator ==(const base_Matrix &, const base_Matrix &);
	friend	int  operator !=(const base_Matrix &, const base_Matrix &);

	double	determinant(); // determinant
	int		rank();           // rank
	void	det_rank(double &, int &); //detetminant and rank
	base_Matrix inverse();	//tspivotB
						//Zɂint̖@(ex.5/3=1)KĂ̂ŒӁB
	CMessages Output();	//f[^̏o
	Type	youso(int, int);//s̗vfo

	void	to_array(Type *); //s̓ezɃRs[
	Type *	to_array();		//s̓ezɃRs[

	bool	add(int, int, Type); //vfɑ
	bool	sub(int, int, Type); //          
	bool	mul(int, int, Type); //          |
	bool	div(int, int, Type); //          
	bool	equal(int, int, Type);//         

	void	mod(int);	//modvZ
	base_Matrix	GetiGyou(int);	//iso
	base_Matrix	GetiRetsu(int); //io
	bool	ChangeGyou(int,int);	//sxsysꊷ
	bool	ChangeRetsu(int,int);	//sxyꊷ
	bool	retsu(int k,Type x);		//kڂ̗vfׂxɂB
	bool	gyou(int k, Type x);		//ksڂ̗vfׂxɂB
	bool	AddGyou(int x, int y);	//xsysɑ

	friend base_Matrix MatrixMerge1(base_Matrix &, base_Matrix &);

protected:
	void change(Type &x, Type &y){Type z; z=x; x=y; y=z;};

private:
	bool myMalloc(int size)
	{
		mtx = new Type[size];
		if(*mtx == NULL)	return false;
		else				return true;
	};
};

typedef base_Matrix<int> iMatrix;
typedef base_Matrix<double> Matrix;


/*********** RXgN^ ***********/
template<class Type>
base_Matrix<Type>::base_Matrix(int mm, int nn, Type *p/*=NULL*/)
{
	m = mm;
	n = nn;

	this->myMalloc(m*n);

	if(p != NULL) {
		for(int i = 0; i < m; i++)
			for(int j = 0; j < n; j++)
				mtx[i*n+j] = p[i*n+j];
	} else {
		for(int i = 0; i < m*n; i++)
			mtx[i] = 0;
	}
}

template<class Type>
base_Matrix<Type>::base_Matrix(int nn, char *cc)
{
	m = n = nn;
	
	this->myMalloc(m*n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			if(i == j)
				mtx[i*n+j] = 1;
			else
				mtx[i*n+j] = 0;
}

template<class Type>
base_Matrix<Type>::base_Matrix(const base_Matrix<Type> &A)
{
	if(A.mtx == NULL) {
		n = m = 0;
		mtx = NULL;
	} else {
		m = A.m; n = A.n;
		this->myMalloc(m*n);

		for(int i = 0; i < m; i++)
			for(int j = 0; j < n; j++)
				mtx[i*n+j] = A.mtx[i*n+j];
	}
}

/************** operator̒` ***************/

template<class Type>
base_Matrix<Type> operator +(const base_Matrix<Type> &A)
{
	return A;
}

template<class Type>
base_Matrix<Type> operator -(const base_Matrix<Type> &A)
{
	base_Matrix<Type> B(A.m,A.n);
	int m = A.m, n = A.n;

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			B.mtx[i*n+j] = -A.mtx[i*n+j];
	return B;
}

template<class Type>
base_Matrix<Type>
 operator +(const base_Matrix<Type> &A, const base_Matrix<Type> &B)
{
	base_Matrix<Type> C;

	int m = A.m, n = A.n;

	if(A.m != B.m || A.n != B.n){
		cout << "Zł܂łB\n";
		return C;
	}
	C = base_Matrix<Type>(m,n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			C.mtx[i*n+j] = A.mtx[i*n+j] + B.mtx[i*n+j]; 

	return C;
}

template<class Type>
base_Matrix<Type>
 operator -(const base_Matrix<Type> &A, const base_Matrix<Type> &B)
{
	base_Matrix<Type> C;

	int m = A.m, n = A.n;

	if(A.m != B.m || A.n != B.n){
		cout << "Zł܂łB\n";
		return C;
	}
	C = base_Matrix<Type>(m,n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			C.mtx[i*n+j] = A.mtx[i*n+j] - B.mtx[i*n+j]; 

	return C;
}

template<class Type>
base_Matrix<Type>
 operator *(const base_Matrix<Type> &A, const base_Matrix<Type> &B)
{
	base_Matrix<Type> C;
	int m = A.m, n = B.n, l = A.n;

	if(A.n != B.m){
		cout <<"Zł܂ł\n";
		return C;
	}else {
		C = base_Matrix<Type>(m, n);

		for(int i = 0; i < m; i++)
			for(int j = 0; j < n; j++)
				for(int k = 0; k < l; k++)
					C.mtx[i*n+j] += A.mtx[i*l+k]*B.mtx[k*n+j];
		return C;
	}
}

template<class Type>
base_Matrix<Type>
 operator *(const double &x, const base_Matrix<Type> &A)
{
	base_Matrix<Type> C;

	if(A.mtx == NULL) {
		cout << "XJ[{ł܂łB\n";
		return C;
	}
	int m = A.m, n = A.n;
	C = base_Matrix<Type>(m, n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			C.mtx[i*n+j] = x*A.mtx[i*n+j];

	return C;
}

template<class Type>
base_Matrix<Type>
 operator *(const base_Matrix<Type> &A, const double &x)
{
	base_Matrix<Type> C;

	if(A.mtx == NULL) {
		cout << "XJ[{ł܂łB\n";
		return C;
	}
	int m = A.m, n = A.n;
	C = base_Matrix<Type>(m, n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			C.mtx[i*n+j] = x*A.mtx[i*n+j];

	return C;
}

template<class Type>
base_Matrix<Type> operator /(const base_Matrix<Type> &A, const double &x)
{
	base_Matrix<Type> C;

	if(!x){
		cout << "0ł\n";
		return C;
	}else if(A.mtx == NULL) {
		cout << "Zł܂łB\n";
		return C;
	}
	int m = A.m, n = A.n;
	C = base_Matrix<Type>(m, n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			C.mtx[i*n+j] = A.mtx[i*n+j] / (Type)x;

	return C;
}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::operator =(const base_Matrix<Type> &A)
{
	if(A.mtx == mtx) //̏ꍇ
		return *this;

	if(mtx != NULL)
		delete[] mtx;

	if(A.mtx == NULL) {
		m = n = 0;
		mtx = NULL;
		return *this;
	}

	m = A.m; n = A.n;

	if(A.mtx != NULL) {
		this->myMalloc(m*n);

		for(int i = 0; i < m; i++)
			for(int j = 0; j < n; j++)
				mtx[i*n+j] = A.mtx[i*n+j];
	}else
	 mtx = NULL;
	
	 return *this;
}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::operator +=(const base_Matrix<Type> &A)
{
	if(A.mtx == NULL) {
		cout << "Zł܂\n";
		return *this;
	} else if(mtx == NULL) {     // A𓚂ɂ 
		m = A.m; n = A.n;
		this->myMalloc(m*n);

		for(int i = 0; i < m; i++)
			for(int j = 0; j < n; j++)
				mtx[i*n+j] = A.mtx[i*n + j];

		return *this;
	}
	else if(m != A.m || n != A.n) {
		cout << "傫Ⴂ܂\n";
		return *this;
	}

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			mtx[i*n+j] += A.mtx[i*n+j];

	return *this;
}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::operator -=(const base_Matrix<Type> &A)
{
	int mm = A.m, nn = A.n;

	if(A.mtx == NULL) {
		cout << "Zł܂\n";
		return *this;
	}else if(mtx == NULL) { // -A𓚂ɂB
		m = A.m; n = A.n;
		this->myMalloc(m*n);

		for(int i = 0; i < mm; i++)
			for(int j = 0; j < nn; j++)
				mtx[i*n+j] = -A.mtx[i*n+j];
		return *this;
	} else if(m != A.m || n != A.n) {
		cout << "傫Ⴂ܂\n";
		return *this;
	}

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			mtx[i*n+j] -= A.mtx[i*n+j];

	return *this;
}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::operator *=(const double &x)
{
	if(mtx == NULL) {
		cout << "XJ[{ł܂\n";
		return *this;
	}

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			mtx[i*n+j] *= x;

	return *this;
}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::operator /=(const double &x)
{
	if(mtx == NULL) {
		cout << "XJ[{ł܂\n";
		return *this;
	}

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			mtx[i*n+j] /= (Type)x;

	return *this;
}

template<class Type>
base_Matrix<Type> operator~(const base_Matrix<Type> &A)
{
	base_Matrix<Type> B;

	if(A.mtx == NULL)
		return B;

	int m = A.n, n = A.m;
	B = base_Matrix<Type>(m, n);

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			B.mtx[i*n+j] = A.mtx[j*m+i];

	return B;
}

template<class Type>
bool  operator ==(const base_Matrix<Type> &A, const base_Matrix<Type> &B)
{
	if(A.mtx == NULL || B.mtx == NULL)
		return false;
	else if(A.m != B.m || A.n != B.n)
		return false;

	int m = A.m, n = A.n;
	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			if(A.mtx[i*n+j] != B.mtx[i*n+j])
				return false;
	return true;
}

template<class Type>
bool  operator !=(const base_Matrix<Type> &A, const base_Matrix<Type> &B)
{
	if(A.mtx == NULL || B.mtx == NULL)
		return true;
	else if(A.m != B.m || A.n != B.n)
		return true;

	int m = A.m, n = A.n;

	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			if(A.mtx[i*n+j] != B.mtx[i*n+j])
				return true;
	return false;
}

/*********** o[֐ *************/
template<class Type>
CMessages base_Matrix<Type>::Output()
{
	CMessages ms;
	if(mtx == NULL){
		ms = "No Matrix\n";
	} else {
		bool flg;
		if(sizeof(int) == sizeof(Type))
			flg = true;

		const int max = 256;
		char str[max];
		
		sprintf(str, "(%d , %d)\n",m, n);
		ms = str;

		for(int i = 0;i < m; i++) {
			for(int j = 0; j < n; j++) {
				if(flg)	sprintf(str, "%d ",  mtx[i*n+j]);
				else	sprintf(str, "%lf ",  mtx[i*n+j]);
				ms += str;
			}
			ms += "\n";
		}
	}
	return ms;
}

template<class Type>
Type base_Matrix<Type>::youso(int mm, int nn)
{
	if(mm >= m || nn >= n || mm < 0 || nn < 0) {
		cout << "̂悤ȗvf݂͑܂\n";
		return 0;
	}
	else
		return mtx[mm*n+nn];
}

template<class Type>
void base_Matrix<Type>::to_array(Type *M)
{
	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			M[i*n+j] = mtx[i*n+j];
}

template<class Type>
Type * base_Matrix<Type>::to_array()
{
	Type *M = new Type[m*n];
	this->to_array(M);
	return M;
}


/************@vf(i,j)x𑫂iA|AAj********/
template<class Type>
bool base_Matrix<Type>::add(int i, int j, Type x)
{
	if(mtx == NULL || i >= m || j >= n || i < 0 || j < 0) {
		cout << "cannot add\n";		return false;
	}
	mtx[i*n + j] += x;	return true;
}

template<class Type>
bool base_Matrix<Type>::sub(int i, int j, Type x)
{
	if(mtx == NULL || i >= m || j >= n || i < 0 || j < 0) {
		cout << "cannot subtract\n";	return false;
	}
	mtx[i*n + j] -= x;	return true;
}

template<class Type>
bool base_Matrix<Type>::mul(int i, int j, Type x)
{
	if(mtx == NULL || i >= m || j >= n || i < 0 || j < 0) {
		cout << "cannot multiply\n";		return false;
	}
	mtx[i*n + j] *= x; return true;
}

template<class Type>
bool base_Matrix<Type>::div(int i, int j, Type x)
{
	if(mtx == NULL || i >= m || j >= n || i < 0 || j < 0) {
		cout << "cannot divide\n";	return false;
	}
	if(x == 0) {
		cout << "divided by zero!";	return false;
	}
	mtx[i*n + j] /= x;	return true;
}

template<class Type>
bool base_Matrix<Type>::equal(int i, int j, Type x)
{
	if(mtx == NULL || i >= m || j >= n || i < 0 || j < 0) {
		cout << "cannot subsituate\n";	return false;
	}
	mtx[i*n + j] = x;	return true;
}

template<class Type>
bool base_Matrix<Type>::retsu(int k, Type x)
{//kڂ̗vfׂxɂB
	if(mtx == NULL || k >= m || k < 0) {
		cout << "cannot subsituate\n";	return false;
	}
	for(int i = 0; i < m; i++)
		mtx[i*n + k] = x;
	return true;
}

template<class Type>
bool base_Matrix<Type>::gyou(int k, Type x)
{//ksڂ̗vfׂxɂB
	if(mtx == NULL || k >= m || k < 0) {
		cout << "cannot subsituate\n";	return false;
	}
	for(int i = 0; i < m; i++)
		mtx[k*n + i] = x;
	return true;

}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::GetiGyou(int k)
{//isڂ𓾂
	Type *array;

	if(mtx == NULL || k >= m || k < 0)
		return base_Matrix<Type>();
	array = new int[n];
	for(int i=0; i<n; i++)
		array[i] = mtx[k*n + i];
	return base_Matrix<Type>(1, n, array);
}

template<class Type>
base_Matrix<Type> base_Matrix<Type>::GetiRetsu(int k)
{//iڂ𓾂
	Type *array;

	if(mtx == NULL || k >= n || k < 0)
		return base_Matrix<Type>();
	array = new Type[m];
	for(int i=0; i<m; i++)
		array[i] = mtx[i*n + k];
	return base_Matrix<Type>(1,m,array);
}

template<class Type>
bool base_Matrix<Type>::ChangeGyou(int x, int y)
{//sxsysꊷ
	if(mtx == NULL || x >= m || y >= m || x < 0 || y < 0) return false;
	for(int i = 0; i < n; i++)
		change(mtx[x*n+i], mtx[y*n+i]);
	return true;
}

template<class Type>
bool base_Matrix<Type>::ChangeRetsu(int x, int y)
{//sxyꊷ
	if(mtx == NULL || x >= n || y >= n || x==y || x < 0 || y < 0) return false;
	for(int i = 0; i < m; i++)
		change(mtx[i*n+x], mtx[i*n+y]);
	return true;
}

template<class Type>
bool base_Matrix<Type>::AddGyou(int x, int y)
{//xsysɑ
	if(mtx == NULL || x >= m || y >= m || x < 0 || y < 0) {
		cout << "xsys𑫂Ƃ͂ł܂B";
		return false;
	}
	for(int i = 0; i < n; i++)
		mtx[y*n+i] += mtx[x*n+i];
	return true;
}

template<class Type>
double  base_Matrix<Type>::determinant()
{
	double det=0;
	int rank;

	if(m != n)
		return 0.0;

	this->det_rank(det, rank);
	return det;
}

template<class Type>
int base_Matrix<Type>::rank()
{
	double det;
	int rank;

	this->det_rank(det, rank);
	return rank;
}

template<class Type>
void base_Matrix<Type>::det_rank(double &det, int &rank)
{
	int i, j, k, index, column, pos;
	Type pivot, max, sgn, temp;
	Type *M;

	M = new Type[m*n];

	this->to_array(M);

	det = sgn = 1;
	k = 0;
	while(k < m) {
		index = column = k * n;
		max = (Type)fabs(M[index+k]);
		for(i = k+1; i < m; i++) {
			pos = i * n;
			if(fabs(M[pos+k]) > max) {
				column = pos;
				max = (Type)fabs(M[pos+k]);
			}
		}
		if(max <= matrix_eps) {
			free(M);
			rank = k;
			det = 0;
			return;
		}
		if(column != index) {
			sgn *= -1;
			for(j = k; j < n; j++)
				change(M[index+j], M[column+j]);
		}
		pivot = M[index+k];
		det *= pivot;
		for(i = k+1; i < m; i++) {
			pos = i*n;
			temp = M[pos+k]/pivot;
			for(j = k; j < n; j++)
				M[pos+j] -= temp*M[index+j];
		}
		k++;
	}
	free(M);
	rank = k;
	det *= sgn;

	return;
}


template<class Type>
base_Matrix<Type> base_Matrix<Type>::inverse()
{
	int i, j, k, index, column, pos;
	Type pivot, max, temp;
	base_Matrix<Type> B;
	Type *M;

	if(mtx == NULL || m != n)
		return B;

	B = base_Matrix<Type>(m, "E");

	M = to_array();

	k = 0;
	while(k < m) {
		index = column = k * n;
		max = (Type)fabs(M[index+k]);
		for(i = k+1; i < m; i++) {
			pos = i * n;
			if(fabs(M[pos+k]) > max) {
				column = pos;
				max = (Type)fabs(M[pos+k]);
			}
		}
		if(max <= matrix_eps) {
			printf("ts݂͑܂\n");
			return B;
		}

		if(column != index) {
			for(j = 0; j < n; j++) { 
				change(M[index+j], M[column+j]);
				change(B.mtx[index+j], B.mtx[column+j]);
			}
		}
		pivot = M[index+k];
		M[index+k] = 1;

		for(j = 0; j <= k; j++)
			B.mtx[index+j] /= pivot;
		for(j = k+1; j < n; j++) {
			M[index+j] /= pivot;
			B.mtx[index+j] /= pivot;
		}

		for(i = 0; i < m; i++) {
			pos = i*n;
			temp = M[pos+k];
			if(i != k)
				for(j = 0; j < n; j++){
					M[pos+j] -= temp*M[index+j];
					B.mtx[pos+j] -= temp*B.mtx[index+j];
				}
		}
		k++;

	}

	delete[] M;
	return B;
}
template<class Type>
void base_Matrix<Type>::mod(int mm)
{//mm@ƂČvZ
	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			(int)mtx[n*i+j] = abs(mtx[n*i+j])%mm;
}

template<class Type>
base_Matrix<Type> MatrixMerge1(base_Matrix<Type> &A, base_Matrix<Type> &B)
{//čsAB
	Type *ans;
	if(B.mtx == NULL) return A;
	if(A.mtx == NULL) return B;
	if(A.m != B.m) {	//TCY킸ɍłȂ
		cout << "ł܂\n";
		return A;
	}
	int new_n = B.n+A.n;	//Vs̗TCY
	int i, j;
	ans = new Type[A.m*new_n];
	for(i = 0; i < A.m; i++) {
		for(j = 0; j < A.n; j++)
			ans[i*new_n+j] = A.youso(i,j);
		for(j = 0; j < B.n; j++)
			ans[i*new_n+A.n+j] = B.youso(i,j);
	}
	return base_Matrix<Type>(A.m, new_n, ans);
}

#endif