(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    156499,       3677]*)
(*NotebookOutlinePosition[    157246,       3702]*)
(*  CellTagsIndexPosition[    157202,       3698]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(\:ff11\:ff10\:ff0e\) \:ff14\ \ \ \ 
      \:30b0\:30e9\:30d5\:306e\:5e73\:9762\:6027\:5224\:5b9a\)], "Input"],

Cell[TextData[
"\n\:3000    \:30b0\:30e9\:30d5\:304c\:5e73\:9762\:7684\:30b0\:30e9\:30d5\
\:3067\:3042\:308b\:304b\:3069\:3046\:304b\:3092\:5224\:5b9a\:3059\:308b\:305f\
\:3081\:306e\:3001\:591a\:9805\:5f0f\:30aa\:30fc\:30c0\:306e\:30a2\:30eb\:30b4\
\:30ea\:30ba\:30e0\:304c\:65e2\:306b\:77e5\:3089\:308c\:3066\:3044\:308b\:ff08\
[AP], [HT]\:ff09\:3002\:3053\:3053\:3067\:306f\:3001\:5e73\:9762\:6027\:5224\
\:5b9a\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306b\:3064\:3044\:3066\:8003\:3048\
\:308b\:3002"], "Text"],

Cell[BoxData[
    \(\:30b5\:30a4\:30af\:30eb\:3068\:5207\:7247\)], "Input"],

Cell[TextData[{
  "\:3000    \:307e\:305a\:3001\:5e73\:9762\:6027\:5224\:5b9a\:306b\:91cd\
\:8981\:306a\:610f\:5473\:3092\:6301\:3064\:5207\:7247\:3068\:3044\:3046\:6982\
\:5ff5\:3092\:5b9a\:3081\:308b\:3002\:30b0\:30e9\:30d5\:ff27\:306e\:90e8\:5206\
\:30b0\:30e9\:30d5\:ff28\:304c\:4e0e\:3048\:3089\:308c\:305f\:3068\:304d\:3001\
E(G)\:30fcH(G) \:306e\:8fba\:306e\:9593\:306b\:6b21\:306e\:3088\:3046\:306a\
\:95a2\:4fc2 ~\:3092\:5b9a\:3081\:308b\:3002\n\:3000",
  Cell[BoxData[
      \(TraditionalForm\`e\_1\)]],
  " \:3068",
  Cell[BoxData[
      \(TraditionalForm\`\(\ e\_2\)\)]],
  "\:3068\:304c\:95a2\:4fc2",
  Cell[BoxData[
      \(TraditionalForm\`\(\ e\_1\)\)]],
  " ~",
  Cell[BoxData[
      \(TraditionalForm\`\(\ e\_2\)\)]],
  "\:3092\:6301\:3064\:306e\:306f\:3001\:6b21\:306e\:6761\:4ef6\:3092\:6e80\
\:305f\:3059\:3068\:304d\:3067\:3042\:308b\:3002\n\:ff08\:ff11\:ff09\:3000",
  Cell[BoxData[
      \(TraditionalForm\`e\_1\)]],
  "\:3068",
  Cell[BoxData[
      \(TraditionalForm\`e\_2\)]],
  "\:3068\:3092\:7d50\:3076\:9053\:ff30\:304c\:3042\:308b\:3002\n\:ff08\:ff12\
\:ff09   \:ff30\:306e\:5185\:70b9\:ff08\:ff30\:306e\:59cb\:70b9\:3068\:7d42\
\:70b9\:4ee5\:5916\:306e\:9802\:70b9\:ff09\:306f\:3001\:ff28\:306b\:542b\:307e\
\:308c\:306a\:3044\:3002\n\:3053\:306e\:3068\:304d\:3001\:3053\:306e\:95a2\
\:4fc2\:306f\:660e\:3089\:304b\:306b\:540c\:5024\:95a2\:4fc2\:3067\:3042\:308b\
\:3002E(G)\:30fcE(H) \:306e\:8981\:7d20\:3092\:3001\:3053\:306e\:540c\:5024\
\:95a2\:4fc2\:3067\:985e\:5225\:3057\:305f\:3068\:304d\:306e\:540c\:5024\:985e\
\:306e\:4f5c\:308b\:96c6\:5408\:3092\:3001\:ff28\:306e\:5207\:7247(bridge)\
\:3068\:8a00\:3046\:3002\:307e\:305f\:3001\:5207\:7247\:ff33\:3068\:ff28\:3068\
\:306e\:5171\:901a\:9802\:70b9\:3092\:ff08H\:306b\:95a2\:3059\:308b\:ff09\
\:ff33\:306e\:63a5\:5408\:70b9\:3068\:8a00\:3046\:3002\n\:3000\:4ee5\:964d\
\:306e\:8b70\:8ad6\:3067\:306f\:3001\:90e8\:5206\:30b0\:30e9\:30d5\:ff28\:304c\
\:30b5\:30a4\:30af\:30eb\:ff23\:3067\:3042\:308b\:5834\:5408\:306e\:307f\:3092\
\:8003\:3048\:308b\:3002\n\:3000\:4f8b\:3048\:3070\:3001\:6b21\:306e\:30b0\
\:30e9\:30d5\:ff27\:3067\:3001\:ff23\:3092\:30b5\:30a4\:30af\:30eb{1,2,3,1}\
\:3068\:3059\:308b\:3068\:3001\:ff12\:3064\:306e\:5207\:7247 \:304c\:3042\
\:308a\:3001\:305d\:308c\:3089\:3092\:8fba\:306e\:96c6\:5408\:3067\:8868\:3059\
\:3068\:3001{{1,4},{2,4},{3,4}}\:3068{{1,5},{3,5}}\:3067\:3042\:308b\:3002\n",
  
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0454545 0.909091 0.0652174 1.30435 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.34848 .93478 Mdot
.04545 .5 Mdot
.34848 .06522 Mdot
.65152 .5 Mdot
.95455 .5 Mdot
.5 Mabswid
.34848 .93478 m
.04545 .5 L
s
.34848 .93478 m
.34848 .06522 L
s
.34848 .93478 m
.65152 .5 L
s
.34848 .93478 m
.95455 .5 L
s
.04545 .5 m
.34848 .93478 L
s
.04545 .5 m
.34848 .06522 L
s
.04545 .5 m
.65152 .5 L
s
.34848 .06522 m
.34848 .93478 L
s
.34848 .06522 m
.04545 .5 L
s
.34848 .06522 m
.65152 .5 L
s
.34848 .06522 m
.95455 .5 L
s
.65152 .5 m
.34848 .93478 L
s
.65152 .5 m
.04545 .5 L
s
.65152 .5 m
.34848 .06522 L
s
.95455 .5 m
.34848 .93478 L
s
.95455 .5 m
.34848 .06522 L
s
.34848 .93478 m
.04545 .5 L
s
.34848 .93478 m
.34848 .06522 L
s
.34848 .93478 m
.65152 .5 L
s
.34848 .93478 m
.95455 .5 L
s
.04545 .5 m
.34848 .93478 L
s
.04545 .5 m
.34848 .06522 L
s
.04545 .5 m
.65152 .5 L
s
.34848 .06522 m
.34848 .93478 L
s
.34848 .06522 m
.04545 .5 L
s
.34848 .06522 m
.65152 .5 L
s
.34848 .06522 m
.95455 .5 L
s
.65152 .5 m
.34848 .93478 L
s
.65152 .5 m
.04545 .5 L
s
.65152 .5 m
.34848 .06522 L
s
.95455 .5 m
.34848 .93478 L
s
.95455 .5 m
.34848 .06522 L
s
[(1)] .32121 .89565 0 1 Mshowa
[(2)] .01818 .46087 0 1 Mshowa
[(3)] .32121 .02609 0 1 Mshowa
[(4)] .62424 .46087 0 1 Mshowa
[(5)] .92727 .46087 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 288},
    ImageMargins->{{43, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooe[o0P34o`00G?l00`3oo`31o`00Fol00`3o
o`32o`00G?l00`3oo`31o`00F_l00`3o0033o`00Fol00`3oo`32o`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00H_l30;_o001Qo`D0^_l0063o
1`2io`00H?l70;Wo001Po`L0^Ol0067o1@000ol0o`2go`00H_l30004o`3o0;Oo001Qo`040?oo00;o
00@0o`00]Ol0067o00@0ool00_l01@3oool00;Co001Po`050?ooo`000ol01@3oool00;?o001Oo`03
0?oo00;o00<0ool00_l0103oool20;7o001No`030?oo00?o00<0ool00ol00`3oo`02o`030?oo0:ko
001No`030?oo00?o00<0ool00ol00`3oo`03o`80[_l005go00<0ool01?l00`3oo`04o`030?oo00Co
00<0ool0Zol005co00<0ool01Ol00`3oo`05o`030?oo00Co00<0ool0Z_l005co00<0ool01Ol00`3o
o`05o`030?oo00Go0P2Zo`00Fol00`3oo`06o`030?oo00Ko00<0ool01_l00`3oo`2Wo`00F_l00`3o
o`07o`030?oo00Oo00<0ool01_l20:Oo001Jo`030?oo00Oo00<0ool01ol00`3oo`08o`030?oo0:Co
001Io`030?oo00So00<0ool02?l00`3oo`08o`030?oo0:?o001Ho`030?oo00Wo00<0ool02Ol00`3o
o`08o`80Xol005Oo00<0ool02_l00`3oo`09o`030?oo00[o00<0ool0X?l005Oo00<0ool02_l00`3o
o`0:o`030?oo00[o00<0ool0Wol005Ko00<0ool02ol00`3oo`0;o`030?oo00[o0P2Oo`00EOl00`3o
o`0<o`030?oo00_o00<0ool03?l00`3oo`2Lo`00EOl00`3oo`0<o`030?oo00co00<0ool03?l209co
001Do`030?oo00go00<0ool03Ol00`3oo`0=o`030?oo09Wo001Co`030?oo00ko00<0ool03_l00`3o
o`0=o`030?oo09So001Co`030?oo00ko00<0ool03_l00`3oo`0>o`80V?l005;o00<0ool03ol00`3o
o`0?o`030?oo00oo00<0ool0UOl0057o00<0ool04?l00`3oo`0@o`030?oo00oo0P2Eo`00DOl00`3o
o`0@o`030?oo013o00<0ool04Ol00`3oo`2Bo`00D?l00`3oo`0Ao`030?oo017o00<0ool04Ol00`3o
o`2Ao`00Col00`3oo`0Bo`030?oo01;o00<0ool04Ol2097o001>o`030?oo01?o00<0ool04_l00`3o
o`0Co`030?oo08ko001>o`030?oo01?o00<0ool04ol00`3oo`0Co`030?oo08go001=o`030?oo01Co
00<0ool05?l00`3oo`0Co`80SOl004co00<0ool05Ol00`3oo`0Do`030?oo01Go00<0ool0R_l004co
00<0ool05Ol00`3oo`0Eo`030?oo01Go0P2:o`00Bol00`3oo`0Fo`030?oo01Ko00<0ool05_l00`3o
o`27o`00B_l00`3oo`0Go`030?oo01Ko00<0ool05ol00`3oo`26o`00B_l00`3oo`0Go`030?oo01Oo
00<0ool05ol208Ko0019o`030?oo01So00<0ool06?l00`3oo`0Ho`030?oo08?o0018o`030?oo01Wo
00<0ool06Ol00`3oo`0Ho`80Pol004Oo00<0ool06_l00`3oo`0Io`030?oo01[o00<0ool0P?l004Oo
00<0ool06_l00`3oo`0Jo`030?oo01[o00<0ool0Ool004Ko00<0ool06ol00`3oo`0Ko`030?oo01[o
0P1oo`00AOl00`3oo`0Lo`030?oo01_o00<0ool07?l00`3oo`1lo`00AOl00`3oo`0Lo`030?oo01co
00<0ool07?l00`3oo`1ko`00A?l00`3oo`0Mo`030?oo01go00<0ool07?l207_o0013o`030?oo01ko
00<0ool07Ol00`3oo`0No`030?oo07So0013o`030?oo01ko00<0ool07_l00`3oo`0No`80N?l004;o
00<0ool07ol00`3oo`0Oo`030?oo01oo00<0ool0MOl0047o00<0ool08?l00`3oo`0Oo`030?oo023o
00<0ool0M?l0047o00<0ool08?l00`3oo`0Po`030?oo023o0P1do`00@?l00`3oo`0Qo`030?oo027o
00<0ool08Ol00`3oo`1ao`00?ol00`3oo`0Ro`030?oo027o00<0ool08_l2077o000no`030?oo02?o
00<0ool08_l00`3oo`0So`030?oo06ko000no`030?oo02?o00<0ool08ol00`3oo`0So`030?oo06go
000mo`030?oo02Co00<0ool09?l00`3oo`0So`80KOl003co00<0ool09Ol00`3oo`0To`030?oo02Go
00<0ool0J_l003co00<0ool09Ol00`3oo`0Uo`030?oo02Go00<0ool0JOl003_o00<0ool09_l00`3o
o`0Vo`030?oo02Go0P1Yo`00>_l00`3oo`0Wo`030?oo02Ko00<0ool09ol00`3oo`1Vo`00>_l00`3o
o`0Wo`030?oo02Oo00<0ool09ol206Ko000io`030?oo02So00<0ool0:?l00`3oo`0Xo`030?oo06?o
000ho`030?oo02Wo00<0ool0:?l00`3oo`0Yo`030?oo06;o000go`030?oo02[o00<0ool0:Ol00`3o
o`0Yo`80H_l003Oo00<0ool0:_l00`3oo`0Zo`030?oo02[o00<0ool0Gol003Ko00<0ool0:ol00`3o
o`0Zo`030?oo02_o0P1Oo`00=Ol00`3oo`0/o`030?oo02_o00<0ool0;?l00`3oo`1Lo`00=Ol00`3o
o`0/o`030?oo02co00<0ool0;?l00`3oo`1Ko`00=?l00`3oo`0]o`030?oo02co00<0ool0;Ol205_o
000co`030?oo02ko00<0ool0;Ol00`3oo`0^o`030?oo05So000co`030?oo02ko00<0ool0;_l00`3o
o`0^o`030?oo05Oo000bo`030?oo02oo00<0ool0;ol00`3oo`0^o`80Eol0037o00<0ool0<?l00`3o
o`0_o`030?oo033o00<0ool0E?l0033o00<0ool0<Ol00`3oo`0`o`030?oo033o0P1Do`00<?l00`3o
o`0ao`030?oo037o00<0ool0<Ol00`3oo`1Ao`00;ol00`3oo`0bo`030?oo037o00<0ool0<_l00`3o
o`1@o`00;_l00`3oo`0co`030?oo03;o00<0ool0<_l2053o000^o`030?oo03?o00<0ool0<ol00`3o
o`0co`030?oo04go000]o`030?oo03Co00<0ool0<ol00`3oo`0do`80COl002co00<0ool0=Ol00`3o
o`0do`030?oo03Go00<0ool0B_l002co00<0ool0=Ol00`3oo`0eo`030?oo03Go00<0ool0BOl002_o
00<0ool0=_l00`3oo`0eo`030?oo03Ko0P19o`00:_l00`3oo`0go`030?oo03Ko00<0ool0=ol00`3o
o`16o`00:_l00`3oo`0go`030?oo03Oo00<0ool0=ol00`3oo`15o`00:Ol00`3oo`0ho`030?oo03Oo
00<0ool0>?l204Go000Xo`030?oo03Wo00<0ool0>?l00`3oo`0io`030?oo04;o000Wo`030?oo03[o
00<0ool0>Ol00`3oo`0io`80@_l002Oo00<0ool0>_l00`3oo`0jo`030?oo03[o00<0ool0?ol002Ko
00<0ool0>ol00`3oo`0jo`030?oo03_o00<0ool0?_l002Go00<0ool0??l00`3oo`0ko`030?oo03_o
0P0no`009Ol00`3oo`0lo`030?oo03co00<0ool0??l00`3oo`0ko`009?l00`3oo`0mo`030?oo03co
00<0ool0?Ol203_o000So`030?oo03ko00<0ool0?Ol00`3oo`0no`030?oo03So000So`030?oo03ko
00<0ool0?_l00`3oo`0no`030?oo03Oo000Ro`030?oo03oo00<0ool0?_l00`3oo`0oo`80=ol0027o
00<0ool0@?l00`3oo`0oo`030?oo043o00<0ool0=?l0023o00<0ool0@Ol00`3oo`10o`030?oo043o
00<0ool0<ol0023o00<0ool0@Ol00`3oo`10o`030?oo047o0P0co`007ol00`3oo`12o`030?oo047o
00<0ool0@_l00`3oo`0`o`007_l00`3oo`13o`030?oo04;o00<0ool0@_l2033o000No`030?oo04?o
00<0ool0@_l00`3oo`14o`030?oo02go000Mo`030?oo04Co00<0ool0@ol00`3oo`14o`030?oo02co
000Lo`030?oo04Go00<0ool0A?l00`3oo`14o`80;?l001co00<0ool0AOl00`3oo`15o`030?oo04Go
00<0ool0:Ol001_o00<0ool0A_l00`3oo`15o`030?oo04Ko0P0Yo`000ol301Co00<0ool0Aol00`3o
o`16o`030?oo00;o0`12o`030?oo00oo00<0ool05?l000?o00<0ool05?l00`3oo`17o`030?oo04Oo
00<0ool00_l00`3oo`12o`030?oo00go00<0o`005Ol000Co00<0ool04_l00`3oo`18o`030?oo04Oo
00<0ool01014o`803ol00`3oo`0Co`001?l00`3oo`0Ao`030?oo04Wo00<0ool0B?l01@3o0?l004Oo
00<0ool02_l201Ko0003o`030?l0017o00<0ool0B_l00`3oo`19o`040?l004So00<0ool02Ol00`3o
o`0Eo`001?l00`3oo`0@o`030?oo04[o00<0ool0BOl0103oo`19o`802Ol301Go000Fo`030?oo04_o
00<0ool0B_l00`3oo`1;o`030?oo01ko000Eo`030?oo04co00<0ool0Bol00`3oo`1;o`807_l001Go
00<0ool0C?l00`3oo`1;o`030?oo04go00<0ool06ol001Co00<0ool0COl00`3oo`1<o`030?oo04go
00<0ool06_l001?o00<0ool0C_l00`3oo`1=o`030?oo04go0P0Jo`004ol00`3oo`1>o`030?oo04go
00<0ool0Col00`3oo`0Go`004_l00`3oo`1?o`030?oo04ko00<0ool0Col201Oo000Ao`030?oo053o
00<0ool0Col00`3oo`1@o`030?oo01Co000@o`030?oo057o00<0ool0D?l00`3oo`1@o`030?oo01?o
000@o`030?oo057o00<0ool0D?l00`3oo`1Ao`804ol000_o0`000ol0o`1Co`030?oo057o101Ao`03
0?oo00<03Ol000[o1@1Eo`030?oo057o1@1Ao`H03?l000Wo1`1Do`030?oo053o1`1@o`L02ol000Wo
]@1@o`L02ol000Wo1`1Do`030?oo053o1`1@o`L02ol000[o1@1Eo`030?oo057o1@1Ao`H03?l000_o
0`000ol0o`1Co`030?oo057o101Ao`030?oo00<03Ol0013o00<0ool0DOl00`3oo`1@o`030?oo057o
0P0Co`004?l00`3oo`1Ao`030?oo053o00<0ool0D?l00`3oo`0Co`004Ol00`3oo`1@o`030?oo04oo
00<0ool0D?l00`3oo`0Do`004_l00`3oo`1?o`030?oo04ko00<0ool0Col201Oo000Co`030?oo04ko
00<0ool0COl00`3oo`1?o`030?oo01Oo000Co`030?oo04ko00<0ool0COl00`3oo`1=o`806_l001Co
00<0ool0COl00`3oo`1<o`030?oo04go00<0ool06_l001Go00<0ool0C?l00`3oo`1;o`030?oo04go
00<0ool06ol001Go00<0ool0C?l00`3oo`1;o`030?oo04_o0P0No`005_l00`3oo`1;o`030?oo04[o
00<0ool0Bol00`3oo`0No`005ol00`3oo`1:o`030?oo04Wo00<0ool0B_l2027o000Go`030?oo04[o
00<0ool0BOl00`3oo`19o`030?oo027o000Ho`030?oo04Wo00<0ool0B?l00`3oo`19o`030?oo02;o
000Io`030?oo04So00<0ool0Aol00`3oo`18o`809Ol001[o00<0ool0Aol00`3oo`17o`030?oo04Oo
00<0ool09Ol001[o00<0ool0Aol00`3oo`16o`030?oo04Oo00<0ool09_l001_o00<0ool0A_l00`3o
o`15o`030?oo04Ko0P0Yo`007?l00`3oo`15o`030?oo04Go00<0ool0AOl00`3oo`0Yo`007?l00`3o
o`15o`030?oo04Co00<0ool0A?l202co000Mo`030?oo04Co00<0ool0@ol00`3oo`14o`030?oo02co
000No`030?oo04?o00<0ool0@_l00`3oo`14o`030?oo02go000No`030?oo04?o00<0ool0@_l00`3o
o`12o`80<?l001oo00<0ool0@_l00`3oo`11o`030?oo04;o00<0ool0<?l0023o00<0ool0@Ol00`3o
o`10o`030?oo047o0P0co`008?l00`3oo`11o`030?oo043o00<0ool0@?l00`3oo`0co`008Ol00`3o
o`10o`030?oo03oo00<0ool0@?l00`3oo`0do`008_l00`3oo`0oo`030?oo03ko00<0ool0?ol203Oo
000So`030?oo03ko00<0ool0?_l00`3oo`0no`030?oo03Oo000So`030?oo03ko00<0ool0?Ol00`3o
o`0no`030?oo03So000To`030?oo03go00<0ool0??l00`3oo`0mo`80>ol002Go00<0ool0??l00`3o
o`0lo`030?oo03co00<0ool0>ol002Go00<0ool0??l00`3oo`0ko`030?oo03_o0P0no`009_l00`3o
o`0ko`030?oo03[o00<0ool0>ol00`3oo`0no`009ol00`3oo`0jo`030?oo03[o00<0ool0>_l00`3o
o`0oo`009ol00`3oo`0jo`030?oo03Wo00<0ool0>Ol204;o000Xo`030?oo03Wo00<0ool0>?l00`3o
o`0io`030?oo04;o000Yo`030?oo03So00<0ool0=ol00`3oo`0ho`80AOl002[o00<0ool0=ol00`3o
o`0go`030?oo03Oo00<0ool0AOl002[o00<0ool0=ol00`3oo`0fo`030?oo03Oo00<0ool0A_l002_o
00<0ool0=_l00`3oo`0eo`030?oo03Ko0P19o`00;?l00`3oo`0eo`030?oo03Go00<0ool0=Ol00`3o
o`19o`00;?l00`3oo`0eo`030?oo03Co00<0ool0=Ol00`3oo`1:o`00;Ol00`3oo`0do`030?oo03?o
00<0ool0=?l204go000^o`030?oo03?o00<0ool0<ol00`3oo`0co`030?oo04go000^o`030?oo03?o
00<0ool0<_l00`3oo`0bo`80D?l002oo00<0ool0<_l00`3oo`0ao`030?oo03;o00<0ool0D?l0033o
00<0ool0<Ol00`3oo`0ao`030?oo037o00<0ool0DOl0033o00<0ool0<Ol00`3oo`0`o`030?oo033o
0P1Do`00<Ol00`3oo`0`o`030?oo02oo00<0ool0<?l00`3oo`1Do`00<_l00`3oo`0_o`030?oo02oo
00<0ool0;_l205Oo000co`030?oo02ko00<0ool0;_l00`3oo`0^o`030?oo05Oo000co`030?oo02ko
00<0ool0;Ol00`3oo`0^o`030?oo05So000do`030?oo02go00<0ool0;?l00`3oo`0]o`80Fol003Go
00<0ool0;?l00`3oo`0/o`030?oo02co00<0ool0Fol003Go00<0ool0;?l00`3oo`0[o`030?oo02co
00<0ool0G?l003Ko00<0ool0:ol00`3oo`0Zo`030?oo02_o0P1Oo`00=ol00`3oo`0Zo`030?oo02[o
00<0ool0:_l00`3oo`1Oo`00=ol00`3oo`0Zo`030?oo02Wo00<0ool0:Ol206;o000ho`030?oo02Wo
00<0ool0:?l00`3oo`0Yo`030?oo06;o000io`030?oo02So00<0ool0:?l00`3oo`0Xo`030?oo06?o
000jo`030?oo02Oo00<0ool09ol00`3oo`0Wo`80I_l003[o00<0ool09ol00`3oo`0Vo`030?oo02Oo
00<0ool0I_l003_o00<0ool09_l00`3oo`0Vo`030?oo02Go0P1Yo`00??l00`3oo`0Uo`030?oo02Go
00<0ool09Ol00`3oo`1Yo`00??l00`3oo`0Uo`030?oo02Co00<0ool09Ol00`3oo`1Zo`00?Ol00`3o
o`0To`030?oo02Co00<0ool08ol206go000no`030?oo02?o00<0ool08ol00`3oo`0So`030?oo06go
000no`030?oo02?o00<0ool08_l00`3oo`0So`030?oo06ko000oo`030?oo02;o00<0ool08Ol00`3o
o`0Ro`80LOl0043o00<0ool08Ol00`3oo`0Qo`030?oo027o00<0ool0LOl0047o00<0ool08?l00`3o
o`0Po`030?oo023o0P1do`00@Ol00`3oo`0Po`030?oo01oo00<0ool08?l00`3oo`1do`00@_l00`3o
o`0Oo`030?oo01oo00<0ool07ol00`3oo`1eo`00@ol00`3oo`0No`030?oo01ko00<0ool07_l207So
0013o`030?oo01ko00<0ool07Ol00`3oo`0No`030?oo07So0014o`030?oo01go00<0ool07Ol00`3o
o`0Lo`80Nol004Go00<0ool07?l00`3oo`0Lo`030?oo01co00<0ool0Nol004Go00<0ool07?l00`3o
o`0Ko`030?oo01co00<0ool0O?l004Ko00<0ool06ol00`3oo`0Ko`030?oo01[o0P1oo`00Aol00`3o
o`0Jo`030?oo01[o00<0ool06_l00`3oo`1oo`00Aol00`3oo`0Jo`030?oo01Wo00<0ool06_l00`3o
o`20o`00B?l00`3oo`0Io`030?oo01Wo00<0ool06?l208?o0019o`030?oo01So00<0ool06?l00`3o
o`0Ho`030?oo08?o001:o`030?oo01Oo00<0ool05ol00`3oo`0Go`80Q_l004[o00<0ool05ol00`3o
o`0Fo`030?oo01Oo00<0ool0Q_l004_o00<0ool05_l00`3oo`0Fo`030?oo01Ko00<0ool0Qol004co
00<0ool05Ol00`3oo`0Eo`030?oo01Go0P2:o`00C?l00`3oo`0Eo`030?oo01Co00<0ool05Ol00`3o
o`2:o`00COl00`3oo`0Do`030?oo01Co00<0ool04ol208go001>o`030?oo01?o00<0ool04ol00`3o
o`0Co`030?oo08go001>o`030?oo01?o00<0ool04_l00`3oo`0Co`030?oo08ko001?o`030?oo01;o
00<0ool04_l00`3oo`0Ao`80TOl0053o00<0ool04Ol00`3oo`0Ao`030?oo017o00<0ool0TOl0057o
00<0ool04?l00`3oo`0@o`030?oo017o00<0ool0T_l0057o00<0ool04?l00`3oo`0@o`030?oo00oo
0P2Eo`00D_l00`3oo`0?o`030?oo00oo00<0ool03ol00`3oo`2Eo`00Dol00`3oo`0>o`030?oo00ko
00<0ool03_l209So001Co`030?oo00ko00<0ool03_l00`3oo`0=o`030?oo09So001Do`030?oo00go
00<0ool03Ol00`3oo`0=o`030?oo09Wo001Eo`030?oo00co00<0ool03?l00`3oo`0<o`80W?l005Go
00<0ool03?l00`3oo`0;o`030?oo00co00<0ool0W?l005Ko00<0ool02ol00`3oo`0;o`030?oo00[o
0P2Oo`00Eol00`3o000400Ko00<0ool02_l00`3oo`0:o`030?oo09oo001Go`050?ooo`002?l00`3o
o`09o`030?oo00[o00<0ool0X?l005So00@0ool02?l00`3oo`09o`030?oo00So0P2So`00FOl00`3o
0008o`030?oo00So00<0ool02?l00`3oo`2So`00F_l200So00<0ool01ol00`3oo`08o`030?oo0:Co
001Jo`802?l00`3oo`07o`030?oo00Ko0P2Wo`00Fol00`3oo`06o`030?oo00Ko00<0ool01_l00`3o
o`2Wo`00G?l00`3oo`05o`030?oo00Go00<0ool01Ol20:[o001Lo`030?oo00Go00<0ool01Ol00`3o
o`04o`030?oo0:[o001Mo`030?oo00Co00<0ool01?l00`3oo`04o`030?oo0:_o001No`030?oo00?o
00<0ool00ol00`3oo`03o`80[_l005ko00<0ool00ol00`3oo`03o`030?oo00;o00<0ool0[_l005oo
00<0ool00_l00`3oo`02o`040?ooo`80/Ol0063o00D0oooo0003o`050?ooo`00/ol0067o00@0ool0
0_l01@3oool00;Co001Qo`040?oo00;o00@0o`00]Ol006;o0`001?l0o`2go`00HOl50003o`3o0;Oo
001Po`L0^Ol0063o1`2io`00H?l70;Wo001Qo`D0^_l006;o0`2ko`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00\
\>"],
    ImageRangeCache->{{{81.8125, 
    311.188}, {-23.9375, -253.313}} -> {-0.442353, -0.896687, 0.00383655, 
    0.00267396}}],
  "\n\:3000\:307e\:305f\:3001\:6b21\:306e\:30b0\:30e9\:30d5\:ff27\:306b\:304a\
\:3044\:3066\:3001\:ff23\:3068\:3057\:3066\:5de6\:5074\:306e\:4e00\:756a\:5927\
\:304d\:306a\:4e09\:89d2\:5f62\:3092\:9078\:3076\:3068\:3001\:5207\:7247\:306f\
\:ff13\:3064\:3042\:308b\:3002\:4e09\:89d2\:5f62\:306e\:5185\:5074\:306b\:ff11\
\:3064\:3068\:3001\:5916\:5074\:306b\:ff12\:3064\:3042\:308b\:3002\n",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.02 w
.5 .60332 Mdot
.02381 .30902 Mdot
.5 .01472 Mdot
.97619 .30902 Mdot
.5 .21092 Mdot
.5 .30902 Mdot
.5 .40712 Mdot
.5 .30902 Mdot
.61905 .30902 Mdot
.5 .30902 Mdot
.5 .25016 Mdot
.5 .30902 Mdot
.5 .30902 Mdot
.5 .30902 Mdot
.5 .36788 Mdot
.5 Mabswid
.5 .60332 m
.02381 .30902 L
s
.5 .60332 m
.5 .30902 L
s
.5 .60332 m
.5 .40712 L
s
.5 .60332 m
.5 .30902 L
s
.5 .60332 m
.61905 .30902 L
s
.5 .60332 m
.5 .30902 L
s
.5 .60332 m
.5 .36788 L
s
.02381 .30902 m
.5 .60332 L
s
.02381 .30902 m
.5 .01472 L
s
.02381 .30902 m
.5 .40712 L
s
.5 .01472 m
.02381 .30902 L
s
.5 .01472 m
.97619 .30902 L
s
.5 .01472 m
.5 .40712 L
s
.5 .01472 m
.5 .30902 L
s
.5 .01472 m
.61905 .30902 L
s
.5 .01472 m
.5 .30902 L
s
.5 .01472 m
.5 .25016 L
s
.97619 .30902 m
.5 .01472 L
s
.97619 .30902 m
.5 .21092 L
s
.97619 .30902 m
.5 .25016 L
s
.5 .21092 m
.97619 .30902 L
s
.5 .21092 m
.5 .30902 L
s
.5 .21092 m
.5 .25016 L
s
.5 .21092 m
.5 .30902 L
s
.5 .21092 m
.5 .30902 L
s
.5 .21092 m
.5 .30902 L
s
.5 .21092 m
.5 .36788 L
s
.5 .30902 m
.5 .60332 L
s
.5 .30902 m
.5 .21092 L
s
.5 .30902 m
.5 .36788 L
s
.5 .40712 m
.5 .60332 L
s
.5 .40712 m
.02381 .30902 L
s
.5 .40712 m
.5 .01472 L
s
.5 .40712 m
.5 .30902 L
s
.5 .30902 m
.5 .60332 L
s
.5 .30902 m
.5 .01472 L
s
.5 .30902 m
.5 .40712 L
s
.5 .30902 m
.61905 .30902 L
s
.61905 .30902 m
.5 .60332 L
s
.61905 .30902 m
.5 .01472 L
s
.61905 .30902 m
.5 .30902 L
s
.61905 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .60332 L
s
.5 .30902 m
.5 .01472 L
s
.5 .30902 m
.61905 .30902 L
s
.5 .30902 m
.5 .25016 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .36788 L
s
.5 .25016 m
.5 .01472 L
s
.5 .25016 m
.97619 .30902 L
s
.5 .25016 m
.5 .21092 L
s
.5 .25016 m
.5 .30902 L
s
.5 .25016 m
.5 .30902 L
s
.5 .30902 m
.5 .21092 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .25016 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .21092 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .21092 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .30902 L
s
.5 .30902 m
.5 .36788 L
s
.5 .36788 m
.5 .60332 L
s
.5 .36788 m
.5 .21092 L
s
.5 .36788 m
.5 .30902 L
s
.5 .36788 m
.5 .30902 L
s
.5 .36788 m
.5 .30902 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 177.938},
    ImageMargins->{{43, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/@P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooo8Ol00?oo8Ol008ko0`2?o`00SOl508ko
002=o`D0S_l008go1@2>o`00Rol20005o`000?l00P2<o`00R_l00`3oo`02o`800ol00`3oo`29o`00
R?l200Go00<0o`000ol208Wo0027o`030?oo00Go00<0o`001Ol00`3oo`26o`00QOl200So00<0o`00
1_l208Ko0023o`802_l0103oo`07o`80Q?l008;o00<0ool02_l0103oo`09o`030?oo087o0020o`80
3Ol01@3oool000Wo0P21o`00Ool00`3oo`0=o`050?ooo`002ol00`3oo`1no`00OOl2013o00D0oooo
000<o`80O_l007_o0P0Bo`030?oo00;o00<0ool02ol207co001jo`030?oo01;o00<0ool00_l00`3o
o`0=o`030?oo07Wo001ho`805Ol00`3oo`03o`030?oo00go0P1io`00M_l201Oo00<0ool00ol00`3o
o`0?o`80Mol007Go00<0ool05ol00`3oo`03o`030?oo017o00<0ool0M?l007?o0P0Jo`030?oo00Co
00<0ool04Ol207Co001bo`030?oo01[o00<0ool01?l00`3oo`0Co`030?oo077o001`o`807Ol00`3o
o`05o`030?oo01?o0P1ao`00K_l201oo00<0ool01Ol00`3oo`0Eo`80Kol006go00<0ool07ol00`3o
o`06o`030?oo01Ko00<0ool0K?l006_o0P0Ro`030?oo00Ko00<0ool05ol206co001Yo`809?l00`3o
o`06o`030?oo01Wo0P1Zo`00J?l00`3oo`0To`030?oo00Oo00<0ool06_l00`3oo`1Wo`00I_l202Oo
00<0ool01ol00`3oo`0Ko`80Iol006Go00<0ool09ol00`3oo`08o`030?oo01co00<0ool0I?l006?o
0P0Zo`030?oo00So00<0ool07Ol206Co001Qo`80;?l00`3oo`08o`030?oo01oo0P1Ro`00H?l00`3o
o`0/o`030?oo00Wo00<0ool08?l00`3oo`1Oo`00G_l202oo00<0ool02Ol00`3oo`0Qo`80Gol005go
00<0ool0;ol00`3oo`0:o`030?oo02;o00<0ool0G?l005_o0P0bo`030?oo00[o00<0ool08ol205co
001Io`80=?l00`3oo`0:o`030?oo02Go0P1Jo`00F?l00`3oo`0do`030?oo00_o00<0ool09_l00`3o
o`1Go`00E_l203Oo00<0ool02ol00`3oo`0Wo`80Eol005Co0P0io`030?oo00co00<0ool0:?l205Go
001Co`030?oo03Wo00<0ool03?l00`3oo`0Zo`030?oo05;o001Ao`80??l00`3oo`0<o`030?oo02_o
0P1Bo`00D?l00`3oo`0lo`030?oo00go00<0ool0;?l00`3oo`1?o`00C_l203oo00<0ool03Ol00`3o
o`0]o`80Col004co0P11o`030?oo00ko00<0ool0;_l204go001;o`030?oo047o00<0ool03_l00`3o
o`0`o`030?oo04[o0019o`80A?l00`3oo`0>o`030?oo037o0P1:o`00Aol204Ko00<0ool03ol00`3o
o`0bo`80B?l004Ko00<0ool0A_l00`3oo`0?o`030?oo03Co00<0ool0AOl004Co0P19o`030?oo013o
00<0ool0=?l204Go0013o`030?oo04Wo00<0ool04?l00`3oo`0fo`030?oo04;o0011o`80C?l00`3o
o`0@o`030?oo03Oo0P12o`00?ol204ko00<0ool04Ol00`3oo`0ho`80@?l003ko00<0ool0C_l00`3o
o`0Ao`030?oo03[o00<0ool0?Ol003co0P1Ao`030?oo01;o00<0ool0>_l203go000ko`030?oo057o
00<0ool04_l00`3oo`0lo`030?oo03[o000io`80E?l00`3oo`0Bo`030?oo03go0P0jo`00=ol205Go
0`0Do`030?oo03ko0P0ho`00=_l00`3oo`1Do`D04ol00`3oo`10o`030?oo03Go000do`80Eol501Co
00<0ool0@?l203Go000bo`80FOl:00oo00<0ool0@_l203?o000ao`030?oo05[o0`06o`D02_l00`3o
o`14o`030?oo033o000_o`80G_l00`3oo`0:o`@01ol00`3oo`14o`80<?l002ko00<0ool0G_l00`3o
o`0>o`D00_l00`3oo`16o`030?oo02go000/o`80HOl00`3oo`0Co`D0Aol202go000Zo`80Hol00`3o
o`0Fo`030?l000@0A?l202_o000Yo`030?oo06?o00<0ool05ol00`3oo`03o`D0@Ol00`3oo`0Xo`00
9ol206Ko00<0ool05ol00`3oo`08o`D0?Ol202So000Uo`80Iol301So00<0ool03Ol503[o0P0Vo`00
9?l00`3oo`1Vo`D06?l00`3oo`0Ao`@0>?l00`3oo`0So`008_l206Wo1P0Go`030?oo01Go1@0do`80
8ol0027o00<0ool0JOl50003o`0000H04?l00`3oo`0Io`D0<Ol00`3oo`0Po`007ol206go0`0:o`P0
2?l00`3oo`0No`D0;Ol2023o000Mo`80L?l00`3oo`0Ao`T09Ol502[o0P0No`007?l00`3oo`1`o`03
0?oo01Wo200So`D09ol00`3oo`0Ko`006_l207?o00<0ool06_l00`3oo`04o`P08?l502?o0P0Ko`00
6Ol00`3oo`1co`030?oo01_o00<0ool02ol801go100Qo`030?oo01So000Go`80M_l00`3oo`0Ko`03
0?oo01?o200Io`D07Ol201So000Eo`80N?l00`3oo`0Ko`030?oo01_o200Fo`D06_l201Ko000Do`03
0?oo07So00<0ool07?l00`3oo`0Ro`P04ol501Oo00<0ool04ol001;o0P1ko`030?oo01co00<0ool0
:_l8013o1@0Co`804ol0013o0P1mo`030?oo01go00<0ool0<Ol800go1@0@o`804Ol000oo00<0ool0
OOl00`3oo`0Mo`030?oo03Wo200:o`D03Ol00`3oo`0>o`003Ol2083o00<0ool07Ol00`3oo`11o`P0
1ol400[o0P0>o`003?l00`3oo`20o`030?oo01ko00<0ool0B?l800?o1@07o`030?oo00_o0005o`<0
0_l208;o0`0Oo`<0D?l=00?o0P001?l00007o`001?l608?o1@0Mo`D0Eol?00Ko0004o`H0PolW05oo
1`06o`001?l;07ko1@0Mo`D0HOl500Ko0005o`<00_l200?o1@1jo`<07ol306?o0`07o`003?l00`3o
o`05o`@0Mol00`3oo`0No`030?oo06go000=o`802Ol507;o00<0ool07Ol00`3oo`1^o`003ol00`3o
o`0;o`D0KOl00`3oo`0Mo`030?oo06ko000@o`804?l506So00<0ool07Ol00`3oo`1^o`004_l201?o
1@1So`030?oo01co00<0ool0Kol001Co00<0ool05Ol505ko00<0ool07?l00`3oo`1_o`005Ol201[o
1@1Io`030?oo01_o00<0ool0L?l001Oo00<0ool07?l405Go00<0ool06ol00`3oo`1`o`006?l2023o
1@1@o`030?oo01_o00<0ool0L?l001[o0P0So`D0Bol00`3oo`0Jo`030?oo077o000Lo`030?oo02Go
1@16o`030?oo01[o00<0ool0LOl001go0P0Zo`D0@Ol00`3oo`0Io`030?oo07;o000Oo`80;Ol503_o
0`0Jo`030?oo07;o000Qo`030?oo02oo1@0eo`D06Ol00`3oo`1bo`008_l203Co100ao`D06?l00`3o
o`1co`009?l00`3oo`0eo`D0;?l501So00<0ool0Lol002Go0P0jo`D0:?l301So00<0ool0M?l002Oo
0P0mo`D09?l00`3oo`0Go`030?oo07Co000Yo`030?oo03oo1@0Oo`030?oo01Ko00<0ool0MOl002[o
0P14o`D06_l00`3oo`0Fo`030?oo07Go000/o`80Aol501Go00<0ool05_l00`3oo`1eo`00;_l00`3o
o`19o`@04Ol00`3oo`0Eo`030?oo07Ko000_o`80COl500co00<0ool05Ol00`3oo`1fo`00<Ol00`3o
o`1?o`D01_l301Go00<0ool0Mol003;o0P1Do`X05?l00`3oo`1go`00=?l205Oo1@0Do`030?oo07Oo
000fo`030?oo05Co1@0Co`030?oo07So000go`80EOl301Co00<0ool0N?l003Wo00<0ool0Dol00`3o
o`0Bo`030?oo07Wo000jo`80Dol00`3oo`0Bo`030?oo07Wo000lo`80DOl00`3oo`0Bo`030?oo07Wo
000no`030?oo04ko00<0ool04Ol00`3oo`1jo`00?ol204ko00<0ool04Ol00`3oo`1jo`00@Ol204co
00<0ool04?l00`3oo`1ko`00@ol00`3oo`19o`030?oo013o00<0ool0Nol004Co0P19o`030?oo013o
00<0ool0Nol004Ko00<0ool0A_l00`3oo`0?o`030?oo07co0017o`80A_l00`3oo`0?o`030?oo07co
0019o`80A?l00`3oo`0>o`030?oo07go001;o`030?oo047o00<0ool03_l00`3oo`1mo`00C?l2047o
00<0ool03_l00`3oo`1mo`00C_l203oo00<0ool03Ol00`3oo`1no`00D?l00`3oo`0lo`030?oo00go
00<0ool0O_l0057o0P0lo`030?oo00co00<0ool0Ool005?o00<0ool0>Ol00`3oo`0<o`030?oo07oo
001Do`80>Ol00`3oo`0<o`030?oo07oo001Fo`80=ol00`3oo`0;o`030?oo083o001Ho`030?oo03Co
00<0ool02ol00`3oo`20o`00FOl203Co00<0ool02_l00`3oo`21o`00Fol00`3oo`0ao`030?oo00[o
00<0ool0POl005co0P0ao`030?oo00[o00<0ool0POl005ko0P0_o`030?oo00Wo00<0ool0P_l0063o
00<0ool0;?l00`3oo`09o`030?oo08;o001Qo`80;?l00`3oo`08o`030?oo08?o001So`80:_l00`3o
o`08o`030?oo08?o001Uo`030?oo02Oo00<0ool02?l00`3oo`23o`00I_l202Oo00<0ool01ol00`3o
o`24o`00J?l00`3oo`0To`030?oo00Oo00<0ool0Q?l006Wo0P0To`030?oo00Ko00<0ool0QOl006_o
0P0Ro`030?oo00Ko00<0ool0QOl006go00<0ool07ol00`3oo`05o`030?oo08Ko001^o`807ol00`3o
o`05o`030?oo08Ko001`o`807Ol00`3oo`05o`030?oo08Ko001bo`030?oo01[o00<0ool01?l00`3o
o`27o`00Lol201[o00<0ool01?l00`3oo`27o`00MOl00`3oo`0Go`030?oo00?o00<0ool0R?l007Ko
0P0Go`030?oo00?o00<0ool0R?l007So0P0Eo`030?oo00?o00<0ool0R?l007[o00<0ool04_l00`3o
o`02o`030?oo08Wo001ko`804_l00`3oo`02o`030?oo08Wo001mo`030?oo00oo00D0oooo002<o`00
O_l200oo00D0oooo002<o`00P?l200go00D0oooo002<o`00P_l00`3oo`0:o`040?oo08go0023o`80
2_l0103oo`2=o`00QOl200So00<0o`00S_l008Oo00<0ool01Ol00`3o002>o`00R?l200Go00<0o`00
S_l008[o00<0ool00_l208oo002;o`800_l208oo002=o`@0Sol008go1@2>o`00SOl508ko002=o`D0
S_l008ko0`2?o`00oolQo`00\
\>"],
    ImageRangeCache->{{{81.8125, 311.188}, {204.75, 
    63.4375}} -> {-1.80474, -0.107283, 0.00734756, 0.0118886}}],
  "\n"
}], "Text"],

Cell[BoxData[
    \(\:30b0\:30e9\:30d5\:306e\:751f\:6210\:6728\)], "Input"],

Cell[TextData[{
  "\:3000\:9023\:7d50\:30b0\:30e9\:30d5\:ff27\:306f\:3001\:3069\:3093\:306a\
\:30b5\:30a4\:30af\:30eb\:3082\:542b\:307e\:306a\:3044\:3068\:304d\:306b\:6728\
(tree)\:3068\:547c\:3070\:308c\:308b\:3002\:307e\:305f\:3001\:ff27\:306e\:90e8\
\:5206\:30b0\:30e9\:30d5\:ff28\:306f\:3001V(H)=V(G) \:3092\:6e80\:305f\:3059\
\:3068\:304d\:751f\:6210\:90e8\:5206\:30b0\:30e9\:30d5(spanning graph)\:3068\
\:8a00\:3046\:3002\:7279\:306b\:3001\:ff27\:306e\:751f\:6210\:90e8\:5206\:30b0\
\:30e9\:30d5\:3067\:3001\:304b\:3064\:6728\:3067\:3042\:308b\:3082\:306e\:3092\
\:ff27\:306e\:751f\:6210\:6728(spanning tree)\:3068\:8a00\:3046\:3002\:751f\
\:6210\:6728\:306f\:3001\:5e73\:9762\:30b0\:30e9\:30d5\:4ee5\:5916\:306e\:8272\
\:3005\:306a\:5206\:91ce\:3067\:3088\:304f\:4f7f\:308f\:308c\:308b\:6982\:5ff5\
\:3067\:3042\:308b\:3002\n\:3000\:30b0\:30e9\:30d5\:ff34\:304c\:ff27\:306e\
\:751f\:6210\:6728\:306e\:3068\:304d\:3001\:6b21\:306e\:7b49\:5f0f\:304c\:6210\
\:308a\:7acb\:3064\:3002\n\t\t\:ff5cE(T)\:ff5c\:ff1d\:ff5cV(T)\:ff5c\:30fc\
\:ff11\n\:4efb\:610f\:306e\:9023\:7d50\:30b0\:30e9\:30d5\:ff27\:306f\:3001\
\:5e38\:306b\:751f\:6210\:6728\:ff34\:3092\:90e8\:5206\:30b0\:30e9\:30d5\:3068\
\:3057\:3066\:542b\:3080\:3053\:3068\:304c\:793a\:3055\:308c\:308b\:306e\:3067\
\:3001\:ff5cE(G)\:ff5c\[GreaterEqual]\:ff5cE(T)\:ff5c\:304b\:3089\:6b21\:3082\
\:6210\:308a\:7acb\:3064\:3002\n\t\t\:ff5cE(G)\:ff5c\[GreaterEqual]\:ff5cV(G)\
\:ff5c\:30fc\:ff11\n\
\:554f\:ff11\:ff0e\:7b49\:5f0f\:ff5cE(T)\:ff5c\:ff1d\:ff5cV(T)\:ff5c\:30fc\
\:ff11\:3092\:793a\:305b\:3002\n\:554f\:ff12\:ff0e\:4efb\:610f\:306e\:9023\
\:7d50\:30b0\:30e9\:30d5\:ff27\:306f\:3001\:5e38\:306b\:751f\:6210\:6728\:3092\
\:6301\:3064\:3053\:3068\:3092\:793a\:305b\:3002\n\:30d2\:30f3\:30c8\:ff1a\
\:ff27\:304c\:30b5\:30a4\:30af\:30eb\:ff23\:3092\:6301\:3066\:3070\:3001\:ff23\
\:306e\:ff11\:3064\:306e\:8fba\:3092\:ff27\:304b\:3089\:53d6\:308a\:9664\:3044\
\:305f\:30b0\:30e9\:30d5\:3082\:307e\:305f\:9023\:7d50\:3067\:3042\:308b\:3002\
\n\n\:3000\:9023\:7d50\:30b0\:30e9\:30d5\:ff27\:304c\:4e0e\:3048\:3089\:308c\
\:305f\:3068\:304d\:3001\:6b21\:306e\:3088\:3046\:306b\:3057\:3066\:751f\:6210\
\:6728\:ff34\:3092\:6c42\:3081\:308b\:3053\:3068\:304c\:51fa\:6765\:308b\:3002\
\n\:3000\:ff27\:306e\:ff11\:3064\:306e\:9802\:70b9\:304b\:3089\:51fa\:767a\
\:3057\:3001\:63a5\:7d9a\:3057\:3066\:3044\:308b\:8fba\:3092\:9078\:3073\:3001\
\:305d\:306e\:8fba\:3092\:901a\:3063\:3066\:65b0\:305f\:306a\:9802\:70b9\:3078\
\:884c\:304f\:3002\:9078\:3093\:3060\:9802\:70b9\:304b\:3089\:51fa\:308b\:65b0\
\:3057\:3044\:8fba\:3092\:901a\:3063\:3066\:3001\:4ed6\:306e\:9802\:70b9\:306b\
\:884c\:304f\:3002\:3053\:306e\:64cd\:4f5c\:3092\:53ef\:80fd\:306a\:9650\:308a\
\:7e70\:308a\:8fd4\:3059\:3002\:305f\:3060\:3057\:3001\:5230\:9054\:3057\:305f\
\:9802\:70b9\:304c\:65e2\:306b\:63a2\:7d22\:3055\:308c\:3066\:3044\:308b\:3068\
\:304d\:306b\:306f\:3001\:ff11\:3064\:524d\:306e\:9802\:70b9\:306b\:5f15\:304d\
\:8fd4\:3057\:3001\:5225\:306e\:30eb\:30fc\:30c8\:306e\:63a2\:7d22\:3092\:7d9a\
\:3051\:308b\:3002\:63a2\:7d22\:4e2d\:306e\:9802\:70b9\:306b\:6761\:4ef6\:3092\
\:6e80\:305f\:3059\:8fba\:304c\:306a\:3044\:3068\:304d\:306b\:306f\:3001\:307e\
\:3060\:63a2\:7d22\:3055\:308c\:3066\:3044\:306a\:3044\:8fba\:3092\:6301\:3064\
\:6700\:3082\:6700\:8fd1\:5230\:9054\:3057\:305f\:9802\:70b9\:ff08\:5f15\:304d\
\:8fd4\:3057\:305f\:9802\:70b9\:306f\:9664\:304f\:ff09\:304b\:3089\:63a2\:7d22\
\:3092\:518d\:958b\:3059\:308b\:3002\n    \
\:3053\:306e\:3088\:3046\:306b\:3001\:3059\:3079\:3066\:306e\:9802\:70b9\:3092\
\:63a2\:7d22\:3059\:308b\:65b9\:6cd5\:3092\:3001\:6df1\:3055\:512a\:5148\:63a2\
\:7d22 (depth first search)\:3068\:8a00\:3046\:3002\n\:3000\:3053\:306e\:65b9\
\:6cd5\:3067\:3001\:6b6320\:9762\:4f53\:30b0\:30e9\:30d5\:306e\:751f\:6210\
\:6728\:3092\:6c42\:3081\:308b\:3068\:6b21\:306e\:3088\:3046\:306b\:306a\:308b\
\:3002\:305f\:3060\:3057\:3001\:51fa\:767a\:70b9\:306f\:9802\:70b911\:3067\
\:3042\:308a\:3001\:82e5\:3044\:756a\:53f7\:512a\:5148\:3067\:9802\:70b9\:306f\
\:9078\:3070\:308c\:3066\:3044\:308b\:3002\n\n",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0465153 0.930307 -0.0221976 0.973522 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95132 Mdot
.04652 .60654 Mdot
.21973 .04868 Mdot
.78027 .04868 Mdot
.95348 .60654 Mdot
.5 .70368 Mdot
.27158 .53002 Mdot
.35883 .24902 Mdot
.64117 .24902 Mdot
.72842 .53002 Mdot
.41147 .57986 Mdot
.58853 .57986 Mdot
.64324 .40365 Mdot
.5 .29474 Mdot
.35676 .40365 Mdot
.46283 .50588 Mdot
.53717 .50588 Mdot
.56014 .43191 Mdot
.5 .38618 Mdot
.43986 .43191 Mdot
.5 Mabswid
.5 .95132 m
.04652 .60654 L
s
.5 .95132 m
.5 .70368 L
s
.04652 .60654 m
.5 .95132 L
s
.04652 .60654 m
.21973 .04868 L
s
.21973 .04868 m
.04652 .60654 L
s
.21973 .04868 m
.78027 .04868 L
s
.78027 .04868 m
.21973 .04868 L
s
.78027 .04868 m
.95348 .60654 L
s
.95348 .60654 m
.78027 .04868 L
s
.95348 .60654 m
.72842 .53002 L
s
.5 .70368 m
.5 .95132 L
s
.5 .70368 m
.41147 .57986 L
s
.27158 .53002 m
.35676 .40365 L
s
.35883 .24902 m
.5 .29474 L
s
.35883 .24902 m
.35676 .40365 L
s
.64117 .24902 m
.64324 .40365 L
s
.64117 .24902 m
.5 .29474 L
s
.72842 .53002 m
.95348 .60654 L
s
.72842 .53002 m
.58853 .57986 L
s
.41147 .57986 m
.5 .70368 L
s
.58853 .57986 m
.72842 .53002 L
s
.58853 .57986 m
.53717 .50588 L
s
.64324 .40365 m
.64117 .24902 L
s
.64324 .40365 m
.56014 .43191 L
s
.5 .29474 m
.35883 .24902 L
s
.5 .29474 m
.64117 .24902 L
s
.35676 .40365 m
.27158 .53002 L
s
.35676 .40365 m
.35883 .24902 L
s
.35676 .40365 m
.43986 .43191 L
s
.46283 .50588 m
.53717 .50588 L
s
.46283 .50588 m
.43986 .43191 L
s
.53717 .50588 m
.58853 .57986 L
s
.53717 .50588 m
.46283 .50588 L
s
.56014 .43191 m
.64324 .40365 L
s
.56014 .43191 m
.5 .38618 L
s
.5 .38618 m
.56014 .43191 L
s
.43986 .43191 m
.35676 .40365 L
s
.43986 .43191 m
.46283 .50588 L
s
.5 .95132 m
.04652 .60654 L
s
.5 .95132 m
.5 .70368 L
s
.04652 .60654 m
.5 .95132 L
s
.04652 .60654 m
.21973 .04868 L
s
.21973 .04868 m
.04652 .60654 L
s
.21973 .04868 m
.78027 .04868 L
s
.78027 .04868 m
.21973 .04868 L
s
.78027 .04868 m
.95348 .60654 L
s
.95348 .60654 m
.78027 .04868 L
s
.95348 .60654 m
.72842 .53002 L
s
.5 .70368 m
.5 .95132 L
s
.5 .70368 m
.41147 .57986 L
s
.27158 .53002 m
.35676 .40365 L
s
.35883 .24902 m
.5 .29474 L
s
.35883 .24902 m
.35676 .40365 L
s
.64117 .24902 m
.64324 .40365 L
s
.64117 .24902 m
.5 .29474 L
s
.72842 .53002 m
.95348 .60654 L
s
.72842 .53002 m
.58853 .57986 L
s
.41147 .57986 m
.5 .70368 L
s
.58853 .57986 m
.72842 .53002 L
s
.58853 .57986 m
.53717 .50588 L
s
.64324 .40365 m
.64117 .24902 L
s
.64324 .40365 m
.56014 .43191 L
s
.5 .29474 m
.35883 .24902 L
s
.5 .29474 m
.64117 .24902 L
s
.35676 .40365 m
.27158 .53002 L
s
.35676 .40365 m
.35883 .24902 L
s
.35676 .40365 m
.43986 .43191 L
s
.46283 .50588 m
.53717 .50588 L
s
.46283 .50588 m
.43986 .43191 L
s
.53717 .50588 m
.58853 .57986 L
s
.53717 .50588 m
.46283 .50588 L
s
.56014 .43191 m
.64324 .40365 L
s
.56014 .43191 m
.5 .38618 L
s
.5 .38618 m
.56014 .43191 L
s
.43986 .43191 m
.35676 .40365 L
s
.43986 .43191 m
.46283 .50588 L
s
[(1)] .47209 .92212 0 1 Mshowa
[(2)] .01861 .57734 0 1 Mshowa
[(3)] .19182 .01947 0 1 Mshowa
[(4)] .75236 .01947 0 1 Mshowa
[(5)] .92558 .57734 0 1 Mshowa
[(6)] .47209 .67448 0 1 Mshowa
[(7)] .24367 .50081 0 1 Mshowa
[(8)] .33092 .21982 0 1 Mshowa
[(9)] .61326 .21982 0 1 Mshowa
[(10)] .70051 .50081 0 1 Mshowa
[(11)] .38356 .55066 0 1 Mshowa
[(12)] .56062 .55066 0 1 Mshowa
[(13)] .61533 .37444 0 1 Mshowa
[(14)] .47209 .26554 0 1 Mshowa
[(15)] .32885 .37444 0 1 Mshowa
[(16)] .43492 .47668 0 1 Mshowa
[(17)] .50926 .47668 0 1 Mshowa
[(18)] .53223 .4027 0 1 Mshowa
[(19)] .47209 .35698 0 1 Mshowa
[(20)] .41196 .4027 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 288},
    ImageMargins->{{43, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooocKo00<0ool0WOl404Ko000go`030?oo09co
00<0o`00Aol003Go00<0o`00Wol204Oo000fo`030?oo09oo00<0ool0AOl00?oo8Ol00?oo8Ol00?oo
8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol003ko0`2Mo`<0?ol003go1@2Ko`D0?_l003co
Y`0mo`00??l709Wo1`0mo`00??l709Wo1`0mo`00?Ol509_o1@0no`00?_l309go0`0oo`00?Ol00`3o
o`2Qo`030?oo03co000mo`030?oo0:7o00<0ool0??l003go00<0ool0XOl00`3oo`0lo`00?Ol00`3o
o`2Qo`030?oo03co000lo`030?oo0:?o00<0ool0>ol003co00<0ool0Xol00`3oo`0ko`00??l00`3o
o`2So`030?oo03_o000ko`030?oo0:Go00<0ool0>_l003_o00<0ool0YOl00`3oo`0jo`00>ol00`3o
o`2Uo`030?oo03[o000jo`030?oo0:Oo00<0ool0>Ol003[o00<0ool0Yol00`3oo`0io`00>_l00`3o
o`2Wo`030?oo03Wo000io`030?oo0:Wo00<0ool0>?l003Wo00<0ool0ZOl00`3oo`0ho`00>Ol00`3o
o`2Yo`030?oo03So000ho`030?oo0:_o00<0ool0=ol003So00<0ool0Zol00`3oo`0go`00>?l00`3o
o`2[o`030?oo03Oo000ho`030?oo0:_o00<0ool0=ol003Oo00<0ool0[Ol00`3oo`0fo`00=ol00`3o
o`2]o`030?oo03Ko000go`030?oo0:go00<0ool0=_l003Ko00<0ool0[ol00`3oo`0eo`00=_l00`3o
o`2_o`030?oo03Go000fo`030?oo0:oo00<0ool0=Ol003Go00<0ool0/Ol00`3oo`0do`00=Ol00`3o
o`2ao`030?oo03Co000eo`030?oo0;7o00<0ool0=?l003Co00<0ool0/ol00`3oo`0co`00=?l00`3o
o`2co`030?oo03?o000do`030?oo0;?o00<0ool0<ol003Co00<0ool0/ol00`3oo`0co`00<ol00`3o
o`2eo`030?oo03;o000co`030?oo0;Go00<0ool0<_l003?o00<0ool0]Ol00`3oo`0bo`00<_l00`3o
o`2go`030?oo037o000bo`030?oo02Wo00<0ool0COl203co00<0ool0<Ol003;o00<0ool0:?l00`3o
001@o`030?oo03Wo00<0ool0<Ol0037o00<0ool0:Ol00`3o001?o`80??l00`3oo`0`o`00<Ol00`3o
o`0Zo`030?oo04go00<0o`00??l00`3oo`0`o`00<Ol00`3oo`0Yo`030?l004ko00<0o`00??l00`3o
o`0`o`00<?l00`3oo`0[o`030?oo04ko0P0mo`030?oo02oo000`o`030?oo0;_o00<0ool0;ol0033o
00<0ool0^ol00`3oo`0_o`00;ol00`3oo`2mo`030?oo02ko000_o`030?oo0;go00<0ool0;_l002oo
00<0ool0_Ol00`3oo`0^o`00;ol00`3oo`2mo`030?oo02ko000^o`030?oo0;oo00<0ool0;Ol002ko
00<0ool0=?l301[o1@02o`<0:_l303Oo00<0ool0;Ol002ko00<0ool0<ol501_o00<0ool00ol00`3o
o`0Xo`D0=_l00`3oo`0]o`00;Ol00`3oo`0co`L06_l0103oool402So1`0fo`030?oo02co000]o`03
0?oo03?o1`0Jo`070?ooo`3o000Yo`L0=_l00`3oo`0/o`00;Ol00`3oo`0co`P06Ol00`3oo`02o`80
:Ol703Ko00<0ool0;?l002co00<0ool0=Ol500;o0`0Eo`801Ol00`3oo`0To`<000?o00000`0ho`03
0?oo02_o000/o`030?oo03Ko0`06o`@0>ol400Go0`0io`030?oo02_o000/o`030?oo03Oo00<0ool0
2Ol303Go0`0;o`030?oo03Oo00<0ool0:ol002_o00<0ool0>?l00`3oo`0<o`<0;ol300ko00<0ool0
>?l00`3oo`0Zo`00:ol00`3oo`0ho`030?oo00oo0`0Yo`<04Ol00`3oo`0ho`030?oo02[o000[o`03
0?oo03So00<0ool04_l302?o0`0Do`030?oo03So00<0ool0:_l002_o00<0ool0>?l00`3oo`0Eo`<0
7Ol301Oo00<0ool0>?l00`3oo`0Zo`00:_l00`3oo`0io`030?oo01So0`0Go`<06_l00`3oo`0io`03
0?oo02Wo000Zo`030?oo03Wo00<0ool06ol400Ko0`06o`@07Ol00`3oo`0io`030?oo02Wo000Zo`03
0?oo03Wo00<0ool07ol300;o1@02o`<08Ol00`3oo`0io`030?oo02Wo000Yo`030?oo03[o00<0ool0
8_l902Co00<0ool0>_l00`3oo`0Xo`00:Ol00`3oo`0jo`030?oo02?o1`0Uo`030?oo03[o00<0ool0
:?l002Wo00<0ool0>_l00`3oo`0So`L09Ol00`3oo`0jo`030?oo02So000Xo`030?oo03_o00<0ool0
9?l502Ko00<0ool0>ol00`3oo`0Wo`00:?l00`3oo`0ko`030?oo02Go0`0Wo`030?oo03_o00<0ool0
9ol002So00<0ool0>ol00`3oo`1?o`030?oo03_o00<0ool09ol002Oo00<0ool0??l00`3oo`1?o`03
0?oo03co00<0ool09_l002Oo00<0ool0??l00`3oo`1?o`030?oo03co00<0ool09_l002Oo00<0ool0
??l00`3oo`1?o`030?oo03co00<0ool09_l002Ko00<0ool0?Ol00`3oo`1?o`030?oo03go00<0ool0
9Ol002Ko00<0ool0?Ol00`3oo`1?o`030?oo03go00<0ool09Ol002Ko00<0ool0?Ol00`3oo`0Io`D0
00?o0000;_l00`3oo`0mo`030?oo02Go000Vo`030?oo03go00<0ool06ol00`3oo`03o`030?oo02_o
00<0ool0?Ol00`3oo`0Uo`009Ol00`3oo`0no`030?oo01_o00<0ool00_l202go00<0ool0?_l00`3o
o`0To`009Ol00`3oo`0no`030?oo01_o00L0oooo0?l002go00<0ool0?_l00`3oo`0To`009Ol00`3o
o`0no`030?oo01_o00L0oooo0?l002go00<0ool0?_l00`3oo`0To`009?l00`3oo`0bo`D00_l00`3o
o`03o`030?oo01[o0P04o`808?l50003o`0000Go00<0ool0?ol00`3oo`0So`009?l00`3oo`0do`07
0?ooo`3o0004o`030?oo04Co00<0ool00ol00`3oo`02o`030?oo03oo00<0ool08ol002Co00<0ool0
=?l00`3oo`03o`030?oo00;o00<0ool0A?l00`3oo`02o`030?oo00?o00<0ool0?ol00`3oo`0So`00
8ol00`3oo`0eo`040?ooo`801Ol00`3oo`14o`030?oo00?o00<0ool00_l00`3oo`10o`030?oo02;o
000So`030?oo03Go00D0oooo0006o`030?oo04Co00L0oooo0?l000Co00<0ool0@?l00`3oo`0Ro`00
8ol00`3oo`0do`800ol300Co00<0ool0@ol200Co00<0ool00ol00`3oo`10o`030?oo02;o000Ro`03
0?oo047o00<0ool0Col00`3oo`11o`030?oo027o000Ro`030?oo047o00<0ool0Col00`3oo`11o`03
0?oo027o000Ro`030?oo047o00<0ool02Ol300?o00<0ool04ol300;o1@02o`030?oo01_o00<0ool0
@Ol00`3oo`0Qo`008Ol00`3oo`12o`030?oo00Wo00<0ool00_l00`3o000Co`D00ol01`3oool0o`00
7?l00`3oo`12o`030?oo023o000Qo`030?oo04;o00<0ool02_l01`3oool0o`004_l700;o00L0oooo
0?l001co00<0ool0@_l00`3oo`0Po`008Ol00`3oo`12o`030?oo00[o00L0oooo0?l001;o1`02o`03
0?oo00;o00<0ool06ol00`3oo`12o`030?oo023o000Qo`030?oo04;o00<0ool02Ol00`3o0002o`03
0?l001;o1`02o`070?ooo`3o000Lo`030?oo04;o00<0ool08?l0023o00<0ool0@_l300_o00<0ool0
0_l00`3oo`0Bo`H000?o00001?l00`3oo`0Jo`<0A?l00`3oo`0Oo`008?l00`3oo`11o`D09Ol300;o
00<0ool08?l504?o00<0ool07ol0023o00<0ool0@?l702[o00<0ool07_l704;o00<0ool07ol001oo
00<0ool0@Ol702_o0P0No`L0@ol00`3oo`0No`007ol00`3oo`11o`P0;?l00`3oo`0Jo`P0@ol00`3o
o`0No`007ol00`3oo`12o`D00_l302[o00<0ool05_l300;o1@14o`030?oo01ko000No`030?oo04?o
1006o`<0:?l201?o0`06o`<0A_l00`3oo`0Mo`007_l00`3oo`12o`030?oo00_o0`0Wo`030?oo00go
0`1Bo`030?oo01go000No`030?oo04;o00<0ool03_l302Go00<0ool02Ol305Go00<0ool07Ol001go
00<0ool0@_l00`3oo`0Bo`<00ol301go1@03o`<0FOl00`3oo`0Lo`007Ol00`3oo`11o`030?oo01Ko
1`0Mo`L0G?l00`3oo`0Lo`007Ol00`3oo`11o`030?oo01Oo1`0Ko`L0GOl00`3oo`0Lo`007Ol00`3o
o`10o`030?oo01So1`0Ko`L0GOl00`3oo`0Lo`007?l00`3oo`10o`030?oo01Wo1`0Ko`L0G_l00`3o
o`0Ko`007?l00`3oo`10o`030?oo01[o1@0Mo`D0Gol00`3oo`0Ko`007?l00`3oo`0oo`030?oo01co
0`0Oo`<0H?l00`3oo`0Ko`006ol00`3oo`0oo`030?oo01Oo1@001?l0000=o`D00_l00`3oo`1/o`03
0?oo01[o000Ko`030?oo03oo00<0ool06Ol01P3oool0o`803_l00`3oo`02o`030?oo06co00<0ool0
6_l001_o00<0ool0?_l00`3oo`0Jo`060?ooo`3o0P0>o`030?oo00;o00<0ool0K?l00`3oo`0Jo`00
6_l00`3oo`0no`030?oo01_o00@0oooo0P000ol0o`0=o`030?oo00?o00<0ool0K?l00`3oo`0Io`00
6_l00`3oo`0no`030?oo01_o00D0oooo0002o`030?oo00co00L0oooo0?l006ko00<0ool06Ol001[o
00<0ool0?Ol00`3oo`0Ko`801?l20003o`3o00_o0P03o`<0K_l00`3oo`0Io`006Ol00`3oo`0mo`03
0?oo02Go00<0ool0POl00`3oo`0Ho`006Ol00`3oo`0Yo`030?oo013o00<0ool09_l00`3oo`10o`D0
0_l00`3oo`0go`030?oo01So000Io`030?oo02Wo00<0ool04?l00`3oo`0Wo`030?oo047o00L0oooo
0?l003So00<0ool06?l001So00<0ool0:_l00`3oo`0?o`030?oo02So00<0ool0@Ol01`3oool0o`00
>Ol00`3oo`0Go`006?l00`3oo`0[o`030?oo00go00<0ool0:Ol00`3oo`11o`070?ooo`3o000io`03
0?oo01Oo000Ho`030?oo02Wo00<0o`003ol00`3oo`0Yo`030?oo047o00L0oooo0?l003Wo00<0ool0
5ol001So00<0ool0:Ol300ko00<0ool0:ol00`3oo`0oo`801?l00`3oo`0ho`030?oo01Oo000Go`03
0?oo03[o00<0ool0;?l00`3oo`21o`030?oo01Ko000Go`030?oo03[o00<0ool0;?l301?o0`1[o`03
0?oo01Ko000Go`030?oo03Wo00<0ool0;?l5017o1@1Zo`030?oo01Ko000Fo`030?oo03Wo00<0ool0
;?l700oo1`1Zo`030?oo01Go000Fo`030?oo03Wo00<0ool0;?lM06[o00<0ool05Ol001Ko00<0ool0
>?l00`3oo`0]o`L03ol706[o00<0ool05Ol001Go00<0ool0>?l00`3oo`0_o`D04Ol506co00<0ool0
5?l001Go00<0ool0>?l00`3oo`0`o`<04ol406co00<0ool05?l001Go00<0ool0=?l404go00<0ool0
;ol303Oo00<0ool05?l001Co00<0ool0=?l501Wo2P0Xo`D000Co0000:_l503Oo00<0ool04ol001Co
00<0ool0<ol701[o00<0ool00_l00`3oo`0Zo`800_l00`3oo`0Yo`L0=_l00`3oo`0Co`005?l00`3o
o`0co`L06_l00`3oo`02o`030?oo02[o00<0o`000_l00`3oo`0Xo`L0=_l00`3oo`0Co`005?l00`3o
o`0co`L06_l00`3oo`02o`030?oo02[o00<0o`000_l00`3oo`0Xo`T0=?l00`3oo`0Co`004ol00`3o
o`0eo`D06ol00`3oo`02o`030?oo02[o00<0ool00P000ol0o`0Uo`<000?o00000`03o`<0<_l00`3o
o`0Bo`004ol00`3oo`0fo`<06ol200?o0P0[o`800ol202Co0`05o`<01ol302oo00<0ool04_l001?o
00<0ool0Rol00`3oo`0Po`<05Ol302co00<0ool04_l000?o0`0<o`030?oo08go00<0ool07?l301_o
0P0Xo`040?oo01?o0003o`030?oo00co00<0ool0S_l00`3oo`0Ho`<08?l302Co00D0o`3o000Co`00
1?l00`3oo`0;o`030?oo08ko00<0ool05_l202Ko0`0So`030?l001?o0004o`030?oo00[o00<0ool0
T?l00`3oo`0Bo`<0:ol301ko0P03o`030?oo013o0003o`030?l000_o00<0ool0TOl00`3oo`0>o`<0
<Ol301_o00<0ool00_l00`3oo`0@o`001?l00`3oo`0:o`030?oo097o00<0ool02ol303Oo0`0Ho`<0
0_l00`3oo`0@o`004?l00`3oo`1Ro`<0;_l400Ko0`0mo`<06ol00`3oo`0?o`004?l00`3oo`1Qo`D0
;Ol500;o0`13o`<06?l00`3oo`0?o`004?l00`3oo`1Po`L0:ol804Wo0`0Eo`030?oo00oo000?o`03
0?oo067o1`0[o`L0COl301?o00<0ool03_l000oo00<0ool0HOl702_o1`1@o`<04?l00`3oo`0>o`00
3ol00`3oo`1Ro`D0;Ol505Co0P0>o`030?oo00ko000?o`030?oo06?o100^o`<0Eol300_o00<0ool0
3_l000ko00<0ool0J?l00`3oo`28o`<02Ol00`3oo`0=o`003?l306_o00<0ool0R_l300Ko0`0=o`00
2ol506[o00<0ool0SOl300;o1@0<o`002_l706[o00<0ool0Sol800_o000:o`L0Jol00`3oo`2?o`L0
2ol000[o1`1[o`030?oo08oo1`0;o`002ol606co00<0ool0Sol500co000<o`<00_l00`3oo`1Zo`03
0?oo08oo0`0=o`004_l00`3oo`1Zo`030?oo09ko000Co`80J_l00`3oo`2No`005Ol00`3oo`1Xo`03
0?oo09go000Fo`030?oo06So00<0ool0W?l001Oo0P1Xo`030?oo09co000Io`030?oo06Ko00<0ool0
Vol001[o00<0ool0I_l00`3oo`2Jo`006ol206Oo0`2Io`007Ol00`3oo`1To`8000?o0?l0Uol001ko
00<0ool0I?l00`3o002Ho`007ol206Co0P2Io`008Ol00`3oo`1Qo`80VOl002;o00<0ool0HOl209So
000So`030?oo06;o00<0ool0UOl002Co0P1So`030?oo09Co000Vo`030?oo063o00<0ool0U?l002Oo
00<0ool0H?l00`3oo`2Co`00:?l2067o00<0ool0T_l002[o00<0ool0G_l00`3oo`2Bo`00:ol00`3o
o`1No`030?oo097o000/o`80Gol00`3oo`2@o`00;_l00`3oo`1Mo`<0Sol002oo00<0ool0Fol508ko
000`o`80F_l708go000bo`030?oo05Oo1`2=o`00<ol00`3oo`1Fo`L0SOl003Co0P1Go`D0S_l003Ko
00<0ool0EOl308oo000go`030?oo05Go00<0ool0S_l003So00<0ool0E?l00`3oo`2>o`00>Ol205Co
00<0ool0S_l003_o00<0ool0DOl00`3oo`2>o`00??l00`3oo`1@o`030?oo08ko000mo`80D?l00`3o
o`2>o`00?ol00`3oo`1=o`030?oo08ko0010o`030?oo04co00<0ool0S_l0047o0P1<o`030?oo08ko
0013o`030?oo04Wo00<0ool0S_l004Co00<0ool0B?l00`3oo`2>o`00AOl204So00<0ool0S_l004Oo
00<0ool0AOl00`3oo`2>o`00B?l00`3oo`14o`030?oo08ko0019o`80A?l00`3oo`2>o`00Bol00`3o
o`11o`030?oo08ko001<o`030?oo043o00<0ool0S_l004go00<0ool0?ol00`3oo`2>o`00C_l203oo
00<0ool0S_l0053o00<0ool0??l00`3oo`2>o`00DOl00`3oo`0ko`030?oo08ko001Bo`80>ol00`3o
o`2>o`00E?l00`3oo`0ho`030?oo08ko001Eo`030?oo03Oo00<0ool0S_l005Ko0P0go`030?oo08ko
001Ho`030?oo03Co00<0ool0S_l005Wo00<0ool0<ol00`3oo`2>o`00F_l203?o00<0ool0S_l005co
00<0ool0<?l00`3oo`2>o`00GOl00`3oo`0_o`030?oo08ko001No`80;ol00`3oo`2>o`00H?l00`3o
o`0/o`030?oo08ko001Qo`030?oo02_o00<0ool0S_l006;o0P0[o`030?oo08ko001To`030?oo02So
00<0ool0S_l006Go00<0ool09ol00`3oo`2>o`00I_l00`3oo`0Vo`030?oo08ko001Wo`809_l00`3o
o`2>o`00JOl00`3oo`0So`030?oo08ko001Zo`030?oo02;o00<0ool0S_l006_o0P0Ro`030?oo08ko
001]o`030?oo01oo00<0ool0S_l006ko00<0ool07_l00`3oo`2>o`00Kol201ko00<0ool0S_l0077o
00<0ool06ol00`3oo`2>o`00L_l00`3oo`0Jo`030?oo08ko001co`806_l00`3oo`2>o`00MOl00`3o
o`0Go`030?oo08ko001fo`030?oo01Ko00<0ool0S_l007Oo0P0Fo`030?oo08ko001io`030?oo00So
1@06o`030?oo08ko001jo`030?oo00Wo00<0ool01_l00`3oo`2>o`00Nol00`3oo`08o`030?oo00Ko
00<0ool0S_l007co0P08o`030?oo00Ko00<0ool0S_l007ko00<0ool01Ol00`3oo`06o`030?oo08ko
001oo`030?oo00?o0P08o`030?oo08ko0020o`803Ol00`3oo`2>o`00P_l00`3oo`0:o`030?oo08ko
0023o`030?oo00Wo00<0ool0S_l008Co0P09o`030?oo08ko0026o`030?oo00Ko00<0ool0S_l008Oo
00<0ool01Ol00`3oo`2>o`00R?l200Go00<0ool0S_l008[o00<0ool00_l00`3oo`2>o`00Rol00`3o
o`0308oo002<o`H0S_l008co1`2=o`00S?l708go002<o`L0SOl008go1@2>o`00S_l308oo003oob7o
003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o0000\
\>"],
    ImageRangeCache->{{{81.8125, 311.188}, {292.813, 63.4375}} -> {-0.433405, 
    0.306888, 0.00374906, 0.00358263}}],
  "\n\:3000\:3053\:306e\:56f3\:5f62\:3092\:63cf\:753b\:3059\:308b\:30d7\:30ed\
\:30b0\:30e9\:30e0\:306f\:3001\:6b21\:306e\:3088\:3046\:306a\:3082\:306e\:3067\
\:3042\:308b\:3002\:4ee5\:4e0b\:306e\:30d7\:30ed\:30b0\:30e9\:30e0\:3067\:306f\
\:3001Combinatorica.m\:306b\:3042\:308b\:6df1\:3055\:512a\:5148\:63a2\:7d22\
\:306e\:305f\:3081\:306e\:95a2\:6570DepthFirstTraversal\:3092\:7528\:3044\
\:3066\:3044\:308b\:3002\:3053\:306e\:95a2\:6570\:306f\:3001\:4e0a\:306b\:8ff0\
\:3079\:305f\:65b9\:6cd5\:306b\:3088\:308a\:3001\:30b0\:30e9\:30d5\:306e\:751f\
\:6210\:6728\:3092\:6c42\:3081\:3001\:751f\:6210\:6728\:306e\:305f\:3081\:306e\
\:9802\:70b9\:5217\:3001\:307e\:305f\:306f\:8fba\:306e\:5217\:3092\:8fd4\:3059\
\:3002"
}], "Text"],

Cell[BoxData[{
    \(drawtree[mtx_, cyl_, st_] := 
      Block[{g1, g2, g3}, \n\t\t
        If[Length[mtx] - 1 != Length[st], Return[False]]; \n\t\t
        g1 = pseudoplanegraph[mtx, cyl]; \n\t\t
        g2 = generategraph[Length[mtx], st]; \n\t\t
        g3 = ChangeVertices[g2, Vertices[g1]]; \n\ \ \ \ \ 
        ShowLabeledGraph[g3]; \n\t\tReturn[g3]\n]\t\), 
    \(drawspanningtree[mtx_, cyl_, sp_, onoff_:  TREE] := 
      Block[{g1, g2, g3, st, ctr, xy, pr1, pr2}, \n\t\t
        g1 = pseudoplanegraph[mtx, cyl]; \n\t\t
        st = DepthFirstTraversal[g1, sp, Edge]; \n\t\t
        g2 = generategraph[Length[mtx], st]; \n\t\txy = Vertices[g1]; \n\t\t
        g3 = ChangeVertices[g2, xy]; 
        \ \ \ \ \ \ \ \  (*\ 
          g3 : \:751f\:6210\:6728\:306eGraph\:8868\:73fe\ *) \ \ \n\t\t
        If[SameQ[onoff, TREE], ShowLabeledGraph[g3], \t\n\t\t\t
            pr1 = Position[\ mtx, \ _?\((Function[n, n\  != \ 0])\)\ ]; \n
            \t\t\tpr2 = Map[Sort, pr1]; \n\t\t\t
            ctr = Complement[Intersection[pr1, pr2], Map[Sort, st]]; \n\t\t\t
            Show[Graphics[{\n\t\t\t\t\ \ \ \ 
                  Join[{PointSize[0.02]}, Map[Point, Chop[xy]], 
                    Map[\n\t\t\t\t\t
                      \(({Thickness[0.00001], Line[Chop[xy[\([#]\)]]]})\)&, 
                      ctr]], \n\t\t\t\t\t\t
                  Join[{PointSize[0.02]}, Map[Point, Chop[xy]], 
                    Map[\n\t\t\t\t\t
                      \(({Thickness[0.008], Line[Chop[xy[\([#]\)]]]})\)&, st]]
                    \n\t\t\t\t}\n\t\ \ \ \ ], {AspectRatio -> 1, 
                PlotRange -> FindPlotRange[Vertices[g1]]}]]\n\t\tReturn[g3]; 
        \n]\)}], "Input"],

Cell[TextData[
"\:3000\:95a2\:6570 drawspanningtree \:306f\:3001\:30b0\:30e9\:30d5\:306e\
\:96a3\:63a5\:884c\:5217\:3001\:5916\:5468\:8def\:3001\:51fa\:767a\:70b9\:3092\
\:5165\:529b\:3059\:308b\:3068\:3001\:5bfe\:5fdc\:3059\:308b\:751f\:6210\:6728\
\:3092\:63cf\:753b\:3059\:308b\:3002\:305f\:3060\:3057\:3001\:7b2c\:ff14\:5f15\
\:6570\:304cTREE\:3067\:3042\:308b\:5834\:5408\:306b\:306f\:3001\:751f\:6210\
\:6728\:306e\:307f\:3092\:3001COTREE\:306e\:3068\:304d\:306f\:3001\:751f\:6210\
\:6728\:3092\:592a\:7dda\:3067\:3001\:305d\:306e\:88dc\:6728\:ff08\:30b0\:30e9\
\:30d5\:306e\:751f\:6210\:6728\:306b\:542b\:307e\:308c\:306a\:3044\:8fba\:5168\
\:4f53\:306e\:4f5c\:308b\:90e8\:5206\:30b0\:30e9\:30d5\:ff09\:3092\:7d30\:7dda\
\:3067\:63cf\:304f\:3002\:4e0a\:306e\:56f3\:5f62\:306f\:3001drawspanningtree[\
dodeca,{1,2,3,4,5},11,TREE]\:3067\:63cf\:3044\:305f\:3082\:306e\:3067\:3042\
\:308b\:3002\n\:3000\:95a2\:6570 drawtree \
\:306f\:3001\:30b0\:30e9\:30d5\:306e\:96a3\:63a5\:884c\:5217\:3001\:5916\:5468\
\:8def\:3001\:751f\:6210\:6728\:3092\:4f5c\:308b\:8fba\:306e\:30ea\:30b9\:30c8\
\:3092\:5165\:529b\:3059\:308b\:3068\:3001\:5bfe\:5fdc\:3059\:308b\:751f\:6210\
\:6728\:3092\:63cf\:753b\:3059\:308b\:3002\:3053\:306e\:95a2\:6570\:3092\:7528\
\:3044\:3066\:3001Herschel \:30b0\:30e9\:30d5\:306e\:751f\:6210\:6728\:3092\
\:63cf\:3044\:3066\:307f\:308b\:3068\:3001\:6b21\:306e\:3088\:3046\:306b\:306a\
\:308b\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"Hersch", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"0", "1", "0", "1", "1", "1", "0", "0", "0", "0", "0"},
                {"1", "0", "1", "0", "0", "0", "1", "0", "0", "0", "0"},
                {"0", "1", "0", "1", "0", "0", "0", "0", "0", "1", "1"},
                {"1", "0", "1", "0", "0", "0", "0", "0", "1", "0", "0"},
                {"1", "0", "0", "0", "0", "0", "1", "1", "0", "0", "0"},
                {"1", "0", "0", "0", "0", "0", "0", "1", "1", "0", "0"},
                {"0", "1", "0", "0", "1", "0", "0", "0", "0", "1", "0"},
                {"0", "0", "0", "0", "1", "1", "0", "0", "0", "1", "1"},
                {"0", "0", "0", "1", "0", "1", "0", "0", "0", "0", "1"},
                {"0", "0", "1", "0", "0", "0", "1", "1", "0", "0", "0"},
                {"0", "0", "1", "0", "0", "0", "0", "1", "1", "0", "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}], ";", "\n", 
      \(drawtree[
        Hersch, {1, 2, 3, 
          4}, {{1, 2}, {2, 3}, {3, 4}, {4, 9}, {9, 6}, {6, 8}, {8, 5}, {5, 
            7}, {7, 10}, {8, 11}}]\)}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0454545 0.909091 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.04545 .5 Mdot
.5 .04545 Mdot
.95455 .5 Mdot
.43506 .65152 Mdot
.56494 .65152 Mdot
.30519 .5 Mdot
.5 .5 Mdot
.69481 .5 Mdot
.43506 .34848 Mdot
.56494 .34848 Mdot
.5 Mabswid
.5 .95455 m
.04545 .5 L
s
.04545 .5 m
.5 .95455 L
s
.04545 .5 m
.5 .04545 L
s
.5 .04545 m
.04545 .5 L
s
.5 .04545 m
.95455 .5 L
s
.95455 .5 m
.5 .04545 L
s
.95455 .5 m
.69481 .5 L
s
.43506 .65152 m
.30519 .5 L
s
.43506 .65152 m
.5 .5 L
s
.56494 .65152 m
.5 .5 L
s
.56494 .65152 m
.69481 .5 L
s
.30519 .5 m
.43506 .65152 L
s
.30519 .5 m
.43506 .34848 L
s
.5 .5 m
.43506 .65152 L
s
.5 .5 m
.56494 .65152 L
s
.5 .5 m
.56494 .34848 L
s
.69481 .5 m
.95455 .5 L
s
.69481 .5 m
.56494 .65152 L
s
.43506 .34848 m
.30519 .5 L
s
.56494 .34848 m
.5 .5 L
s
.5 .95455 m
.04545 .5 L
s
.04545 .5 m
.5 .95455 L
s
.04545 .5 m
.5 .04545 L
s
.5 .04545 m
.04545 .5 L
s
.5 .04545 m
.95455 .5 L
s
.95455 .5 m
.5 .04545 L
s
.95455 .5 m
.69481 .5 L
s
.43506 .65152 m
.30519 .5 L
s
.43506 .65152 m
.5 .5 L
s
.56494 .65152 m
.5 .5 L
s
.56494 .65152 m
.69481 .5 L
s
.30519 .5 m
.43506 .65152 L
s
.30519 .5 m
.43506 .34848 L
s
.5 .5 m
.43506 .65152 L
s
.5 .5 m
.56494 .65152 L
s
.5 .5 m
.56494 .34848 L
s
.69481 .5 m
.95455 .5 L
s
.69481 .5 m
.56494 .65152 L
s
.43506 .34848 m
.30519 .5 L
s
.56494 .34848 m
.5 .5 L
s
[(1)] .47273 .92727 0 1 Mshowa
[(2)] .01818 .47273 0 1 Mshowa
[(3)] .47273 .01818 0 1 Mshowa
[(4)] .92727 .47273 0 1 Mshowa
[(5)] .40779 .62424 0 1 Mshowa
[(6)] .53766 .62424 0 1 Mshowa
[(7)] .27792 .47273 0 1 Mshowa
[(8)] .47273 .47273 0 1 Mshowa
[(9)] .66753 .47273 0 1 Mshowa
[(10)] .40779 .32121 0 1 Mshowa
[(11)] .53766 .32121 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV0<aV
0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0<fH0
<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI<lbI
<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0IP0c
IS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<IVK<
IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITcVL`c
VOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<V@3o
VC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=Vc6IV
c9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Woc<co
c?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>IofJI
oiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H61PL7
1`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D50000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooohOo00<0ool0U_l008So00<0ool0UOl008Ko
00<0o`00Uol008Oo00<0ool0U_l00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo
8Ol008ko0`2?o`00SOl508ko002<o`L0SOl008co1`2=o`00S?l708go002=o`D0S_l008co00<0o`00
0P000ol0o`2<o`00Rol00`3oo`05o`030?oo08[o002:o`030?oo00Oo00<0ool0ROl008Wo00<0ool0
2Ol00`3oo`28o`00R?l00`3oo`0;o`030?oo08Oo0027o`030?oo00go00<0ool0Q_l008Ko00<0ool0
3ol00`3oo`25o`00QOl00`3oo`0Ao`030?oo08Co0024o`030?oo01?o00<0ool0Pol008?o00<0ool0
5Ol00`3oo`22o`00P_l00`3oo`0Go`030?oo087o0021o`030?oo01Wo00<0ool0P?l0083o00<0ool0
6ol00`3oo`1oo`00Ool00`3oo`0Mo`030?oo07ko001no`030?oo01oo00<0ool0OOl007go00<0ool0
8Ol00`3oo`1lo`00O?l00`3oo`0So`030?oo07_o001ko`030?oo02Go00<0ool0N_l007[o00<0ool0
9ol00`3oo`1io`00NOl00`3oo`0Yo`030?oo07So001ho`030?oo02_o00<0ool0Mol007Oo00<0ool0
;Ol00`3oo`1fo`00M_l00`3oo`0_o`030?oo07Go001eo`030?oo037o00<0ool0M?l007Co00<0ool0
<ol00`3oo`1co`00Lol00`3oo`0eo`030?oo07;o001bo`030?oo03Oo00<0ool0LOl0077o00<0ool0
>Ol00`3oo`1`o`00L?l00`3oo`0ko`030?oo06oo001_o`030?oo03go00<0ool0K_l006ko00<0ool0
?ol00`3oo`1]o`00KOl00`3oo`11o`030?oo06co001/o`030?oo04?o00<0ool0Jol006_o00<0ool0
AOl00`3oo`1Zo`00J_l00`3oo`17o`030?oo06Wo001Yo`030?oo04Wo00<0ool0J?l006So00<0ool0
Bol00`3oo`1Wo`00Iol00`3oo`1=o`030?oo06Ko001Vo`030?oo04oo00<0ool0IOl006Go00<0ool0
DOl00`3oo`1To`00I?l00`3oo`1Co`030?oo06?o001So`030?oo05Go00<0ool0H_l006;o00<0ool0
Eol00`3oo`1Qo`00HOl00`3oo`1Io`030?oo063o001Po`030?oo05_o00<0ool0Gol005oo00<0ool0
GOl00`3oo`1No`00G_l00`3oo`1Oo`030?oo05go001Mo`030?oo067o00<0ool0G?l005co00<0ool0
Hol00`3oo`1Ko`00Fol00`3oo`1Uo`030?oo05[o001Jo`030?oo06Oo00<0ool0FOl005Wo00<0ool0
JOl00`3oo`1Ho`00F?l00`3oo`1[o`030?oo05Oo001Go`030?oo06go00<0ool0E_l005Ko00<0ool0
Kol00`3oo`1Eo`00EOl00`3oo`1ao`030?oo05Co001Do`030?oo07?o00<0ool0Dol005?o00<0ool0
MOl00`3oo`1Bo`00D_l00`3oo`1go`030?oo057o001Ao`030?oo07Wo00<0ool0D?l0053o00<0ool0
Nol00`3oo`1?o`00Col00`3oo`1mo`030?oo04ko001>o`030?oo07oo00<0ool0COl004go00<0ool0
POl00`3oo`1<o`00C?l00`3oo`23o`030?oo04_o001;o`030?oo08Go00<0ool0B_l004[o00<0ool0
Qol00`3oo`19o`00BOl00`3oo`29o`030?oo04So0018o`030?oo02Go1@02o`030?oo01_o2P0go`03
0?oo04Oo0017o`030?oo02So00L0oooo0?l001ko00<0ool00_l00`3oo`0ho`030?oo04Ko0016o`03
0?oo02Wo00L0oooo0?l001ko00<0ool00_l00`3oo`0io`030?oo04Go0015o`030?oo02[o00L0oooo
0?l001ko00<0ool00_l00`3oo`0jo`030?oo04Co0014o`030?oo02_o00L0oooo0?l001ko00<0ool0
0_l00`3oo`0ko`030?oo04?o0013o`030?oo02_o0P04o`030?oo01co0P03o`80?_l00`3oo`12o`00
@_l00`3oo`2Go`030?oo047o0011o`030?oo09Wo00<0ool0@?l0043o00<0ool0Vol00`3oo`0oo`00
?ol00`3oo`2Mo`030?oo03ko000no`030?oo09oo00<0ool0?Ol003go00<0ool0XOl00`3oo`0lo`00
??l00`3oo`2So`030?oo03_o000ko`030?oo03go0`0So`<0?ol00`3oo`0jo`00>_l00`3oo`0mo`D0
8Ol503oo00<0ool0>Ol003Wo00<0ool0?Ol701oo1`0oo`030?oo03So000ho`030?oo03ko1`0Oo`L0
@?l00`3oo`0go`00=ol00`3oo`0oo`L07ol7047o00<0ool0=_l003Ko00<0ool0@Ol5027o1@13o`03
0?oo03Go000eo`030?oo047o00<0o`000P0So`<0AOl00`3oo`0do`00=?l00`3oo`12o`030?oo02Co
00<0ool0Aol00`3oo`0co`00<ol00`3oo`12o`030?oo02Go00<0ool0B?l00`3oo`0bo`00<_l00`3o
o`12o`030?oo02Go00<0ool0B_l00`3oo`0ao`00<Ol00`3oo`12o`030?oo02Ko00<0ool0Bol00`3o
o`0`o`00<?l00`3oo`12o`030?oo02Ko00<0ool0COl00`3oo`0_o`00;ol00`3oo`12o`030?oo02Oo
00<0ool0C_l00`3oo`0^o`00;_l00`3oo`12o`030?oo02So00<0ool0Col00`3oo`0]o`00;Ol00`3o
o`13o`030?oo02Oo00<0ool0DOl00`3oo`0/o`00;?l00`3oo`13o`030?oo02So00<0ool0D_l00`3o
o`0[o`00:ol00`3oo`13o`030?oo02So00<0ool0E?l00`3oo`0Zo`00:_l00`3oo`13o`030?oo02Wo
00<0ool0EOl00`3oo`0Yo`00:Ol00`3oo`13o`030?oo02Wo00<0ool0Eol00`3oo`0Xo`00:?l00`3o
o`13o`030?oo02[o00<0ool0F?l00`3oo`0Wo`009ol00`3oo`13o`030?oo02[o00<0ool0F_l00`3o
o`0Vo`009_l00`3oo`14o`030?oo02[o00<0ool0Fol00`3oo`0Uo`009Ol00`3oo`14o`030?oo02_o
00<0ool0G?l00`3oo`0To`009?l00`3oo`14o`030?oo02_o00<0ool0G_l00`3oo`0So`008ol00`3o
o`14o`030?oo02co00<0ool0Gol00`3oo`0Ro`008_l00`3oo`14o`030?oo02co00<0ool0HOl00`3o
o`0Qo`008Ol00`3oo`14o`030?oo02go00<0ool0H_l00`3oo`0Po`008?l00`3oo`14o`030?oo02go
00<0ool0I?l00`3oo`0Oo`007ol00`3oo`14o`030?oo02ko00<0ool0IOl00`3oo`0No`007_l00`3o
o`15o`030?oo02ko00<0ool0I_l00`3oo`0Mo`000ol301Oo00<0ool0;ol00`3oo`0Co`030?oo01oo
00<0ool03?l00`3oo`0Uo`80@Ol00`3oo`05o`<05?l000?o00<0ool05_l00`3oo`0`o`030?oo01;o
00<0ool07ol00`3o000=o`030?oo02Oo00<0ool0?ol00`3oo`05o`030?oo01?o0004o`030?oo01Co
00<0ool0<Ol00`3oo`0Ao`030?oo023o00<0o`003?l00`3oo`0Wo`80@_l00`3oo`02o`@05?l000Co
00<0ool04ol00`3oo`0co`030?oo00oo00<0ool08_l00`3oo`0;o`030?oo02Ko00<0o`00@ol01`3o
ool0o`005Ol000?o00<0o`004ol00`3oo`0bo`030?l0013o00<0ool08_l00`3o000;o`030?oo02Oo
00<0o`00A?l0103oool201Go0004o`030?oo017o00<0ool0<ol300oo00<0ool09?l00`3oo`0:o`03
0?oo02So0P15o`050?ooo`005Ol001Oo00<0ool0A_l00`3oo`0`o`030?oo077o00<0ool05_l001Ko
00<0ool0A_l00`3oo`0ao`030?oo07;o00<0ool05Ol001Go00<0ool0A_l00`3oo`0bo`030?oo07?o
00<0ool05?l001Co00<0ool0A_l00`3oo`0bo`030?oo07Go00<0ool04ol001?o00<0ool0A_l00`3o
o`0co`030?oo07Ko00<0ool04_l001;o00<0ool0A_l00`3oo`0co`030?oo07So00<0ool04Ol0017o
00<0ool0A_l00`3oo`0do`030?oo07Wo00<0ool04?l000_o0`02o`030?oo04?o0`000ol0o`0bo`<0
=Ol304Go00<0o`000P0=o`002_l604Go1@0co`D0<ol504Go1@0<o`002Ol704Co1`0ao`L0<Ol704?o
1`0;o`002Ol704Co1`0ao`L0<OmA00_o0009o`L0A?l7037o1`0ao`L0@ol700_o000:o`H0AOl503?o
1@0co`D0AOl500co000;o`<00_l00`3oo`13o`<000?o0?l0<_l303?o00<0o`000P17o`<03Ol0017o
00<0ool0A_l00`3oo`0`o`050?ooo`00<_l00`3oo`1Io`004_l00`3oo`16o`030?oo02oo00D0oooo
000ao`030?oo05[o000Co`030?oo04Ko00<0ool0;Ol00`3oo`03o`030?oo02go00<0ool0Fol001Co
00<0ool0A_l00`3oo`0/o`030?oo00?o00<0ool0;?l00`3oo`1Lo`005Ol00`3oo`16o`030?oo02[o
00<0ool01Ol00`3oo`0Zo`030?oo05go000Fo`030?oo04Ko00<0ool0:Ol00`3oo`05o`030?oo02Wo
00<0ool0G_l001Oo00<0ool0A_l00`3oo`0Xo`030?oo00Go00<0ool0:?l00`3oo`1Oo`006?l00`3o
o`15o`030?oo02Oo00<0ool01ol00`3oo`0Wo`030?oo05oo000Io`030?oo04Go00<0ool09_l00`3o
o`07o`030?oo02Ko00<0ool0H?l001[o00<0ool0AOl00`3oo`0To`030?oo00Wo00<0ool09?l00`3o
o`1Qo`006ol00`3oo`15o`030?oo02?o00<0ool02Ol00`3oo`0So`030?oo06;o000Lo`030?oo04Go
00<0ool08Ol00`3oo`0;o`030?oo027o00<0ool0Hol001go00<0ool0AOl00`3oo`0Po`030?oo00_o
00<0ool08?l00`3oo`1To`007_l00`3oo`15o`030?oo01ko00<0ool03Ol00`3oo`0No`030?oo06Go
000Oo`030?oo04Co00<0ool07_l00`3oo`0=o`030?oo01ko00<0ool0IOl0023o00<0ool0A?l00`3o
o`0Mo`030?oo00go00<0ool07Ol00`3oo`1Vo`008Ol00`3oo`14o`030?oo01_o00<0ool03ol00`3o
o`0Ko`030?oo06Oo000Ro`030?oo04Co00<0ool06_l00`3oo`0?o`030?oo01[o00<0ool0J?l002?o
00<0ool0A?l00`3oo`0Ho`030?oo017o00<0ool06?l00`3oo`1Yo`009?l00`3oo`14o`030?oo01Oo
00<0ool04Ol00`3oo`0Go`030?oo06[o000Uo`030?oo04Co00<0ool05Ol00`3oo`0Co`030?oo01Go
00<0ool0Jol002Ko00<0ool0A?l00`3oo`0Do`030?oo01?o00<0ool05?l00`3oo`1/o`009ol00`3o
o`13o`030?oo01Co00<0ool04ol00`3oo`0Do`030?oo06co000Xo`030?oo04?o00<0ool04_l00`3o
o`0Eo`030?oo01;o00<0ool0KOl002Wo00<0ool0@ol00`3oo`02o`030?oo00co00<0ool04_l20003
o`3o01;o00<0ool0K_l002[o00<0ool0@ol01P3oo`3o00co00<0ool04ol01@3o0?l0017o00<0ool0
Kol002_o00<0ool0@ol01@3oool000co00<0ool04ol01@3o0?l0013o00<0ool0L?l002co00<0ool0
@ol300co00<0ool05?l200?o00<0ool03?l00`3oo`1ao`00;Ol00`3oo`13o`030?oo00_o00<0ool0
5?l00`3oo`02o`030?oo00_o00<0ool0L_l002ko00<0ool0@_l300[o00<0ool05_l200?o00<0ool0
2_l00`3oo`1bo`00;ol00`3oo`12o`030?oo00Wo00<0ool06ol00`3oo`09o`030?oo07?o000`o`03
0?oo04;o00<0ool02?l00`3oo`0Ko`030?oo00So00<0ool0M?l0037o00<0ool0@_l00`3oo`06o`03
0?oo01go00<0ool01_l00`3oo`1eo`00<_l00`3oo`12o`030?oo00Go00<0ool07Ol00`3oo`05o`03
0?oo07Ko000co`030?oo04;o00<0ool00ol00`3oo`0Oo`030?oo00?o00<0ool0Mol003Co00<0ool0
@_l00`3oo`02o`030?oo01oo00<0ool00_l00`3oo`1ho`00=Ol00`3oo`11o`050?ooo`008ol01@3o
ool007[o000fo`030?oo047o100So`@0Nol003Oo00<0ool0@?l5027o1@1ko`00>?l00`3oo`0no`L0
7ol707[o000io`030?oo03go1`0Oo`L0N_l003[o00<0ool0??l701oo1`1jo`00>ol00`3oo`0lo`D0
8Ol507_o000lo`030?oo03co0`0So`<0O?l003go00<0ool0h?l003ko00<0ool0gol003oo00<0ool0
g_l0043o00<0ool0gOl0047o00<0ool0g?l004;o00<0ool0fol004?o00<0ool0f_l004Co00<0ool0
fOl004Go00<0ool0f?l004Ko00<0ool0eol004Oo00<0ool0e_l004So00<0ool0eOl004Wo00<0ool0
e?l004[o00<0ool0dol004_o00<0ool0d_l004co00<0ool0dOl004go00<0ool0d?l004ko00<0ool0
col004oo00<0ool0c_l0053o00<0ool0cOl0057o00<0ool0c?l005;o00<0ool0bol005?o00<0ool0
b_l005Co00<0ool0bOl005Go00<0ool0b?l005Ko00<0ool0aol005Oo00<0ool0a_l005So00<0ool0
aOl005Wo00<0ool0a?l005[o00<0ool0`ol005_o00<0ool0`_l005co00<0ool0`Ol005go00<0ool0
`?l005ko00<0ool0_ol005oo00<0ool0__l0063o00<0ool0_Ol0067o00<0ool0_?l006;o00<0ool0
^ol006?o00<0ool0^_l006Co00<0ool0^Ol006Go00<0ool0^?l006Ko00<0ool0]ol006Oo00<0ool0
]_l006So00<0ool0]Ol006Wo00<0ool0]?l006[o00<0ool0/ol006_o00<0ool0/_l006co00<0ool0
/Ol006go00<0ool0/?l006ko00<0ool0[ol006oo00<0ool0[_l0073o00<0ool0[Ol0077o00<0ool0
[?l007;o00<0ool0Zol007?o00<0ool0Z_l007Co00<0ool0ZOl007Go00<0ool0Z?l007Ko00<0ool0
Yol007Oo00<0ool0Y_l007So00<0ool0YOl007Wo00<0ool0Y?l007[o00<0ool0Xol007_o00<0ool0
X_l007co00<0ool0XOl007go00<0ool0X?l007ko00<0ool0Wol007oo00<0ool0W_l0083o00<0ool0
0_l509Ko0021o`030?oo00?o00<0ool0U_l008;o00<0ool00_l00`3oo`2Fo`00Pol01@3oool009So
0024o`040?oo09So0025o`<0V?l008Ko00<0ool0Uol008Oo00<0ool0U_l008So00<0ool0UOl008Wo
00<0ool0U?l008[o00<0ool0Tol008_o00<0ool0T_l008co00<0ool0TOl008go102?o`00SOl508ko
002<o`L0SOl008co1`2=o`00S?l708go002=o`D0S_l008ko0`2?o`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00\
\>"],
  ImageRangeCache->{{{83, 312.375}, {476.438, 247.063}} -> {-0.448048, 
  1.13483, 0.00383655, 0.00383655}}]
}, Open  ]],

Cell[TextData[
"\:7b2c\:ff11\:5f15\:6570\:306e Hersch \:306f\:3001\:3053\:306e\:30b0\:30e9\
\:30d5\:306e\:96a3\:63a5\:884c\:5217\:3067\:3042\:308b\:3002"], "Text"],

Cell[BoxData[
    \(\(\:ff11\:ff10\:ff0e\) \:ff15\ \ \ \ 
      \:30b0\:30e9\:30d5\:306e\:5e73\:9762\:6027\:5224\:5b9a\:30a2\:30eb\:30b4\
\:30ea\:30ba\:30e0\)], "Input"],

Cell[TextData[{
  "\:3000\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:ff27\:306e\:ff08\:5e73\:9762\
\:7684\:ff09\:90e8\:5206\:30b0\:30e9\:30d5\:ff28\:306e\:5e73\:9762\:30b0\:30e9\
\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  "\:306f\:3001\:6b21\:306e\:6761\:4ef6\:3092\:6e80\:305f\:3059\:3068\:304d\
\:306b\:ff27\:2212\:4e26\:5217\:63cf\:753b\:53ef\:80fd\:3068\:8a00\:3046\:3002\
\n\:ff08\:ff11\:ff09\:ff27\:306e\:5e73\:9762\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  " \:3067",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  " \:3092\:5e73\:9762\:4e0a\:306e\:90e8\:5206\:56f3\:5f62\:3068\:3057\:3066\
\:542b\:3080\:3088\:3046\:306a\:3082\:306e\:304c\:3042\:308b\:3002\n\n\:3000\
\:6b21\:306b\:3001\:ff22\:3092\:ff28\:306b\:95a2\:3059\:308b\:4efb\:610f\:306e\
\:5207\:7247\:3067\:3001\:6b21\:306e\:6761\:4ef6\:3092\:6e80\:305f\:3059\:3068\
\:304d\:3001\:ff22\:306f",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  "\:306e\:9762\:ff46\:306b\:63cf\:753b\:53ef\:80fd (drawable)\:3068\:8a00\
\:3046\:3002\n\:ff08\:ff11\:ff09\:ff46\:306f",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  "\:304c\:5e73\:9762\:3092\:5206\:5272\:3057\:3066\:51fa\:6765\:308b\:9762\
\:306e\:ff11\:3064\:3067\:3042\:308b\:3002\n\:ff08\:ff12\:ff09\:ff22\:306e",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  "\:306b\:95a2\:3059\:308b\:7d50\:5408\:70b9\:306f\:3001\:3059\:3079\:3066\
\:ff46\:306b\:542b\:307e\:308c\:308b\:3002\n\n\:3000\:ff22\:304c\:63cf\:753b\
\:53ef\:80fd\:306a",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  "\:306e\:9762\:306e\:96c6\:5408\:3092 F(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ") \:3068\:8868\:3059\:3002\:3053\:306e\:3068\:304d\:3001\
\[CloseCurlyDoubleQuote]",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  " \:304c\:ff27\:2212\:4e26\:5217\:63cf\:753b\:53ef\:80fd\:306a\:3089\:3070\
\:3001\:ff28\:306e\:4efb\:610f\:306e\:5207\:7247\:ff22\:306b\:5bfe\:3057\:3066\
\:3001F(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ")\:306f\:7a7a\:96c6\:5408\:3067\:306a\:3044\[CloseCurlyDoubleQuote]\:3001\
\:304c\:6210\:308a\:7acb\:3064\:3002\n\n\:3000\:3053\:306e\:4e8b\:5b9f\:3092\
\:5229\:7528\:3057\:3066\:3001\:30b0\:30e9\:30d5\:306e\:5e73\:9762\:6027\:5224\
\:5b9a\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:3092\:4e0e\:3048\:308b\:3002\n\
\:ff08\:ff11\:ff09\:ff27\:306e\:ff11\:3064\:306e\:30b5\:30a4\:30af\:30eb\:3092\
",
  Cell[BoxData[
      \(TraditionalForm\`G\_1\)]],
  "\:3068\:3059\:308b\:3002",
  Cell[BoxData[
      \(TraditionalForm\`G\_1\)]],
  "\:306e\:5e73\:9762\:30b0\:30e9\:30d5\:3092",
  Cell[BoxData[
      \(TraditionalForm\`\(G\_1\)\&_\)]],
  "\:3068\:3057\:3066\:3001\:5e73\:9762\:306b\:63cf\:304d\:3001i  = 1 \:3068\
\:7f6e\:304f\:3002\n\:ff08\:ff12\:ff09\:3082\:3057E(G) - E(",
  Cell[BoxData[
      \(TraditionalForm\`G\_i\)]],
  ") = \[Phi] \:306a\:3089\:3070\:7d42\:4e86\:3059\:308b\:3002\:3053\:306e\
\:5834\:5408\:306b\:306f\:ff27\:306f\:5e73\:9762\:30b0\:30e9\:30d5\:3067\:3042\
\:308b\:3002\:305d\:3046\:3067\:306a\:3044\:3068\:304d\:306f\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_i\)]],
  "\:306e\:3059\:3079\:3066\:306e\:5207\:7247\:3092\:6c7a\:5b9a\:3057\:3001\
\:5404\:5207\:7247\:306eF(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ") \:3092\:6c42\:3081\:308b\:3002\n\:ff08\:ff13\:ff09\:3082\:3057F(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ") = \[Phi] \:306a\:3089\:3070\:3001\:ff27\:306f\:5e73\:9762\:7684\:30b0\
\:30e9\:30d5\:3067\:306f\:306a\:3044\:3068\:3057\:3066\:7d42\:4e86\:3059\:308b\
\:3002\:3082\:3057\:ff5cF(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ")\:ff5c\:ff1d\:ff11\:3068\:306a\:308b\:ff22\:304c\:3042\:308c\:3070\:3001{ \
f } = F(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ") \:3068\:3057\:3066\:9762\:ff46\:3092\:5b9a\:3081\:308b\:3002\:305d\:3046\
\:3067\:306a\:3044\:306a\:3089\:3001\:ff46\[Epsilon] F(B, ",
  Cell[BoxData[
      \(TraditionalForm\`H\&_\)]],
  ") \:3092\:6e80\:305f\:3059\:5207\:7247\:ff22\:3068\:9762\:ff46\:3092\:5b9a\
\:3081\:308b\:3002\n\:ff08\:ff14\:ff09\:ff22\:306e",
  Cell[BoxData[
      \(TraditionalForm\`\(\ G\_i\)\)]],
  "\:306b\:95a2\:3059\:308b\:76f8\:7570\:306a\:308b\:ff12\:3064\:306e\:7d50\
\:5408\:70b9\:ff08\:552f\:ff11\:3064\:306e\:7d50\:5408\:70b9\:306e\:307f\:3092\
\:6301\:3064\:5834\:5408\:306f\:3001\:3088\:308a\:7c21\:5358\:306a\:5834\:5408\
\:3068\:3057\:3066\:6392\:9664\:3067\:304d\:308b\:3002\:3059\:306a\:308f\:3061\
\:3001G\:306f\:ff12\:2212\:9023\:7d50\:3068\:3059\:308b\:ff09\:3092\:7d50\
\:3076\:9053\:3092",
  Cell[BoxData[
      \(TraditionalForm\`P\_i\)]],
  "\:3068\:3057\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_\(i + 1\)\)]],
  " = ",
  Cell[BoxData[
      \(TraditionalForm\`\(\ G\_i\)\)]],
  Cell[BoxData[
      \(TraditionalForm\`\(\  \)\)]],
  "\[Union]",
  Cell[BoxData[
      \(TraditionalForm\`P\_i\)]],
  " \:3068\:7f6e\:304f\:3002\:3053\:306e\:3068\:304d\:3001",
  Cell[BoxData[
      \(TraditionalForm\`P\_i\)]],
  " \:3092",
  Cell[BoxData[
      \(TraditionalForm\`G\_i\)]],
  "\:306e\:9762\:ff46\:306b\:63cf\:304f\:3053\:3068\:306b\:3088\:308a\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_\(i + 1\)\)]],
  "\:306e\:5e73\:9762\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`\(G\_\(i + 1\)\)\&_\)]],
  "\:304c\:5f97\:3089\:308c\:308b\:3002\:6b21\:306b\:3001i \:3092 i+1 \:3068\
\:3057\:3066\:3001\:30b9\:30c6\:30c3\:30d7\:ff08\:ff12\:ff09\:306b\:623b\:308b\
\:3002\n\n\:3000\:3053\:3053\:306b\:8ff0\:3079\:305f\:65b9\:6cd5\:3067\:306f\
\:3001\:30b9\:30c6\:30c3\:30d7\:ff08\:ff12\:ff09\:3067\:5e73\:9762\:306b\:63cf\
\:304b\:308c\:305f\:90e8\:5206\:30b0\:30e9\:30d5\:304c\:5927\:304d\:304f\:306a\
\:308b\:3054\:3068\:306b\:3001\:305d\:308c\:306e\:5207\:7247\:3092\:4f5c\:308a\
\:76f4\:3059\:5fc5\:8981\:304c\:3042\:308b\:3002Combinatorica.m \:3067\:5b9a\
\:7fa9\:3055\:308c\:305f\:5e73\:9762\:6027\:5224\:5b9a\:306e\:305f\:3081\:306e\
\:95a2\:6570 PlanarQ \:306f\:3001\:4e0a\:306b\:8ff0\:3079\:305f\:65b9\:6cd5\
\:3092\:7528\:3044\:3066\:30d7\:30ed\:30b0\:30e9\:30e0\:3055\:308c\:3066\:3044\
\:308b\:3002\n\:3000\:3057\:304b\:3057\:3001\:6df1\:3055\:512a\:5148\:63a2\
\:7d22\:3092\:7528\:3044\:3066\[CloseCurlyDoubleQuote]\:30d1\:30fc\:30e0\:30fb\
\:30c4\:30ea\:30fc(palm tree)\[CloseCurlyDoubleQuote]\:3068\:547c\:3070\:308c\
\:308b\:6709\:5411\:6728\:3092\:4f5c\:308a\:3001\:3053\:308c\:304b\:3089\:6700\
\:521d\:306b\:ff11\:5ea6\:3060\:3051\:ff11\:3064\:306e\:30b5\:30a4\:30af\:30eb\
\:ff23\:306e\:3059\:3079\:3066\:306e\:5207\:7247\:3092\:6c42\:3081\:3001\:57cb\
\:3081\:8fbc\:3080\:9053\:306e\:9806\:756a\:3092\:6c7a\:3081\:3066\:5224\:5b9a\
\:3059\:308b\:3088\:308a\:52b9\:7387\:7684\:306a\:30a2\:30eb\:30b4\:30ea\:30ba\
\:30e0\:304c\:77e5\:3089\:308c\:3066\:3044\:308b[HT]\:3002\:3053\:306e\:65b9\
\:6cd5\:306b\:3064\:3044\:3066\:306f\:5f8c\:8ff0\:3059\:308b\:3002\n\n\:3000\
\:3053\:3053\:3067\:306f\:3001\:95a2\:6570PlanarQ \:3092\:7528\:3044\:3066\
\:3001\:3044\:304f\:3064\:304b\:306e\:30b0\:30e9\:30d5\:304c\:5e73\:9762\:7684\
\:3067\:3042\:308b\:304b\:3069\:3046\:304b\:3092\:5224\:5b9a\:3057\:3066\:307f\
\:308b\:3002\n\:4f8b\:ff11\:ff0e\:ff27\:3092\:96a3\:63a5\:884c\:5217 mm \
\:304c\:6b21\:306e\:3088\:3046\:306a\:30b0\:30e9\:30d5\:3068\:3059\:308b\:3002\
\n          mm = ",
  Cell[BoxData[
      TagBox[
        RowBox[{"(", GridBox[{
              {"0", "1", "0", "0", "0", "0", "0", "0", "1", "1"},
              {"1", "0", "1", "1", "1", "0", "0", "0", "0", "0"},
              {"0", "1", "0", "1", "0", "0", "1", "1", "1", "0"},
              {"0", "1", "1", "0", "1", "1", "0", "0", "0", "1"},
              {"0", "1", "0", "1", "0", "0", "0", "0", "0", "0"},
              {"0", "0", "0", "1", "0", "0", "1", "0", "0", "1"},
              {"0", "0", "1", "0", "0", "1", "0", "1", "1", "0"},
              {"0", "0", "1", "0", "0", "0", "1", "0", "1", "0"},
              {"1", "0", "1", "0", "0", "0", "1", "1", "0", "1"},
              {"1", "0", "0", "1", "0", "1", "0", "0", "1", "0"}
              }], ")"}],
        (MatrixForm[ #]&)]]],
  "\n \:3053\:306e\:3068\:304d\:3001\:30b0\:30e9\:30d5\:306f\:6b21\:306e\:3088\
\:3046\:306a\:56f3\:3092\:6301\:3064\:3002"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ShowLabeledGraph[pseudoplanegraph[mm, {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}]]
      \)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0242882 0.951424 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.22038 .86773 Mdot
.04757 .64046 Mdot
.04757 .35954 Mdot
.22038 .13227 Mdot
.5 .04545 Mdot
.77962 .13227 Mdot
.95243 .35954 Mdot
.95243 .64046 Mdot
.77962 .86773 Mdot
.5 Mabswid
.5 .95455 m
.22038 .86773 L
s
.5 .95455 m
.95243 .64046 L
s
.5 .95455 m
.77962 .86773 L
s
.22038 .86773 m
.5 .95455 L
s
.22038 .86773 m
.04757 .64046 L
s
.22038 .86773 m
.04757 .35954 L
s
.22038 .86773 m
.22038 .13227 L
s
.04757 .64046 m
.22038 .86773 L
s
.04757 .64046 m
.04757 .35954 L
s
.04757 .64046 m
.77962 .13227 L
s
.04757 .64046 m
.95243 .35954 L
s
.04757 .64046 m
.95243 .64046 L
s
.04757 .35954 m
.22038 .86773 L
s
.04757 .35954 m
.04757 .64046 L
s
.04757 .35954 m
.22038 .13227 L
s
.04757 .35954 m
.5 .04545 L
s
.04757 .35954 m
.77962 .86773 L
s
.22038 .13227 m
.22038 .86773 L
s
.22038 .13227 m
.04757 .35954 L
s
.5 .04545 m
.04757 .35954 L
s
.5 .04545 m
.77962 .13227 L
s
.5 .04545 m
.77962 .86773 L
s
.77962 .13227 m
.04757 .64046 L
s
.77962 .13227 m
.5 .04545 L
s
.77962 .13227 m
.95243 .35954 L
s
.77962 .13227 m
.95243 .64046 L
s
.95243 .35954 m
.04757 .64046 L
s
.95243 .35954 m
.77962 .13227 L
s
.95243 .35954 m
.95243 .64046 L
s
.95243 .64046 m
.5 .95455 L
s
.95243 .64046 m
.04757 .64046 L
s
.95243 .64046 m
.77962 .13227 L
s
.95243 .64046 m
.95243 .35954 L
s
.95243 .64046 m
.77962 .86773 L
s
.77962 .86773 m
.5 .95455 L
s
.77962 .86773 m
.04757 .35954 L
s
.77962 .86773 m
.5 .04545 L
s
.77962 .86773 m
.95243 .64046 L
s
.5 .95455 m
.22038 .86773 L
s
.5 .95455 m
.95243 .64046 L
s
.5 .95455 m
.77962 .86773 L
s
.22038 .86773 m
.5 .95455 L
s
.22038 .86773 m
.04757 .64046 L
s
.22038 .86773 m
.04757 .35954 L
s
.22038 .86773 m
.22038 .13227 L
s
.04757 .64046 m
.22038 .86773 L
s
.04757 .64046 m
.04757 .35954 L
s
.04757 .64046 m
.77962 .13227 L
s
.04757 .64046 m
.95243 .35954 L
s
.04757 .64046 m
.95243 .64046 L
s
.04757 .35954 m
.22038 .86773 L
s
.04757 .35954 m
.04757 .64046 L
s
.04757 .35954 m
.22038 .13227 L
s
.04757 .35954 m
.5 .04545 L
s
.04757 .35954 m
.77962 .86773 L
s
.22038 .13227 m
.22038 .86773 L
s
.22038 .13227 m
.04757 .35954 L
s
.5 .04545 m
.04757 .35954 L
s
.5 .04545 m
.77962 .13227 L
s
.5 .04545 m
.77962 .86773 L
s
.77962 .13227 m
.04757 .64046 L
s
.77962 .13227 m
.5 .04545 L
s
.77962 .13227 m
.95243 .35954 L
s
.77962 .13227 m
.95243 .64046 L
s
.95243 .35954 m
.04757 .64046 L
s
.95243 .35954 m
.77962 .13227 L
s
.95243 .35954 m
.95243 .64046 L
s
.95243 .64046 m
.5 .95455 L
s
.95243 .64046 m
.04757 .64046 L
s
.95243 .64046 m
.77962 .13227 L
s
.95243 .64046 m
.95243 .35954 L
s
.95243 .64046 m
.77962 .86773 L
s
.77962 .86773 m
.5 .95455 L
s
.77962 .86773 m
.04757 .35954 L
s
.77962 .86773 m
.5 .04545 L
s
.77962 .86773 m
.95243 .64046 L
s
[(1)] .47146 .92727 0 1 Mshowa
[(2)] .19184 .84046 0 1 Mshowa
[(3)] .01903 .61319 0 1 Mshowa
[(4)] .01903 .33227 0 1 Mshowa
[(5)] .19184 .10499 0 1 Mshowa
[(6)] .47146 .01818 0 1 Mshowa
[(7)] .75107 .10499 0 1 Mshowa
[(8)] .92389 .33227 0 1 Mshowa
[(9)] .92389 .61319 0 1 Mshowa
[(10)] .75107 .84046 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l:C8l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV
0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0
<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI
<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0
IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<
IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITc
VL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<
V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=V
c6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Wo
c<coc?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>I
ofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H6
1PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D5000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooohGo00<0o`00V?l008Go0P2Io`00QOl00`3o
o`2Ho`00Q_l209So003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o002>o`<0
Sol008go1@2>o`00S?l708go002<o`L0SOl008co202<o`00S?l600;o1028o`00R_l200;o0`07o`<0
QOl008Wo00<0ool01?l00`3oo`08o`<0P_l008So00<0ool01_l00`3oo`0:o`@0O_l008Ko0P09o`03
0?oo00ko0`1ko`00QOl00`3oo`09o`030?oo017o0`1ho`00Pol200go00<0ool04ol407Co000fo`03
0?oo04Wo00<0ool03Ol00`3oo`0Go`<0:?l00`3oo`16o`00=Ol00`3o0018o`804?l00`3oo`0Jo`<0
9Ol00`3oo`16o`00=ol00`3oo`15o`030?oo017o00<0ool07?l4027o00<0ool0A_l003Go0P16o`80
5?l00`3oo`0Po`<07ol00`3oo`15o`00=Ol00`3oo`14o`030?oo01Co00<0ool08ol301[o00<0o`00
Aol003Go0`13o`030?oo01Ko00<0ool09Ol401Ko0`17o`00NOl201Wo00<0ool0:Ol305go001ho`03
0?oo01Wo00<0ool0;?l305[o001fo`807Ol00`3oo`0^o`@0E_l007Go00<0ool07Ol00`3oo`0bo`<0
Dol007?o0P0Po`030?oo03Go0`1@o`00L_l00`3oo`0Qo`030?oo03Oo101<o`00L?l202Co00<0ool0
>ol304Wo000no`<0;_l00`3oo`0To`030?oo03ko0`04o`<0?ol003go1@0/o`030?oo02Ko00<0ool0
@?l803ko000lo`L0:Ol202Wo00<0ool0@_l703go000lo`L0:?l00`3oo`0Yo`030?oo04;o1`0mo`00
??l702Ko0P0]o`030?oo047o1`0mo`00?Ol502Ko00<0ool0;Ol00`3oo`0oo`8000?o00000`0no`00
??l00`3o000202Go0P0`o`030?oo03ko00<0ool00_l30003o`3o03co000ko`050?ooo`009Ol00`3o
o`0ao`030?oo03co00<0ool01_l00`3o000lo`00>_l00`3oo`02o`030?oo027o0P0do`030?oo03[o
0P09o`040?oo03_o000jo`030?oo00;o00<0ool08?l00`3oo`0eo`030?oo03So00<0ool02Ol0103o
o`0ko`00>Ol00`3oo`03o`030?oo01oo00<0ool0=_l00`3oo`0fo`803Ol0103oo`0jo`00>?l00`3o
o`04o`030?oo01go0P0io`030?oo03Go00<0ool03Ol01@3oool003Wo000go`030?oo00Go00<0ool0
7?l00`3oo`0jo`030?oo03;o0P0@o`030?oo00;o00<0ool0=_l003Oo00<0ool01Ol00`3oo`0Jo`80
?Ol00`3oo`0ao`030?oo017o00D0oooo000ho`00=_l00`3oo`06o`030?oo01Wo00<0ool0?Ol00`3o
o`0`o`030?oo01;o00<0ool00_l00`3oo`0eo`00=Ol00`3oo`07o`030?oo01Oo0P11o`030?oo02go
0P0Eo`030?oo00?o00<0ool0=?l003Co00<0ool02?l00`3oo`0Fo`030?oo047o00<0ool0;?l00`3o
o`0Fo`030?oo00?o00<0ool0<ol003Co00<0ool02?l00`3oo`0Do`80A?l00`3oo`0Zo`806Ol00`3o
o`03o`030?oo03?o000co`030?oo00Wo00<0ool04ol00`3oo`15o`030?oo02So00<0ool06Ol00`3o
o`04o`030?oo03;o000bo`030?oo00[o00<0ool04_l00`3oo`16o`030?oo02Ko0P0Mo`030?oo00Co
00<0ool0<Ol0037o00<0ool02ol00`3oo`0@o`80BOl00`3oo`0Uo`030?oo01go00<0ool01Ol00`3o
o`0`o`00<Ol00`3oo`0;o`030?oo00oo00<0ool0B_l00`3oo`0Ro`808Ol00`3oo`04o`030?oo033o
000`o`030?oo00co00<0ool03Ol204go00<0ool08Ol00`3oo`0Qo`030?oo00Go00<0ool0;ol002oo
00<0ool03Ol00`3oo`0<o`030?oo04go00<0ool08?l00`3oo`0Ro`030?oo00Ko00<0ool0;_l002ko
00<0ool03_l00`3oo`0:o`80DOl00`3oo`0Mo`809_l00`3oo`06o`030?oo02go000^o`030?oo00ko
00<0ool02Ol00`3oo`1Ao`030?oo01co00<0ool09_l00`3oo`06o`030?oo02go000]o`030?oo00oo
00<0ool01ol205Co00<0ool06_l202Wo00<0ool01ol00`3oo`0/o`00;?l00`3oo`0@o`030?oo00Ko
00<0ool0EOl00`3oo`0Ho`030?oo02[o00<0ool01ol00`3oo`0[o`00:ol00`3oo`0Ao`030?oo00Go
00<0ool0E_l00`3oo`0Fo`80;Ol00`3oo`08o`030?oo02[o000[o`030?oo017o00<0ool00ol205Wo
00<0ool05Ol00`3oo`0]o`030?oo00So00<0ool0:_l002[o00<0ool04_l00`3oo`02o`030?oo05[o
00<0ool04ol00`3oo`0_o`030?oo00So00<0ool0:Ol002Wo00<0ool04ol00`3oo`0205go00<0ool0
4Ol203;o00<0ool02Ol00`3oo`0Xo`00:?l00`3oo`0Do`030?l005oo00<0ool04?l00`3oo`0bo`03
0?oo00[o00<0ool09ol002So00<0ool05?l2067o00<0ool03Ol203Ko00<0ool02Ol00`3oo`0Wo`00
9ol00`3oo`0Do`80H_l00`3oo`0<o`030?oo03Ko00<0ool02_l00`3oo`0Vo`009_l00`3oo`0Co`80
00?o0?l0HOl00`3oo`0:o`80>Ol00`3oo`0;o`030?oo02Go000Uo`030?oo01?o00D0oooo001So`03
0?oo00So00<0ool0>_l00`3oo`0;o`030?oo02Co000To`030?oo01?o00<0ool00_l00`3oo`1Qo`03
0?oo00Ko0P0mo`030?oo00co00<0ool08ol002Co00<0ool04Ol200Go00<0ool0HOl00`3oo`05o`03
0?oo03go00<0ool03?l00`3oo`0So`008ol00`3oo`0Ao`030?oo00Go00<0ool0H_l00`3oo`03o`03
0?oo03oo00<0ool03?l00`3oo`0Ro`008_l00`3oo`0@o`802?l00`3oo`1Ro`040?ooo`80@_l00`3o
o`0=o`030?oo027o000Qo`030?oo013o00<0ool02?l00`3oo`1Ro`040?oo04Co00<0ool03_l00`3o
o`0Po`008Ol00`3oo`0>o`802ol00`3oo`1So`80A_l00`3oo`0=o`030?oo023o000Po`030?oo00ko
00<0ool02ol00`3oo`1Ro`80Aol00`3oo`0>o`030?oo01oo000Oo`030?oo00go0P0>o`030?oo063o
0P000ol0o`16o`030?oo00oo00<0ool07_l001ko00<0ool03Ol00`3oo`0>o`030?oo05oo00<0ool0
0_l00`3oo`15o`030?oo00oo00<0ool07Ol001ko00<0ool03?l00`3oo`0?o`030?oo05go0P05o`03
0?oo04Go00<0ool03ol00`3oo`0Mo`007Ol00`3oo`0;o`804_l00`3oo`1Lo`030?oo00Go00<0ool0
AOl00`3oo`0@o`030?oo01co000Lo`030?oo00_o00<0ool04_l00`3oo`1Ko`030?oo00Oo00<0ool0
AOl00`3oo`0@o`030?oo01_o000Ko`030?oo00[o0P0Eo`030?oo05Wo0P0:o`030?oo04Go00<0ool0
4Ol00`3oo`0Jo`006ol00`3oo`09o`030?oo01Go00<0ool0F?l00`3oo`0:o`030?oo04Go00<0ool0
4Ol00`3oo`0Jo`006_l00`3oo`08o`806?l00`3oo`1Fo`803_l00`3oo`15o`030?oo017o00<0ool0
6Ol000Co0`0Bo`030?oo00So00<0ool06?l00`3oo`1Eo`030?oo00ko00<0ool0AOl00`3oo`0Bo`04
0?oo01Oo0005o`030?oo013o00<0ool01ol201_o00<0ool0Dol2017o00<0ool0AOl00`3oo`0Co`80
00?o0?l05Ol000?o100Ao`030?oo00Ko00<0ool06ol00`3oo`1Bo`030?oo01;o00<0ool0AOl00`3o
o`0Bo`8000?o0?l05Ol000?o00<0o`004Ol00`3oo`06o`030?oo01co00<0ool0DOl00`3oo`0Co`03
0?oo04Go00<0ool04ol201Oo0004o`804?l00`3oo`05o`807ol00`3oo`1?o`805_l00`3oo`15o`03
0?oo01?o0`0Fo`001Ol00`3oo`0=o`030?oo00Go00<0ool07ol00`3oo`1>o`030?oo01Oo00<0ool0
AOl00`3oo`0Co`805_l001Go00<0ool00ol202;o00<0ool0C?l201[o00<0ool0AOl00`3oo`0Do`03
0?oo01Co000Do`030?oo00?o00<0ool08_l00`3oo`1;o`030?oo01[o00<0ool0A_l00`3oo`0Do`03
0?oo01?o000Co`030?oo00;o0P0Uo`030?oo04Wo0P0No`030?oo04Go00<0ool05Ol00`3oo`0Bo`00
4_l00`3oo`02o`030?oo02Go00<0ool0B?l00`3oo`0No`030?oo04Go00<0ool05_l00`3oo`0Ao`00
4_l00`3oo`0202So00<0ool0A_l2027o00<0ool0A_l00`3oo`0Eo`030?oo017o000Ao`040?oo02[o
00<0ool0AOl00`3oo`0Ro`030?oo04Go00<0ool05_l00`3oo`0@o`004?l0103oo`0[o`030?oo04Co
00<0ool08ol00`3oo`15o`030?oo01Oo00<0ool03ol000co10000ol0000/o`030?oo04;o0P0Vo`03
0?oo04Ko00<0ool05ol400go000;o`H0;_l00`3oo`11o`030?oo02Oo00<0ool0AOl00`3oo`0Go`D0
3?l000[o1`0^o`030?oo03oo0P0Zo`030?oo04Go00<0ool05_l700_o000:o`L0;_l00`3oo`0no`03
0?oo02_o00<0ool0AOl00`3oo`0Eo`L02ol000[o1`0^o`030?oo03co0P0^o`030?oo04Go00<0ool0
5?l800_o000;o`H0;_l00`3oo`0ko`030?oo02ko00<0ool0AOl00`3oo`0@o`@00_l500co000<o`<0
0_l202co00<0ool0>_l00`3oo`0`o`030?oo04Go00<0ool03?l300Oo0`0=o`003Ol200Co00<0ool0
:Ol00`3oo`0ho`80<ol00`3oo`15o`030?oo00Wo0`0;o`030?oo00co000=o`030?l000Co00<0ool0
:?l00`3oo`0go`030?oo03?o00<0ool0AOl00`3oo`06o`<03_l00`3oo`0<o`003Ol00`3o0005o`80
:?l00`3oo`0eo`80=ol00`3oo`15o`040?ooo`@04Ol00`3oo`0<o`003Ol00`3o0007o`030?oo02Go
00<0ool0=?l00`3oo`0go`030?oo04Go100Eo`030?oo00co000=o`040?oo00Oo0P0Uo`030?oo03;o
0P0jo`030?oo04?o0`0Ho`030?oo00co000=o`040?oo00Wo00<0ool08_l00`3oo`0ao`030?oo03_o
00<0ool0?ol300?o00<0ool05Ol00`3oo`0<o`003Ol0103oo`0:o`808_l00`3oo`0_o`80?_l00`3o
o`0ko`@01_l00`3oo`0Eo`030?oo00co000=o`050?ooo`002ol00`3oo`0Oo`030?oo02ko00<0ool0
?_l00`3oo`0ho`<02_l00`3oo`0Eo`030?oo00co000=o`050?ooo`003?l00`3oo`0No`030?oo02go
00<0ool0@?l00`3oo`0do`<03_l00`3oo`0Do`030?oo00co000=o`050?ooo`003Ol201ko00<0ool0
:ol204?o00<0ool0<Ol3017o00<0ool05?l00`3oo`0<o`003Ol00`3oo`02o`030?oo00co00<0ool0
6ol00`3oo`0Zo`030?oo04?o00<0ool0;Ol401Co00<0ool05?l00`3oo`0<o`003Ol00`3oo`02o`03
0?oo00go0P0Ko`030?oo02So0P17o`030?oo02Wo0`0Io`030?oo01?o00<0ool03?l000go00<0ool0
0_l00`3oo`0?o`030?oo01So00<0ool09ol00`3oo`17o`030?oo02Ko0`0Lo`030?oo01?o00<0ool0
3?l000go00<0ool00ol00`3oo`0?o`806?l00`3oo`0Uo`80B_l00`3oo`0So`<07ol00`3oo`0Co`03
0?oo00co000=o`030?oo00?o00<0ool04Ol00`3oo`0Eo`030?oo02Co00<0ool0Bol00`3oo`0No`@0
8ol00`3oo`0Bo`030?oo00co000=o`030?oo00Co00<0ool04Ol201Go00<0ool08ol00`3oo`1<o`03
0?oo01_o0`0Wo`030?oo01;o00<0ool03?l000go00<0ool01?l00`3oo`0Co`030?oo01;o00<0ool0
8Ol204oo00<0ool06?l302[o00<0ool04_l00`3oo`0<o`003Ol00`3oo`04o`030?oo01Co00<0ool0
4Ol00`3oo`0Po`030?oo053o00<0ool05?l302ko00<0ool04Ol00`3oo`0<o`003Ol00`3oo`05o`03
0?oo01Co0P0Ao`030?oo01ko0P1Co`030?oo013o100ao`030?oo017o00<0ool03?l000go00<0ool0
1Ol00`3oo`0Fo`030?oo00ko00<0ool07Ol00`3oo`1Co`030?oo00go0`0eo`030?oo017o00<0ool0
3?l000go00<0ool01Ol00`3oo`0Go`803_l00`3oo`0Ko`80Eol00`3oo`09o`<0>Ol00`3oo`0@o`03
0?oo00co000=o`030?oo00Ko00<0ool06?l00`3oo`0;o`030?oo01[o00<0ool0Eol00`3oo`06o`<0
??l00`3oo`0@o`030?oo00co000=o`030?oo00Ko00<0ool06Ol200_o00<0ool06?l205[o00<0ool0
0_l4043o00<0ool03ol00`3oo`0<o`003Ol00`3oo`06o`030?oo01_o00<0ool02?l00`3oo`0Go`03
0?oo05_o1014o`030?oo00oo00<0ool03?l000go00<0ool01ol00`3oo`0Ko`030?oo00Oo00<0ool0
5_l00`3oo`1Jo`<0Aol00`3oo`0?o`030?oo00co000=o`030?oo00Oo00<0ool07?l200Oo00<0ool0
5?l205[o0`02o`030?oo04Ko00<0ool03_l00`3oo`0<o`003Ol00`3oo`07o`030?oo01ko00<0ool0
1?l00`3oo`0Co`030?oo05Ko1006o`030?oo04Go00<0ool03_l00`3oo`0<o`003Ol00`3oo`08o`03
0?oo01ko0P04o`030?oo017o0P1Fo`<02_l00`3oo`15o`030?oo00ko00<0ool03?l000go00<0ool0
2?l00`3oo`0Po`050?ooo`004_l00`3oo`1Co`<03Ol00`3oo`16o`030?oo00go00<0ool03?l000go
00<0ool02?l00`3oo`0Qo`8000?o0?l03ol205?o0`0Ao`030?oo04Go00<0ool03Ol00`3oo`0<o`00
3Ol00`3oo`09o`030?oo02;o0P0?o`030?oo04oo100Do`030?oo04Go00<0ool03Ol00`3oo`0<o`00
3Ol00`3oo`09o`030?oo02?o0P0=o`030?oo04go0`0Ho`030?oo04Ko00<0ool03?l00`3oo`0<o`00
3Ol00`3oo`09o`030?oo02?o00<0o`002_l204go0`0Lo`030?oo04Go00<0ool03?l00`3oo`0<o`00
3Ol00`3oo`0:o`030?oo02;o00@0ool02?l00`3oo`1:o`<07ol00`3oo`15o`030?oo00co00<0ool0
3?l000go00<0ool02_l00`3oo`0Ro`040?ooo`801?l204Wo100Ro`030?oo04Ko00<0ool02ol00`3o
o`0<o`003Ol00`3oo`0:o`030?oo02;o00<0ool00ol0103oo`18o`<09ol00`3oo`15o`030?oo00_o
00<0ool03?l000go00<0ool02ol00`3oo`0Qo`030?oo00Co0P16o`<0:_l00`3oo`15o`030?oo00_o
00<0ool03?l000go00<0ool02ol00`3oo`0Qo`030?oo00?o00@0ool0@_l302go00<0ool0A_l00`3o
o`0:o`030?oo00co000=o`030?oo00_o00<0ool08Ol0103oool200Co0P0lo`@0<Ol00`3oo`15o`03
0?oo00[o00<0ool03?l000go00<0ool03?l00`3oo`0Po`040?oo00So00<0ool0=_l303Go00<0ool0
AOl00`3oo`0:o`030?oo00co000=o`030?oo00co00<0ool08?l00`3o000:o`80<ol303So00<0ool0
A_l00`3oo`09o`030?oo00co000=o`030?oo00co00<0ool08?l200go00<0ool0;Ol303co00<0ool0
AOl00`3oo`09o`030?oo00co000=o`030?oo00go00<0ool07_l200oo00<0ool0:?l403oo00<0ool0
AOl00`3oo`09o`030?oo00co000=o`030?oo00go00<0ool07?l20003o`3o00oo0P0Uo`<0@ol00`3o
o`16o`030?oo00So00<0ool03?l000go00<0ool03Ol00`3oo`0Ko`050?ooo`004_l00`3oo`0Oo`<0
Aol00`3oo`15o`030?oo00So00<0ool03?l000go00<0ool03_l00`3oo`0Ho`801?l00`3oo`0Ao`80
7?l304[o00<0ool0AOl00`3oo`08o`030?oo00co000=o`030?oo00ko00<0ool05ol00`3oo`04o`03
0?oo01?o00<0ool05Ol404go00<0ool0A_l00`3oo`07o`030?oo00co000=o`030?oo00ko00<0ool0
5Ol200Oo00<0ool05?l201;o0`1Bo`030?oo04Go00<0ool01ol00`3oo`0<o`003Ol00`3oo`0?o`03
0?oo01?o00<0ool01ol00`3oo`0Fo`030?oo00co0`1Eo`030?oo04Go00<0ool01ol00`3oo`0<o`00
3Ol00`3oo`0?o`030?oo01;o00<0ool02?l00`3oo`0Go`030?oo00So0`1Ho`030?oo04Ko00<0ool0
1_l00`3oo`0<o`003Ol00`3oo`0?o`030?oo013o0P0;o`030?oo01So0P04o`@0G?l00`3oo`15o`03
0?oo00Ko00<0ool03?l000go00<0ool04?l00`3oo`0>o`030?oo00_o00<0ool06_l4063o00<0ool0
AOl00`3oo`06o`030?oo00co000=o`030?oo013o00<0ool03?l200ko00<0ool06?l5067o00<0ool0
A_l00`3oo`05o`030?oo00co000=o`030?oo017o00<0ool02_l00`3oo`0>o`030?oo01Go0`05o`03
0?oo05oo00<0ool0AOl00`3oo`05o`030?oo00co000=o`030?oo017o00<0ool02?l2017o00<0ool0
4Ol400Wo0P1Oo`030?oo04Go00<0ool01Ol00`3oo`0<o`003Ol00`3oo`0Ao`030?oo00Oo00<0ool0
4Ol00`3oo`0>o`<03ol00`3oo`1Mo`030?oo04Go00<0ool01?l00`3oo`0<o`003Ol00`3oo`0Bo`03
0?oo00Go00<0ool04_l00`3oo`0;o`<04ol205go00<0ool0AOl00`3oo`04o`030?oo00co000=o`03
0?oo01;o00<0ool00ol201Go00<0ool02?l301So00<0ool0F_l00`3oo`15o`030?oo00Co00<0ool0
3?l000go00<0ool04_l00`3oo`02o`030?oo01Go00<0ool01?l401co00<0ool0F_l00`3oo`15o`03
0?oo00?o00<0ool03?l000go00<0ool04ol0103o000Ho`040?ooo`<08Ol205[o00<0ool0AOl00`3o
o`03o`030?oo00co0003o`802?l00`3oo`0Co`806_l402Ko00<0ool0Eol00`3oo`11o`800ol00`3o
o`02o`030?oo00co0005o`030?oo00Go00<0ool04_l201Wo0`0Zo`80F?l00`3oo`12o`040?oo00Co
00<0ool03?l000Co00<0ool01_l00`3oo`0Ao`040?oo01Co1002o`030?oo02[o00<0ool0EOl00`3o
o`11o`800_l00`3oo`02o`030?oo00co0005o`030?oo00Go00<0ool03ol200?o00<0ool03ol300Ko
00<0ool0:ol205Go00<0ool0@?l00`3o0003o`050?ooo`003_l000?o00<0o`001ol00`3oo`0>o`03
0?oo00?o00<0ool03?l300Wo00<0ool0;Ol00`3oo`1Co`030?oo03oo00<0o`000ol01@3oool000ko
0004o`030?oo00Ko00<0ool03Ol00`3oo`05o`030?oo00So0`0<o`030?oo02ko00<0ool0D_l00`3o
o`10o`800ol01@3oool000ko000=o`030?oo00_o0P08o`030?oo00Co100?o`030?oo02oo0P1Bo`03
0?oo04Ko00@0ool03_l000go00<0ool02_l00`3oo`08o`040?ooo`<04ol00`3oo`0ao`030?oo053o
00<0ool0AOl0103oo`0>o`003Ol00`3oo`08o`803?l301Ko00<0ool0<_l2053o00<0ool0AOl0103o
o`0>o`003Ol00`3oo`07o`030?oo00Wo100Ho`030?oo03Co00<0ool0COl00`3oo`16o`030?l000ko
000=o`030?oo00Go0P08o`@00ol00`3oo`0Fo`030?oo03Go0P1>o`030?oo04Go00<0o`003_l000go
00<0ool01?l00`3oo`05o`<02?l00`3oo`0Eo`030?oo03Oo00<0ool0Bol00`3oo`15o`030?l000ko
000=o`030?oo00?o00<0ool00ol300_o00<0ool05Ol00`3oo`0ho`80Bol00`3oo`16o`803_l000co
0`02o`800ol300ko00<0ool05Ol00`3oo`0jo`030?oo04Wo00<0ool0AOl300go000;o`H000?o0000
0P0Bo`030?oo01Co00<0ool0>ol00`3oo`18o`030?oo04Co1@0<o`002_l801Ko00<0ool05?l00`3o
o`0lo`80B?l00`3oo`13o`L02ol000[oo`0<00_o000:o`L06?l00`3oo`0Co`030?oo03oo0P16o`03
0?oo04;o1`0;o`002ol501Wo00<0ool04ol00`3oo`11o`030?oo04?o00<0ool0@_l600co000<o`@0
6Ol00`3oo`0Co`030?oo04;o0P14o`030?oo03oo0P000ol0000200go000@o`030?oo01Oo00<0ool0
4_l00`3oo`14o`030?oo047o00<0ool0?_l0103oo`0Ao`004Ol00`3oo`0Fo`030?oo01;o00<0ool0
AOl00`3oo`10o`030?oo03go00@0ool04_l001;o00<0ool05Ol00`3oo`0Bo`030?oo04Ko0P11o`03
0?oo03[o0P02o`030?oo017o000Bo`030?oo01Ko00<0ool04Ol00`3oo`18o`030?oo03ko00<0ool0
>Ol00`3oo`02o`030?oo017o000Co`030?oo01Go00<0ool04Ol00`3oo`19o`80?_l00`3oo`0go`80
1?l00`3oo`0Bo`005?l00`3oo`0Do`030?oo017o00<0ool0Bol00`3oo`0lo`030?oo03Go00<0ool0
0ol00`3oo`0Co`005Ol00`3oo`0Do`030?oo013o00<0ool0C?l203co00<0ool0<ol200Go00<0ool0
5?l001Go00<0ool05?l00`3oo`0@o`030?oo04ko00<0ool0>Ol00`3oo`0bo`030?oo00Go00<0ool0
5?l001Ko00<0ool05?l00`3oo`0?o`030?oo04oo0P0jo`030?oo02oo0P07o`030?oo01Go000Go`03
0?oo01?o00<0ool03ol00`3oo`1Ao`030?oo03Oo00<0ool0;_l00`3oo`06o`030?oo01Ko000Ho`03
0?oo01;o00<0ool03ol00`3oo`1Bo`030?oo03Ko00<0ool0;Ol00`3oo`06o`030?oo01Oo000Ho`03
0?oo01?o00<0ool03_l00`3oo`1Co`80=ol00`3oo`0Zo`802Ol00`3oo`0Go`006Ol00`3oo`0Bo`03
0?oo00ko00<0ool0EOl00`3oo`0do`030?oo02Wo00<0ool02?l00`3oo`0Ho`006_l00`3oo`0Ao`03
0?oo00ko00<0ool0E_l203Co00<0ool09ol200[o00<0ool06Ol001_o00<0ool04Ol00`3oo`0=o`03
0?oo05So00<0ool0<_l00`3oo`0Uo`030?oo00Wo00<0ool06_l001_o00<0ool04Ol00`3oo`0=o`03
0?oo05Wo0P0bo`030?oo02?o0P0<o`030?oo01[o000Lo`030?oo013o00<0ool03Ol00`3oo`1Ko`03
0?oo02oo00<0ool08_l00`3oo`0;o`030?oo01_o000Mo`030?oo013o00<0ool03?l00`3oo`1Lo`03
0?oo02oo00<0ool07ol200go00<0ool07?l001ko00<0ool03ol00`3oo`0<o`030?oo05go0P0_o`03
0?oo01ko00<0ool03?l00`3oo`0Mo`007_l00`3oo`0?o`030?oo00co00<0ool0Gol00`3oo`0/o`03
0?oo01go00<0ool03Ol00`3oo`0Mo`007ol00`3oo`0?o`030?oo00_o00<0ool0H?l202go00<0ool0
6_l200oo00<0ool07_l0023o00<0ool03_l00`3oo`0;o`030?oo06;o00<0ool0:_l00`3oo`0Io`03
0?oo00ko00<0ool07ol0027o00<0ool03Ol00`3oo`0;o`030?oo06?o0P0Zo`030?oo01Oo0P0@o`03
0?oo023o000Qo`030?oo00ko00<0ool02_l00`3oo`1Uo`030?oo02So00<0ool05Ol00`3oo`0@o`03
0?oo023o000Ro`030?oo00go00<0ool02_l00`3oo`1Vo`80:?l00`3oo`0Co`804_l00`3oo`0Qo`00
8ol00`3oo`0<o`030?oo00[o00<0ool0J?l00`3oo`0Uo`030?oo01;o00<0ool04Ol00`3oo`0Ro`00
9?l00`3oo`0<o`030?oo00Wo00<0ool0JOl00`3oo`0Uo`030?oo00oo0P0Co`030?oo02?o000To`03
0?oo00co00<0ool02Ol00`3oo`1Zo`809Ol00`3oo`0>o`030?oo01?o00<0ool08ol002Go00<0ool0
2ol00`3oo`09o`030?oo06co00<0ool08_l00`3oo`0=o`030?oo01?o00<0ool09?l002Ko00<0ool0
2ol00`3oo`08o`030?oo06go0P0So`030?oo00[o0P0Eo`030?oo02Go000Wo`030?oo00[o00<0ool0
2?l00`3oo`1_o`030?oo023o00<0ool02Ol00`3oo`0Do`030?oo02Ko000Xo`030?oo00Wo00<0ool0
2?l00`3oo`1`o`808?l00`3oo`07o`805_l00`3oo`0Wo`00:?l00`3oo`0:o`030?oo00Oo00<0ool0
L_l00`3oo`0No`030?oo00Go00<0ool05_l00`3oo`0Wo`00:Ol00`3oo`09o`030?oo00Oo00<0ool0
Lol201ko00<0ool00ol201So00<0ool0:?l002[o00<0ool02?l00`3oo`07o`030?oo07Go00<0ool0
7?l01@3oool001Wo00<0ool0:Ol002_o00<0ool02?l00`3oo`06o`030?oo07Ko00<0ool06ol0103o
000Io`030?oo02[o000[o`030?oo00So00<0ool01_l00`3oo`1go`806ol201_o00<0ool0:_l002co
00<0ool01ol00`3oo`06o`030?oo07Wo00<0ool06?l201[o00<0ool0:ol002go00<0ool01ol00`3o
o`05o`030?oo07[o0P0Fo`8000?o0?l06?l00`3oo`0/o`00;_l00`3oo`06o`030?oo00Go00<0ool0
O?l00`3oo`0Bo`050?ooo`006?l00`3oo`0]o`00;_l00`3oo`06o`030?oo00Go00<0ool0OOl2013o
0P05o`030?oo01Go00<0ool0;Ol002oo00<0ool01_l00`3oo`04o`030?oo07oo00<0ool03?l00`3o
o`05o`030?oo01Co00<0ool0;_l0033o00<0ool01Ol00`3oo`04o`030?oo083o00<0ool02Ol200So
00<0ool04ol00`3oo`0_o`00<Ol00`3oo`04o`030?oo00Co00<0ool0POl200So00<0ool02Ol00`3o
o`0Ao`030?oo033o000ao`030?oo00Go00<0ool00ol00`3oo`23o`030?oo00?o0P0<o`030?oo017o
00<0ool0<?l003;o00<0ool01?l00`3oo`03o`030?oo08Co0P02o`030?oo00co00<0ool04?l00`3o
o`0ao`00<ol00`3o000200;o00<0ool00_l00`3oo`26o`802?l500;o0P0@o`030?oo03;o000do`80
1?l00`3oo`02o`030?oo08Go1009o`070?ooo`3o000?o`030?oo03?o000do`030?l000?o00<0ool0
0_l00`3oo`24o`030?oo00;o00<0ool01_l01`3oool0o`003ol00`3oo`0co`00=Ol200Co00D0oooo
0024o`801_l200Ko00H0oooo0?l200go00<0ool0=?l003Go0`03o`050?ooo`00Pol00`3oo`08o`03
0?oo00?o00H0oooo0?l200co00<0ool0=Ol003Ko0P03o`050?ooo`00POl200co00@0oooo0P04o`03
0?l000_o00<0ool0=_l003Oo00<0ool00_l0103oo`20o`030?oo00go0P0:o`030?oo00So00<0ool0
=_l003So00D0oooo0002o`030?oo07co0P0Bo`030?oo00Oo00<0ool01ol00`3oo`0go`00>Ol0103o
o`02o`030?oo07_o00<0ool04ol200Oo00<0ool01_l00`3oo`0ho`00>_l01P3oo`3o07co00<0ool0
5_l00`3oo`05o`030?oo00Co00<0ool0>Ol003[o00H0ool0o`1jo`806_l200Go00<0ool01?l00`3o
o`0io`00>ol01@3o0?l007Wo00<0ool07?l00`3oo`02o`030?oo00?o00<0ool0>_l003co00@0o`00
Mol2023o00<0ool00_l01@3oool003go000mo`@0MOl00`3oo`0Qo`800_l403ko000mo`D0L_l202Ko
1P0no`00??l7073o00<0ool09_l703go000lo`L0K_l202Wo1`0mo`00??l806co00<0ool0:?l803go
000mo`D00_l406Oo00<0ool09Ol400;o1@0no`00?_l300Oo0`1Ro`809Ol300Oo0`0oo`00Bol305ko
00<0ool08_l304co001>o`@0F?l2027o101?o`00D_l305Co00<0ool07_l305?o001Eo`<0Col201ko
0`1Fo`00F?l404[o00<0ool06_l405Wo001Lo`<09Ol501_o0P0Jo`<0GOl005oo0`0To`030?oo01[o
00<0ool05ol3063o001Ro`@08?l00`3oo`0Io`030?oo01Co101So`00I_l301go00<0ool05ol201Co
0`1Wo`00JOl301[o00<0ool05_l00`3oo`0Ao`<0J_l006co100Eo`805_l2013o101]o`00L?l302Wo
00<0ool03Ol3077o001co`<09?l200go0`1do`00M_l401oo00<0ool02Ol407Oo001jo`<06_l200Wo
0`1ko`00OOl301Ko00<0ool01_l307ko0020o`@04Ol00`3oo`03o`@0POl008Co0`0<o`800ol308Go
0027o`<01?l30004o`3oo`<0R?l008[o2`2;o`00S?l708go002<o`L0SOl008co1`2=o`00SOl508ko
002>o`<0Sol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo
8Ol00001\
\>"],
  ImageRangeCache->{{{83, 312.375}, {702.438, 473.063}} -> {-0.405865, 
  2.21865, 0.00366585, 0.00383655}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(getgraph[mtx_] := 
      Block[{g, len}, \n\t\t\ \ \ \ len = Length[mtx]; \n\t\t\t\t
        g = ChangeVertices[EmptyGraph[len], circluarvertices[len]]; \n\t\t\t\t
        Return[ChangeEdges[g, mtx]]\n\t]\n\), 
    \(PlanarQ[getgraph[mm]]\)}], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[TextData[
"\:3053\:306e\:30b0\:30e9\:30d5\:306f\:5e73\:9762\:7684\:3067\:3042\:308b\
\:3053\:3068\:304c\:89e3\:3063\:305f\:306e\:3067\:3001\:5b9f\:969b\:306b\:5e73\
\:9762\:30b0\:30e9\:30d5\:3068\:3057\:3066\:63cf\:753b\:3057\:3088\:3046\:3002\
"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(drawgraph[mm, {1, 2, 5, 4, 10}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.477937 0.452012 0.502533 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.04545 .6073 Mdot
.21908 .04545 Mdot
.78092 .04545 Mdot
.95455 .6073 Mdot
.55288 .45116 Mdot
.79773 .37986 Mdot
.65773 .48681 Mdot
.62273 .51354 Mdot
.65758 .60267 Mdot
.5 Mabswid
.5 .95455 m
.04545 .6073 L
s
.5 .95455 m
.95455 .6073 L
s
.5 .95455 m
.65758 .60267 L
s
.04545 .6073 m
.5 .95455 L
s
.04545 .6073 m
.21908 .04545 L
s
.04545 .6073 m
.78092 .04545 L
s
.04545 .6073 m
.55288 .45116 L
s
.21908 .04545 m
.04545 .6073 L
s
.21908 .04545 m
.78092 .04545 L
s
.78092 .04545 m
.04545 .6073 L
s
.78092 .04545 m
.21908 .04545 L
s
.78092 .04545 m
.95455 .6073 L
s
.78092 .04545 m
.55288 .45116 L
s
.78092 .04545 m
.79773 .37986 L
s
.95455 .6073 m
.5 .95455 L
s
.95455 .6073 m
.78092 .04545 L
s
.95455 .6073 m
.79773 .37986 L
s
.95455 .6073 m
.65758 .60267 L
s
.55288 .45116 m
.04545 .6073 L
s
.55288 .45116 m
.78092 .04545 L
s
.55288 .45116 m
.65773 .48681 L
s
.55288 .45116 m
.62273 .51354 L
s
.55288 .45116 m
.65758 .60267 L
s
.79773 .37986 m
.78092 .04545 L
s
.79773 .37986 m
.95455 .6073 L
s
.79773 .37986 m
.65773 .48681 L
s
.65773 .48681 m
.55288 .45116 L
s
.65773 .48681 m
.79773 .37986 L
s
.65773 .48681 m
.62273 .51354 L
s
.65773 .48681 m
.65758 .60267 L
s
.62273 .51354 m
.55288 .45116 L
s
.62273 .51354 m
.65773 .48681 L
s
.62273 .51354 m
.65758 .60267 L
s
.65758 .60267 m
.5 .95455 L
s
.65758 .60267 m
.95455 .6073 L
s
.65758 .60267 m
.55288 .45116 L
s
.65758 .60267 m
.65773 .48681 L
s
.65758 .60267 m
.62273 .51354 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV0<aV
0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0<fH0
<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI<lbI
<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0IP0c
IS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<IVK<
IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITcVL`c
VOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<V@3o
VC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=Vc6IV
c9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Woc<co
c?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>IofJI
oiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H61PL7
1`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D50000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo
8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol003go0`2No`<0?ol003co
1@2Lo`D0?_l003coYP0no`00??l509co1@0no`00?Ol309go1@0no`00?Ol00`3oo`2Lo`040?l0o`80
?_l003go00<0ool0Vol01@3oo`3o0080?_l003co00<0ool0V_l200;o00H0ool0o`0mo`00??l00`3o
o`2Io`030?oo00;o00H0ool0o`0mo`00??l00`3oo`2Ho`030?oo00;o00L0oooo0?l003go000lo`03
0?oo09Ko0P04o`030?oo00;o00<0o`00?Ol003_o00<0ool0U_l00`3oo`04o`030?oo00;o00@0ool0
??l003_o00<0ool0UOl00`3oo`04o`030?oo00?o00@0ool0??l003_o00<0ool0Tol200Oo00<0ool0
0ol0103oo`0lo`00>_l00`3oo`2Co`030?oo00Ko00<0ool01?l01@3oool003_o000jo`030?oo09;o
00<0ool01ol00`3oo`05o`040?oo03_o000jo`030?oo093o0P09o`030?oo00Ko00@0ool0>ol003Wo
00<0ool0T?l00`3oo`08o`030?oo00Oo00D0oooo000jo`00>Ol00`3oo`2?o`030?oo00Wo00<0ool0
1ol01@3oool003[o000io`030?oo08ko00<0ool02Ol00`3oo`08o`050?ooo`00>_l003Wo00<0ool0
S?l200co00<0ool02?l01@3oool003[o000ho`030?oo08co00<0ool02ol00`3oo`09o`030?oo00;o
00<0ool0=ol003So00<0ool0Rol00`3oo`0<o`030?oo00Wo00<0ool00_l00`3oo`0go`00>?l00`3o
o`29o`803_l00`3oo`0:o`030?oo00;o00<0ool0=ol003Oo00<0ool0ROl00`3oo`0=o`030?oo00_o
00<0ool00ol00`3oo`0fo`00=ol00`3oo`28o`030?oo00ko00<0ool02ol00`3oo`03o`030?oo03Ko
000go`030?oo08Ko0P0@o`030?oo00co00<0ool00ol00`3oo`0fo`00=_l00`3oo`26o`030?oo013o
00<0ool03?l00`3oo`04o`030?oo03Go000fo`030?oo08Go00<0ool04?l00`3oo`0=o`030?oo00Co
00<0ool0=Ol003Ko00<0ool0Pol201?o00<0ool03Ol00`3oo`04o`030?oo03Go000eo`030?oo08?o
00<0ool04_l00`3oo`0>o`030?oo00Go00<0ool0=?l003Go00<0ool0P_l00`3oo`0Bo`030?oo00oo
00<0ool01Ol00`3oo`0do`00=Ol00`3oo`21o`030?oo01?o00<0ool03ol00`3oo`05o`030?oo03Co
000eo`030?oo07oo0P0Eo`030?oo013o00<0ool01Ol00`3oo`0do`00=?l00`3oo`1oo`030?oo01Go
00<0ool04?l00`3oo`06o`030?oo03?o000do`030?oo07ko00<0ool05Ol00`3oo`0Ao`030?oo00Ko
00<0ool0<ol003Co00<0ool0O?l201So00<0ool04Ol00`3oo`06o`030?oo03?o000co`030?oo07co
00<0ool05ol00`3oo`0Bo`030?oo00Oo00<0ool0<_l003?o00<0ool0Nol00`3oo`0Ho`030?oo01;o
00<0ool01ol00`3oo`0bo`00<ol00`3oo`1io`806_l00`3oo`0Do`030?oo00Ko00<0ool0<_l003;o
00<0ool0NOl00`3oo`0Io`030?oo01Go00<0ool01ol00`3oo`0ao`00<_l00`3oo`1ho`030?oo01[o
00<0ool05Ol00`3oo`07o`030?oo037o000bo`030?oo07Ko0P0Lo`030?oo01Ko00<0ool01ol00`3o
o`0ao`00<_l00`3oo`1eo`030?oo01co00<0ool05_l00`3oo`07o`030?oo037o000ao`030?oo07Go
00<0ool07?l00`3oo`0Go`030?oo00So00<0ool0<?l0037o00<0ool0Lol201oo00<0ool05ol00`3o
o`08o`030?oo033o000ao`030?oo07;o00<0ool07_l00`3oo`0Ho`030?oo00So00<0ool0<?l0033o
00<0ool0L_l00`3oo`0No`030?oo01Wo00<0ool02Ol00`3oo`0_o`00<?l00`3oo`1ao`030?oo01oo
00<0ool06Ol00`3oo`09o`030?oo02oo000`o`030?oo06oo0P0Qo`030?oo01[o00<0ool02Ol00`3o
o`0_o`00;ol00`3oo`1_o`030?oo027o00<0ool06_l00`3oo`0:o`030?oo02ko000_o`030?oo06ko
00<0ool08Ol00`3oo`0Ko`030?oo00[o00<0ool0;_l002oo00<0ool0K?l202Co00<0ool06ol00`3o
o`0:o`030?oo02ko000^o`030?oo06co00<0ool08ol00`3oo`0Lo`030?oo00_o00<0ool0;Ol002ko
00<0ool0Jol00`3oo`0So`030?oo01go00<0ool02ol00`3oo`0]o`00;_l00`3oo`1Yo`809_l00`3o
o`0Mo`030?oo00_o00<0ool0;Ol002ko00<0ool0J?l00`3oo`0Uo`030?oo01ko00<0ool02ol00`3o
o`0]o`00;Ol00`3oo`1Xo`030?oo02Ko00<0ool07_l00`3oo`0<o`030?oo02co000]o`030?oo06Ko
0P0Xo`030?oo01oo00<0ool03?l00`3oo`0/o`00;Ol00`3oo`1Uo`030?oo02So00<0ool07ol00`3o
o`0<o`030?oo02co000/o`030?oo06Go00<0ool0:?l00`3oo`0Po`030?oo00go00<0ool0:ol002co
00<0ool0I?l00`3oo`0Xo`030?oo027o00<0ool03Ol00`3oo`0[o`00;?l00`3oo`1Ro`80:ol00`3o
o`0Qo`030?oo00go00<0ool0:ol002_o00<0ool0H_l00`3oo`0Zo`030?oo02?o00<0ool03Ol00`3o
o`0Zo`00:ol00`3oo`1Qo`030?oo02_o00<0ool08ol00`3oo`0=o`030?oo02[o000[o`030?oo05oo
0P0]o`030?oo02Co00<0ool03Ol00`3oo`0Zo`00:ol00`3oo`1No`030?oo02go00<0ool09?l00`3o
o`0=o`030?oo02[o000Zo`030?oo05ko00<0ool0;Ol00`3oo`0Uo`030?oo00ko00<0ool0:Ol002[o
00<0ool0G?l202oo00<0ool09_l00`3oo`0>o`030?oo02Wo000Zo`030?oo05_o00<0ool0;ol00`3o
o`0Vo`030?oo00ko00<0ool0:Ol002Wo00<0ool0Fol00`3oo`0_o`030?oo02Oo00<0ool03ol00`3o
o`0Xo`00:Ol00`3oo`1Io`80<_l00`3oo`0Wo`030?oo00oo00<0ool0:?l002Wo00<0ool0F?l00`3o
o`0ao`030?oo02So00<0ool03ol00`3oo`0Xo`00:?l00`3oo`1Ho`030?oo03;o00<0ool0:?l00`3o
o`0@o`030?oo02Oo000Xo`030?oo05Ko0P0do`030?oo02Wo00<0ool04?l00`3oo`0Wo`00:?l00`3o
o`1Eo`030?oo03?o00<0ool0:_l00`3oo`0@o`030?oo02Oo000Wo`030?oo05Go00<0ool0=?l00`3o
o`0Zo`030?oo017o00<0ool09_l002Oo00<0ool0E?l00`3oo`0do`030?oo02_o00<0ool04Ol00`3o
o`0Vo`009ol00`3oo`1Bo`80=ol00`3oo`0[o`030?oo017o00<0ool09_l002Oo00<0ool0DOl00`3o
o`0fo`030?oo02co00<0ool04Ol00`3oo`0Vo`009_l00`3oo`1Ao`030?oo03Oo00<0ool0;?l00`3o
o`0Bo`030?oo02Go000Vo`030?oo04oo0P0io`030?oo02go00<0ool04_l00`3oo`0Uo`009_l00`3o
o`1>o`030?oo03So00<0ool0;_l00`3oo`0Bo`030?oo02Go000Uo`030?oo04ko00<0ool0>Ol00`3o
o`0^o`030?oo01?o00<0ool09?l002Go00<0ool0C?l203_o00<0ool0;ol00`3oo`0Co`030?oo02Co
000Uo`030?oo04_o00<0ool0>ol00`3oo`0_o`030?oo01?o00<0ool09?l002Co00<0ool0Bol00`3o
o`0ko`030?oo033o00<0ool05?l00`3oo`0So`009?l00`3oo`19o`80?_l00`3oo`0ao`030?oo01?o
00<0ool08ol002Co00<0ool0B?l00`3oo`0mo`030?oo03;o00<0ool04ol00`3oo`0So`009?l00`3o
o`17o`030?oo03go00<0ool0<ol00`3oo`0Co`030?oo02?o000So`030?oo04Oo00<0ool0?_l00`3o
o`0co`030?oo01Co00<0ool08_l002?o00<0ool0AOl2043o00<0ool0=?l00`3oo`0Do`030?oo02;o
000So`030?oo04Co00<0ool0@?l00`3oo`0do`030?oo01Co00<0ool08_l002;o00<0ool0A?l00`3o
o`10o`030?oo03Go00<0ool05Ol00`3oo`0Qo`008_l00`3oo`12o`80@ol00`3oo`0eo`030?oo01Go
00<0ool08Ol002;o00<0ool0@Ol00`3oo`12o`030?oo03Ko00<0ool05Ol00`3oo`0Qo`008Ol00`3o
o`11o`030?oo04?o00<0ool0=Ol301Oo00<0ool08?l0027o00<0ool0?ol204Go00<0ool0=Ol501Ko
00<0ool08?l0027o00<0ool0?_l00`3oo`14o`030?oo03Ko1@0Fo`030?oo023o000Po`030?oo03ko
00<0ool0AOl00`3oo`0fo`D05ol00`3oo`0Oo`008?l00`3oo`0lo`80Aol00`3oo`0fo`D06?l00`3o
o`0Oo`008?l00`3oo`0ko`030?oo04Oo00<0ool0=Ol00`3oo`03o`030?oo01Go00<0ool07ol0023o
00<0ool0>_l00`3oo`17o`030?oo03Go00<0ool01Ol00`3oo`0Do`030?oo01oo000Oo`030?oo03Wo
0P1:o`030?oo03?o0P08o`030?oo01Go00<0ool07_l001oo00<0ool0>?l00`3oo`19o`030?oo03?o
00<0ool02Ol00`3oo`0Do`030?oo01ko000Oo`030?oo03Oo00<0ool0BOl00`3oo`0co`030?oo00_o
00<0ool04ol00`3oo`0No`007_l00`3oo`0go`030?oo04[o00<0ool0<Ol200oo00<0ool04ol00`3o
o`0Mo`007_l00`3oo`0eo`80C?l00`3oo`0ao`030?oo00oo00<0ool04ol00`3oo`0Mo`007_l00`3o
o`0do`030?oo04co00<0ool0<?l00`3oo`0Ao`030?oo01;o00<0ool07Ol001go00<0ool0=?l00`3o
o`1<o`030?oo02oo0P0Eo`030?oo01;o00<0ool07?l001go00<0ool0<_l204oo00<0ool0;_l00`3o
o`0Eo`030?oo01;o00<0ool07?l001go00<0ool0<Ol00`3oo`1>o`030?oo02ko00<0ool05ol00`3o
o`0Ao`030?oo01co000Mo`030?oo033o00<0ool0C_l00`3oo`0]o`806ol00`3oo`0@o`030?oo01co
000Lo`030?oo02oo0P1Ao`030?oo02co00<0ool06ol00`3oo`0Ao`030?oo01_o000Lo`030?oo02ko
00<0ool0D?l00`3oo`0/o`030?oo01go00<0ool04?l00`3oo`0Ko`007?l00`3oo`0]o`030?oo057o
00<0ool0:_l2027o00<0ool03ol00`3oo`0Ko`006ol00`3oo`0/o`80DOl302co00<0ool08Ol00`3o
o`0@o`030?oo01[o000Ko`030?oo02_o00<0ool0D?l502[o00<0ool08ol00`3oo`0?o`030?oo01[o
000Ko`030?oo02[o00<0ool0DOl502So0P0Wo`030?oo00ko00<0ool06_l001[o00<0ool0:_l00`3o
o`1@o`T09Ol00`3oo`0Xo`030?oo00ko00<0ool06Ol001[o00<0ool0:?l204oo1003o`@00_l3027o
00<0ool0:Ol00`3oo`0>o`030?oo01Wo000Jo`030?oo02Oo00<0ool0C?l300[o0P04o`<07?l202go
00<0ool03Ol00`3oo`0Io`006Ol00`3oo`0Wo`030?oo04[o0`0>o`801_l301So00<0ool0;_l00`3o
o`0=o`030?oo01So000Io`030?oo02Go0P1:o`<04Ol0103o0007o`<05?l00`3oo`0_o`030?oo00go
00<0ool06?l001Wo00<0ool09?l00`3oo`17o`<05Ol0103oo`09o`<03ol203?o00<0ool03?l00`3o
o`0Ho`006Ol00`3oo`0So`030?oo04Co100Io`040?oo00_o0`0;o`030?oo03Co00<0ool02ol00`3o
o`0Ho`006?l00`3oo`0Ro`80A?l301ko00@0ool03Ol300Oo00<0ool0=Ol00`3oo`0<o`030?oo01Oo
000Ho`030?oo027o00<0ool0@Ol3027o00D0oooo000?o`L0>Ol00`3oo`0;o`030?oo01Oo000Ho`03
0?oo023o00<0ool0?ol302Go00D0oooo000@o`D0>_l00`3oo`0:o`030?oo01Oo000Go`030?oo01oo
0P0no`@0:Ol01@3oool000oo1@0jo`030?oo00_o00<0ool05_l001Oo00<0ool07_l00`3oo`0ko`<0
;Ol00`3oo`02o`030?oo00_o1P0ko`030?oo00[o00<0ool05_l001Oo00<0ool07Ol00`3oo`0io`<0
<Ol00`3oo`02o`030?oo00Wo00<0ool00`0mo`030?oo00Wo00<0ool05_l001Ko00<0ool07?l203Wo
0`0eo`030?oo00;o0P08o`030?oo00;o00<0ool0?Ol00`3oo`09o`030?oo01Go000Fo`030?oo01_o
00<0ool0=_l303So00<0ool01?l00`3oo`04o`030?oo00?o00<0ool0?Ol00`3oo`09o`030?oo01Go
000Fo`030?oo01[o00<0ool0<ol403co00<0ool01?l600Ko00<0ool0?_l00`3oo`08o`030?oo01Go
000Fo`030?oo01Wo00<0ool0<Ol3047o00<0ool00ol500Oo00<0ool0?ol00`3oo`07o`030?oo01Go
000Eo`030?oo01So0P0ao`<0AOl00`3oo`02o`D01ol00`3oo`0oo`030?oo00So00<0ool05?l001Go
00<0ool05ol00`3oo`0^o`<0B?l00`3oo`02o`D01ol00`3oo`10o`030?oo00Oo00<0ool05?l001Go
00<0ool05_l00`3oo`0[o`@0C?l00`3oo`02o`<02?l00`3oo`11o`030?oo00Ko00<0ool05?l001Co
00<0ool05Ol202_o0`1Ao`030?oo00?o00<0ool01_l00`3oo`11o`030?oo00Oo00<0ool04ol001Co
00<0ool05?l00`3oo`0Xo`<0E?l00`3oo`04o`030?oo00Go00<0ool0@_l00`3oo`06o`030?oo01?o
000Do`030?oo01?o00<0ool09_l305So00<0ool00ol00`3oo`05o`030?oo04?o00<0ool01Ol00`3o
o`0Co`004ol00`3oo`0Bo`809_l305co00<0ool00_l00`3oo`05o`030?oo04?o00<0ool01_l00`3o
o`0Bo`004ol00`3oo`0Ao`030?oo02;o101Oo`030?oo00?o00<0ool01?l00`3oo`14o`030?oo00Go
00<0ool04_l001?o00<0ool04?l00`3oo`0Po`<0I?l00`3oo`02o`030?oo00Co00<0ool0AOl00`3o
o`04o`030?oo01;o000Bo`030?oo00oo0P0Po`<0J?l00`3oo`02o`030?oo00?o00<0ool0A_l00`3o
o`04o`030?oo017o000Bo`030?oo00ko00<0ool07Ol306co00D0oooo0005o`030?oo04Ko00<0ool0
1?l00`3oo`0Ao`004_l00`3oo`0=o`030?oo01[o101_o`050?ooo`001Ol00`3oo`17o`030?oo00?o
00<0ool04Ol001;o00<0ool03?l00`3oo`0Ho`<0M?l01@3oool000Co00<0ool0B?l00`3oo`02o`03
0?oo017o000Ao`030?oo00_o0P0Ho`<0N?l0103oo`04o`030?oo04So00<0ool00ol00`3oo`0@o`00
4Ol00`3oo`0:o`030?oo01Go0`1ko`050?ooo`000ol00`3oo`19o`030?oo00;o00<0ool04?l0017o
00<0ool02Ol00`3oo`0Co`<0Ool0103oo`03o`030?oo04[o00D0oooo000Bo`004?l00`3oo`08o`80
4_l408?o00<0o`000ol00`3oo`1:o`030?oo00;o00<0ool03ol0013o00<0ool01ol00`3oo`0?o`<0
Qol0103oo`02o`030?oo04_o00D0oooo000Ao`004?l00`3oo`06o`030?oo00go0`2;o`030?l000;o
00<0ool0C?l0103oo`0Ao`003ol00`3oo`05o`803Ol308oo00D0o`3o001>o`050?ooo`004?l000oo
00<0ool01?l00`3oo`09o`@0Tol20003o`3o04ko00@0ool04?l000oo00<0ool00ol00`3oo`07o`<0
Uol20003o`3o04oo00<0o`004?l000oo00@0oooo0P07o`<0Vol3057o0P0@o`003_l01@3oool000Ko
0`2Oo`80DOl00`3o000?o`003_l0103oo`04o`<0X_l3057o0P0?o`002ol60003o`000080Y?lH03ko
0`0=o`002_l80:So1@0CobX04ol500co000:o`D0Zol503go600<o`002_l50:co0`1Ao`D03?l000_o
0`000ol0002Yo`030?oo057o1@0=o`004Ol00`3oo`2Vo`030?oo053o00<0ool04?l001;o00<0ool0
Y?l00`3oo`1@o`030?oo017o000Co`80Y?l00`3oo`1>o`805?l001Go00<0ool0X?l00`3oo`1>o`03
0?oo01Co000Fo`030?oo09oo00<0ool0COl00`3oo`0Eo`005ol209oo00<0ool0Bol201So000Io`03
0?oo09_o00<0ool0Bol00`3oo`0Ho`006_l00`3oo`2Jo`030?oo04[o00<0ool06Ol001_o0P2Io`03
0?oo04Wo0P0Lo`007Ol00`3oo`2Fo`030?oo04So00<0ool07?l001ko00<0ool0U?l00`3oo`18o`03
0?oo01go000Oo`80U?l00`3oo`16o`808?l0027o00<0ool0T?l00`3oo`16o`030?oo023o000Ro`03
0?oo08oo00<0ool0AOl00`3oo`0Qo`008ol00`3oo`2>o`030?oo04Co00<0ool08_l002Co0P2=o`03
0?oo04?o0P0Uo`009_l00`3oo`2:o`030?oo04;o00<0ool09Ol002Oo00<0ool0R?l00`3oo`12o`03
0?oo02Ko000Xo`80R?l00`3oo`10o`80:Ol002[o00<0ool0Q?l00`3oo`10o`030?oo02Wo000[o`03
0?oo08?o00<0ool0?ol00`3oo`0Zo`00;?l208;o00<0ool0?_l202go000^o`030?oo07oo00<0ool0
?Ol00`3oo`0]o`00;ol00`3oo`1no`030?oo03co00<0ool0;_l0033o0P1mo`030?oo03_o0P0ao`00
<_l00`3oo`1jo`030?oo03[o00<0ool0<Ol003?o00<0ool0N?l00`3oo`0jo`030?oo03;o000do`80
N?l00`3oo`0ho`80=Ol003Ko00<0ool0M?l00`3oo`0ho`030?oo03Go000go`030?oo07?o00<0ool0
=ol00`3oo`0fo`00>?l00`3oo`1ao`030?oo03Oo00<0ool0=ol003Wo0P1ao`030?oo03Go0P0jo`00
>ol00`3oo`1^o`030?oo03Co00<0ool0>_l003co00<0ool0K?l00`3oo`0do`030?oo03_o000mo`80
K?l00`3oo`0bo`80?_l003oo00<0ool0J?l00`3oo`0bo`030?oo03ko0010o`030?oo06Oo00<0ool0
<Ol00`3oo`0oo`00@Ol206Ko00<0ool0<?l204;o0013o`030?oo06?o00<0ool0;ol00`3oo`12o`00
A?l00`3oo`1Qo`030?oo02oo00<0ool0@ol004Go0P1Qo`030?oo02go0P16o`00Aol00`3oo`1No`03
0?oo02co00<0ool0A_l004So00<0ool0G?l00`3oo`0/o`030?oo04Oo0019o`80G?l00`3oo`0Zo`80
B_l004_o00<0ool0F?l00`3oo`0Zo`030?oo04[o001<o`030?oo05Oo00<0ool0:Ol00`3oo`1;o`00
COl00`3oo`1Eo`030?oo02Wo00<0ool0C?l004ko0P1Eo`030?oo02Oo0P1?o`00D?l00`3oo`1Ao`03
0?oo02Oo00<0ool0Col0057o00<0ool0D?l00`3oo`0Vo`030?oo053o001Bo`80Col00`3oo`0Uo`80
Dol005Co00<0ool0C?l00`3oo`0To`030?oo05?o001Eo`030?oo04_o00<0ool08ol00`3oo`1Do`00
E_l204[o00<0ool08_l205Oo001Ho`030?oo04Oo00<0ool08Ol00`3oo`1Go`00FOl00`3oo`15o`03
0?oo027o00<0ool0F?l005[o0P15o`030?oo01oo0P1Ko`00G?l00`3oo`11o`030?oo01oo00<0ool0
Fol005go00<0ool0@?l00`3oo`0No`030?oo05co001No`80?ol00`3oo`0Mo`80Gol0063o00<0ool0
??l00`3oo`0Lo`030?oo05oo001Qo`030?oo03_o00<0ool06ol00`3oo`1Po`00H_l203[o00<0ool0
6_l206?o001To`030?oo03Oo00<0ool06Ol00`3oo`1So`00IOl00`3oo`0eo`030?oo01Wo00<0ool0
I?l006Ko00<0ool0=?l00`3oo`0Ho`030?oo06Go001Wo`80<ol00`3oo`0Go`80J?l006Wo00<0ool0
<?l00`3oo`0Fo`030?oo06So001Zo`030?oo02ko00<0ool05_l00`3oo`1Yo`00Jol202ko00<0ool0
5?l206co001]o`030?oo02_o00<0ool04ol00`3oo`1/o`00K_l00`3oo`0Yo`030?oo01?o00<0ool0
KOl006oo0P0Yo`030?oo017o0P1`o`00LOl00`3oo`0Uo`030?oo017o00<0ool0L?l007;o00<0ool0
9?l00`3oo`0@o`030?oo077o001co`808ol00`3oo`0?o`80M?l007Go00<0ool08?l00`3oo`0>o`03
0?oo07Co001fo`030?oo01ko00<0ool03_l00`3oo`1eo`00Mol201ko00<0ool03?l207So001io`03
0?oo01_o00<0ool02ol00`3oo`1ho`00N_l00`3oo`0Io`030?oo00_o00<0ool0NOl007_o00<0ool0
6?l00`3oo`0:o`030?oo07[o001lo`805ol00`3oo`09o`80OOl007ko00<0ool05?l00`3oo`08o`03
0?oo07go001oo`030?oo01;o00<0ool02?l00`3oo`1no`00P?l201;o00<0ool01_l2087o0022o`03
0?oo00ko00<0ool01_l00`3oo`21o`00Pol00`3oo`0=o`030?oo00Go00<0ool0P_l008Co0P0=o`03
0?oo00?o0P25o`00Q_l00`3oo`09o`030?oo00?o00<0ool0QOl008Oo00<0ool02?l00`3oo`02o`03
0?oo08Ko0028o`801ol0103oool208Wo002:o`030?oo00Co00@0ool0Rol008_o00<0ool00_l0103o
o`2<o`00S?l200;o0`2=o`00S_l308oo002=o`D0S_l008go1@2>o`00SOl508ko002>o`<0Sol00?oo
8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00001
\
\>"],
  ImageRangeCache->{{{83, 312.375}, {466.25, 236.875}} -> {-1.8033, 1.15553, 
  0.00729756, 0.00694039}}]
}, Open  ]],

Cell[TextData[
"\:63cf\:304b\:308c\:305f\:56f3\:5f62\:306f\:78ba\:304b\:306b\:3001\:5e73\
\:9762\:30b0\:30e9\:30d5\:3067\:3042\:308b\:3002\n\:554f\:ff13\:ff0e\:96a3\
\:63a5\:884c\:5217 mm \:306b\:305f\:3044\:3057\:3066\:3001\:4e0a\:3068\:7570\
\:306a\:308b\:8272\:3005\:306a\:5916\:5468\:8def\:3092\:6307\:5b9a\:3057\:3066\
\:5e73\:9762\:30b0\:30e9\:30d5\:3092\:63cf\:753b\:305b\:3088\:3002\n\n    \
\:4f8b\:ff11\:306e\:30b0\:30e9\:30d5\:306e\:751f\:6210\:6728\:3092\:6c42\:3081\
\:3066\:307f\:308b\:3068\:3001\:6b21\:306e\:3088\:3046\:306b\:306a\:308b\:3002\
"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(drawspanningtree[mm, {1, 2, 3, 4, 5, 6, 7, 8, 9, 10}, 1, TREE]\)], 
  "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0242882 0.951424 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.22038 .86773 Mdot
.04757 .64046 Mdot
.04757 .35954 Mdot
.22038 .13227 Mdot
.5 .04545 Mdot
.77962 .13227 Mdot
.95243 .35954 Mdot
.95243 .64046 Mdot
.77962 .86773 Mdot
.5 Mabswid
.5 .95455 m
.22038 .86773 L
s
.22038 .86773 m
.5 .95455 L
s
.22038 .86773 m
.04757 .64046 L
s
.04757 .64046 m
.22038 .86773 L
s
.04757 .64046 m
.04757 .35954 L
s
.04757 .35954 m
.04757 .64046 L
s
.04757 .35954 m
.22038 .13227 L
s
.04757 .35954 m
.5 .04545 L
s
.22038 .13227 m
.04757 .35954 L
s
.5 .04545 m
.04757 .35954 L
s
.5 .04545 m
.77962 .13227 L
s
.77962 .13227 m
.5 .04545 L
s
.77962 .13227 m
.95243 .35954 L
s
.95243 .35954 m
.77962 .13227 L
s
.95243 .35954 m
.95243 .64046 L
s
.95243 .64046 m
.95243 .35954 L
s
.95243 .64046 m
.77962 .86773 L
s
.77962 .86773 m
.95243 .64046 L
s
.5 .95455 m
.22038 .86773 L
s
.22038 .86773 m
.5 .95455 L
s
.22038 .86773 m
.04757 .64046 L
s
.04757 .64046 m
.22038 .86773 L
s
.04757 .64046 m
.04757 .35954 L
s
.04757 .35954 m
.04757 .64046 L
s
.04757 .35954 m
.22038 .13227 L
s
.04757 .35954 m
.5 .04545 L
s
.22038 .13227 m
.04757 .35954 L
s
.5 .04545 m
.04757 .35954 L
s
.5 .04545 m
.77962 .13227 L
s
.77962 .13227 m
.5 .04545 L
s
.77962 .13227 m
.95243 .35954 L
s
.95243 .35954 m
.77962 .13227 L
s
.95243 .35954 m
.95243 .64046 L
s
.95243 .64046 m
.95243 .35954 L
s
.95243 .64046 m
.77962 .86773 L
s
.77962 .86773 m
.95243 .64046 L
s
[(1)] .47146 .92727 0 1 Mshowa
[(2)] .19184 .84046 0 1 Mshowa
[(3)] .01903 .61319 0 1 Mshowa
[(4)] .01903 .33227 0 1 Mshowa
[(5)] .19184 .10499 0 1 Mshowa
[(6)] .47146 .01818 0 1 Mshowa
[(7)] .75107 .10499 0 1 Mshowa
[(8)] .92389 .33227 0 1 Mshowa
[(9)] .92389 .61319 0 1 Mshowa
[(10)] .75107 .84046 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV0<aV
0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0<fH0
<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI<lbI
<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0IP0c
IS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<IVK<
IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITcVL`c
VOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<V@3o
VC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=Vc6IV
c9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Woc<co
c?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>IofJI
oiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H61PL7
1`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D50000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooohGo00<0o`00V?l008Go0P2Io`00QOl00`3o
o`2Ho`00Q_l209So003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o002>o`<0
Sol008go1@2>o`00S?l708go002<o`L0SOl008co202<o`00S?l600;o1028o`00R_l200;o0`07o`<0
QOl008Wo00<0ool03ol308;o0028o`030?oo01?o101no`00Q_l201[o0`1ko`00QOl00`3oo`0Mo`<0
N?l008?o0P0So`@0M?l003Ko00<0ool0BOl00`3oo`0Wo`<0:?l00`3oo`16o`00=Ol00`3o0018o`80
;Ol302Go00<0ool0A_l003Oo00<0ool0AOl00`3oo`0`o`@08Ol00`3oo`16o`00=Ol204Ko0P0go`<0
7ol00`3oo`15o`00=Ol00`3oo`14o`030?oo03[o0`0Jo`030?l004Oo000eo`<0@ol00`3oo`0no`@0
5_l304Oo001io`80AOl305go001ho`030?oo04So0`1Jo`00M_l204ko101Fo`00MOl00`3oo`1Bo`<0
Dol007?o0P1Ho`<0D?l007;o00<0ool0Fol404co001`o`80H_l304Wo000no`<0;_l00`3oo`1Uo`<0
1?l303oo000mo`D0;?l00`3oo`1Yo`P0?_l003co1`0Yo`80K_l703go000lo`L0:?l00`3oo`1^o`L0
?Ol003co1`0Vo`80LOl703go000mo`D09_l00`3oo`1bo`D0?_l003co00<0o`000P0Uo`80M_l30003
o`3o03co000ko`030?oo02Oo00<0ool0Nol00`3oo`0jo`00>_l00`3oo`0Vo`80Ool00`3oo`0io`00
>_l00`3oo`0Uo`030?oo07oo00<0ool0>Ol003Wo00<0ool09Ol00`3oo`21o`030?oo03So000ho`03
0?oo02Co0P25o`030?oo03Oo000go`030?oo02Co00<0ool0Q_l00`3oo`0fo`00=ol00`3oo`0Ro`80
ROl00`3oo`0fo`00=_l00`3oo`0Ro`030?oo08[o00<0ool0=Ol003Go00<0ool08Ol208ko00<0ool0
=?l003Co00<0ool08Ol00`3oo`2?o`030?oo03?o000do`030?oo01oo0P2Bo`030?oo03?o000co`03
0?oo01oo00<0ool0Tol00`3oo`0bo`00<_l00`3oo`0Oo`030?oo09Go00<0ool0<Ol0037o00<0ool0
7_l209Wo00<0ool0<?l0037o00<0ool07Ol00`3oo`2Io`030?oo033o000`o`030?oo01co0P2Mo`03
0?oo02oo000_o`030?oo01co00<0ool0W_l00`3oo`0^o`00;_l00`3oo`0Ko`80X_l00`3oo`0]o`00
;_l00`3oo`0Jo`030?oo0:;o00<0ool0;Ol002go00<0ool06Ol20:Ko00<0ool0;?l002co00<0ool0
6Ol00`3oo`2Wo`030?oo02_o000[o`030?oo01Wo00<0ool0ZOl00`3oo`0Zo`00:ol00`3oo`0Go`80
[?l00`3oo`0Zo`00:_l00`3oo`0Go`030?oo0:go00<0ool0:Ol002Wo00<0ool05_l20;7o00<0ool0
:?l002So00<0ool05_l00`3oo`2bo`030?oo02Oo000Xo`030?oo01Co0P2eo`030?oo02Oo000Wo`03
0?oo01Co00<0ool0]_l00`3oo`0Vo`009_l00`3oo`0Co`80^_l00`3oo`0Uo`009Ol00`3oo`0Co`03
0?oo0;_o00<0ool09?l002Co00<0ool04ol00`3oo`2mo`030?oo02?o000To`030?oo017o0P30o`03
0?oo02?o000So`030?oo017o00<0ool0`Ol00`3oo`0Ro`008_l00`3oo`0@o`80aOl00`3oo`0Qo`00
8Ol00`3oo`0@o`030?oo0<Ko00<0ool08?l0027o00<0ool03_l20<Wo00<0ool08?l0023o00<0ool0
3_l00`3oo`3:o`030?oo01oo000Oo`030?oo00go0P3>o`030?oo01ko000No`030?oo00go00<0ool0
col00`3oo`0Mo`007_l00`3oo`0<o`030?oo0=3o00<0ool07Ol001go00<0ool02ol20=Co00<0ool0
7?l001co00<0ool02ol00`3oo`3Eo`030?oo01_o000Ko`030?oo00[o0P3Io`030?oo01[o000Ko`03
0?oo00Wo00<0ool0fOl00`3oo`0Jo`006_l00`3oo`08o`80gOl00`3oo`0Io`001?l301;o00<0ool0
2?l00`3oo`3No`040?oo01Oo0005o`030?oo013o00<0ool01ol20>;o0P000ol0o`0Eo`000ol4017o
00<0ool01_l00`3oo`3Ro`8000?o0?l05Ol000?o00<0o`004Ol00`3oo`06o`030?oo0>Co0P0Go`00
1?l2013o00<0ool01Ol20>Oo0`0Fo`001Ol00`3oo`0=o`030?oo00Go00<0ool0j?l201Ko000Eo`03
0?oo00?o0P3/o`030?oo01Co000Do`030?oo00?o00<0ool0kOl00`3oo`0Co`004ol00`3oo`02o`80
lOl00`3oo`0Bo`004_l00`3oo`02o`030?oo0?;o00<0ool04Ol001;o00<0ool00P3eo`030?oo017o
000Ao`040?oo0?So00<0ool04?l0013o00@0ool0n_l00`3oo`0?o`003?l40003o`000?co100=o`00
2ol60?ko1@0<o`002_l70?go1`0;o`002_l70?go1`0;o`002_l70?go1`0;o`002ol50?oo1@0<o`00
3?l30?oo0_l300go000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go
00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool0
3?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o
00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3o
o`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`00
3Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3o
o`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo
0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`03
0?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co
000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`03
0?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0
ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go
00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool0
3?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o
00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3o
o`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`00
3Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo0_l00`3o
o`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`030?oo0?oo
0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`03
0?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co
000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`03
0?oo00co000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0
ool2o`030?oo00co0003o`802?l00`3oo`3go`802?l00`3oo`0<o`001Ol00`3oo`05o`030?oo0?Wo
00<0ool01Ol00`3oo`0<o`001?l00`3oo`06o`030?oo0?So0P07o`030?oo00co0005o`030?oo00Go
00<0ool0mol00`3o0007o`030?oo00co0003o`030?l000Oo00<0ool0mol00`3o0007o`030?oo00co
0004o`030?oo00Ko00<0ool0n?l200Oo00<0ool03?l000go00<0ool0ool2o`030?oo00co000=o`03
0?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`030?oo00co
000=o`030?oo0?oo0_l00`3oo`0<o`003Ol00`3oo`3oo`;o00<0ool03?l000go00<0ool0ool2o`03
0?oo00co000<o`<0ool2o`<03Ol000_o1@3oo`D03?l000[o1`3mo`L02ol000[o1`3mo`L02ol000[o
1`3mo`L02ol000_o1@3oo`D03?l000co103oo`@03Ol0013o00<0ool0nol00`3oo`0?o`004Ol00`3o
o`3io`030?oo013o000Bo`030?oo0?Oo00<0ool04Ol001;o00<0ool0mol00`3oo`0Ao`004ol00`3o
o`3eo`030?oo01;o000Do`030?oo0??o00<0ool04ol001Go00<0ool0lOl00`3oo`0Do`005Ol00`3o
o`3ao`030?oo01Co000Fo`030?oo0>oo00<0ool05Ol001Oo00<0ool0kOl00`3oo`0Fo`006?l00`3o
o`3[o`030?oo01Oo000Ho`030?oo0>_o00<0ool05ol001Wo00<0ool0jOl00`3oo`0Ho`006_l00`3o
o`3Wo`030?oo01Wo000Ko`030?oo0>Go00<0ool06_l001_o00<0ool0iOl00`3oo`0Jo`007?l00`3o
o`3So`030?oo01_o000Mo`030?oo0>7o00<0ool07?l001ko00<0ool0gol00`3oo`0Mo`007_l00`3o
o`3Oo`030?oo01go000Oo`030?oo0=go00<0ool07_l0023o00<0ool0fol00`3oo`0Oo`008Ol00`3o
o`3Io`030?oo023o000Qo`030?oo0=Wo00<0ool08?l002;o00<0ool0eol00`3oo`0Qo`008ol00`3o
o`3Eo`030?oo02;o000To`030?oo0=?o00<0ool08ol002Co00<0ool0dol00`3oo`0So`009Ol00`3o
o`3Ao`030?oo02Co000Vo`030?oo0<oo00<0ool09Ol002Oo00<0ool0cOl00`3oo`0Vo`00:?l00`3o
o`3;o`030?oo02Oo000Xo`030?oo0<_o00<0ool09ol002Wo00<0ool0bOl00`3oo`0Xo`00:_l00`3o
o`37o`030?oo02Wo000[o`030?oo0<Go00<0ool0:_l002_o00<0ool0aOl00`3oo`0Zo`00;?l00`3o
o`33o`030?oo02_o000]o`030?oo0<7o00<0ool0;?l002ko00<0ool0_ol00`3oo`0]o`00;_l00`3o
o`2oo`030?oo02go000_o`030?oo0;go00<0ool0;_l0033o00<0ool0^ol00`3oo`0_o`00<Ol00`3o
o`2io`030?oo033o000ao`030?oo0;Wo00<0ool0<?l003;o00<0ool0]ol00`3oo`0ao`00<ol00`3o
000209[o1@02o`030?oo00oo00<0ool0<_l003Co0P2No`070?ooo`3o000?o`030?oo03?o000do`03
0?l009go00L0oooo0?l000oo00<0ool0<ol003Go0P2Mo`070?ooo`3o000>o`030?oo03Co000eo`<0
W?l01`3oool0o`003Ol00`3oo`0eo`00=_l209_o0P04o`030?oo00_o00<0ool0=_l003Oo00<0ool0
[Ol00`3oo`0fo`00>?l00`3oo`2[o`030?oo03Oo000io`030?oo0:Wo00<0ool0>?l003[o00<0ool0
Yol00`3oo`0io`00>_l00`3oo`2Wo`030?oo03Wo000ko`030?oo0:Go00<0ool0>_l003co00<0ool0
Xol00`3oo`0ko`00?Ol409go100no`00?Ol509_o1@0no`00??l709Wo1`0mo`00??l709Wo1`0mo`00
??l809So1`0mo`00?Ol500;o102Eo`D0?_l003ko0`07o`<0Tol303oo001;o`<0d_l004ko103>o`00
D_l30<_o001Eo`<0b?l005So1034o`00G?l302Go1@2Go`00Gol302Co00<0ool0Uol006;o100Po`03
0?oo09Oo001Vo`<07Ol00`3oo`2Go`00JOl301[o00<0ool0Uol006co100Eo`80VOl0073o0`2]o`00
Lol30:[o001fo`@0Y_l007[o0`2So`00OOl30:3o0020o`@0W?l008Co0`2Io`00Qol300Co0`2?o`00
R_l808ko002<o`L0SOl008co1`2=o`00S?l708go002=o`D0S_l008ko0`2?o`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00\
\>"],
  ImageRangeCache->{{{83, 312.375}, {318.313, 88.9375}} -> {-0.405865, 
  0.376511, 0.00366585, 0.00383655}}],

Cell[BoxData[
    \(Graph[{{0, 1, 0, 0, 0, 0, 0, 0, 0, 0}, {1, 0, 1, 0, 0, 0, 0, 0, 0, 0}, {
          0, 1, 0, 1, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 1, 1, 0, 0, 0, 0}, {0, 
          0, 0, 1, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 1, 0, 0, 0}, {0, 0, 
          0, 0, 0, 1, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0, 1, 0}, {0, 0, 0, 
          0, 0, 0, 0, 1, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0}}, {{0, 1.`}, {
          \(-0.587785252292473181`\), 0.809016994374947451`}, {
          \(-0.951056516295153464`\), 0.309016994374947495`}, {
          \(-0.951056516295153642`\), \(-0.309016994374947229`\)}, {
          \(-0.58778525229247327`\), \(-0.809016994374947273`\)}, {0, 
          \(-1.`\)}, {0.587785252292473181`, \(-0.809016994374947628`\)}, {
          0.951056516295153464`, \(-0.30901699437494754`\)}, {
          0.951056516295153819`, 0.309016994374947184`}, {
          0.587785252292473359`, 0.809016994374947273`}}]\)], "Print"]
}, Open  ]],

Cell[TextData[
"    \:6c42\:3081\:305f\:751f\:6210\:6728\:306e\:6839 (root) \:306f\:9802\
\:70b9\:ff11\:3067\:3042\:308b\:3002\:3053\:306e\:9802\:70b9\:3092\:6839\:3068\
\:3057\:3066\:3001\:6728\:3092\:4e0a\:304b\:3089\:4e0b\:306b\:5411\:304b\:3063\
\:3066\:63cf\:753b\:3059\:308b\:306b\:306f\:3001Combinatorica.m \:306e\:95a2\
\:6570 RootedEmbedding\:3092\:5229\:7528\:51fa\:6765\:308b\:3002\:3057\:304b\
\:3057\:3001\:6728\:306f\:4e0b\:304b\:3089\:4e0a\:306b\:5411\:304b\:3046\:306e\
\:304c\:81ea\:7136\:3067\:3042\:308b\:306e\:3067\:3001\:3053\:306e\:95a2\:6570\
\:3092\:6b21\:306e\:3088\:3046\:306b\:5909\:66f4\:3059\:308b\:3002"], "Text"],

Cell[BoxData[
    \(RotateRootedEmbedding[g_Graph, rt_Integer]\  := \n\t
      Module[{root = rt, pos, i, x, dx, new, n = V[g], v, done, next, 
          e = ToAdjacencyLists[g], g1, s = Pi, vtx}, \n\t\t
        pos\  = \ Table[{\(-Ceiling[Sqrt[n]]\), Ceiling[Sqrt[n]]}, {n}]; \n
        \t\tv\  = \ Table[{0, 0}, {n}]; \n\t\t
        next\  = \ \(done\  = \ {root}\); \n\t\t
        While\ [next\  != \ {}, \n\t\t\troot\  = \ First[next]; \n\t\t\t
          new\  = \ Complement[e[\([root]\)], \ done]; \n\t\t\t
          Do\ [\n\t\t\t\t
            dx\  = \ \((pos[\([root, 2]\)] - pos[\([root, 1]\)])\)/
                Length[new]; \n\t\t\t\t
            pos[\([\ new[\([i]\)]\ ]\)]\  = 
              \ {pos[\([root, 1]\)]\  + \ \((i - 1)\)*dx, \n\t\t\t\t\t
                pos[\([root, 1]\)]\  + \ i*dx}; \n\t\t\t\t
            x\  = \ Apply[Plus, pos[\([\ new[\([i]\)]\ ]\)]\ ]/2; \n\t\t\t\t
            v[\([\ new[\([i]\)]\ ]\)]\  = \ {x, v[\([root, 2]\)] - 1}, \n
            \t\t\t\t{i, Length[new]}\n\t\t\t]; \n\t\t\t
          next\  = \ Join[Rest[next], new]; \n\t\t\t
          done\  = \ Join[done, new]\n\t\t]; \n\t\t
        g1 = Graph[Edges[g], N[v]]; \n
        \t\t (*\ g1\ is\ the\ return\ value\ of\ RootedEmbedding\ \ *) \n\t\t
        vtx = Map[\(({{Cos[s], \(-Sin[s]\)}, {Sin[s], Cos[s]}}\  . \ #)\)&, 
            Vertices[g1]]; \n\t\t (*\ Rotation\ of\ Pi\ *) \n\t\t
        ChangeVertices[g1, vtx]\n\t]\)], "Input"],

Cell[TextData[
"\:3000\:3053\:306e\:95a2\:6570\:3092\:7528\:3044\:308b\:3068\:3001\:6728\
\:3092\:4e0b\:304b\:3089\:4e0a\:306b\:5411\:304b\:3063\:3066\:4e0a\:6607\:7684\
\:306b\:63cf\:753b\:51fa\:6765\:308b\:3002\:4f8b\:3048\:3070\:3001tree1 \
\:3092\:4e0a\:306e\:51fa\:529b\:306b\:3088\:308a\:5f97\:3089\:308c\:305f \
Graph\:8868\:73fe\:3068\:3057\:3066\:3001\:5b9f\:884c\:3059\:308b\:3068\:6b21\
\:306e\:3088\:3046\:306b\:306a\:308b\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ShowLabeledGraph[RotateRootedEmbedding[tree1, 1]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.1 2 -0.166667 1.11111 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .05556 Mdot
.5 .16667 Mdot
.5 .27778 Mdot
.5 .38889 Mdot
.9 .5 Mdot
.1 .5 Mdot
.1 .61111 Mdot
.1 .72222 Mdot
.1 .83333 Mdot
.1 .94444 Mdot
.5 Mabswid
.5 .05556 m
.5 .16667 L
s
.5 .16667 m
.5 .05556 L
s
.5 .16667 m
.5 .27778 L
s
.5 .27778 m
.5 .16667 L
s
.5 .27778 m
.5 .38889 L
s
.5 .38889 m
.5 .27778 L
s
.5 .38889 m
.9 .5 L
s
.5 .38889 m
.1 .5 L
s
.9 .5 m
.5 .38889 L
s
.1 .5 m
.5 .38889 L
s
.1 .5 m
.1 .61111 L
s
.1 .61111 m
.1 .5 L
s
.1 .61111 m
.1 .72222 L
s
.1 .72222 m
.1 .61111 L
s
.1 .72222 m
.1 .83333 L
s
.1 .83333 m
.1 .72222 L
s
.1 .83333 m
.1 .94444 L
s
.1 .94444 m
.1 .83333 L
s
.5 .05556 m
.5 .16667 L
s
.5 .16667 m
.5 .05556 L
s
.5 .16667 m
.5 .27778 L
s
.5 .27778 m
.5 .16667 L
s
.5 .27778 m
.5 .38889 L
s
.5 .38889 m
.5 .27778 L
s
.5 .38889 m
.9 .5 L
s
.5 .38889 m
.1 .5 L
s
.9 .5 m
.5 .38889 L
s
.1 .5 m
.5 .38889 L
s
.1 .5 m
.1 .61111 L
s
.1 .61111 m
.1 .5 L
s
.1 .61111 m
.1 .72222 L
s
.1 .72222 m
.1 .61111 L
s
.1 .72222 m
.1 .83333 L
s
.1 .83333 m
.1 .72222 L
s
.1 .83333 m
.1 .94444 L
s
.1 .94444 m
.1 .83333 L
s
[(1)] .44 .02222 0 1 Mshowa
[(2)] .44 .13333 0 1 Mshowa
[(3)] .44 .24444 0 1 Mshowa
[(4)] .44 .35556 0 1 Mshowa
[(5)] .84 .46667 0 1 Mshowa
[(6)] .04 .46667 0 1 Mshowa
[(7)] .04 .57778 0 1 Mshowa
[(8)] .04 .68889 0 1 Mshowa
[(9)] .04 .8 0 1 Mshowa
[(10)] .04 .91111 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l:C8l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV
0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0
<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI
<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0
IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<
IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITc
VL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<
V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=V
c6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Wo
c<coc?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>I
ofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H6
1PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D5000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooggo00<0ool0X?l007go00<0ool0X?l007go
00<0ool0X?l007go00<0ool0X?l007co0P2Ro`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`00oolQo`00S_l308oo002=o`D0S_l008co1`2=o`00S?l708go002<o`L0
SOl008go1@2>o`00S_l308oo002?o`030?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`03
0?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`03
0?oo08ko002?o`030?oo08ko001lo`<04?l00`3oo`2>o`00O?l00`3oo`0@o`030?oo08ko001mo`03
0?oo00oo00<0ool0S_l007go00<0ool03ol00`3oo`2>o`00O?l00`3o000@o`030?oo08ko001mo`03
0?oo00oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0
S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008ko0`2?o`00
SOl508ko002<o`L0SOl008co1`2=o`00S?l708go002=o`D0S_l008ko0`2?o`00Sol00`3oo`2>o`00
Sol00`3oo`2>o`00Sol00`3oo`2>o`00Sol00`3oo`2>o`00Sol00`3oo`2>o`00Sol00`3oo`2>o`00
Sol00`3oo`2>o`00Sol00`3oo`2>o`00Sol00`3oo`2>o`00Sol00`3oo`2>o`00Sol00`3oo`2>o`00
O?l2017o00<0ool0S_l007ko00<0ool03_l00`3oo`2>o`00OOl00`3oo`0?o`030?oo08ko001no`03
0?oo00ko00<0ool0S_l007co00<0o`004?l00`3oo`2>o`00OOl00`3oo`0?o`030?oo08ko002?o`03
0?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`030?oo08ko002?o`03
0?oo08ko002?o`030?oo08ko002?o`030?oo08ko002>o`<0Sol008go1@2>o`00S?l708go002<o`L0
SOl008co1`2=o`00SOl508ko002>o`<0Sol008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0
S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0
S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l007go0`0?o`030?oo08ko001no`03
0?oo00ko00<0ool0S_l007co100?o`030?oo08ko001lo`030?l0013o00<0ool0S_l007go0P0@o`03
0?oo08ko001no`030?oo00ko00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0
S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0S_l008oo00<0ool0
S_l008ko0`2?o`00SOl508ko002<o`L0SOl008co1`2=o`00R_l;08_o0027o`<00ol500?o0`28o`00
Pol400Oo0`07o`@0Q?l007oo100Io`@0P?l007co0`0Qo`<0OOl007So100Wo`@0NOl007Go0`0_o`<0
M_l0077o100eo`@0L_l006go100mo`@0K_l006[o0`15o`<0Jol006Ko101;o`@0Iol006?o0`1Co`<0
I?l005oo101Io`@0H?l000Wo0P1@o`@0HOl402co00<0ool0;Ol000Wo00<0o`00C?l306Wo0`0Xo`03
0?l002ko0009o`030?l004So101_o`@09_l00`3oo`0/o`002Ol204Ko0`1go`<08Ol202oo0009o`03
0?oo047o101mo`@07Ol00`3oo`0^o`002_l203go1025o`@06Ol302ko0016o`<0SOl304Oo0012o`@0
Tol404?o000oo`<0Vol3043o000ko`@0XOl403co000go`@0ZOl403So000do`<0/Ol303Go000`o`@0
]ol4037o000]o`<0_ol302ko000Yo`@0aOl402[o000Ko`<01ol40<go1007o`<07?l001[o1@03o`<0
eOl300?o1@0Ko`006Ol90=_o2@0Jo`006Ol70=oo1`0Jo`006Ol70=oo1`0Jo`006_l50>7o1@0Ko`00
6ol30>?o0`0Lo`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3o
o`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo
0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000:o`030?oo00oo00<0ool0ool2o`002_l00`3o
o`0?o`030?oo0?oo0_l000[o00<0ool03ol00`3oo`3oo`;o000;o`030?oo00ko00<0ool0ool2o`00
2Ol00`3o000@o`030?oo0?oo0_l000Wo0`0@o`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3o
o`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo
0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001_o0`3oo`?o000Jo`D0
ool2o`006Ol70?oo0Ol001Wo1`3oo`7o000Io`L0ool1o`006_l50?oo0_l001_o0`3oo`?o000Lo`03
0?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0
ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o
000Lo`030?oo0?oo0_l000[o00<0ool03ol00`3oo`3oo`;o0009o`030?l0013o00<0ool0ool2o`00
2Ol00`3o000@o`030?oo0?oo0_l000[o00<0ool03ol00`3oo`3oo`;o0009o`030?l0013o00<0ool0
ool2o`002_l00`3oo`0?o`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`03
0?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0
ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001_o0`3oo`?o000Jo`D0ool2o`006Ol70?oo
0Ol001Wo1`3oo`7o000Io`L0ool1o`006_l50?oo0_l001_o0`3oo`?o000Lo`030?oo0?oo0_l001co
00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3o
o`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo
0_l000Wo0P0Ao`030?oo0?oo0_l000_o00<0ool03_l00`3oo`3oo`;o000:o`804?l00`3oo`3oo`;o
0009o`030?l0013o00<0ool0ool2o`002Ol00`3o000@o`030?oo0?oo0_l000[o0P0@o`030?oo0?oo
0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`00
7?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`03
0?oo0?oo0_l001_o0`3oo`?o000Jo`D0ool2o`006Ol70?oo0Ol001Wo1`3oo`7o000Io`L0ool1o`00
6_l50?oo0_l001_o0`3oo`?o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o
000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co
00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l000Ko1@02o`030?oo00co00<0ool0
ool2o`002?l01`3oool0o`003Ol00`3oo`3oo`;o0008o`070?ooo`3o000=o`030?oo0?oo0_l000So
00L0oooo0?l000go00<0ool0ool2o`002?l01`3oool0o`003Ol00`3oo`3oo`;o0007o`801?l00`3o
o`0<o`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co
00<0ool0ool2o`007?l00`3oo`3oo`;o000Lo`030?oo0?oo0_l001co00<0ool0ool2o`007?l00`3o
o`3oo`;o000Lo`030?oo0?oo0_l001_o0`3oo`?o000Jo`D0ool2o`006Ol70?oo0Ol001Wo1`3oo`7o
000Io`L0ool1o`006_l50?oo0_l001_o0`3oo`?o003oob7o003oob7o003oob7o003oob7o003oob7o
003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o0000\
\>"],
  ImageRangeCache->{{{83, 312.375}, {318.313, 88.9375}} -> {-0.230931, 
  0.498964, 0.00174389, 0.003139}}]
}, Open  ]],

Cell[TextData[{
  "\:3000ShowLabeledGraph[RootedEmbedding[RandomTree[n],sp]](ShowLabeledGraph[\
RotateRootedEmbedding[RandomTree[n],sp]])\:3092\:5b9f\:884c\:3059\:308b\:3068\
\:3001\:ff4e\:9802\:70b9\:306e\:30e9\:30f3\:30c0\:30e0\:306a\:6728\:3067\:9802\
\:70b9 sp( 1\[LessEqual] sp \[LessEqual] n)\:3092\:6839\:3068\:3059\:308b\
\:4e0b\:964d\:7684\:ff08\:4e0a\:6607\:7684\:ff09\:306a\:6728\:3092\:63cf\:753b\
\:3059\:308b\:3002\n\:554f\:ff13\:ff0e13\:9802\:70b9\:3092\:6301\:3064\:30e9\
\:30f3\:30c0\:30e0\:306a\:6728\:3092\:3001\:9802\:70b9\:ff11\:3092\:6839\:3068\
\:3057\:3066\:3001\:4e0b\:964d\:7684\:3001\:4e0a\:6607\:7684\:306b\:63cf\:753b\
\:305b\:3088\:3002\:3000\n\n    \:5b9f\:306f\:3001\:30d1\:30fc\:30e0\:30fb\
\:30c4\:30ea\:30fc\:3068\:547c\:3070\:308c\:308b\:6709\:5411\:30b0\:30e9\:30d5\
\:306f\:3001\:6839\:3092\:6700\:4e0b\:7aef\:306b\:7f6e\:3044\:305f\:4e0b\:304b\
\:3089\:4e0a\:306b\:5411\:304b\:3046\:6728\:306e\:8fba\:306b\:4e0a\:5411\:304d\
\:306e\:77e2\:5370\:3092\:4ed8\:3051\:3001\:88dc\:6728\:306b\:5c5e\:3059\:308b\
\:8fba\:306b\:306f\:3001\:4e0b\:5411\:304d\:306e\:77e2\:5370\:3092\:4ed8\:3051\
\:305f\:30b0\:30e9\:30d5\:ff27\:304b\:3089\:5f97\:3089\:308c\:308b\:6709\:5411\
\:30b0\:30e9\:30d5\:3067\:3042\:308b\:3002\n    \:30b0\:30e9\:30d5 tree1 \
\:306e\:5834\:5408\:306b\:3001\:30d1\:30fc\:30e0\:30fb\:30c4\:30ea\:30fc\:306e\
\:6839\:ff11\:304b\:3089\:51fa\:767a\:3057\:3066\:6728\:306e\:8fba\:3092\:77e2\
\:5370\:306e\:5411\:304d\:306b\:305f\:3069\:308a\:3001\:6700\:5f8c\:306b\:88dc\
\:6728\:306e\:8fba\:306e\:5411\:304d\:306b\:5f93\:3063\:3066\:6839\:ff11\:306b\
\:6700\:77ed\:3067\:623b\:308b\:30eb\:30fc\:30c8\:306f\:3001\:30b5\:30a4\:30af\
\:30ebC = {1,2,3,4,6,7,8,9,1} \
\:3067\:3042\:308b\:3002\:3053\:306e\:3068\:304d\:3001C\:306e\:5207\:7247\
\:3092\:6c42\:3081\:308b\:3068\:3001\:6b21\:306e\:3088\:3046\:306a7\:500b\
\:306e\:5207\:7247 \
B1={{9,10},{10,1},{10,4},{10,6}}\:3001B2={{9,3}}\:3001B3={{9,7}}\:3001B4={{8,\
3}}\:3001B5={{7,3}}\:3001B6={{4,5},{5,2}}\:3001B7= {{4,2}}\:304c\:5f97\:3089\
\:308c\:308b\:3002\:3053\:308c\:3089\:306e\:5207\:7247\:3092\:4e0a\:306b\:8ff0\
\:3079\:305f\:5e73\:9762\:6027\:5224\:5b9a\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\
\:306b\:9069\:7528\:3057\:3001B1\:3001B2\:3001...\:3001B7\:306e\:9806\:306b\
\:5e73\:9762\:306b\:57cb\:3081\:8fbc\:3093\:3067\:3044\:3063\:305f\:3068\:304d\
\:3001\:3046\:307e\:304f\:5168\:90e8\:304c\:5e73\:9762\:30b0\:30e9\:30d5\:3068\
\:3057\:3066\:57cb\:3081\:8fbc\:3081\:305f\:3068\:304d\:3001\:5e73\:9762\:7684\
\:30b0\:30e9\:30d5\:3067\:3042\:308a\:3001\:3082\:3057\:9014\:4e2d\:3067\:57cb\
\:3081\:8fbc\:3081\:306a\:304f\:306a\:3063\:305f\:3068\:304d\:306f\:3001\:975e\
\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:3067\:3042\:308b\:3002\n    \n    \
\:3053\:306e\:65b9\:6cd5\:3067\:306f\:3001\:6700\:521d\:306b\:ff11\:5ea6\:3060\
\:3051\:30b5\:30a4\:30af\:30eb\:ff23\:3068\:305d\:306e\:5207\:7247\:3092\:3059\
\:3079\:3066\:6c42\:3081\:308b\:3053\:3068\:306b\:3088\:308a\:3001\:30b0\:30e9\
\:30d5\:306e\:5e73\:9762\:6027\:3092\:5224\:5b9a\:3059\:308b\:3053\:3068\:304c\
\:53ef\:80fd\:3067\:3042\:308b\:3002\n    \
\:305d\:3053\:3067\:3001\:3053\:306e\:65b9\:6cd5\:306b\:3088\:308b\:30b5\:30a4\
\:30af\:30eb\:ff23\:3068\:305d\:308c\:306e\:3059\:3079\:3066\:306e\:5207\:7247\
\:3092\:6c42\:3081\:308b\:624b\:9806\:3092\:5b9a\:3081\:308b\:3002\:305d\:306e\
\:305f\:3081\:306b\:3001\:3044\:304f\:3064\:304b\:306e\:8a18\:53f7\:3092\:5c0e\
\:5165\:3059\:308b\:3002\n    \
\:305f\:3060\:3057\:3001\:6df1\:3055\:512a\:5148\:63a2\:7d22\:3067\:751f\:6210\
\:6728T\:3092\:6c42\:3081\:305f\:5f8c\:3067\:3001\:9802\:70b9\:306e\:756a\
\:53f7\:3092\:63a2\:7d22\:3055\:308c\:305f\:9806\:756a\:306b\:5909\:66f4\:3057\
\:3001\:3053\:306e\:756a\:53f7\:3067\:9802\:70b9\:3092\:8868\:3059\:3082\:306e\
\:3068\:3059\:308b\:3002\:307e\:305f\:3001T \:304b\:3089\:30d1\:30fc\:30e0\
\:30fb\:30c4\:30ea\:30fc\:304c\:4f5c\:3089\:308c\:3066\:3044\:308b\:3082\:306e\
\:3068\:3059\:308b\:3002\n    \:307e\:305a\:3001\:ff56\:3001\:ff57\:3092 V(G) \
\:306e\:7570\:306a\:308b\:ff12\:3064\:306e\:9802\:70b9\:3068\:3059\:308b\:3002\
\n  \:ff08\:ff11\:ff09\:ff56\:3068\:ff57\:3068\:306e\:9593\:306b\:3001\:6728\
\:306e\:6709\:5411\:8fba (v,w) \:304c\:3042\:308b\:3068\:304d\:3001v\[Rule]w \
\:3068\:8868\:3059\:3002\:3053\:306e\:3068\:304d\:3001\:ff56\:3092\:ff57\:306e\
\:89aa\:3001\:ff57\:3092\:ff56\:306e\:5b50\:3068\:547c\:3076\:3002\n  \:ff08\
\:ff12\:ff09\:6728\:306e\:4e2d\:306b\:ff56\:304b\:3089\:ff57\:3078\:5411\:304b\
\:3046\:6709\:5411\:9053\:304c\:3042\:308b\:3068\:304d\:ff08\:9577\:3055 0 \
\:306e\:9053\:3001\:3059\:306a\:308f\:3061 v = w \:3067\:3082\:3088\:3044\
\:ff09\:3001v\[RuleDelayed] w \
\:3068\:8868\:3059\:3002\:3053\:306e\:3068\:304d\:3001\:ff56\:306f\:ff57\:306e\
\:7956\:5148\:3001\:ff57\:306f\:ff56\:306e\:5b50\:5b6b\:3068\:547c\:3076\:3002\
\n  \:ff08\:ff13\:ff09\:88dc\:6728\:306e\:4e2d\:306b\:6709\:5411\:8fba (v,w) \
\:ff08\:4ee5\:964d\:3067\:306f\:3001\:3053\:308c\:3092\:8449\:3068\:547c\:3076\
\:ff09\:304c\:3042\:308b\:3068\:304d\:3001v\[Implies] w \:3068\:8868\:3059\
\:3002\n  \
\:3053\:306e\:3068\:304d\:3001\:95a2\:6570FirstLowPoint\:3001SecondLowPoint\
\:3092\:6b21\:306e\:3088\:3046\:306b\:5b9a\:3081\:308b\:3002\n  \t\
FirstLowPoint(v) = min{{v}\[Union]",
  Cell[BoxData[
      \(TraditionalForm\`S\_v\)]],
  "}\n  \t\:305f\:3060\:3057\:3001",
  Cell[BoxData[
      \(TraditionalForm\`S\_v\)]],
  " = {w\:ff5c\:ff57\:306f\:3001\:ff56\:306e\:5b50\:5b6b\:304b\:3089\:4e01\
\:5ea6\:ff11\:500b\:306e\:8449\:3092\:901a\:3063\:3066\:5230\:9054\:53ef\:80fd\
\:306a\:9802\:70b9 }\n  \tSecondLowPoint(v) = min{{v}\[Union]{",
  Cell[BoxData[
      \(TraditionalForm\`S\_v\)]],
  " - FirstLowPoint(v)}}\n  \:3053\:308c\:3089\:306e\:95a2\:6570\:3092\:7528\
\:3044\:3066\:3001\:9802\:70b9\:3067\:306e\:8fba\:306e\:9078\:3073\:65b9\:306e\
\:512a\:5148\:9806\:4f4d\:3092\:6c7a\:3081\:308b\:95a2\:6570 \[Psi] \:3092\
\:5b9a\:7fa9\:3059\:308b\:3002\n  \t\[Psi]( (v,w)) = ",
  Cell[BoxData[
      FormBox[
        RowBox[{"(", GridBox[{
              {GridBox[{
                    {\(2  w\), \((v \[Implies] \ w\:306e\:3068\:304d\ )\)},
                    {\(2 \( FirstLowPoint(w)\)\), 
                      \(\((v \[Rule] w, 
                        SecondLowPoint(w) \[GreaterEqual] v\:306e\:3068\:304d)
                        \)\n\t\)}
                    }]},
              {GridBox[{
                    {\(2 \( FirstLowPoint(w)\) + 1\), 
                      \((v \[Rule] w, SecondLowPoint(w) < v\:306e\:3068\:304d)
                        \)}
                    }]}
              }]}], TraditionalForm]]],
  "\n  \:305f\:3060\:3057\:3001 (v,w)\:306f\:ff56\:306b\:63a5\:7d9a\:3059\
\:308b\:3001\:6728\:307e\:305f\:306f\:88dc\:6728\:306e\:6709\:5411\:8fba \
\:3068\:3059\:308b\:3002\n  \n  \:3053\:306e\:95a2\:6570\:3092\:7528\:3044\
\:3066\:3001\:4e0a\:3067\:8003\:5bdf\:3057\:305f\:6728 tree1 \:3068\:305d\
\:308c\:306e\:4f5c\:308b\:30d1\:30fc\:30e0\:30fb\:30c4\:30ea\:30fc\:304b\:3089\
\:3001\:30b5\:30a4\:30af\:30eb\:ff23\:3068\:305d\:306e\:5207\:7247\:3092\:30ea\
\:30b9\:30c8\:30fb\:30a2\:30c3\:30d7\:3057\:3066\:307f\:3088\:3046\:3002\n\
\:307e\:305a\:3001\:30d1\:30fc\:30e0\:30fb\:30c4\:30ea\:30fc\:306e\:305f\:3081\
\:306e\:96a3\:63a5\:30ea\:30b9\:30c8\:3092\:3001\:5404\:9802\:70b9\:ff56\:3067\
 \[Psi]((v,w))\:306e\:975e\:6e1b\:5c11\:9806\:3067\:4f5c\:308b\:3068\:3001\
\:6b21\:306e\:3088\:3046\:306b\:306a\:308b\:3002\n    \
{{1:2},{2:3},{3:4},{4:6,5,(2)},{5:(2)},{6:7},{7:8,(3)},{8:9,{3}},{9:(1),10,(3)\
,(7)},{10:(1),(4),(6)}}  \n\:3053\:306e\:30ea\:30b9\:30c8\:306f\:3001\:6b21\
\:306e\:3053\:3068\:3092\:8868\:3059\:3002\:4f8b\:3048\:3070\:3001\:30ea\:30b9\
\:30c8\:306e\:8981\:7d20{4:6,5,(2)}\:306f\:3001\:9802\:70b9\:ff14\:306b\:306f\
\:ff12\:500b\:306e\:6728\:306e\:6709\:5411\:8fba (4,6)\:3001(4,5)\:3068\:3001\
\:8449 (4,2)\:3068\:304c\:63a5\:7d9a\:3057\:3001\[Psi]((4,6))=3<\[Psi]((4,5))=\
4=\[Psi]((4,2))\:3092\:53cd\:6620\:3057\:305f\:9806\:5e8f\:3067\:4e26\:3079\
\:3066\:3042\:308b\:3002\:305f\:3060\:3057\:3001\[Psi]((4,5))=\[Psi]((4,2))\
\:306e\:3088\:3046\:306b\:3001\[Psi]\:306e\:5024\:304c\:7b49\:3057\:3044\:3068\
\:304d\:306f\:3001\:6728\:306e\:8fba\:3092\:524d\:306b\:7f6e\:304f\:3002\n\
\:6b21\:306b\:3001\:3053\:306e\:96a3\:63a5\:30ea\:30b9\:30c8\:306e\:9802\:70b9\
\:3092\:3001\:4ee5\:4e0b\:306b\:8ff0\:3079\:308b\:624b\:9806 \
PathFind(v)\:3067\:305f\:3069\:308b\:3053\:3068\:306b\:3088\:308a\:3001\:57cb\
\:3081\:8fbc\:3080\:3079\:304d\:6709\:5411\:9053\:306e\:3059\:3079\:3066\:304c\
\:5f97\:3089\:308c\:308b\:3002\:305f\:3060\:3057\:3001\:9802\:70b9\:ff56\:306e\
\:96a3\:63a5\:30ea\:30b9\:30c8\:3092PA(v)\:3067\:8868\:3059\:3002\:4f8b\:3048\
\:3070\:3001PA(4)={6,5,2}\:3067\:3042\:308b\:3002\n\:ff08\:ff11\:ff09s = p = \
0\:3001v=a \:3068\:3057\:3066PathFind(v)\:3092\:547c\:3073\:51fa\:3059\:3002\
\:3053\:3053\:3067 a (=1) \:306f\:6839\:3068\:3059\:308b\:3002\n\ts : \:73fe\
\:5728\:306e\:9053\:306e\:59cb\:70b9\t\n\t\:ff50: \:73fe\:5728\:306e\:9053\
\:306e\:756a\:53f7\n\t\
Path[p]:\:ff50\:756a\:76ee\:306e\:9053\:306e\:30ea\:30b9\:30c8\n\:ff08\:ff12\
\:ff09\:3082\:3057PA(v)\:304c\:7a7a\:30ea\:30b9\:30c8\:306a\:3089\:3070\:3001\
\:305d\:306e\:307e\:307e\:623b\:308b\:3002\:7a7a\:30ea\:30b9\:30c8\:3067\:306a\
\:3044\:3068\:304d\:306f\:3001PA(v)\:306e\:5148\:982d\:306e\:8981\:7d20\:3092\
\:ff57\:306b\:4ee3\:5165\:3057\:3001PA(v)\:3092\:5148\:982d\:3092\:9664\:3044\
\:305f\:6b8b\:308a\:306e\:30ea\:30b9\:30c8\:3068\:3059\:308b\:3002\n\:ff08\
\:ff13\:ff09\:3082\:3057\:ff53=0\:306a\:3089\:3070\:3001\:ff53\:306b\:ff56\
\:3092\:3001p\:306bp+1\:3092\:4ee3\:5165\:3059\:308b\:3002\n\
\:ff08\:ff14\:ff09\:ff57\:3092Path[p]\:306b\:8ffd\:52a0\:3059\:308b\:3002\
\:3082\:3057\:ff56\:ff1c\:ff57\:ff08(v,w) \
\:304c\:6728\:306e\:8fba\:ff09\:306e\:3068\:304d\:306f\:3001v=w\:3068\:3057\
\:3066PathFind(v)\:3092\:547c\:3073\:51fa\:3059\:ff08\:30b9\:30c6\:30c3\:30d7\
\:ff08\:ff12\:ff09\:4ee5\:964d\:3092\:518d\:5e30\:7684\:306b\:7e70\:308a\:8fd4\
\:3059\:ff09\:3002\:305d\:3046\:3067\:306a\:3044\:3068\:304d\:306b\:306f\:ff08\
(v,w) \:304c\:8449\:306e\:3068\:304d\:ff09\:3001\:ff53=0 \:3068\:3057\:3066\
\:ff08\:ff12\:ff09\:306b\:623b\:308b\:3002\n\:9053\:3092\:4e0a\:306e\:65b9\
\:6cd5\:3067\:4f5c\:308b\:3068\:3001\:ff11\:3064\:306e\:9053\:306b\:4e01\:5ea6\
\:ff11\:500b\:306e\:88dc\:6728\:306e\:8fba\:304c\:542b\:307e\:308c\:3001\:76f8\
\:7570\:306a\:308b\:9053\:306b\:306f\:3001\:7570\:306a\:308b\:8449\:304c\:542b\
\:307e\:308c\:308b\:306e\:3067\:3001\:9053\:306e\:500b\:6570\:306f\:88dc\:6728\
\:306b\:542b\:307e\:308c\:308b\:8fba\:306e\:500b\:6570\:3001\:3059\:306a\:308f\
\:3061\:ff5cE(G)\:ff5c\:30fc\:ff5cV(G\:ff5c\:ff0b\:ff11\:306b\:7b49\:3057\
\:3044\:3002\n\:554f\:ff14\:ff0e\:30b0\:30e9\:30d5\:ff27\:304c\:5e73\:9762\
\:7684\:30b0\:30e9\:30d5\:306a\:3089\:3070\:3001\:4e0a\:306e\:65b9\:6cd5\:3067\
\:4f5c\:3089\:308c\:308b\:9053\:306e\:500b\:6570\:306f\:3001\:5e73\:9762\:30b0\
\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  " \:306e\:6709\:9650\:9818\:57df\:306e\:9762\:306e\:500b\:6570\:306b\:7b49\
\:3057\:3044\:3053\:3068\:3092\:793a\:305b\:3002\n\n\:30b0\:30e9\:30d5 tree1 \
\:306e\:5834\:5408\:306b\:3001\:3053\:306e\:624b\:9806\:3092\:9069\:7528\:3059\
\:308b\:3068\:3001\:6b21\:306e10\:500b\:306e\:6709\:5411\:9053\:304c\:5f97\
\:3089\:308c\:308b\:3002\n\
P1={1,2,3,4,6,7,8,9}\:3001P2={9,10,1}\:3001P3={10,4}\:3001P4={10,6}\:3001P5={\
9,3}\:3001P6={9,7}\:3001P7={8,3}\:3001P8={7,3}\:3001P9={4,5,2}\:3001P10={4,2}\
\n\:30b5\:30a4\:30af\:30eb\:ff23\:3068\:5207\:7247\:306e\:5217B1\:3001B2\:3001\
...\:3001B7\:3068\:3001\:9053\:306e\:5217 P1\:3001P2\:3001\:ff0e\:ff0e\:ff0e\
\:3001P10\:3068\:306e\:95a2\:4fc2\:306f\:3001\n\t\:ff23 = P1\:3001B1=P2\
\[Union]P3\[Union]P4\:3001B2=P5\:3001B3=P6\:3001B4=P7\:3001B5=P8\:3001B6=P9\
\:3001B7=P10 \n\:3067\:3042\:308b\:3002\n\n    \
\:30b5\:30a4\:30af\:30ebC\:304b\:3089\:59cb\:3081\:3066\:3001\:5207\:7247\
\:306e\:5217B1\:3001B2\:3001...\:3001B7\:3092\:3001\:3053\:306e\:9806\:756a\
\:3067\:5e73\:9762\:306b\:57cb\:3081\:8fbc\:3080\:5177\:4f53\:7684\:306a\:4ed5\
\:65b9\:304c\:6b21\:30da\:30fc\:30b8\:306b\:4f8b\:793a\:3057\:3066\:3042\:308b\
\:3002\n    \
\:57cb\:3081\:8fbc\:307f\:306f\:6b21\:306e\:ff13\:3064\:306e\:30eb\:30fc\:30eb\
\:306b\:5f93\:3063\:3066\:884c\:3046\:3002\n    \
\:ff08\:ff11\:ff09\:6700\:521d\:306e\:30b5\:30a4\:30af\:30eb",
  Cell[BoxData[
      \(TraditionalForm\`C\_0\)]],
  "\:ff1d\:ff23\:306f\:3001\:5e73\:9762\:306b\:53cd\:6642\:8a08\:56de\:308a\
\:306b\:57cb\:3081\:8fbc\:3080\:3002i = 1 \:3068\:7f6e\:304f\:3002\n    \
\:ff08\:ff12\:ff09\:5207\:7247\:306f\:30b5\:30a4\:30af\:30eb\:306e\:5185\:5074\
\:3078\:512a\:5148\:3057\:3066\:57cb\:3081\:8fbc\:3080\:3002\:3053\:306e\:57cb\
\:3081\:8fbc\:307f\:306e\:969c\:5bb3\:3068\:306a\:308b\:305d\:308c\:4ee5\:524d\
\:306b\:57cb\:3081\:8fbc\:307e\:308c\:305f\:5207\:7247\:304c\:3001\:5185\:5074\
\:306b\:3042\:308b\:3068\:304d\:306b\:306f\:3001\:305d\:306e\:5207\:7247\:3092\
\:5916\:5074\:306b\:57cb\:3081\:76f4\:3059\:ff08\:3053\:306e\:3068\:304d\:3001\
\:4ed6\:306e\:5916\:5074\:5207\:7247\:3092\:5185\:5074\:306b\:57cb\:3081\:76f4\
\:3059\:3053\:3068\:3082\:3042\:308b\:ff09\:3002\:3053\:306e\:57cb\:3081\:76f4\
\:3057\:304c\:4e0d\:53ef\:80fd\:306a\:3068\:304d\:3001\:30b0\:30e9\:30d5\:306f\
\:975e\:5e73\:9762\:7684\:3067\:3042\:308b\:3002\n    \
\:ff08\:ff13\:ff09\:30eb\:30fc\:30eb\:ff08\:ff12\:ff09\:306b\:3088\:308a\:3001\
i \:756a\:76ee\:306e\:5207\:7247\:ff22i\:306f (i-1)\:756a\:76ee\:306e\:30b5\
\:30a4\:30af\:30eb",
  Cell[BoxData[
      \(TraditionalForm\`C\_\(i - 1\)\)]],
  "\:306b\:5bfe\:3057\:3066\:3001\:5e38\:306b\:5185\:5074\:5207\:7247\:3068\
\:3057\:3066\:5168\:4f53\:3092\:57cb\:3081\:8fbc\:3080\:306e\:3067\:3001\:ff22\
i\:306b\:5c5e\:3059\:308b\:9053",
  Cell[BoxData[
      \(TraditionalForm\`P\_ij\)]],
  "(j = 1,...)\:3092\:9078\:3076\:3054\:3068\:306b\:3001\:9053",
  Cell[BoxData[
      \(TraditionalForm\`P\_ij\)]],
  "\:3092\:ff11\:90e8\:5206\:3068\:3057\:3066\:542b\:3080\:53cd\:6642\:8a08\
\:56de\:308a\:306e\:6700\:5c0f\:306e\:30b5\:30a4\:30af\:30eb",
  Cell[BoxData[
      \(TraditionalForm\`C\_\(\((i - 1)\) j\)\)]],
  "\:3092",
  Cell[BoxData[
      \(TraditionalForm\`C\_\(\((i - 1)\) \((j - 1)\)\)\)]],
  "\[Union]",
  Cell[BoxData[
      \(TraditionalForm\`P\_ij\)]],
  "\:306e\:90e8\:5206\:30b0\:30e9\:30d5\:3068\:3057\:3066\:5b9a\:3081\:3001",
  Cell[BoxData[
      \(TraditionalForm\`C\_\(\((i - 1)\) j\)\)]],
  "\:306b\:5bfe\:3057\:3066\:3001\:ff22i\:306e\:6b8b\:308a\:306e\:9053\:3092\
\:518d\:5e30\:7684\:306b\:57cb\:3081\:8fbc\:3080\:3002\:305f\:3060\:3057\:3001\
",
  Cell[BoxData[
      \(TraditionalForm\`C\_\(\((i - 1)\) o\)\)]],
  "\:ff1d",
  Cell[BoxData[
      \(TraditionalForm\`C\_\(i - 1\)\)]],
  "\:3068\:3059\:308b\:3002\n    \:554f\:ff15\:ff0e\:30d1\:30fc\:30e0\:30fb\
\:30c4\:30ea\:30fc\:3092\:5229\:7528\:3057\:305f\:5e73\:9762\:6027\:5224\:5b9a\
\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306b\:3088\:308a\:3001",
  Cell[BoxData[
      \(TraditionalForm\`K\_5\)]],
  "\:3068",
  Cell[BoxData[
      \(TraditionalForm\`K\_\(3, 3\)\)]],
  "\:304c\:975e\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:3067\:3042\:308b\:3053\
\:3068\:3092\:793a\:305b\:3002   "
}], "Text"]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowToolbars->{"RulerBar", "EditBar"},
WindowSize->{596, 282},
WindowMargins->{{6, Automatic}, {Automatic, 16}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 131, 2, 30, "Input"],
Cell[1888, 55, 511, 7, 71, "Text"],
Cell[2402, 64, 75, 1, 30, "Input"],
Cell[2480, 67, 28263, 734, 746, "Text"],
Cell[30746, 803, 75, 1, 30, "Input"],
Cell[30824, 806, 20971, 525, 796, "Text"],
Cell[51798, 1333, 1685, 30, 570, "Input"],
Cell[53486, 1365, 1428, 19, 128, "Text"],

Cell[CellGroupData[{
Cell[54939, 1388, 1149, 21, 244, "Input"],
Cell[56091, 1411, 12552, 313, 296, 2208, 181, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[68658, 1727, 163, 2, 33, "Text"],
Cell[68824, 1731, 169, 3, 30, "Input"],
Cell[68996, 1736, 8236, 167, 814, "Text"],

Cell[CellGroupData[{
Cell[77257, 1907, 111, 2, 30, "Input"],
Cell[77371, 1911, 22633, 527, 296, 3581, 287, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[100041, 2443, 273, 5, 150, "Input"],
Cell[100317, 2450, 38, 1, 29, "Output"]
}, Open  ]],
Cell[100370, 2454, 261, 4, 33, "Text"],

Cell[CellGroupData[{
Cell[100656, 2462, 64, 1, 30, "Input"],
Cell[100723, 2465, 16614, 348, 296, 2028, 163, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[117352, 2816, 571, 8, 90, "Text"],

Cell[CellGroupData[{
Cell[117948, 2828, 98, 2, 30, "Input"],
Cell[118049, 2832, 11245, 282, 296, 2269, 167, "GraphicsData", "PostScript", \
"Graphics"],
Cell[129297, 3116, 941, 13, 158, "Print"]
}, Open  ]],
Cell[130253, 3132, 643, 8, 71, "Text"],
Cell[130899, 3142, 1443, 24, 530, "Input"],
Cell[132345, 3168, 451, 6, 52, "Text"],

Cell[CellGroupData[{
Cell[132821, 3178, 82, 1, 30, "Input"],
Cell[132906, 3181, 8360, 251, 296, 1893, 167, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[141281, 3435, 15214, 240, 1625, "Text"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

